// "clsMultiThreadCtrl.h"
// (setq c-basic-offset 4)

#include "../MAINCANVAS/clsPreference.h"
#include "clsMultiThreadCtrl.h"

MultiThreadThread_cls::
MultiThreadThread_cls(wxThreadKind kind) :
    wxThread(kind) {
    mpbReadyFlag = NULL;
}

void MultiThreadThread_cls::
SetReadyFlag(bool *pbReadyFlag){
    mpbReadyFlag = pbReadyFlag;
}

// -----

void MultiThreadCtrl_cls::
InitializeThreadCtrl(){
    mThreadNum = mspCPreferenceLink->GetThreadNumFilter();
    mbAThreadReady[_MAX_THREAD_NUM];
    for (int i = 0; i < _MAX_THREAD_NUM; i++) mbAThreadReady[i] = TRUE;
}

void MultiThreadCtrl_cls::
WaitForThreadsAndRun(MultiThreadThread_cls *pCThread){
    bool bRun = FALSE;
    while (bRun == FALSE){
	for (int th = 0; th < mThreadNum; th++)
	    if (mbAThreadReady[th] == TRUE){
		mbAThreadReady[th] = FALSE;

		pCThread->SetReadyFlag(&mbAThreadReady[th]);
		pCThread->Run();
		th = mThreadNum;
		bRun = TRUE;
	    }
	
	wxMilliSleep(1);
    }
}

void MultiThreadCtrl_cls::
WaitAllThreadsEnd(){
    for (int i = 0; i < mThreadNum; i++)
	if (mbAThreadReady[i] == FALSE){ wxMilliSleep(1); i--; }
}

Preference_cls *MultiThreadCtrl_cls::mspCPreferenceLink;
