// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsImportList.h"

#include "clsImportList.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(ImportListGUI_cls, wxDialog)
     EVT_BUTTON(wxID_OK,       ImportListGUI_cls::OnButtonOK)
     EVT_BUTTON(wxID_CANCEL,   ImportListGUI_cls::OnButtonClose)
END_EVENT_TABLE()

ImportListGUI_cls::
ImportListGUI_cls(ImportList_cls *pCParent, wxWindow *pC,
		  wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Import"),
		  pos, size)
{
    mpCParent = pCParent;
    SetScreenRectPos(&pCParent->mCScreenRect);
    
#ifdef WIN32
    wxIcon icon(wxT("ICONS/Import.ico"), wxBITMAP_TYPE_ICO);
#else
    wxIcon icon(wxT("ICONS/Import.png"), wxBITMAP_TYPE_PNG);
#endif
    SetIcon(icon);

    // TCU[
    wxBoxSizer       *pBoxSizerSRC   = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerTOP   = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerBTM   = new wxBoxSizer(wxHORIZONTAL);

    SetMNumMainParam(pBoxSizerTOP);

    wxButtonEX *pCButtonOK = new wxButtonEX (this, wxID_OK, wxT("Import"));
    wxButtonEX *pCButtonCANCEL = new wxButtonEX (this, wxID_CANCEL, wxT("Cancel"));

    pBoxSizerBTM->Add(-1, -1, 1, wxEXPAND);
    pBoxSizerBTM->Add( pCButtonOK,     0, wxEXPAND);
    pBoxSizerBTM->Add( pCButtonCANCEL, 0, wxEXPAND);

    pBoxSizerSRC->Add (pBoxSizerTOP, 0, wxEXPAND);
    pBoxSizerSRC->Add (pBoxSizerBTM, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSRC);
}

ImportListGUI_cls::
~ImportListGUI_cls(){
    MakeModal(FALSE);
}

void ImportListGUI_cls::
SetMNumMainParam(wxBoxSizer *pBoxSizer){
    mpCMNumMainParam = new MultiNumericalInputsPanel_cls(&mpCMNumMainParam, this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxBORDER_SIMPLE);

    MultiNumericalInputsPanel_cls* pCurr = mpCMNumMainParam;
    pCurr->mDefaultButton = _MN_NO_BUTTONS;
    pCurr->mTextWidth = 140;

    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbPathLine.mbBody,
			  wxT("Path Line"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbStereo.mbBody,
			  wxT("Stereo"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbHotSpot.mbBody,
			  wxT("Hot Spot"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbLight.mbBody,
			  wxT("Light"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbBoxSize.mbBody,
			  wxT("Box Size"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbSceneInfo.mbBody,
			  wxT("Scene Info"));

    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbDF3Seq.mbBody,
			  wxT("DF3Info"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbPovRay.mbBody,
			  wxT("PovRay Info"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbFilters.mbBody,
			  wxT("Filters Info"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbCustomColor.mbBody,
			  wxT("Custom Color"));
        
    pCurr->FinishSetting(pBoxSizer, TRUE);
}

void ImportListGUI_cls::
OnButtonOK(wxCommandEvent &event){
    mpCParent->UpdateItems();
    CloseEXKey(wxID_OK);
}

void ImportListGUI_cls::
OnButtonClose(wxCommandEvent &event){
    CloseEXKey();
}

MultiNumericalInputsPanel_cls* ImportListGUI_cls::mpCMNumMainParam;

// -------------------------

#include "../../clsFrameMain.h"

ImportList_cls::
ImportList_cls(FrameMain_cls *pC) :
    mCScreenRect(wxDefaultPosition, wxDefaultSize)
{
    mpCParentFrame = pC;
    mpCGUI = NULL;
    SetToDefault(_IMPORT_LIST_ALL);
    InitGUI(pC); // GUI ̃CX^X
}

ImportList_cls::
~ImportList_cls(){
    //if (mpCGUI != NULL) delete mpCGUI;
}

void ImportList_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumMainParam->UpdateValuesAll(bForce);
}

void ImportList_cls::
SetToDefault(unsigned int type){
    std::wstring strPath, strRender;
    switch(type){
    case _IMPORT_LIST_ALL:
	strPath = L"1"; strRender = L"1";
	break;
    case _IMPORT_LIST_RENDER:
	strPath = L"0"; strRender = L"1";
	break;
    case _IMPORT_LIST_PATH:
	strPath = L"1"; strRender = L"0";
	break;
    }
    mCConfList.Clear();
    mCConfList.Add(&mCbPathLine , wxT("ImportPathLine="),  strPath);
    mCConfList.Add(&mCbStereo   , wxT("ImportStereo="),    strPath);
    mCConfList.Add(&mCbHotSpot  , wxT("ImportHotSpot="),   strPath);
    mCConfList.Add(&mCbLight    , wxT("ImportLight="),     strPath);
    mCConfList.Add(&mCbBoxSize  , wxT("ImportBoxSize="),   strPath);
    mCConfList.Add(&mCbAlpha    , wxT("ImportAlpha="),     strPath);
    mCConfList.Add(&mCbSceneInfo, wxT("ImportSceneInfo="), strPath);

    mCConfList.Add(&mCbDF3Seq     , wxT("ImportDF3Seq="), strRender);
    mCConfList.Add(&mCbPovRay     , wxT("ImportPovray="), strRender);
    mCConfList.Add(&mCbFilters    , wxT("ImportFilters="), strRender);
    mCConfList.Add(&mCbCustomColor, wxT("ImportCustomColor"), strRender);
}

void ImportList_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new ImportListGUI_cls(this, pC, 
				   mCScreenRect.GetPosition(),
				   mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}
