// (setq c-basic-offset 4)

#include "clsReadBodyDF3.h"
#include "../clsDF3.h"
#include "../clsDF3Sequence.h"
#include "../GL/clsColoring.h"
extern Coloring_cls GCColoring;

#include "../../COMMON/MyEndian.h"

#include "../../MYAPI/MsgBox.h"

#include <wx/utils.h>
#include <wx/wx.h>
//#include <fstream>
#include <time.h>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#define ENDLWX wxT("\n")

Thread16bitTo8bit::
Thread16bitTo8bit(wxThreadKind kind) : 
    wxThread(kind){
}

void Thread16bitTo8bit::
SetParameters(bool *pbFinishedFlag,
	      int bufferSize,
	      unsigned short *pBuffer16,
	      unsigned char  *pOffsetPoint){
    mpbFinishedFlagLink = pbFinishedFlag;
    mBufferSize   = bufferSize;
    mpBuffer16    = pBuffer16;
    mpOffsetPoint = pOffsetPoint;

    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode Thread16bitTo8bit::
Entry(){
    int bufferSize = mBufferSize;
    unsigned short *pBuffer16    = mpBuffer16;
    unsigned char  *pOffsetPoint = mpOffsetPoint;
    for (int i = 0; i < bufferSize; i++){
	unsigned char *pPos = (unsigned char*)(pBuffer16 + i);
	unsigned char tmp = *(pPos);
	*(pPos) = *(pPos+1);
	*(pPos+1) = tmp;
	*(pOffsetPoint + i) = pBuffer16[i] / 256;
	if (i % 100000 == 0)
	    printf("buffersize=%d, %d\n", bufferSize, i);
    }
    
    *mpbFinishedFlagLink = TRUE;
    return 0;
}

/*
void ReadBodyDF3_cls::
DensityModifier(unsigned char *pIni, unsigned int size){
    for (unsigned int i = 0; i < size; i++){
	float value = ((float)pIni[i]) / 255;
	pIni[i] =  (unsigned char)(GCColoring.GetModulator(value) * 255);
    }
}
*/

void ReadBodyDF3_cls::
Read8bit(bool type, std::fstream &ifstream){
    for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z+= 8){
	int zWidth = 8;
	if (z > mpC->mCurrSize[Z] - 8) zWidth = mpC->mCurrSize[Z] - z;
	ifstream.seekg(6 + 
		       mpC->GetCurrSizeSxT(Z) * z,
		       std::ios::beg);
	ifstream.read((char*)mpC->mpMainXYZ[Z] +
		      mpC->GetCurrSizeSxT(Z) * z,
		      mpC->GetCurrSizeSxT(Z) * zWidth);
	mNext = z + 8;
	if (IsResumeConditionSatisfied(type) == TRUE) break;
    }
}

void ReadBodyDF3_cls::
Read8bitDownSize(bool type, std::fstream &ifstream){
    unsigned char *pStartPoint = mpC->mpMainXYZ[Z];
    long trueSizeSxT = mpC->GetTrueSizeSxT(Z);
    int  trueSizeS   = mpC->GetTrueSizeS(Z);
    int  currSizeSxT = mpC->GetCurrSizeSxT(Z);
    int  currSizeS   = mpC->GetCurrSizeS(Z);
    int downsizeX    = DF3Sequence_cls::msCDownSizeSrc.mpBody[X];
    int downsizeY    = DF3Sequence_cls::msCDownSizeSrc.mpBody[Y];
    int downsizeZ    = DF3Sequence_cls::msCDownSizeSrc.mpBody[Z];
    for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z += 1){
	unsigned char *buf;
	buf = new unsigned char [trueSizeSxT];
	ifstream.seekg(6 + 
		       trueSizeSxT * z * downsizeZ,
		       std::ios::beg);
	ifstream.read((char*)buf, trueSizeSxT);

	unsigned char *pOffsetPointZ = pStartPoint + currSizeSxT*z;
	for (unsigned int y = 0; y < mpC->mCurrSize[Y]; y++)
	    for (unsigned int x = 0; x < mpC->mCurrSize[X]; x++)
		*(pOffsetPointZ + currSizeS * y + x) = 
		    buf[trueSizeS * y * downsizeY + x * downsizeX];
	
	delete buf;
	mNext = z + 1;
	if (IsResumeConditionSatisfied(type) == TRUE) break;
    }
}

void ReadBodyDF3_cls::
Read16bit(bool type, std::fstream &ifstream){
    unsigned char *pStartPoint = mpC->mpMainXYZ[Z];
    int zUnit = 16;
    for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z+= zUnit){
	int zWidth = zUnit;
	if (z > mpC->mCurrSize[Z] - zUnit) zWidth = mpC->mCurrSize[Z] - z;
	long bufferSize = mpC->GetCurrSizeSxT(Z) * zWidth;
	unsigned short *pBuffer16 = new unsigned short [bufferSize];
	long layerOffset = mpC->GetCurrSizeSxT(Z) * z;

	ifstream.seekg(6 + layerOffset * 2, std::ios::beg);
	ifstream.read((char*)pBuffer16, bufferSize * 2);

	unsigned char *pOffsetPoint = pStartPoint + layerOffset;

	bool bAFinished[2] = {FALSE, FALSE};
	Thread16bitTo8bit* pCThread[2];
	pCThread[0] = new Thread16bitTo8bit(wxTHREAD_DETACHED);
	pCThread[1] = new Thread16bitTo8bit(wxTHREAD_DETACHED);

	pCThread[0]->SetParameters(&bAFinished[0],
				   bufferSize/2, 
				   pBuffer16, 
				   pOffsetPoint);
	long bufferSizeLH = bufferSize - bufferSize/2; // łŜ
	pCThread[1]->SetParameters(&bAFinished[1],
				   bufferSizeLH,  
				   pBuffer16 + bufferSize/2,
				   pOffsetPoint + bufferSize/2);
	
	pCThread[0]->Run();
	pCThread[1]->Run();

	bool bFinishedAll = FALSE;
	while (bFinishedAll == FALSE){
	    wxMilliSleep(3);
	    bFinishedAll = TRUE;
	    for (int core = 0; core < 2; core++) 
		bFinishedAll &= bAFinished[core];
	}
	
	mNext = z + zUnit;
	delete pBuffer16;
	if (IsResumeConditionSatisfied(type) == TRUE) break;
    }
}

void ReadBodyDF3_cls::
Read16bitDownSize(bool type, std::fstream &ifstream){
    unsigned char *pStartPoint = mpC->mpMainXYZ[Z];
    long trueSizeSxT = mpC->GetTrueSizeSxT(Z);
    int  trueSizeS   = mpC->GetTrueSizeS(Z);
    int  currSizeSxT = mpC->GetCurrSizeSxT(Z);
    int  currSizeS   = mpC->GetCurrSizeS(Z);
    int downsizeX    = DF3Sequence_cls::msCDownSizeSrc.mpBody[X];
    int downsizeY    = DF3Sequence_cls::msCDownSizeSrc.mpBody[Y];
    int downsizeZ    = DF3Sequence_cls::msCDownSizeSrc.mpBody[Z];
    for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z+= 1){
	unsigned short *pBuffer16 = new unsigned short [trueSizeSxT];

	ifstream.seekg(6 + trueSizeSxT * z*downsizeZ * 2, std::ios::beg);
	ifstream.read((char*)pBuffer16, trueSizeSxT * 2);
	
	unsigned char *pOffsetPointZ = pStartPoint + currSizeSxT*z;
	for (unsigned int y = 0; y < mpC->mCurrSize[Y]; y++){
	    int bufferIndexY = trueSizeS * y * downsizeY;
	    unsigned char *pOffsetPoint = pOffsetPointZ + currSizeS*y;
	    for (unsigned int x = 0; x < mpC->mCurrSize[X]; x++){
		int bufferIndex = bufferIndexY + x * downsizeX;
		unsigned char *pPos = (unsigned char*)(pBuffer16+bufferIndex);
		unsigned char tmp = *(pPos);
		*(pPos) = *(pPos+1);
		*(pPos+1) = tmp;
		*(pOffsetPoint + x) = pBuffer16[bufferIndex]/256;
	    }
	}

	delete pBuffer16;	
	mNext = z + 1;
	if (IsResumeConditionSatisfied(type) == TRUE) break;
    }
}

bool ReadBodyDF3_cls::
MainProcess(bool type, wxWindow *pC){
    Initialize(mpC->GetCurrSize(Z));

    mpC->mOldPointXYZ = 10;
    assert(mpC->IsAllocated() == TRUE);

    std::fstream ifstream(wxFNCONV(mpC->GetFilePathWXStr()),
			  std::ios::in | std::ios::binary);

    size_t fileSize = (size_t)ifstream.seekg(0, std::ios::end).tellg();
    ifstream.seekg(0, std::ios::beg);
    
    int downsizeX   = DF3Sequence_cls::msCDownSizeSrc.mpBody[X];
    int downsizeY   = DF3Sequence_cls::msCDownSizeSrc.mpBody[Y];
    int downsizeZ   = DF3Sequence_cls::msCDownSizeSrc.mpBody[Z];

    unsigned long totalSizeForFile = mpC->GetTrueTotalSize();
    
    bool b16bit = FALSE;
    if (fileSize == totalSizeForFile*2 + 6)
	b16bit = TRUE;
    else if (fileSize != totalSizeForFile + 6){
	wxString strMessage = _("File Size Inconsistency");
	strMessage << ENDLWX << mpC->GetFilePathWXStr() << ENDLWX;
	strMessage << wxString::Format(_T("Filesize = %ld : Expected size = %ld\n%d x %d x %d"), fileSize, mpC->GetCurrentTotalSize() + 6, mpC->GetCurrSize(X), mpC->GetCurrSize(Y), mpC->GetCurrSize(Z));
	MsgBox(pC, strMessage, _T("read Error Main"));
	return FALSE; }
    
    if (ifstream.fail()) {
	MsgBox(pC, _T("read Error Main"),
	       mpC->GetFilePathWXStr() + _("can not open"));
	return FALSE; }
    
    if (DF3Sequence_cls::msCDownSizeSrc.mpBody[X] == 1 &&
	DF3Sequence_cls::msCDownSizeSrc.mpBody[Y] == 1 && 
	DF3Sequence_cls::msCDownSizeSrc.mpBody[Z] == 1){
	if (b16bit == TRUE)
	    Read16bit(type, ifstream);
	else
	    Read8bit(type, ifstream);
    }
    else{
	// ---- READ with DownSize ----
	if (b16bit == TRUE)
	    Read16bitDownSize(type, ifstream);
	else
	    Read8bitDownSize(type, ifstream);
    }
    
    if (IsFinishConditionSatisfied() == FALSE) return TRUE;
    
    Finalize();
    mpC->mbDirty = TRUE;

    return TRUE;
}

bool ReadBodyDF3_cls::
ReadHeaderInfo(wxWindow *pCWindow){
    
    std::fstream ifstream(wxFNCONV(mpC->GetFilePathWXStr()), std::ios::in | std::ios::binary);
    
    if (ifstream.fail()) {
	if (pCWindow != NULL)
	    MsgBox(pCWindow, mpC->GetFilePathWXStr() + _("can not open"),
		   _("read error Header DF3"));
	return FALSE; }
    
    short buffer[3];
    ifstream.read((char*)buffer, 6);
    
    LOOP_XYZ{
	MyEndian::SwapByte((void*)&buffer[xyz], 2);
	mpC->mTrueSize[xyz] = buffer[xyz];
    }

    return TRUE;
}
