
#ifndef _PREVIEW_PROPERTY_H_
#define _PREVIEW_PROPERTY_H_

#include "../../CONFITEM/clsConfItem.h"
#include "../../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"
#include "../../WIDGETCTRL/clsDialogController.h"
#include <wx/wx.h>
#include <GL/glut.h>

class DF3SeqCtrl_cls;
class DF3Sequence_cls;
class FilterCtrl_cls;
class GraphPanel_cls; 
class PreviewProperty_cls;

#define _PREVIEW_ALPHA 0
#define _PREVIEW_LUMINANCE_ALPHA 1
#define _PREVIEW_RGBA 2

#define _PREVIEW_MUTUAL_HIDE 0
#define _PREVIEW_NO_HIDE 1
#define _PREVIEW_INVERSE_HIDE 2

class PreviewPropertyGUI_cls : public wxDialogEXKey {
 public:
    PreviewPropertyGUI_cls(PreviewProperty_cls* pCParent,
			   wxWindow *pC, wxPoint pos, wxSize size);
    ~PreviewPropertyGUI_cls();

    static PreviewPropertyGUI_cls* mspCThis;
    PreviewProperty_cls *mpCParent;
    MultiNumericalInputsPanel_cls* mpCMNumRenderParam;
    MultiNumericalInputsPanel_cls* mpCMNumShadeParam;

    void SetMNumRenderParam(wxBoxSizer *pBoxSizer);
    void SetMNumShadeParam(wxBoxSizer *pBoxSizer);

    wxButtonEX *mpCBTNShade;
    
    GraphPanel_cls       *mpCGraphModulator;

    static void FuncHookRefresh(void *pArg, void *pEvent);
    static void FuncHookHideButton(void *pArg, void *pEvent);
    static void FuncHookFormat(void *pArg, void *pEvent);
    void HideAndShowAll();

    unsigned int mIndexComboFormat;
    unsigned int mIndexCheckBoxFBO;
    unsigned int mIndexComboSliceType;
    unsigned int mIndexLuminance;
    unsigned int mIndexAbsorption, mIndexComplement, mIndexOffset;
    unsigned int mIndexShading, mIndexShadePattern;

    void OnSize(wxSizeEvent& event);
    void OnButtonShowItem(wxCommandEvent& event);

    //void UpdateDisplay();
    
    void UpdateGraph();
    void OnButtonClose  (wxCommandEvent &event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class PreviewProperty_cls : 
public DialogControl_cls
{
 public:
    PreviewProperty_cls(wxWindow* pCParentWindew,
			DF3SeqCtrl_cls* pCDF3SeqCtrl,
			wxBitmap *pBitmap);
    ~PreviewProperty_cls();

    static PreviewProperty_cls *mspCThis;

    bool mbBlendEquationEX;
    PreviewPropertyGUI_cls *mpCGUI;
    wxWindow *mpCParentWindow;
    DF3SeqCtrl_cls *mpCDF3SeqCtrlLink;
    wxBitmap *mpBitmapLink;
   
    ConfItemList_cls   mCConfListPreview;
    ConfItemUINT_cls   mCPreviewType3D;
    ConfItemUINT_cls   mCPreviewNormalQuality;
    ConfItemUINT_cls   mCTextureType;
    ConfItemUINT_cls   mCRenderType;
    ConfItemUINT_cls   mCHiding;
    ConfItemFLOAT_cls  mCAbsorption;
    ConfItemFLOAT_cls  mCAbsorptionComplement;
    ConfItemFLOAT_cls  mCLuminanceFactor;
    ConfItemUINT_cls   mCShadingType, mCShadingCoord, mCShadingPattern;
    ConfItemFLOAT_cls  mCShadeOffset;
    

    ConfItemUINT_cls   mCTexFilter;

    bool mbUse3DTexture;

    void SetToDefault();
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void Set3DTextureCondition(int majorVersionGL, int minorVersionGL);

    bool IsFilterProcessRequired(unsigned int df3index);
    static double GetLevelMapping(double value, void *pClue = NULL);
    static double GetLevelMapping(double value, int df3index);

    int  GetNQuality();
    GLuint GetGLTexFilter();

    void ReadStrLine(std::wstring strLine);
    wxString SerializeConf();
};

#endif
