// (setq c-basic-offset 4)
#include "clsParametersPanelList.h"

#include "../../GLCANVAS/clsMainGLCanvas.h"
#include "../../PARAMETER/clsParameters.h"
#include "../../PARAMETER/clsParametersPanel.h"
#include "../../PARAMETER/clsTimeLinePanel.h"
#include "../../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;

#include "../../../wxWidgetEnum.h"
#include "../../../clsFrameMain.h"
extern FrameMain_cls* GpCMainFrameCLS;

#include <wx/splitter.h> 

// ÓIɃCxgт
BEGIN_EVENT_TABLE(ParametersPanelList_cls, wxPanel)
     EVT_MOUSE_EVENTS(ParametersPanelList_cls::OnMouse)
     EVT_KEY_DOWN(ParametersPanelList_cls::OnKey)
END_EVENT_TABLE()

ParametersPanelList_cls::
ParametersPanelList_cls(wxWindow *pCParent) 
    : wxPanel (pCParent, wxID_ANY, wxDefaultPosition, wxDefaultSize) {
    mVPParameterPanel.clear();
    mVstrTag.clear();

    mpCBoxSizer = new wxBoxSizer(wxVERTICAL);

    this->SetSizer(mpCBoxSizer);
}

ParametersPanel_cls* ParametersPanelList_cls::
GetPPanel(int index){
    if (index >= mVPParameterPanel.size()) return NULL;
    std::list < ParametersPanel_cls* >::iterator itr = mVPParameterPanel.begin();
    for (int i = 0; i < index; i++){
	if (itr == mVPParameterPanel.end()) return NULL;
	itr++; 
    }
    return *itr;
}

wxString ParametersPanelList_cls::
GetStrTag(int index){
    std::list < wxString >::iterator itr = mVstrTag.begin();
    for (int i = 0; i < index; i++, itr++);
    return *itr;
}

int ParametersPanelList_cls::
GetItemId(int index){
    return GetPPanel(index)->mpCTimeLine->GetId();
}

bool ParametersPanelList_cls::
IsActive(wxString strTag){
    ParametersPanel_cls* pPanel = GetPPanel(strTag);
    if (pPanel != NULL) return pPanel->mpCTimeLine->mbActive;
    return FALSE;
}

ParametersPanel_cls* ParametersPanelList_cls::
Add(Parameters_cls* pCParam, wxString strCustomName){
    ParametersPanel_cls *pParamPanel = 
	new ParametersPanel_cls(pCParam, this, strCustomName, 
				pCParam->mCbShow.mbBody);
    mVPParameterPanel.push_back(pParamPanel);
    mVstrTag.push_back(strCustomName);

    return pParamPanel;
}

void ParametersPanelList_cls::
Remove(wxString strTag){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end();){
	if ((*itr)->mpCTimeLine->mstrCustomName == strTag){
	    delete *itr;
	    itr = mVPParameterPanel.erase(itr);
	    continue;
	}
	itr++;
    }

    std::list < wxString >::iterator itr2;
    for (itr2 = mVstrTag.begin(); itr2 != mVstrTag.end();){
	if (*itr2 == strTag){
	    itr2 = mVstrTag.erase(itr2);
	    continue;
	}
	itr2++;
    }
}

void ParametersPanelList_cls::
Reconnect(wxString strTag, Parameters_cls* pCParam){
    ParametersPanel_cls* pCPanel = GetPPanel(strTag);
    if (pCPanel == NULL) return;
    pCPanel->LinkParameter(pCParam);
}

void ParametersPanelList_cls::
Rename(wxString strTagOrg, wxString strTagNew){
       ParametersPanel_cls* pCPanel = GetPPanel(strTagOrg);
    if (pCPanel == NULL) return;
    pCPanel->mpCTimeLine->mstrCustomName = strTagNew;
    
    for (std::list < wxString >::iterator itr = mVstrTag.begin();
	 itr != mVstrTag.end(); itr++)
	if (*itr == strTagOrg) *itr = strTagNew;
}

void ParametersPanelList_cls::
RemapKeys(double rate){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end();){
	if ((*itr)->mpCParam != NULL)
	    (*itr)->mpCParam->RemapKeys(rate);
	itr++;
    }
}

void ParametersPanelList_cls::
UpdatePanelLayout(){
    mpCBoxSizer->Clear();
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	mpCBoxSizer->Add(*itr, 0, wxEXPAND);
    mpCBoxSizer->Fit(this);
    wxSizeEvent dummy;
    GetParent()->AddPendingEvent(dummy);
    GetParent()->SetSize(GetParent()->GetClientSize().GetWidth(),
			 GetParent()->GetBestSize().GetHeight());
}

void ParametersPanelList_cls::
UpdateDisplay(){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	(*itr)->UpdateDisplay();
}

void ParametersPanelList_cls::
UpdateBitmapPanels(){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	(*itr)->UpdatePanelBitmapState();
}

void ParametersPanelList_cls::
DeactivateAllPanel(bool bExclusive){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	(*itr)->mpCTimeLine->Activate(FALSE, bExclusive);
    MainGLCanvas_cls::mspCSelectedItem = NULL;
}

void ParametersPanelList_cls::
Activate(unsigned int index, bool bExclusive){
    ParametersPanel_cls* pCPanel = GetPPanel(index);
    if (pCPanel != NULL)
	pCPanel->mpCTimeLine->Activate(TRUE);
}

void ParametersPanelList_cls::
Activate(wxString strTag, bool bExclusive){
    ParametersPanel_cls *pPanel = GetPPanel(strTag);
    if (pPanel != NULL)
	pPanel->mpCTimeLine->Activate(TRUE);
}

void ParametersPanelList_cls::
ShowAllTimeDependentItems(){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCParam->mCbTimeDependent.mbBody == TRUE)
	    (*itr)->Show(TRUE);
}

void ParametersPanelList_cls::
SelectKeyFrame(double doubleIndexA, double doubleIndexB){
    GCUndoList.OpenBlock();
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected)
	    if ((*itr)->IsKeyFrame(doubleIndexA) == FALSE){
		(*itr)->mpCParam->InsertKey(doubleIndexA);
		// JȂm[}CYKv
		if ((*itr)->mpCParam->mLabelStr == L"CamPos")
		    GpCMainFrameCLS->NormalizeActiveCameraPath();
		
		(*itr)->mpCTimeLine->mSelected = 
		    (*itr)->mpCParam->SelectKeyFrame(doubleIndexA, doubleIndexB, FALSE, TRUE);
	    }
    GCUndoList.CloseBlock();
}

void ParametersPanelList_cls::
DeleteKeyFrame(double doubleIndex){
    GCUndoList.OpenBlock();
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected)
	    if ((*itr)->IsKeyFrame(doubleIndex) == TRUE)
		(*itr)->mpCParam->DeleteKey(doubleIndex);
    GCUndoList.CloseBlock();
}

void ParametersPanelList_cls::
SetTimeDependent(bool bTimeDependent){
    GCUndoList.OpenBlock();
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected){
	    (*itr)->mpCParam->SetTimeDependent(bTimeDependent);
	    (*itr)->UpdatePanelBitmapState();
	}
    GCUndoList.CloseBlock();
}

void ParametersPanelList_cls::
SetVisibility(bool bVisibility){
    GCUndoList.OpenBlock();
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected){
	    (*itr)->mpCParam->mCbVisible.mbBody = bVisibility;
	    (*itr)->UpdatePanelBitmapState();
	}
    GCUndoList.CloseBlock();
}



void ParametersPanelList_cls::
HidePanel(){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected){
	    (*itr)->mpCTimeLine->mbSelected = FALSE;
	    (*itr)->mpCTimeLine->mbActive = FALSE;
	    (*itr)->Show(FALSE);
	    MainGLCanvas_cls::mspCSelectedItem = NULL;
	}
    //Layout();
    //UpdatePanelLayout();
}

void ParametersPanelList_cls::
DragAllPanel(bool bDrag,
	     double dragDoubleIndexOrigin,  double dragDoubleIndex){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected){
	    (*itr)->mpCTimeLine->mbDragging = bDrag;
	    (*itr)->mpCTimeLine->mDragDoubleIndexOrigin = dragDoubleIndexOrigin;
	    (*itr)->mpCTimeLine->mDragDoubleIndex = dragDoubleIndex;
	    if (bDrag == TRUE)
		(*itr)->mpCTimeLine->Refresh(TRUE);
	}
}

void ParametersPanelList_cls::
MoveTimeSelectedKeyAllPanel(double doubleIndexDiff, 
			    TimeLinePanel_cls *pCExclude){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected && (*itr)->mpCTimeLine != pCExclude){
	    (*itr)->mpCTimeLine->mpCParam->MoveTimeSelectedKey(doubleIndexDiff);
	    (*itr)->mpCTimeLine->Refresh(TRUE);
	}
}

void ParametersPanelList_cls::
SelectAllKeySelectedPanel(bool bSelected){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCTimeLine->mbSelected)
	    (*itr)->mpCTimeLine->mpCParam->SelectKeyFrameRegion(0, 1, bSelected); 
}

std::vector < wxString > ParametersPanelList_cls::
GetInvisibleItems(){
    std::vector < wxString > VInvisibleItems;
    std::list < ParametersPanel_cls* >::iterator itr;
    std::list < wxString >::iterator itr2 = mVstrTag.begin();
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++, itr2++){
	if ((*itr)->mpCParam != NULL)
	    (*itr)->mpCParam->mCbShow.mbBody = (*itr)->IsShownOnScreen();
	
	if ((*itr)->mpCParam != NULL &&
	    (*itr)->mpCParam->mCbSelectable.mbBody == TRUE)
	    if ((*itr)->IsShownOnScreen() == FALSE)
		VInvisibleItems.push_back((*itr)->mpCTimeLine->mstrCustomName);
    }
    return VInvisibleItems;
}

unsigned int ParametersPanelList_cls::
GetIndexFromID(int id){
    std::list < ParametersPanel_cls* >::iterator itr;
    unsigned int i;
    for (i = 0, itr = mVPParameterPanel.begin(); 
	 itr != mVPParameterPanel.end(); i++, itr++)
	if (id == (*itr)->mpCTimeLine->GetId()) return i;
	
    return 9999;
}

unsigned int ParametersPanelList_cls::
GetIndexFromTag(wxString strTag){
    std::list < wxString >::iterator itr;
    unsigned int i;
    for (i = 0, itr = mVstrTag.begin(); itr != mVstrTag.end(); i++, itr++)
	if (strTag == (*itr)) return i;
    return 9999;
}

#include "../../MYAPI/MsgBox.h"

wxString ParametersPanelList_cls::
GetTagActivated(){
    std::list < ParametersPanel_cls* >::iterator itr;
    std::list < wxString >::iterator itr2 = mVstrTag.begin();
    for (itr = mVPParameterPanel.begin();
	 itr != mVPParameterPanel.end(); itr++, itr2++)
	if ((*itr)->mpCTimeLine->mbActive == TRUE)
	    return *itr2;
    
    return wxT("");
}

void ParametersPanelList_cls::
SetSnippingTag(std::vector < bool > &VBSnipping, int maxFrame){
    std::list < ParametersPanel_cls* >::iterator itr;
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end(); itr++)
	if ((*itr)->mpCParam != NULL)
	    (*itr)->mpCParam->SetSnippingTag(VBSnipping, maxFrame);
}

ParametersPanel_cls* ParametersPanelList_cls::
GetPPanel(wxString strTag){
    std::list < ParametersPanel_cls* >::iterator itr;
    std::list < wxString >::iterator itr2 = mVstrTag.begin();
    for (itr = mVPParameterPanel.begin(); itr != mVPParameterPanel.end();
	 itr++, itr2++){
	if (strTag == *itr2) return *itr;
	if (strTag == (*itr)->mpCTimeLine->mstrCustomName) return *itr;
    }
    return NULL;
}

ParametersPanel_cls* ParametersPanelList_cls::
GetPPanelActivated(){
    return GetPPanel(GetTagActivated());
}

// ---

/*
bool ParametersPanelList_cls::
SkipEventToSelected(wxKeyEvent& event){
    if (GetPPanelActivated() != NULL){
	event.SetId(GetPPanelActivated()->GetId());
	GetPPanelActivated()->mpCTimeLine->AddPendingEvent(event);
	return TRUE;
    }
    return FALSE;
}
*/

void ParametersPanelList_cls::
OnMouse(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
}

void ParametersPanelList_cls::
OnKey(wxKeyEvent& event){
    GetParent()->AddPendingEvent(event);
}
