// -*- c -*- 
// "clsParametersPanelLists.h"

#ifndef _DF3_PARAMETERSPANELLIST_H_
#define _DF3_PARAMETERSPANELLIST_H_

#include <vector>
#include <list>
#include <wx/wx.h>

class DF3SeqGUI_cls;
class ParametersPanel_cls;
class Parameters_cls;
class TimeLinePanel_cls;

class ParametersPanelList_cls : public wxPanel {
 public:
    ParametersPanelList_cls(wxWindow *pCParent);
    wxBoxSizer* mpCBoxSizer;

    std::list < ParametersPanel_cls* > mVPParameterPanel;
    std::list < wxString > mVstrTag;

    ParametersPanel_cls* GetPPanel(int index);
    wxString GetStrTag(int index);
    int  GetItemId(int index);

    bool IsActive(wxString strTag);

    ParametersPanel_cls* Add(Parameters_cls* pCParam, wxString strCustomName);
    void Remove(wxString strTag);
    void Reconnect(wxString strTag, Parameters_cls* pCParam);
    void Rename(wxString strTagOrg, wxString strTagNew);

    void RemapKeys(double rate);
    
    wxBoxSizer mpCSizer();
    void UpdatePanelLayout();
    void UpdateDisplay();
    void UpdateBitmapPanels();

    void DeactivateAllPanel(bool bExclusive = TRUE);
    void Activate(unsigned int index, bool bExclusive);
    void Activate(wxString strTag, bool bExclusive);
    void ShowAllTimeDependentItems();

    void SelectKeyFrame(double doubleIndexA, double doubleIndexB);
    void DeleteKeyFrame(double doubleIndex);
    void SetTimeDependent(bool bDependent);
    void SetVisibility(bool bVisibility);
    void DragAllPanel(bool bDrag,
		      double dragDoubleIndexOrigin,  double dragDoubleIndex);
    void MoveTimeSelectedKeyAllPanel(double doubleIndexDiff,
				     TimeLinePanel_cls *pCExclude);
    void SelectAllKeySelectedPanel(bool bSelected);
   
    void HidePanel();

    std::vector < wxString > GetInvisibleItems();

    unsigned int GetIndexFromID(int id);
    unsigned int GetIndexFromTag(wxString strTag);
    wxString GetTagActivated();

    void SetSnippingTag(std::vector < bool > &VBSnipping, int maxFrame);

    // ---
    
    //bool SkipEventToSelected(wxKeyEvent& event);

    ParametersPanel_cls* GetPPanel(wxString strTag);
    ParametersPanel_cls* GetPPanelActivated();

    void OnMouse(wxMouseEvent& event);
    void OnKey(wxKeyEvent& event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
