// -*- c -*- 
// "clsTLPanelAA.h"

#include "clsTLPanelAA.h"
#include "../clsDF3Sequence.h"
#include "../../../clsTimeCtrl.h"

#include "../../../wxWidgetEnumMenu.h"

#include <wx/dcbuffer.h>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#define _TL_SEL_MIN 1
#define _TL_SEL_MAX 2
#define _TL_SEL_REGION 3

BEGIN_EVENT_TABLE(TLPanelAA_cls, wxPanel)
     EVT_PAINT       (TLPanelAA_cls::OnPaint)
     EVT_MOUSE_EVENTS(TLPanelAA_cls::OnMouse)
END_EVENT_TABLE()

TLPanelAA_cls::
TLPanelAA_cls(wxWindow *parent, wxWindowID id, wxPoint pos, wxSize size):
     TLPanel_cls(parent, id, pos, size)
{
    mpCTimeSliderIcon = new wxIcon(wxT("ICONS/TimeSliderSmall.png"), wxBITMAP_TYPE_PNG);
    mpCTimeSliderIcon->SetWidth(7);
    mpCTimeSliderIcon->SetHeight(9);

    mFrameInSlider = 0;
    mPosCurrent = 0;
    mbCaptureMouse = 0;

    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

TLPanelAA_cls::
~TLPanelAA_cls(){
    delete mpCTimeSliderIcon;
}

void TLPanelAA_cls::
UpdateDisplay(){
    wxPaintEvent com;
    OnPaint(com);
}

void TLPanelAA_cls::
UpdateDisplay(wxAutoBufferedPaintDC &dc){

    dc.SetBackground(wxBrush(wxColour(216, 216, 216), wxSOLID));
    dc.Clear();

    SetMemberSize(GetClientSize());

    UpdateTLFrame();
    
    wxBrush PlayModeBrush(wxColour(191,216,216, wxSOLID));

    dc.SetPen(*wxTRANSPARENT_PEN);
    // WorkingArea
    dc.SetBrush(*wxWHITE_BRUSH);
    CalcCoordinateX0X1(mMinFrameWA, mMaxFrameWA-mMinFrameWA, 0, mFrameMax);
    dc.DrawRectangle(mX0, 0, mX1-mX0, mHeight - 0);

    // ActiveArea
    dc.SetBrush(PlayModeBrush);
    CalcCoordinateX0X1(mAAMin, mAAMax-mAAMin, 0, mFrameMax);
    dc.DrawRectangle(mX0, 3, mX1-mX0, mHeight - 6);

    DrawRegionSliderX0X1(dc);

    dc.SetPen(*wxRED_PEN);
    dc.DrawRectangle(mXCurrent, 0, 1, mHeight);
    
    if (mSelected == _TL_SEL_SLIDER)
	dc.DrawIcon(*mpCTimeSliderIcon, mXDragging-3, 2);
    else
	dc.DrawIcon(*mpCTimeSliderIcon, mXCurrent-3, 2);
    
    int offset = 0;
    if (mPosCurrent > mWidth * 0.7) offset = -40;

    dc.SetFont(*wxSMALL_FONT);
    if (mbCaptureMouse == TRUE && 
	(mSelected == _TL_SEL_MIN || mSelected == _TL_SEL_MAX ||
	 mSelected == _TL_SEL_SLIDER)){
	wxString Mes;
	
	dc.SetTextForeground(*wxRED);
	Mes << mFrameInSlider; 
	dc.DrawText(Mes, mPosCurrent + 15 + offset, 0);
    }
    
    dc.SetTextForeground(wxColour(128, 128, 128));
    wxString Mes;
    Mes << mspCTimeLink->mFrame << wxT(" / ") << mspCTimeLink->mCMaxFrame.mBody;
    int posX = mWidth / 2 - 16;
    if ((mPosCurrent - posX) > -64 && (mPosCurrent - posX) < 64) posX = 24;
    dc.DrawText(Mes, posX, 0);
}

void TLPanelAA_cls::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
    event.Skip();
}

void TLPanelAA_cls::
OnMouse(wxMouseEvent& event){
    
    SetRange(0, mspCTimeLink->mCMaxFrame.mBody);
    mpCRegionTgtMin = &mspCTimeLink->mCAAMin.mBody;
    mpCRegionTgtMax = &mspCTimeLink->mCAAMax.mBody;
    SetInitRegion(event, *mpCRegionTgtMin, *mpCRegionTgtMax);
        
    ProcMouseEventBase(event);

    event.Skip();
}

