// "clsMemoryPanel.h"

#include "clsTLPanelMemory.h"
#include "../clsDF3SeqCtrl.h"
#include "../clsDF3Sequence.h"
#include "../clsDF3SeqGUI.h"
#include "../GL/clsPreviewProperty.h"
#include "../../PARAMETER/clsTimeLinePanel.h"
#include "../../../clsTimeCtrl.h"

#include "../../../wxWidgetEnumMenu.h"

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#define _TL_SEL_MIN 1
#define _TL_SEL_MAX 2
#define _TL_SEL_REGION 3

// OnPaint$B$N%$%Y%s%H$O7Q>5%/%i%9$KMh$k$N$GDj5A(B
BEGIN_EVENT_TABLE(TLPanelMemory_cls, wxPanel)
     EVT_PAINT       (TLPanelMemory_cls::OnPaint)
     EVT_MOUSE_EVENTS(TLPanelMemory_cls::OnMouse)
     EVT_MENU        (menuItemMemScene, TLPanelMemory_cls::OnMenuScene)
     EVT_MENU_RANGE  (menuItemMemRange00, menuItemMemRange03, 
		      TLPanelMemory_cls::OnMenuPlayMode)
END_EVENT_TABLE()

TLPanelMemory_cls::
TLPanelMemory_cls(DF3SeqCtrl_cls *pCDF3SeqCtrl,
		  DF3Sequence_cls *pCParent, DF3Sequence_cls *pCParent2, 
		  DF3SeqGUI_cls *parent, wxWindowID id, wxPoint pos, wxSize size):
TLPanel_cls(parent, id, pos, size)
{
    mpCTimeSliderIcon = new wxIcon(wxT("ICONS/TimeSlider.png"), wxBITMAP_TYPE_PNG);
    mpCTimeSliderIcon->SetWidth(13);
    mpCTimeSliderIcon->SetHeight(18);

    mpCParentGUI = parent;
    mpCDF3SeqCtrl = pCDF3SeqCtrl;
    mpCParent = pCParent;
    mpCParent2 = pCParent2;
    mpPopupMenu = new wxMenu;
    mpPopupMenu->Append(menuItemMemScene, _("Scene Setting"),
			_("Scene Setting"));
    
    mpCMenuPlayRange = new wxMenu;
    mpCMenuPlayRange->AppendCheckItem(menuItemMemRange00, wxT("On Texture"),
				 wxT("Play Mode"));
    mpCMenuPlayRange->AppendCheckItem(menuItemMemRange01, wxT("On Memory XYZ"),
				 wxT("Play Mode"));
    mpCMenuPlayRange->AppendCheckItem(menuItemMemRange02, wxT("On Memory Z"),
				 wxT("Play Mode"));
    mpCMenuPlayRange->AppendCheckItem(menuItemMemRange03, wxT("Full"),
				 wxT("Play Mode"));

    mpPopupMenu->Append(menuItemMemRange, _("Play Range"),
			mpCMenuPlayRange, _("Play Range"));
    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

TLPanelMemory_cls::
~TLPanelMemory_cls(){
    delete mpPopupMenu;
    delete mpCTimeSliderIcon;
}

void TLPanelMemory_cls::
UpdateDisplay(){
    wxPaintEvent com;
    OnPaint(com);
}

void TLPanelMemory_cls::
UpdateDisplay(wxAutoBufferedPaintDC &dc){

    dc.SetBackground(wxBrush(wxColour(216,216,216), wxSOLID));
    dc.Clear();

    SetMemberSize(GetClientSize());

    UpdateTLFrame();

    wxBrush PlayModeBrush(wxColour(216,216,216), wxSOLID);
    
    dc.SetPen(*wxTRANSPARENT_PEN);

    // WorkingArea
    dc.SetBrush(*wxWHITE_BRUSH);
    CalcCoordinateX0X1(mMinFrameWA, mMaxFrameWA-mMinFrameWA, mAAMin, mAAMax);
    dc.DrawRectangle(mX0, 0, mX1-mX0, mHeight - 0);
    dc.SetBrush(*wxWHITE_BRUSH);
    
    dc.SetPen(*wxTRANSPARENT_PEN);
    dc.SetBrush(PlayModeBrush);
    CalcCoordinateX0X1(0, 1, 0, 1);

    switch(mspCTimeLink->mPlayMode){
    case 0:
	dc.DrawRectangle(mX0-2, 1, mX1-mX0+4, 4);
	break;
    case 1:
	dc.DrawRectangle(mX0-2, 8, mX1-mX0+4, 4);
	break;
    case 2:
	dc.DrawRectangle(mX0-2, 14, mX1-mX0+4, 4);
	break;
    }
    
    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    
    int slotNum = mpCDF3SeqCtrl->GetMaxActiveSlot() + 1;
    int lineHight = 6 + 4 * DF3_cls::mspCProperty->mbUse3DTexture;
    if (slotNum == 0) slotNum = 1;

    unsigned int regionMin = mAAMin - 5;
    unsigned int regionMax = mAAMax + 5;
    if (regionMin > mFrameMax) regionMin = 0; //unsigined$B$J$N$G(B0$BL$K~$OL5$$(B
    if (regionMax > mFrameMax) regionMax = mFrameMax;
    regionMin /= mStep; regionMin *= mStep;
    regionMax /= mStep; regionMax *= mStep;

    int step = mStep;
    int stepDensity = (regionMax - regionMin) / mWidth * 2;
    while (step < stepDensity) step *= 2;
    

    dc.SetPen(*wxBLACK_PEN);
    for (unsigned int i = regionMin; i <= regionMax; i += /*mStep*/step){
	CalcCoordinateX0X1(i, /*mStep*/step, mAAMin, mAAMax);
	if (mX1 < 0 || mX0 > GetSize().GetWidth()) continue;
	//if (i > TimeLinePanel_cls::msVBSnippingTag.size()) continue;
	if (TimeLinePanel_cls::msVBSnippingTag[i] == TRUE){
	    dc.DrawRectangle(mX0, 20, mX1-mX0, 2);
	}
    }

    dc.SetPen(*wxGREEN_PEN);
    for (int df3index = 0; df3index < _DF3_MAX_SLOT; df3index++){
	for (unsigned int i = regionMin; i <= regionMax; i += /*mStep*/step){
	    unsigned int index = mpCDF3SeqCtrl->GetPDF3Seq(df3index)->GetRemappedIndex(i);
	    DF3GL_cls *pCDF3 = &mpCDF3SeqCtrl->GetPDF3Seq(df3index)->mVDF3GL[index];
	    CalcCoordinateX0X1(i, /*mStep*/step, mAAMin, mAAMax);
	    if (mX1 < 0 || mX0 > GetSize().GetWidth()) continue;
	    if (pCDF3->IsAllocated()){
		int degree;
		if (pCDF3->mFileType == _DF3_FILETYPE_IMAGE)
		    degree = (pCDF3->mCReadBodyImgSeq.GetPercent()) * lineHight / 100;
		else
		    degree = (pCDF3->mCReadBodyDF3.GetPercent()) * lineHight / 100;
		dc.DrawRectangle(mX0, 20-lineHight*df3index/slotNum- degree/slotNum, mX1-mX0, degree/slotNum + (df3index > 0));
	    }
	}
    }

    dc.SetPen(*wxBLACK_PEN);
    for (unsigned int i = regionMin; i <= regionMax; i += /*mStep*/step){
	unsigned int index = mpCParent->GetRemappedIndex(i);
	DF3GL_cls *pCDF3 = &mpCParent->mVDF3GL[index];
	CalcCoordinateX0X1(i, /*mStep*/step, mAAMin, mAAMax);
	if (mX1 < 0 || mX0 > GetSize().GetWidth()) continue;
	if (pCDF3->IsAllocatedXY()){
	    int degree = (pCDF3->GetConstructPercent()) / 16;
	    dc.DrawRectangle(mX0, 12-degree, mX1-mX0, degree );
	}
    }

    dc.SetPen(*wxRED_PEN);
    for (int df3index = 0; df3index < _DF3_MAX_SLOT; df3index++){
	for (unsigned int i = regionMin; i <= regionMax; i += /*mStep*/step){
	    unsigned int index = mpCDF3SeqCtrl->GetPDF3Seq(df3index)->GetRemappedIndex(i);
	    DF3GL_cls *pCDF3 = &mpCDF3SeqCtrl->GetPDF3Seq(df3index)->mVDF3GL[index];
	    CalcCoordinateX0X1(i, /*mStep*/step, mAAMin, mAAMax);
	    if (mX1 < 0 || mX0 > GetSize().GetWidth()) continue;
	    if (pCDF3->IsTexObjectGenFinished() == TRUE){
		int degree = (pCDF3->GetTextureBindPercent()) * lineHight / 100;
		dc.DrawRectangle(mX0, 10-lineHight*df3index/slotNum- degree/slotNum, mX1-mX0, degree/slotNum + (df3index > 0));
	    }
	}
    }
    
    //dc.SetPen(*wxRED_PEN);
    
    dc.DrawRectangle(mXCurrent, 0, 1, mHeight);

   
    /*
    if (mpCParent->GetpDF3()->GetFilePathStr() != ""){
	SplitPath_cls CCurrent(mpCParent->GetpDF3()->GetFilePathStr());
	mpCParent->mpCCurrentFile->SetLabel(wxT(" Current: ") + wxString::FromAscii(CCurrent.msFilename.c_str()));
    }
    */
    
    wxString Mes;
    dc.SetTextForeground(*wxRED);
    /*
    Mes << mpCParent->mTexMemoryMB << wxT("MB"); 
    
    dc.DrawText(Mes, mX0 + 15 + offset, 5);

    dc.SetTextForeground(*wxBLACK);
    Mes = wxT("/ ");
    Mes << mpCParent->mXYZMemoryMB << wxT("MB ");
    Mes << mpCParent->mOldIndexTex << wxT(" : ") << mpCParent->mOldIndexXYZ;
    Mes << wxT(" : ");
    Mes << mpCParent->mOldPointMaxTex << wxT(" : ") << mpCParent->mOldPointMaxXYZ;

    //Mes << wxT(":") << mpCParent->mpCPanelPath->mpCCameraPath->mCurrentDoubleIndex;
    */

    CalcCoordinateX0X1(mMinFrameWA, mMaxFrameWA-mMinFrameWA, mAAMin, mAAMax);
    DrawRegionSliderX0X1(dc);

    if (mSelected == _TL_SEL_SLIDER)
	dc.DrawIcon(*mpCTimeSliderIcon, mXDragging-6, 2);
    else
	dc.DrawIcon(*mpCTimeSliderIcon, mXCurrent-6, 2);
    
    int offset = 0;
    if (mPosCurrent > mWidth * 0.7) offset = -40;

    if (mbCaptureMouse == TRUE && 
	(mSelected == _TL_SEL_MIN || mSelected == _TL_SEL_MAX ||
	 mSelected == _TL_SEL_SLIDER)){
	wxString Mes;
	dc.SetFont(*wxSMALL_FONT);
	dc.SetTextForeground(*wxRED);
	Mes << mFrameInSlider; 
	dc.DrawText(Mes, mPosCurrent + 15 + offset, 0);
    }
}

void TLPanelMemory_cls::
OnPaint(wxPaintEvent& event){
    wxAutoBufferedPaintDC dc(this);
    UpdateDisplay(dc);
    event.Skip();
}

void TLPanelMemory_cls::
UpdateMenu(){
    for (int i = _TIME_CTRL_PLAY_TEX; i <= _TIME_CTRL_PLAY_FULL; i++)
	if (mspCTimeLink->mPlayMode == i)
	    mpPopupMenu->Check(menuItemMemRange00+i, TRUE);
	else
	    mpPopupMenu->Check(menuItemMemRange00+i, FALSE);
}

void TLPanelMemory_cls::
OnMenuScene(wxCommandEvent& event){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemScene);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void TLPanelMemory_cls::
OnMenuPlayMode(wxCommandEvent& event){
    for (int i = _TIME_CTRL_PLAY_TEX; i <= _TIME_CTRL_PLAY_FULL; i++)
	if (i != mspCTimeLink->mPlayMode && 
	    mpPopupMenu->IsChecked(menuItemMemRange00+i) == TRUE){
	    mspCTimeLink->mPlayMode = i;
	    Refresh(TRUE);
	    break;
	}
}

void TLPanelMemory_cls::
OnMouse(wxMouseEvent& event){
    if (event.ButtonDown(wxMOUSE_BTN_RIGHT)){
	UpdateMenu();
#ifdef WIN32
	PopupMenu(mpPopupMenu);
#else
	PopupMenu(mpPopupMenu, event.GetX(), event.GetY());
#endif
    }

    // ---

    SetRange(mAAMin, mAAMax);
    mpCRegionTgtMin = &mspCTimeLink->mCWAMin.mBody;
    mpCRegionTgtMax = &mspCTimeLink->mCWAMax.mBody;
    SetInitRegion(event, *mpCRegionTgtMin, *mpCRegionTgtMax);
    
    ProcMouseEventBase(event);

    if (event.ButtonDown(wxMOUSE_BTN_LEFT) &&
	(mSelected == _TL_SEL_REGION || mSelected == 0))
	mpCParentGUI->DeactivateAllPanel(!event.m_shiftDown);
    
    event.Skip(); 
}
