// "clsMemoryPanel.h"

#include "clsTLPanelTics.h"
#include "../clsDF3Sequence.h"
#include "../../PARAMETER/clsTimeLinePanel.h"

#include "../../../wxWidgetEnum.h"

#include <wx/dcbuffer.h>

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#define X 0
#define Y 1
#define Z 2

TLPanelTics_cls::
TLPanelTics_cls(/*DF3Sequence_cls *pParent,*/ wxWindow *parent, wxWindowID id, wxPoint pos, wxSize size):
    TLPanel_cls(/*pParent,*/ parent, id, pos, size)
{
    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

TLPanelTics_cls::
~TLPanelTics_cls(){
}

void TLPanelTics_cls::
UpdateDisplay(){
   
    wxAutoBufferedPaintDC dc(this);
    
    dc.SetBackground(wxBrush(wxColour(216, 216, 216), wxSOLID));
    dc.Clear();

    SetMemberSize(GetClientSize());

    UpdateTLFrame();

    //dc.SetBrush(*wxTRANSPARENT_BRUSH);

    unsigned int regionMin = mAAMin - 5;
    unsigned int regionMax = mAAMax + 5;
    if (regionMin > mFrameMax) regionMin = 0; //unsigined$B$J$N$G(B0$BL$K~$OL5$$(B
    if (regionMax > mFrameMax) regionMax = mFrameMax;
    regionMin /= mStep; regionMin *= mStep;
    regionMax /= mStep; regionMax *= mStep;

    int AAWidth = mAAMax - mAAMin;
    int stepLarge = 1;
    if (AAWidth > 20)   stepLarge = 2;
    if (AAWidth > 50)   stepLarge = 5;
    if (AAWidth > 100)  stepLarge = 10;
    if (AAWidth > 200)  stepLarge = 20; 
    if (AAWidth > 500)  stepLarge = 50; 
    if (AAWidth > 1000) stepLarge = 100; 
    if (AAWidth > 2000)	stepLarge = 200; 
    if (AAWidth > 5000) stepLarge = 500; 
    int stepMiddle = stepLarge / 2;
    int stepSmall = stepLarge / 10; 
    if (stepLarge == 5) stepMiddle = 5;
    if (stepSmall == 0) stepSmall = 1;
    if (stepMiddle == 0) stepMiddle = 1;

    dc.SetFont(*wxSMALL_FONT);
    dc.SetPen(wxColour(128, 128, 128));
    dc.SetTextForeground(wxColour(128, 128, 128));
    for (unsigned int i = regionMin; i <= regionMax; i++){
	CalcCoordinateX0X1(i, mStep, mAAMin, mAAMax);
	if (i % stepSmall != 0) continue;
	if (mX1 < 0 || mX0 > GetSize().GetWidth()) continue;
	if (i % stepMiddle == 0) 
	    dc.SetPen(wxColour(32, 32, 32));
	else
	    dc.SetPen(wxColour(128, 128, 128));
	if (i % stepLarge == 0){
	    wxString Mes;
	    Mes << i;
	    dc.DrawText(Mes, mX0+2, +7);
	    dc.DrawRectangle(mX0, mHeight-6, 1, 6);
	    continue;
	}
	dc.DrawRectangle(mX0, mHeight-3, 1, 3);
    }
   
    dc.SetPen(*wxRED_PEN);
    CalcCoordinateX0X1(mCurrentFrame, 0, mAAMin, mAAMax);
    dc.DrawRectangle(mX0, 0, 1, mHeight);
}
