// -*- c -*- 
// "clsAxisXYZSTU.h"

#include "clsAxisXYZSTU.h"

#define X 0
#define Y 1
#define Z 2

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

AxisXYZSTU_cls::
AxisXYZSTU_cls(){
    LOOP_XYZ mTrueSize[xyz] = 0;
    LOOP_XYZ mCurrSize[xyz] = 0;
}

unsigned int AxisXYZSTU_cls::
GetSAxis(unsigned int axis){
    unsigned int retval = 0;
    switch(axis){
    case Z: retval = X; break;
    case X: retval = Y; break;
    case Y: retval = X; break; }
    return retval;
}

unsigned int AxisXYZSTU_cls::
GetTAxis(unsigned int axis){
    unsigned int retval = 0;
    switch(axis){
    case Z: retval = Y; break;
    case X: retval = Z; break;
    case Y: retval = Z; break; }
    return retval;
}

unsigned int AxisXYZSTU_cls::
GetCurrSize(unsigned int axis){
    return mCurrSize[axis];
}

unsigned int AxisXYZSTU_cls::
GetCurrSizeS(unsigned int axis){
    return GetCurrSize(GetSAxis(axis));
}

unsigned int AxisXYZSTU_cls::
GetCurrSizeT(unsigned int axis){
    return GetCurrSize(GetTAxis(axis));
}

unsigned int AxisXYZSTU_cls::
GetCurrSizeSxT(unsigned int axis){
    return GetCurrSizeS(axis) * GetCurrSizeT(axis);
}

unsigned int AxisXYZSTU_cls::
GetIndex(unsigned int x, unsigned int y, unsigned int z){
    return mCurrSize[X] * (mCurrSize[Y] * z + y) + x;
}

unsigned long AxisXYZSTU_cls::
GetCurrentTotalSize(){
    unsigned long long size = mCurrSize[X] * mCurrSize[Y] * mCurrSize[Z];
    return size;
}

unsigned long AxisXYZSTU_cls::
GetTrueTotalSize(){
    unsigned long long size = mTrueSize[X] * mTrueSize[Y] * mTrueSize[Z];
    return size;
}

// ---

unsigned int AxisXYZSTU_cls::
GetTrueSize(unsigned int axis){
    return mTrueSize[axis];
}

unsigned int AxisXYZSTU_cls::
GetTrueSizeS(unsigned int axis){
    return GetTrueSize(GetSAxis(axis));
}

unsigned int AxisXYZSTU_cls::
GetTrueSizeT(unsigned int axis){
    return GetTrueSize(GetTAxis(axis));
}

unsigned int AxisXYZSTU_cls::
GetTrueSizeSxT(unsigned int axis){
    return GetTrueSizeS(axis) * GetTrueSizeT(axis);
}
