// "clsDF3.cpp"

#ifndef _DF3_H_
#define _DF3_H_

#include <string>

#include "wx/wx.h"
#include "wx/thread.h"
#include "clsResumableProgress.h"
#include "clsAxisXYZSTU.h"
#include "clsLevelMap.h"

#include "FILEIO/clsReadBodyDF3.h"
#include "FILEIO/clsReadBodyImgSeq.h"

class DF3Sequence_cls; 
class DF3_cls; 

class LevelMap_cls; 
class PreviewProperty_cls;
class Preference_cls;

#define _DF3_ENABLE_RESUME FALSE 
#define _DF3_FORCE_FINISH  TRUE

#define _DF3_FILETYPE_DF3   0
#define _DF3_FILETYPE_IMAGE 1

class ConstructXY_cls : public ResumableProgress_cls{
 public:
    DF3_cls *mpC;
    // $B=i4|CM$H$7$F(BDF3_cls$B%3%s%9%H%i%/%?Fb$N(Bthis$B$O4m81$J$N$G!"(B
    // DF3Sequence_cls$B$N%3%s%9%H%i%/%?$GBeF~$7$F$$$k(B
};

class DF3_cls : public AxisXYZSTU_cls {
 public:
    DF3_cls(DF3Sequence_cls* pCParent);
    ~DF3_cls();

 public:
    unsigned int mSelfIndex;
    unsigned int mFileType;
    void         SetSelfIndex(unsigned int index);
    unsigned int GetSelfIndex();
    DF3_cls      *mpCNextDF3;
    
    unsigned char *mpMainXYZ[3];
    unsigned char *mpProcessedXYZ[3];
    static bool msbUseProcessedXYZ;
    static PreviewProperty_cls *mspCProperty;
    
    void Allocate();
    void AllocateXY();
    void FakeRelease();
    void Release();
    void ReleaseXY();

    bool IsAllocated();
    bool IsAllocatedXY();
  
    void Clean();
    bool IsDirty();
    bool IsReadFinished();
    bool IsFileChanged();
    void SetFileChangedTag();

    void SetFilePath(wxString strFilePath, wxString strFilePathFormat,
		     int channel);
    wxString   GetFilePathWXStr();
    wxString   GetFilePathFormat();
 private:
    wxString   mwsFilePath, mwsFilePathFormat;
    wxString   mwsFilePathLoaded;
    //int  mChannel;
    
 public:
    bool ProcessXYZData();

    ConstructXY_cls mCConstructXY[2];
    bool ConstructXYAxisData(bool type);
    bool mbConstructType; // for theread;
    bool IsXYConstructFinished();
    bool IsXYFinishConditionSatisfied(); 
    int  GetConstructPercent();
    
    unsigned int GetAllocatedXYKB();
    unsigned int GetAllocatedXYZKB();
    
    bool ReadHeader(wxWindow *pCWindow);
    bool ReadBodyIfNotFinished (bool type, wxWindow *pCWindow);
    ReadBodyDF3_cls mCReadBodyDF3;
    ReadBodyImgSeq_cls mCReadBodyImgSeq;
    bool ExportDF3(wxString strFilename, bool bMirroring[3]);
    bool ExportIMGSeq(FileSequenceWX_cls CFileSequence, wxStatusBar *pCStatusBar);

 public:
    DF3Sequence_cls* mpCParent;
    
 private:
    bool mbAllocatedXYAxis;
    bool mbAllocated;
    bool mbAllocatedProcessed;
    int  mAllocatedSize;
    
 public:
    bool mbProcessFinished;
    bool mbDirty;
    bool mbValid;

 public:
    unsigned int mOldPointXYZ;
    LevelMap_cls mCLevelMap;
};

class ThreadConstructX_cls : public wxThread{
 public:

    ThreadConstructX_cls(DF3_cls *pC, int axis);

    virtual ExitCode Entry();
    //virtual void OnExit();

    DF3_cls* mpC;
    int      mAxis;
};

class ThreadReader_cls : public wxThread{
 public:
    
    ThreadReader_cls(DF3_cls *pC);
    
    //virtual ExitCode Entry();
    virtual void *Entry();
    virtual void OnExit();

    DF3_cls* mpC;
};

#endif
