// "clsDF3SeqCtrl.cpp"
// (setq c-basic-offset 4)

#ifndef _DF3_SEQ_CTRL_H_
#define _DF3_SEQ_CTRL_H_

#include "clsDF3Sequence.h"

class CameraPath_cls;
class DF3SeqGUI_cls;
class DrawingBlock_cls;
class FilterBase_cls;
class FilterGUI_cls;
class FilterCtrl_cls;
class FilterData_cls;
class TimeCtrl_cls;
class TreeBoxRule_cls;

class wxWindow;
class wxGLContext;
class wxGLCanvas;

#include <vector>
#include <wx/wx.h>

#include "../../GlobalConstants.h"
//#define _DF3_MAX_SLOT 4
// f[^PƂ̖cŉ0gĂƂB
#define _DF3_SLOT_0_FIX_ME 0
// \ƂăXbg0gƊm̏ꍇ
#define _DF3_SLOT_0 0

#define _DF3INDEX_ALL -1
#define _DF3_TIMEINDEX_EACH -1

#define _CHECK_ALL 0
#define _CHECK_VOLUME_ONLY 1

class DF3SeqCtrl_cls{
public:
    DF3SeqCtrl_cls(wxWindow *pCParentWindow,
		   CameraPath_cls *pCPath, 
		   TimeCtrl_cls *pCTime);
    ~DF3SeqCtrl_cls();

    wxWindow *mpCParentWindow;
    DF3SeqGUI_cls *mpCGUI;
    DF3Sequence_cls *mpCDF3Seq[_DF3_MAX_SLOT];
    static DF3SeqCtrl_cls *mspCThis;
    static TimeCtrl_cls *mspCTimeLink;
    static TreeBoxRule_cls *mspCTreeBoxRuleLink;

    Parameters_cls mCBaseAlpha;

    ConfItemINT_cls mCConfActiveSlot;

    unsigned int mTexMemoryMB, mXYMemoryMB, mXYZMemoryMB;

    ConfItemList_cls mCConfListRender;
    ConfItemUINT_cls mCCritTexMemoryMB;
    ConfItemUINT_cls mCCritXYMemoryMB;
    ConfItemUINT_cls mCCritXYZMemoryMB;

    ConfItemList_cls mCConfListScene;
    ConfItemINT_cls  mCAppendType;

    bool mbPreFetch, mbQuickShow;
    int  mPrefetchMin, mPrefetchMax;
    bool mAbShow[3];

    CheckTreeFile_cls* GetPCheckTreeFile();
    std::vector < CheckTreeFile_cls > mVCCheckTreeFile;
    
    DF3Sequence_cls *GetPDF3Seq(unsigned int index/* = 0*/);
    DF3Sequence_cls *GetPDF3SeqActive();
    FilterCtrl_cls* GetPFilterCtrl(unsigned int index);
    FilterCtrl_cls* GetPFilterCtrlActive();
    FilterBase_cls* GetPFilterFromTag(wxString strTag);
    DF3_cls* GetPDF3Active();
    void GetClippingInformation(double scaleMin[3], double scaleMax[3],
				wxString targetStr, wxString strTagActivated);
    int  GetMaxActiveSlot();
    void ClearFilterAll();
    void ClearAlreadyOutputtedTagAll();
    void ReleaseAllDF3Seq(int flagBit = _DF3SEQ_ALL, 
			  bool bFakePermitted = TRUE);
    void ReleaseStepDF3(int df3index, int index, 
			int flagBit = _DF3SEQ_ALL, bool bFakePermitted = TRUE);
    void ClearTreeInfo(int timeIndex);
    bool IsReprocessRequired(int df3index, int type = _CHECK_ALL);
    bool ProcessXYZDataAllChannel();
    //void UpdateFilterHideAndShowAll();
    void UpdateFilterParametersAll(double doubleIndex);
    void UpdateFilterPanelListAll();
    void UpdateFilterTargetsAll();
    void UpdateFilterColorsAll();
    void UpdateFilterColorBarAll();

    unsigned int GetCurrentSizeOf1Data(int axis, int index = 0);

    bool IsAllDataDF3();
    bool DoesFilterExistInAllDF3(int type);
    bool DoesSameFilterNameExistInAllDF3(wxString strTag,
					 FilterBase_cls *pCException);
    bool DoesVolumeBoxRequiredAll();
    double GetFogInfoAll(float fogColor[3], wxString strTag);
    FilterData_cls* GetFirstPFilterDataInAllDF3(int type);

    // --

    unsigned int GetCurrentFrame();
    unsigned int GetMaxFrame();
    unsigned int GetRemappedIndex(int df3index, int frame = _TIME_CTRL_CURRENT);
    double GetRemappedIndexDouble(int df3index, int frame = _TIME_CTRL_CURRENT);
    long unsigned int GetCurrentTotalSizeAllChannel();
    std::vector < wxString > GetCurrentFWXStrAllChannel();
    unsigned int GetTexMemoryFor1StepAllChannelMB();
    void CalcPrefetchRange(unsigned int memoryFor1StepMB);
    void CalcCurrentUsedMemory();

    bool IsPlayTexConditionSatisfied(unsigned int step);
    bool PlayTex();
    void StopPlayTex();
    int  CheckUpdate();
    bool IdleProcessesMainEach(int df3index,
			       unsigned int timeIndex, bool type,
			       bool bSkipTextureProcess = FALSE);
    bool IdleProcessesMainAll(int timeIndex, bool type,
			      bool bSkipTextureProcess = FALSE);
    bool IdleProcessesFetch();
    bool IdleProcessesRelease(int df3index, bool type);
    void SetFileChangedTagAllChannel();

    // --

    // --- ݉Bp Adhoc ȋ@\Q
    void SetDF3GLVector(int timeIndex, int df3index);
    // --- ݉Bp Adhoc ȋ@\Q RR܂

    void DrawDataInitSetting();
    void DrawDataEndSetting();
    void DrawDataSlot(PositionAndDirection_cls CCam, 
		      double boxScaleX, double boxScaleY, double boxScaleZ,
		      unsigned int axis, bool bMirror[3],
		      double clipBoxMin[3], double clipBoxMax[3],
		      double *pShadeOffset);
    void DrawItems(double center[3], double scale[3]);
    void DrawObject(double scale, bool bPositiveObject, bool bNegativeObject);
    int  GetMaxColorLayerNum();
    void SetRGBAtoGLAllChannel(unsigned int cindex);

    // --
    
    static void DeselectAllFilter();
    static FilterGUI_cls *GetPFilterGUI(void *pArg);
    
    // --

    wxString GetPovStrColorMapsAllDF3();

    wxString GetPovStrFog();
    wxString GetPovStrGlobalObject
	(wxString strTag, PositionAndDirection_cls CCamGlobalCoord,
	 std::vector < wxString > VstrFilePath);
    void GetPovStrDensityBox
	(std::wfstream &ofstream,
	 wxString strTag, std::vector < wxString > VstrFilePath,
	 wxString strGeometry, DrawingBlock_cls *pCDrawingBlock,
	 PositionAndDirection_cls CCamLocalCoord, int frame);
    wxString GetPovStrPolygonObject
	(std::vector < DrawingBlock_cls > &VCDrawingCls);

    // --

    void ReadStrLineAllDF3Sequence(std::wistream &istream, std::wstring strLine);
    wxString SerializeAllDF3Sequence();
    

    void ReadStrLineRenderParam(std::wstring strLine);
    wxString SerializeRenderParam();
    void ReadStrLineSceneConf(std::wstring strLine);
    wxString SerializeSceneConf();
};

#endif
