// -*- c -*- 
// "clsDF3SeqGUI.h"
// "../../wxWidgetEnum.h"
// (setq c-basic-offset 4)

#include "clsDF3SeqGUI.h"
#include "clsDF3SeqCtrl.h"
#include "clsDF3Sequence.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"
#include "../../clsCameraPath.h"
#include "../../clsTimeCtrl.h"
#include "../FILTER/clsClipping.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../PARAMETER/clsParametersPanel.h"
#include "../PARAMETER/clsTimeLinePanel.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsSliderEX.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../WIDGETCTRL/clsAtoiTextCtrl.h"
#include "../POVRAY/clsPovRay.h"
#include "../POVRAY/clsStereoGram.h"
#include "../../clsDrawingBox.h"

#include "../MYAPI/MsgBox.h"

#include <wx/tglbtn.h>

#include "TL/clsTLPanelMemory.h"
#include "TL/clsTLPanelTics.h"
#include "TL/clsTLPanelAA.h"

#define LOOP_XYZ for(int xyz = 0; xyz < 3; xyz++)

#ifdef WIN32
#define _LEFT_WIDTH 69
#define _ZOOM_WIDTH 34
#else
#define _LEFT_WIDTH 73
#define _ZOOM_WIDTH 36
#endif

// ----------------------------------------------

// ÓIɃCxgт
BEGIN_EVENT_TABLE(DF3SeqGUI_cls, wxPanel)
EVT_PAINT(DF3SeqGUI_cls::OnPaint)
EVT_SIZE(DF3SeqGUI_cls::OnSize)
EVT_KEY_DOWN(DF3SeqGUI_cls::OnKeyDown)
END_EVENT_TABLE()

DF3SeqGUI_cls::DF3SeqGUI_cls
(CameraPath_cls *pCPath,
 DF3SeqCtrl_cls *pCParentCtrl, TimeCtrl_cls *pCTime,
 wxWindow *pC, wxPoint pos, wxSize size) :
wxPanel(pC, wxID_ANY, pos, size)
{
    mspCTimeLink = pCTime;
    
    wxBoxSizer *pBoxSizerBase = new wxBoxSizer(wxHORIZONTAL);

    int flags = wxEXPAND | wxALIGN_CENTER_VERTICAL;
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);

    // -----
    msCBitmapZoomOut = wxBitmap(wxT("ICONS/ZoomOut.png"),wxBITMAP_TYPE_PNG);
    msCBitmapZoomIn  = wxBitmap(wxT("ICONS/ZoomIn.png"),wxBITMAP_TYPE_PNG);
    // ----

    wxBoxSizer *pBoxSizerWA = new wxBoxSizer(wxHORIZONTAL);
    mpCBPanelZoomOut = new BitmapPanel_cls(this, buttonCtrlZoomOut, wxDefaultPosition, wxSize(_ZOOM_WIDTH, 12));
    mpCBPanelZoomIn = new BitmapPanel_cls(this, buttonCtrlZoomIn, wxDefaultPosition, wxSize(_ZOOM_WIDTH + 1, 12));
    mpCBPanelZoomOut->AddBitmapP(&msCBitmapZoomOut);
    mpCBPanelZoomIn ->AddBitmapP(&msCBitmapZoomIn);
    mpCBPanelZoomOut->SetOffset(1, 1);
    mpCBPanelZoomIn->SetOffset(1, 1);
    mpCBPanelZoomIn->SetToolTip(wxT("Zoom In"));
    mpCBPanelZoomOut->SetToolTip(wxT("Zoom Out"));

    Connect(buttonCtrlZoomOut, wxEVT_LEFT_UP,
	    wxMouseEventHandler(DF3SeqGUI_cls::OnZoomOut));
    Connect(buttonCtrlZoomOut, wxEVT_LEFT_DCLICK,
	    wxMouseEventHandler(DF3SeqGUI_cls::OnZoomOut));
    Connect(buttonCtrlZoomIn, wxEVT_LEFT_UP,
	    wxMouseEventHandler(DF3SeqGUI_cls::OnZoomIn));
    Connect(buttonCtrlZoomIn, wxEVT_LEFT_DCLICK,
	    wxMouseEventHandler(DF3SeqGUI_cls::OnZoomIn));
    mpCBPanelZoomOut->SetKeyEventSkipTarget(_WIDGETEX_DIRECTPARENT);
    mpCBPanelZoomIn->SetKeyEventSkipTarget(_WIDGETEX_DIRECTPARENT);
    
    mpCTLPanelAA  = new TLPanelAA_cls
	(this, wxID_ANY, wxDefaultPosition, wxSize(-1, 12));
    pBoxSizerWA->Add(mpCBPanelZoomOut,  0, flags);
    pBoxSizerWA->Add(mpCBPanelZoomIn,  0, flags);
    pBoxSizerWA->Add(mpCTLPanelAA, 1, 0);
    Connect(mpCTLPanelAA->GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(DF3SeqGUI_cls::OnKeyDown));
    
    ParametersPanel_cls::mspCDF3SeqGUILink = this;
    ParametersPanel_cls::mspCTimeLink = pCTime;
    
    mpCPanelList = new ParametersPanelList_cls(this);
    
    mspCTimeLink->mCTimeRemap.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&mspCTimeLink->mCTimeRemap, wxT("[Time Remap]"));

    pCPath->mCPosition.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&pCPath->mCPosition, wxT("[Cam XYZ]"));

    pCPath->mCRotYPR.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&pCPath->mCRotYPR, wxT("[Cam YPR]"));

    pCPath->mCAncPos.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&pCPath->mCAncPos,
		      wxT("[Anc XYZ]"));

    pCPath->mpCStereoGramLinked->mCDistanceOfEyes.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&pCPath->mpCStereoGramLinked->mCDistanceOfEyes,
		      wxT("[Parallax]"));

    DrawingBlock_cls::mspCBoxSize->mCbShow.mbBody = FALSE;
    mpCPanelList->Add(DrawingBlock_cls::mspCBoxSize, wxT("[Box Size]"));

    DrawingBlock_cls::mspCRotate->mCbShow.mbBody = FALSE;
    mpCPanelList->Add(DrawingBlock_cls::mspCRotate, wxT("[Box Rotate]"));

    pCParentCtrl->mCBaseAlpha.mCbShow.mbBody = FALSE;
    mpCPanelList->Add(&pCParentCtrl->mCBaseAlpha, wxT("[Alpha]"));
    
    //!!Master-Slave֌W̕sTOPҏWKvȎ̂ݎgBDEBUGp
    /*
    pCPath->mCTop.mCbShow.mbBody = TRUE;
    mpCPanelList->Add(&pCPath->mCTop, wxT("[Cam TOP]"));
    */
    
    wxString dummy[1] = {wxT("dummy")};
    wxBoxSizer *pBoxSizerHMemory = new wxBoxSizer(wxHORIZONTAL);
    mpCComboVisible = new wxComboBox(this, wxID_ANY, wxT("Panel"), wxDefaultPosition, wxSize(_LEFT_WIDTH, 22), 
				     1, dummy, wxCB_DROPDOWN); 
    Connect(mpCComboVisible->GetId(), wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(DF3SeqGUI_cls::OnComboBoxVis));
    mpCComboVisible->SetToolTip(_("Show Item on Time Line"));

    mpCPanelMem  = new TLPanelMemory_cls
	(pCParentCtrl, pCParentCtrl->GetPDF3Seq(0), pCParentCtrl->GetPDF3Seq(1),
	 this, wxID_ANY, wxDefaultPosition, wxSize(-1, 22));
    Connect(mpCPanelMem->GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(DF3SeqGUI_cls::OnActivatePanel));

    pBoxSizerHMemory->Add(mpCComboVisible, 0, 0);
    pBoxSizerHMemory->Add(mpCPanelMem, 1, 0);
    mpCPanelMem->Connect(mpCPanelMem->GetId(),
			 wxEVT_KEY_DOWN,
			 wxKeyEventHandler(DF3SeqGUI_cls::OnKeyDown));
			 
    wxBoxSizer *pBoxSizerHSlider = new wxBoxSizer(wxHORIZONTAL);
    //wxBoxSizer *pBoxSizerVSlider = new wxBoxSizer(wxVERTICAL);

    mpCCurrentIndex = new AtoiTextCtrl_cls(this, wxID_ANY, 0, 
					   wxDefaultPosition, wxSize(_ZOOM_WIDTH + 1, -1));
    mpCCurrentIndex->SetToolTip(_("Scene Length Tip"));

    mpCMaxLength = new AtoiTextCtrl_cls(this, wxID_ANY, 99,
					wxDefaultPosition, wxSize(_ZOOM_WIDTH, -1));
    mpCMaxLength->Disable();
				    
    mpCCurrentIndex->mbReturnForTab = FALSE;
    Connect(mpCCurrentIndex->GetId(), wxEVT_CHAR, 
	    wxKeyEventHandler(DF3SeqGUI_cls::OnCurrentIndex));
    

    mpCTLPanelTics = new TLPanelTics_cls
	(this, wxID_ANY, wxDefaultPosition, wxSize(-1, 12));

    pBoxSizerHSlider->Add(mpCCurrentIndex, 0, 0);
    pBoxSizerHSlider->Add(mpCMaxLength, 0, 0);
    pBoxSizerHSlider->Add(mpCTLPanelTics, 1, wxEXPAND);

      
    pBoxSizerSrc->Add(pBoxSizerWA, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHSlider, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHMemory, 0, wxEXPAND);
    
    mpCPanelList->UpdatePanelLayout();
    pBoxSizerSrc->Add(mpCPanelList, 1, wxEXPAND);

    ConnectMouseEvent();

    //#ifdef WIN32    
    mpCScroll = new wxScrolledWindow
	(this, wxID_ANY, wxDefaultPosition, wxSize(17, -1), 
	 wxVSCROLL | wxALWAYS_SHOW_SB);
    mpCScroll->SetTargetWindow(mpCPanelList);
    mpCScroll->SetScrollbars(0, 1, 0, 48);
    //#else
    //SetScrollbars(0,5,0,50);
    //#endif

    pBoxSizerBase->Add(pBoxSizerSrc, 1, wxEXPAND);
    //#ifdef WIN32
    pBoxSizerBase->Add(mpCScroll, 0, wxEXPAND);
    //#endif

    SetSizerAndFit(pBoxSizerBase);
    //SetSizerAndFit(pBoxSizerSrc);

    // ͂ƈʉI
    mVListSelectable.push_back(wxT("[Light]*"));
    mVListSelectable.push_back(wxT("[HSpot]*"));
    mVListSelectable.push_back(wxT("[Anc XYZ]"));
    mVListSelectable.push_back(wxT("[Cam XYZ]"));
    mVListSelectable.push_back(wxT("[Cam YPR]"));
    mVListSelectable.push_back(wxT("[Box Size]"));
    mVListSelectable.push_back(wxT("[Box Rotate]"));
    mVListSelectable.push_back(wxString::Format(_T("%s*"), _("Clipping")));
    mVListSelectable.push_back(wxString::Format(_T("%s*"), _("Density Curve")));
    mVListSelectable.push_back(wxString::Format(_T("%s*"), _("Object")));
    mVListSelectable.push_back(wxString::Format(_T("%s*"), _("DiffObject")));
    
    mUpdateLevel = 0;

    
}

DF3SeqGUI_cls::
~DF3SeqGUI_cls(){
    FilterBase_cls::mspCDF3SeqGUI = NULL;
}

void DF3SeqGUI_cls::
UpdatePanelLayout(){
    int viewx, viewy;
    Freeze();
    mpCScroll->GetViewStart(&viewx, &viewy);
    mpCScroll->Scroll(0, 0);
    mpCPanelList->UpdatePanelLayout();
    mpCScroll->Scroll(viewx, viewy);
    Thaw();

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemDF3GUIChanged);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void DF3SeqGUI_cls::
UpdatePanelsBitmapState(){
    for (unsigned int i = 0; i < mpCPanelList->mVPParameterPanel.size(); i++)
	mpCPanelList->GetPPanel(i)->UpdatePanelBitmapState();
    UpdateItemsVisivility();
}

void DF3SeqGUI_cls::
UpdateDisplay(bool bUpdateParent){
    mpCCurrentIndex->SetValueInt(mspCTimeLink->mFrame);
    mpCMaxLength->SetValueInt(mspCTimeLink->mCMaxFrame.mBody);
    
    mspCTimeLink->EmptySnippingTag();
    mpCPanelList->SetSnippingTag(TimeLinePanel_cls::msVBSnippingTag, 
				 mspCTimeLink->mCMaxFrame.mBody);
    TimeLinePanel_cls::msVBSnippingTag[mspCTimeLink->mFrame] = TRUE;
    mpCPanelList->UpdateDisplay();
  
    mpCPanelMem->Refresh(FALSE);
    mpCTLPanelTics->Refresh(FALSE);
    mpCTLPanelAA->Refresh(TRUE);

    mpCComboVisible->SetValue(wxT("Panel"));

    // RefreshñCxg𔭐̂́A
    // OnPaintsƂ΂AUpdateParent̎̂
    if (bUpdateParent){
	mUpdateLevel = 1;
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	wxGetTopLevelParent(this)->AddPendingEvent(com);
    }
}

bool DF3SeqGUI_cls::
IsPanelActive(wxString strTag){
    return mpCPanelList->IsActive(strTag);
}

void DF3SeqGUI_cls::
ConnectMouseEvent(){
    for (unsigned int i = 0; i < mpCPanelList->mVPParameterPanel.size(); i++){
	Connect(mpCPanelList->GetItemId(i),
		wxEVT_LEFT_DOWN,
		wxMouseEventHandler(DF3SeqGUI_cls::OnActivatePanel));
	Connect(mpCPanelList->GetItemId(i),
		wxEVT_RIGHT_DOWN,
		wxMouseEventHandler(DF3SeqGUI_cls::OnActivatePanel));
    }
}

// --------

void DF3SeqGUI_cls::
OnPaint(wxPaintEvent& event){
    UpdateDisplay();
    event.Skip();
}

// -------

void DF3SeqGUI_cls::
UpdateItemsVisivility(){
    mpCComboVisible->Clear();
    std::vector < wxString > invisibleItems = 
	mpCPanelList->GetInvisibleItems();
    for (unsigned int i = 0; i < invisibleItems.size(); i++)
	mpCComboVisible->Append(invisibleItems[i]);
    if (mpCComboVisible->GetCount() == 0)
	mpCComboVisible->Append(wxT("Panel"));

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemDF3GUIChanged);
    wxGetTopLevelParent(this)->AddPendingEvent(com);

    //RechckSize();
}

void DF3SeqGUI_cls::
ShowAllTimeDependentItems(){
    mpCPanelList->ShowAllTimeDependentItems();
    wxSizeEvent dummy;
    AddPendingEvent(dummy);

    UpdateItemsVisivility();

    if (GetClientSize().GetHeight() < GetBestSize().GetHeight()){
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	wxGetTopLevelParent(this)->AddPendingEvent(dummy);
    }
}

void DF3SeqGUI_cls::
SetPanelVis(wxString strVis){
    mpCComboVisible->SetValue(strVis);
    wxCommandEvent dummy;
    OnComboBoxVis(dummy);
}

void DF3SeqGUI_cls::
OnComboBoxVis(wxCommandEvent& event){
    ShowItem(mpCComboVisible->GetValue());
}

void DF3SeqGUI_cls::
ShowItem(wxString strItem, bool bShow){
    ParametersPanel_cls* pPanel = mpCPanelList->GetPPanel(strItem);
    if (pPanel != NULL){
	pPanel->Show(bShow);
	wxSizeEvent dummy;
	AddPendingEvent(dummy);
    }

    UpdatePanelLayout();
    UpdateItemsVisivility();

    if (GetClientSize().GetHeight() < GetBestSize().GetHeight()){
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	wxGetTopLevelParent(this)->AddPendingEvent(dummy);
    }
}

void DF3SeqGUI_cls::
RechckSize(){
    //int viewx, viewy;
    //mpCScroll->GetViewStart(&viewx, &viewy);
    int height = mpCPanelList->GetBestSize().GetHeight();    
    mpCScroll->SetScrollbars(0, 1, 0, height);
    //mpCScroll->Scroll(viewx, viewy);
}

// --------

void DF3SeqGUI_cls::
LinkParameter(wxString wxstrTag, Parameters_cls *pCParam){
    for (unsigned int i = 0; i < mpCPanelList->mVPParameterPanel.size(); i++)
	if (wxstrTag == mpCPanelList->GetPPanel(i)->mpCTimeLine->/*mstrTag*/mstrCustomName)
	    mpCPanelList->GetPPanel(i)->LinkParameter(pCParam);
    Refresh(FALSE);
}

void DF3SeqGUI_cls::
AppendMenu(wxWindow *pCCustomTarget, int menuID,
	   wxString wxstrTag, wxString wxstrTitle, int type){
    mpCPanelList->GetPPanel(wxstrTag)->mpCTimeLine->
	AppendMenu(pCCustomTarget, menuID, wxstrTitle, type);
}

// --------

// OnPaint̕OnScroll葁Ƃ܂̂

void DF3SeqGUI_cls::
OnZoomIn(wxMouseEvent& event){
    mspCTimeLink->ZoomIn();
    mspCTimeLink->UpdateDF3SeqGUI();
}

void DF3SeqGUI_cls::
OnZoomOut(wxMouseEvent& event){
    mspCTimeLink->ZoomOut();
    mspCTimeLink->UpdateDF3SeqGUI();
}

void DF3SeqGUI_cls::
OnSize(wxSizeEvent& event){
    event.Skip();
    //RechckSize();
}

#include "../MYAPI/MsgBox.h"

void DF3SeqGUI_cls::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    /*
    if (code == WXK_DELETE){
	if (mpCPanelList->SkipEventToSelected(event) == TRUE) return;
    }
    */
    wxGetTopLevelParent(this)->AddPendingEvent(event);
}

void DF3SeqGUI_cls::
OnCurrentIndex(wxKeyEvent &event){
    mspCTimeLink->SetIndex(mpCCurrentIndex->GetValue());
    mspCTimeLink->UpdateDF3SeqGUI(TRUE);
}

void DF3SeqGUI_cls::
ActivatePanel(wxString strTag, bool bExclusive, bool bTerminate){
    
    unsigned int index = mpCPanelList->GetIndexFromTag(strTag);
    if (index == 9999) return;
    if (bExclusive == TRUE) mpCPanelList->DeactivateAllPanel(bExclusive);
    mpCPanelList->Activate(index, bExclusive);
    if (bTerminate == FALSE) // FilterƂ̃[vif
	mspCFilterCtrlLink->SelectFilter(strTag, bExclusive, TRUE);
    
    for (unsigned int i = 0; i < mVListSelectable.size(); i++)
	if (mpCPanelList->GetTagActivated().Matches(mVListSelectable[i]))
	    MainGLCanvas_cls::SelectItem
		(mpCPanelList->GetPPanelActivated()->mpCParam);
}

void DF3SeqGUI_cls::
OnActivatePanel(wxMouseEvent& event){
    unsigned int index = mpCPanelList->GetIndexFromID(event.GetId());
    DeactivateAllPanel();
    if (index != 9999)
	ActivatePanel(mpCPanelList->GetStrTag(index), !event.m_shiftDown);
}

int DF3SeqGUI_cls::
GetSelectedKeyNum(){
    if (mpCPanelList->GetPPanelActivated() == NULL) return 0;
    return mpCPanelList->GetPPanelActivated()->mpCParam->GetSelectedKeyNum();
}

void DF3SeqGUI_cls::
SelectAllKey(bool bSelected){
    mpCPanelList->SelectAllKeySelectedPanel(bSelected);
}

void DF3SeqGUI_cls::
SelectKeyFrame(double doubleIndexA, double doubleIndexB){
    mpCPanelList->SelectKeyFrame(doubleIndexA, doubleIndexB);
}

void DF3SeqGUI_cls::
DeleteKeyFrame(double doubleIndex){
    mpCPanelList->DeleteKeyFrame(doubleIndex);
}

void DF3SeqGUI_cls::
SetTimeDependent(bool bDependent){
    mpCPanelList->SetTimeDependent(bDependent);
}

void DF3SeqGUI_cls::
SetVisibility(bool bVisibility){
    mpCPanelList->SetVisibility(bVisibility);
}

void DF3SeqGUI_cls::
HidePanel(){
    mpCPanelList->HidePanel();
    UpdatePanelLayout();
    //RechckSize();
}

void DF3SeqGUI_cls::
DeactivateAllPanel(bool bExclusive){
    mpCPanelList->DeactivateAllPanel(bExclusive);
}

void DF3SeqGUI_cls::
OnMouseWA(wxMouseEvent& event){
    mspCTimeLink->CheckWorkingArea();
    mspCTimeLink->UpdateDF3SeqGUI();
}

void DF3SeqGUI_cls::
DispatchKeyEventToActivePanel(wxKeyEvent& event){
    ParametersPanel_cls* pActivePanel = mpCPanelList->GetPPanelActivated();
    if (pActivePanel == NULL) return;
    event.SetId(pActivePanel->mpCTimeLine->GetId());
    pActivePanel->mpCTimeLine->AddPendingEvent(event);
}

wxBitmap DF3SeqGUI_cls::msCBitmapZoomOut;
wxBitmap DF3SeqGUI_cls::msCBitmapZoomIn;
FilterCtrl_cls* DF3SeqGUI_cls::mspCFilterCtrlLink;
TimeCtrl_cls* DF3SeqGUI_cls::mspCTimeLink;
