// -*- c -*- 
// "clsDF3SeqGUI.cpp"

#ifndef _DF3_SEQUENCE_GUI_H_
#define _DF3_SEQUENCE_GUI_H_

#include <wx/wx.h>
#include <vector>

class AtoiTextCtrl_cls; 
class BitmapPanel_cls; 
class CameraPath_cls; 
class DF3SeqCtrl_cls; 
class DF3Sequence_cls; 
class FilterCtrl_cls;
class Parameters_cls; 
class ParametersPanel_cls; 
class TLPanelMemory_cls; 
class TLPanelTics_cls;
class TLPanelAA_cls; 
class TimeCtrl_cls;
class wxCheckBoxEX; 
class wxButtonEX; 
//class wxSliderEX;
class wxToggleButton; 

#include "TL/clsParametersPanelList.h"

#define _EXCLUSIVE TRUE

class DF3SeqGUI_cls : 
//#ifdef WIN32
public wxPanel 
//#else
//public wxScrolledWindow
//#endif
{
 public:
    DF3SeqGUI_cls(CameraPath_cls *pCPath,
		  DF3SeqCtrl_cls *pCParentCtrl, TimeCtrl_cls *pCTime,
		  wxWindow *pC, wxPoint pos, wxSize size);
    ~DF3SeqGUI_cls();
    
    //DF3Sequence_cls *mpCParent;
    static FilterCtrl_cls  *mspCFilterCtrlLink;
    static TimeCtrl_cls    *mspCTimeLink;
    wxScrolledWindow *mpCScroll;
    
    int mUpdateLevel;
    void UpdatePanelLayout();
    void UpdatePanelsBitmapState();
    void UpdateDisplay(bool bUpdateParent = FALSE);
    bool IsPanelActive(wxString strTag);
    void ConnectMouseEvent();

    wxComboBox  *mpCComboVisible;
    void        UpdateItemsVisivility();
    void        ShowAllTimeDependentItems();
    void        SetPanelVis(wxString strVis);
    void        OnComboBoxVis(wxCommandEvent& event);
    void        ShowItem(wxString strItem, bool bShow = TRUE);
    void        RechckSize();
    

    BitmapPanel_cls *mpCBPanelZoomOut;
    BitmapPanel_cls *mpCBPanelZoomIn;
    static wxBitmap msCBitmapZoomOut;
    static wxBitmap msCBitmapZoomIn;
    
    TLPanelAA_cls        *mpCTLPanelAA;
    TLPanelMemory_cls    *mpCPanelMem;
    TLPanelTics_cls      *mpCTLPanelTics;

    ParametersPanelList_cls *mpCPanelList;
    void         LinkParameter(wxString wxstrTag, Parameters_cls *pCParam);
    void         AppendMenu(wxWindow *pCCustomTarget, int menuID,
			    wxString wxstrTag, wxString wxstrTitle, 
			    int type = 0);
    
    AtoiTextCtrl_cls *mpCCurrentIndex;
    AtoiTextCtrl_cls *mpCMaxLength;
 public:
  
    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    //void OnScroll(wxScrollEvent& event);
    void OnZoomOut(wxMouseEvent& event);
    void OnZoomIn(wxMouseEvent& event);
    
    void OnKeyDown(wxKeyEvent& event);
    void OnCurrentIndex(wxKeyEvent& event);

    // ----
    std::vector < wxString > mVListSelectable;
    void ActivatePanel(wxString strTag, bool bExclusive = FALSE, bool bTerminate = FALSE);
    void OnActivatePanel(wxMouseEvent& event);
    int  GetSelectedKeyNum();
    void SelectAllKey(bool bSelected = TRUE);
    void SelectKeyFrame(double doubleIndexA, double doubleIndexB);
    void DeleteKeyFrame(double doubleIndex);
    void SetTimeDependent(bool bDependent);
    void SetVisibility(bool bVisibility);
    void HidePanel();
    void DeactivateAllPanel(bool bExclusive = FALSE);

    // ----
    void OnMouseWA(wxMouseEvent& event);
    void DispatchKeyEventToActivePanel(wxKeyEvent& event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
