// -*- c++ -*- 
// "clsDF3Sequence.h"
// "../../wxWidgetEnum.h"
// (setq c-basic-offset 4)

#include "clsDF3Sequence.h"

#include "clsDF3SeqCtrl.h"
#include "clsDF3SeqGUI.h"
#include "clsDF3.h"
#include "../COMMON/clsFilename.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../MYAPI/MsgBox.h"
#include "../PARAMETER/clsTimeLinePanel.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;

#include "../WIDGETCTRL/clsAtoiTextCtrl.h"
#include "../WIDGETCTRL/EX/clsSliderEX.h"

#include "../DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
#include "../DF3/GL/clsPreviewProperty.h"

#include "../GLCANVAS/clsMainGLCanvas.h"

#include "../../wxWidgetEnum.h"
#include "../../clsTimeCtrl.h"

#include <sstream>

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)
#define LOOP_RGB for (int rgb = 0; rgb < 3; rgb++)

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#define X 0
#define Y 1
#define Z 2

#define ENDL std::endl
#define ENDLWX wxT("\n")

// ---------------------------

DF3Sequence_cls::
DF3Sequence_cls(int selfIndex, DF3SeqCtrl_cls *pCParentCtrl, TimeCtrl_cls *pCTime) :  
    mVDF3GL(_DF3_SEQ_MAX, this)/*,
				 mVCCheckTreeFile(_DF3_SEQ_MAX)*/
{
    mSelfIndex = selfIndex;
    mPreIndex = 0;
    mspCParentCtrlLink = pCParentCtrl;
    mspCTimeLink = pCTime;
    mbAlphaAlocatted = FALSE;
    mAlphaAllocatedNumber = 0;

    mpCFilterCtrl = new FilterCtrl_cls(this);
    
    // DF3std::vectorŃRXgNgthisgƊ댯Ȃ̂
    // DF3Sequence_cls̃RXgN^őĂ
    for (unsigned int i = 0 ; i < _DF3_SEQ_MAX; i++){
	mVDF3GL[i].mCLevelMap.SetParent(&mVDF3GL[i]);
	mVDF3GL[i].SetSelfIndex(i);
	mVDF3GL[i].mCReadBodyDF3.mpC    = &mVDF3GL[i];
	mVDF3GL[i].mCReadBodyImgSeq.InitializeMember(&mVDF3GL[i]);
	mVDF3GL[i].mCConstructXY[X].mpC = &mVDF3GL[i];
	mVDF3GL[i].mCConstructXY[Y].mpC = &mVDF3GL[i];
	LOOP_XYZ{
	    mVDF3GL[i].mCTexObjectGen [xyz]  .mpC = &mVDF3GL[i];
	    mVDF3GL[i].mCTexObjectBind[xyz]  .mpC = &mVDF3GL[i];
	    mVDF3GL[i].mCTexObjectDelete[xyz].mpC = &mVDF3GL[i];
	}
	if (i < _DF3_SEQ_MAX - 1)
	    mVDF3GL[i].mpCNextDF3 = &(mVDF3GL[i+1]);
	else
	    mVDF3GL[i].mpCNextDF3 = &(mVDF3GL[i]);
    }

    //mbPreFetch = FALSE;
    //mPrefetchMin = mPrefetchMax = 0;
    mAPreFetchList = new bool [0];
    mbPreFetchListAllocated = TRUE;
    mPreFetchListAllocatedNumber = 0;

    mMaxIndex = 0;
    
    // staticċʉقǂ
    //mCConfListScene.Add(&mCAppendType, L"DF3SequenceAppendType=", L"0");
    
    mCSequenceNumber.SetItem(L"DF3SequenceNumber=", L"0");

    mFactorAlpha = 1;

    //double alpha=32;
    //mCBaseAlphaNew.ExecCommandInitSet(&alpha);

    mOldIndexTex    = mOldIndexXYZ    = 0;
    mOldPointMaxTex = mOldPointMaxXYZ = 0;
    
    mbSubThreadReader = FALSE;

    //mDownSizeLayer[X] = mDownSizeLayer[Y] = mDownSizeLayer[Z] = 1;
    //mDownSizeSrc[X] = mDownSizeSrc[Y] = mDownSizeSrc[Z] = 1;

    //LOOP_XYZ mShow[xyz] = TRUE;

    mDefaultDigit = 0;
    mDefaultZSliceInit = 0;
    mDefaultChannel = 0;
}

DF3Sequence_cls::
~DF3Sequence_cls(){
    mVDF3GL.resize(0, this);
    //mVCCheckTreeFile.resize(0);
    if (mbPreFetchListAllocated == TRUE)
	delete mAPreFetchList;
    delete mpCFilterCtrl;
    if (mbAlphaAlocatted == TRUE)
	delete mpAlpha;
}

void DF3Sequence_cls::
SetIndividualFileNames(){
    int index = 0;
    for (unsigned int i = 0; i < mVCFileSequence.size(); i++)
	for (int offset = 0; offset < mVCFileSequence[i].mSeqLength; offset++){
	    wxString strFilename = mVCFileSequence[i].GetModifiedWXStr(offset);
	    wxString strFilenameFormat = mVCFileSequence[i].GetModifiedWXStr(offset, 0, FALSE);
	    mVDF3GL[index].SetFilePath(strFilename, strFilenameFormat,
				       mVCFileSequence[i].mChannel);
	    mVDF3GL[index].mbValid = TRUE;
	    //mVDF3GL[index].mCLevelMap.Clear();
	    index++;
	}
}

void DF3Sequence_cls::
ClearFileSequence(){
    for (unsigned int i = 0; i <= mMaxIndex; i++) 
	mVDF3GL[i].SetFilePath(wxT(""), wxT(""), 0);
    mVCFileSequence.clear();
    mMaxIndex = 0;
}

void DF3Sequence_cls::
AppendFileSequence(wxString strFilepath, bool bSelectChannel,
		   bool bImageTimeSequence){
    
    FileSequenceWX_cls CFileSequence;
    CFileSequence.Set(strFilepath);
    
    if (mDefaultDigit != 0) CFileSequence.mDigit = mDefaultDigit;

    CFileSequence.mZSliceInit = mDefaultZSliceInit;
    
    CFileSequence.mSeqLength = 0;
    wxString strExt = CFileSequence.mwsExt;
    if (strExt == wxT(".bmp") || strExt == wxT(".BMP") ||
	strExt == wxT(".png") || strExt == wxT(".PNG") ||
	strExt == wxT(".tif") || strExt == wxT(".TIF") ||
	strExt == wxT(".tiff") || strExt == wxT(".TIFF")){
	SplitPathWX_cls CSplit0(CFileSequence.GetModifiedWXStr(0));
	SplitPathWX_cls CSplit1(CFileSequence.GetModifiedWXStr(1));
	if (CSplit0.GetPathWXStr(_FN_DRIVE_DIR) == 
	    CSplit1.GetPathWXStr(_FN_DRIVE_DIR)){
	    wxString strMessage = CFileSequence.GetModifiedWXStr(0) + ENDLWX;
	    if (bSelectChannel == FALSE)
		strMessage << wxT("Reading Channnel: ") << CFileSequence.GetChannelStr() << ENDLWX;

	    // 摜̘AԂ́Aԏ܂߂āH
	    if (bImageTimeSequence == FALSE){
		strMessage << _("Read ImgSequence for 1 data snap.");
		if (MsgBoxYesno(mspCParentCtrlLink->mpCParentWindow,
				_("Query"), strMessage) == TRUE)
		    CFileSequence.mSeqLength = 1;
	    }
	}
	
	// g`l
	if (bSelectChannel == TRUE){
	    MultiNumericalInputs_cls *pCDLG;
	    pCDLG = new MultiNumericalInputs_cls(&pCDLG, mspCGUILink->GetParent(), wxID_ANY, _("Select Color Channel"));
	    pCDLG->SetDefaultButtonType(_MN_OK_CANCEL_DEFAULT);
	    pCDLG->mTextWidth = 120;
	    pCDLG->mComboWidth = 108;
	    wxString listChannel[3] = { wxT("Red"), wxT("Green"), wxT("Blue") };
	    pCDLG->CombinePointer(_GP_UNSIGNED_INT_LIST, &CFileSequence.mChannel, _("channel"), TRUE, 3, listChannel, CFileSequence.mChannel);
	    if (pCDLG->FinishSettingDLG(TRUE, _MN_DLG_MODAL, _MN_DLG_MAKEGEOM) == wxID_CANCEL){
		return;
	    }
	}
    }
    
    if (bSelectChannel == FALSE) CFileSequence.mChannel = mDefaultChannel;
    
    if (CFileSequence.mSeqLength == 0) CFileSequence.CalcMaxOffset();
        
    Filename_cls::DoubleSlash(CFileSequence.mwsFileHead);
    if (CFileSequence.mSeqLength == 0) return;
    mVCFileSequence.push_back(CFileSequence);

    int oldMaxIndex = mMaxIndex;
    
    int maxIndex = -1;
    for (unsigned int i = 0; i < mVCFileSequence.size(); i++)
	maxIndex += mVCFileSequence[i].mSeqLength;

    SetMaxIndex(maxIndex);
    if (mspCParentCtrlLink->mCAppendType.mBody == _DF3SEQ_APPEND_ADJUST && oldMaxIndex != 0){
	Parameters_cls::RemapKeyFrameAll(oldMaxIndex, mMaxIndex);
    }
    mspCTimeLink->SetWorkingArea(maxIndex);
    mspCTimeLink->UpdateDF3SeqGUI();
}

// ---

void DF3Sequence_cls::
BeginBusyCursor(){
#ifdef WIN32
    wxBeginBusyCursor();
#endif
}

void DF3Sequence_cls::
EndBusyCursor(){
#ifdef WIN32
    wxEndBusyCursor();
#endif
}

// RESUMABLE ̎͏Ō܂łFALSE
// FORCE_FINISH ̎ABindinds\iprocesseddatȁ܂j̎FALSE
// 0 : ĂȂ (PreFetch̔Ŏg)
// 1 : ̏
// 0 : `͏͂܂
// 2 : O.K.
int DF3Sequence_cls::
IdleProcessesMain(unsigned int index, bool type, bool bSkipTextureProcess){
    bool bValidData = TRUE;
    
    // ǂݍݖ̏
    if (index > mMaxIndex) index = mMaxIndex;

    if (mVDF3GL[index].GetFilePathWXStr() == wxT("")) bValidData = FALSE;
    if (mVDF3GL[index].mbValid == FALSE) bValidData = FALSE;
    if (mspCParentCtrlLink->mbQuickShow == TRUE) bValidData = FALSE;
    
    // ̏ꍇ͎sł͂Ȃ O.K.Ǐ͂ĂȂ
    if (bValidData == FALSE) return 0+2;

    bool bCursorBusy = FALSE;
    if (type == _DF3_FORCE_FINISH && mVDF3GL[index].IsAllocated() == FALSE){
	BeginBusyCursor();
	bCursorBusy = TRUE;
    }

    if (mVDF3GL[index].IsFileChanged() == TRUE) 
	//mVDF3GL[index].FakeRelease(); 
	mVDF3GL[index].Release();
    
    if (mVDF3GL[index].IsAllocated() == FALSE){
	mVDF3GL[index].ReadHeader(wxGetTopLevelParent(mspCGUILink));
	if (mVDF3GL[index].mbValid == FALSE){
	    if (bCursorBusy == TRUE) EndBusyCursor();
	    return 1+0; 
	}
	mVDF3GL[index].Allocate();
	if (mVDF3GL[index].mbValid == FALSE){
	    if (bCursorBusy == TRUE) EndBusyCursor();
	    return 1+0; 
	}
	if (type == _DF3_ENABLE_RESUME) return TRUE;
    }

    if (mVDF3GL[index].ReadBodyIfNotFinished(type, wxGetTopLevelParent(mspCGUILink)) == TRUE){
	if (mVDF3GL[index].mbValid == FALSE){
	    if (bCursorBusy == TRUE) wxEndBusyCursor();
	    return 1+0; // CHECK!! ͂ǂԂׂH 
	}
	if (type == _DF3_ENABLE_RESUME) return TRUE;
    }

    if (DF3GL_cls::mspCProperty->mbUse3DTexture == FALSE){
	if (mVDF3GL[index].IsAllocatedXY() == FALSE){
	    mVDF3GL[index].AllocateXY();
	    if (type == _DF3_ENABLE_RESUME) return 1+0;
	}
	
	if (mVDF3GL[index].IsXYConstructFinished() == FALSE){
	    mVDF3GL[index].ConstructXYAxisData(type);
	    if (type == _DF3_ENABLE_RESUME) return 1+0;
	}
    }

    if (bSkipTextureProcess == TRUE) {
	if (bCursorBusy == TRUE) EndBusyCursor();
	return 0+2; }
    
    if (mVDF3GL[index].IsDirty() == TRUE ||
	mVDF3GL[index].IsTexObjectDeleteInProgress() == TRUE) {
	mVDF3GL[index].DeleteTexObjects(type, GetRemappedIndex() == index);
	if (type == _DF3_ENABLE_RESUME) return 1+0;
    }
    if (mVDF3GL[index].IsTexObjectGenFinished() == FALSE){
	mVDF3GL[index].GenerateTexObjects(type, GetRemappedIndex() == index);
	if (type == _DF3_ENABLE_RESUME) return 1+0;
    }
    if (mVDF3GL[index].IsTexObjectBindFinished() == FALSE){
	if (mVDF3GL[index].BindTexObjects(type) == FALSE){
	    if (bCursorBusy == TRUE) EndBusyCursor();
	    return 0+0; // oCfBOsFALSEԂI
	}
	if (type == _DF3_ENABLE_RESUME) return 1+2;
    }

    if (bCursorBusy == TRUE) EndBusyCursor();

    //ɂ܂ŗ̂ŁAFetchĂ悯FALSE;
    /*
    if (type == _DF3_ENABLE_RESUME &&
	pbHasAlreadyFinished != NULL) *pbHasAlreadyFinished = TRUE;
    */
    return 0+2;//retval;
}

/*
  bool DF3Sequence_cls::
  IdleProcessesSubTreadReader(unsigned int index){
  if (mbSubThreadReader == TRUE) return FALSE;
  if (index > mMaxIndex) return FALSE;
  if (mVDF3GL[index].GetFilePathStr() == "") return FALSE;
  if (mVDF3GL[index].IsAllocated() == TRUE) return FALSE;

  if (1 == 1){ //SingleThread
  mVDF3GL[index].ReadHeader();
  mVDF3GL[index].Allocate();
  mVDF3GL[index].ReadBody();
  }
  else{ //MultiThread
  mbSubThreadReader = TRUE;
  ThreadReader_cls* pSubThreadReader = new ThreadReader_cls(&mVDF3GL[index]);
  pSubThreadReader->Run();
  }

  return TRUE;
  }
*/

// Prefetcht[ݒ(RemapƊԊul)
void DF3Sequence_cls::
UpdatePreFetchList(){
    // !! XgXVKv炷A鏈 !!
    if (mbPreFetchListAllocated == TRUE && mPreFetchListAllocatedNumber != mMaxIndex + 1){
        delete mAPreFetchList;
	mbPreFetchListAllocated = FALSE;
    }
    
    if (mbPreFetchListAllocated == FALSE){
	mAPreFetchList = new bool [mMaxIndex + 1];
	mbPreFetchListAllocated = TRUE;
	mPreFetchListAllocatedNumber = mMaxIndex + 1;
    }

    for (unsigned int i = 0; i <= mMaxIndex; i++) mAPreFetchList[i] = FALSE;
    unsigned int frame = 0;
    while (frame <= mspCTimeLink->mCMaxFrame.mBody){
	mAPreFetchList[GetRemappedIndex(frame)] = TRUE;
	frame += mspCTimeLink->mCStep.mBody;
    }
}

bool DF3Sequence_cls::
IdleProcessesFetch(){
    if (mspCParentCtrlLink->mbPreFetch == TRUE)
	UpdatePreFetchList();

    for (int nextStep = GetRemappedIndex();
	 nextStep < mspCParentCtrlLink->mPrefetchMax; nextStep += 1){
	if (nextStep < (int)mspCTimeLink->mCWAMin.mBody) continue;
	if (nextStep > (int)mspCTimeLink->mCWAMax.mBody) continue;
	
	if (mAPreFetchList[nextStep] == FALSE) continue;
	
	mVDF3GL[nextStep].mOldPointTex = 0;
	mVDF3GL[nextStep].mOldPointXYZ = 0;
	if (mspCParentCtrlLink->mbPreFetch == FALSE) continue;
	int IdleProcess = IdleProcessesMain(nextStep, _DF3_ENABLE_RESUME);
	if ((IdleProcess & 1) != 0) return TRUE; //d̂ňUA
    }

    for (int nextStep = GetRemappedIndex(); nextStep > mspCParentCtrlLink->mPrefetchMin; nextStep -= 1){
	if (nextStep < (int)mspCTimeLink->mCWAMin.mBody) continue;
	if (nextStep > (int)mspCTimeLink->mCWAMax.mBody) continue;
	if (mAPreFetchList[nextStep] == FALSE) continue;
	mVDF3GL[nextStep].mOldPointTex = 0;
	mVDF3GL[nextStep].mOldPointXYZ = 0;
	if (mspCParentCtrlLink->mbPreFetch == FALSE) continue;
	int IdleProcess = IdleProcessesMain(nextStep, _DF3_ENABLE_RESUME);
	if ((IdleProcess & 1) != 0) return TRUE; //d̂ňUA
    }
    
    return FALSE;
}

void DF3Sequence_cls::SetFileChangedTagAll(){
    for (unsigned int i = 0; i <= mMaxIndex; i++)
	mVDF3GL[i].SetFileChangedTag();
}

bool DF3Sequence_cls::
IsPlayTexConditionSatisfied(unsigned int step){
    if (mspCTimeLink->IsWorkingArea(step) == FALSE) return FALSE;
    if (mspCParentCtrlLink->mbQuickShow == TRUE) return TRUE;
    if (mVCFileSequence.size() == 0) return TRUE;

    bool condition = TRUE;
        
    switch (mspCTimeLink->mPlayMode){
    case _TIME_CTRL_PLAY_TEX:
	condition = mVDF3GL[GetRemappedIndex(step)].IsTexObjectBindFinished();break;
    case _TIME_CTRL_PLAY_MEM_XY:
	condition = mVDF3GL[GetRemappedIndex(step)].IsAllocatedXY();break;
    case _TIME_CTRL_PLAY_MEM_Z:
	condition = mVDF3GL[GetRemappedIndex(step)].IsAllocated();break;
    }
    return condition;
}

int DF3Sequence_cls::
GetQuickIndex(){
    for (unsigned int frame = mspCTimeLink->mFrame; 
	 frame <= mspCTimeLink->mFrame; frame--)
	if (mVDF3GL[GetRemappedIndex(frame)].IsTexObjectBindFinished()){
	    return GetRemappedIndex(frame);
	}
    for (unsigned int frame = mspCTimeLink->mFrame;
	 frame <= mspCTimeLink->mCMaxFrame.mBody; frame++)
	if (mVDF3GL[GetRemappedIndex(frame)].IsTexObjectBindFinished()){
	    return GetRemappedIndex(frame);
	}
    return GetRemappedIndex();
}

bool DF3Sequence_cls::
DrawData(PositionAndDirection_cls CCam, 
	 double boxScaleX, double boxScaleY, double boxScaleZ,
	 unsigned int axis, bool bMirror[3],
	 double clipBoxMin[3], double clipBoxMax[3],
	 double *pShadeOffset){
    
    bool retVal = FALSE;

    int timeIndex;
    if (mspCParentCtrlLink->mbQuickShow == TRUE)
	timeIndex = GetQuickIndex();
    else
	timeIndex = GetRemappedIndex();
    mspCParentCtrlLink->SetDF3GLVector(timeIndex, mSelfIndex);
    
    unsigned int indexNum = DF3GL_cls::msVpDF3GL.size();
    if (indexNum == 0) return retVal;
    
    if (mbAlphaAlocatted == TRUE && mAlphaAllocatedNumber != indexNum){
	delete mpAlpha;
	mbAlphaAlocatted = FALSE;
    }

    if (mbAlphaAlocatted == FALSE){
	mpAlpha = new double [indexNum];
	mbAlphaAlocatted = TRUE;
	mAlphaAllocatedNumber = indexNum;
    }

    for (int df3 = 0; df3 < indexNum; df3++){
	mpAlpha[df3] = mspCParentCtrlLink->mCBaseAlpha.GetPInterpolatedValue(mspCTimeLink->GetDoubleIndex())[0] * mFactorAlpha * DF3GL_cls::msVAlpha[df3];
	if (mspCParentCtrlLink->GetPDF3Seq(df3)->GetPDF3()->GetFilePathWXStr() == wxT(""))
	    mpAlpha[df3] = 0;
    }
    
    mVDF3GL[GetRemappedIndex()].SetBoxScale(boxScaleX, boxScaleY, boxScaleZ);
    
    if (mVDF3GL[timeIndex].IsAllocated() == TRUE){
	mVDF3GL[timeIndex].DrawData(CCam, mpAlpha, axis, bMirror,
				    clipBoxMin, clipBoxMax,
				    pShadeOffset);
	retVal = TRUE;
    }

    return retVal;
}

void DF3Sequence_cls::
EvaluateOldPoint(){
    if (mspCTimeLink->mbPlayTex == 0)
	mspCTimeLink->mPlayDirection = 0;

    mVDF3GL[GetRemappedIndex()].mOldPointXYZ = 0;
    mVDF3GL[GetRemappedIndex()].mOldPointTex = 0;

    for (unsigned int i = 0; i <= mMaxIndex; i++){
	int incPoint = 1; 
	incPoint += (mAPreFetchList[i] == FALSE) * 5;
	if (mspCTimeLink->mPlayDirection == 1 && i < mspCTimeLink->mFrame)  incPoint *= 3;
	if (mspCTimeLink->mPlayDirection == -1 && i > mspCTimeLink->mFrame) incPoint *= 3;
	
	if (mVDF3GL[i].IsTexObjectGenFinished() == TRUE ||
	    mVDF3GL[i].IsTexObjectGenInProcess() == TRUE)
	    mVDF3GL[i].mOldPointTex += incPoint;
	/*
	else
	    mVDF3GL[i].mOldPointTex = 0;
	*/

	if (mVDF3GL[i].IsAllocated() == TRUE) 
	    mVDF3GL[i].mOldPointXYZ += incPoint;

	if ((mAPreFetchList[i] == TRUE) && (int)i > mspCParentCtrlLink->mPrefetchMin && (int)i < mspCParentCtrlLink->mPrefetchMax){
	    mVDF3GL[i].mOldPointTex = 0;
	    mVDF3GL[i].mOldPointXYZ = 0;
	}
    }
}

void DF3Sequence_cls::
ReleaseAll(int flagBit, bool bFakePermitted){
    for (unsigned int i = 0; i <= mMaxIndex; i++) 
	ReleaseStep(i, flagBit, bFakePermitted);
}

void DF3Sequence_cls::
ReleaseStep(unsigned int index, int flagBit, bool bFakePermitted){
    
    if (mVDF3GL[index].IsTexObjectGenInProcess() == TRUE ||
	mVDF3GL[index].IsTexObjectGenFinished() == TRUE)
	mVDF3GL[index].DeleteTexObjects(_RESUMABLE_FORCE_FINISH, GetRemappedIndex() == index);

    mVDF3GL[index].mbProcessFinished = FALSE;

    if ((flagBit & _DF3SEQ_MEMORY) == 0) return; 
    
    if (mVDF3GL[index].IsAllocatedXY() == TRUE)
	mVDF3GL[index].ReleaseXY();

    if (mVDF3GL[index].IsAllocated() == TRUE){
	if (index == GetRemappedIndex() && bFakePermitted == TRUE)
	    mVDF3GL[index].FakeRelease();
	else
	    mVDF3GL[index].Release();
    }

    //mVCCheckTreeFile[index].ClearTree();
    mVDF3GL[index].mbValid = TRUE;
}

bool DF3Sequence_cls::
IdleProcessesRelease(bool type){
    // ǂݔ͈͌vZ
    if (GetRemappedIndex() != mPreIndex) EvaluateOldPoint();
    mPreIndex = GetRemappedIndex();

    MaxElement_cls 
	CTexOld(mspCParentCtrlLink->mPrefetchMin, mspCParentCtrlLink->mPrefetchMax),
	CXYOld (mspCParentCtrlLink->mPrefetchMin, mspCParentCtrlLink->mPrefetchMax),
	CXYZOld(mspCParentCtrlLink->mPrefetchMin, mspCParentCtrlLink->mPrefetchMax);
    
    for (unsigned int i = 0; i <= mMaxIndex; i++){
	if (i == mPreIndex) continue;
	if (mVDF3GL[i].IsTexObjectGenFinished() == TRUE ||
	    mVDF3GL[i].IsTexObjectGenInProcess() == TRUE)
	    CTexOld.SetIndexAndElement(i, mVDF3GL[i].mOldPointTex); 
	
	if (mVDF3GL[i].IsAllocatedXY() == TRUE)
	    CXYOld.SetIndexAndElement(i, mVDF3GL[i].mOldPointXYZ); 

	if (mVDF3GL[i].IsAllocated() == TRUE)
	    CXYZOld.SetIndexAndElement(i, mVDF3GL[i].mOldPointXYZ); 
    }

    // -- `p--ŏIIɂ͂ȂȂ
    mOldIndexTex = CTexOld.GetIndex();
    mOldIndexXYZ = CXYZOld.GetIndex();
    mOldPointMaxTex = CTexOld.GetMax(); //mspCParentCtrlLink->mPrefetchMin;
    mOldPointMaxXYZ = CTexOld.GetMax(); //mspCParentCtrlLink->mPrefetchMax;

    bool retval = FALSE;

    unsigned int merginTex = 0, merginXY = 0, merginXYZ = 0;
    if (type == _RESUMABLE_FORCE_FINISH){
	merginTex = 8;
	merginXY = 16;
	merginXYZ = 24;
    }

    // ܂藭܂ĂƋ
    if (mspCParentCtrlLink->mTexMemoryMB > mspCParentCtrlLink->mCCritTexMemoryMB.mBody + merginTex ||
	mspCParentCtrlLink->mXYMemoryMB  > mspCParentCtrlLink->mCCritXYMemoryMB.mBody  + merginXY ||
	mspCParentCtrlLink->mXYZMemoryMB > mspCParentCtrlLink->mCCritXYZMemoryMB.mBody + merginXYZ)
	type = _RESUMABLE_FORCE_FINISH;

    if (mspCParentCtrlLink->mTexMemoryMB > mspCParentCtrlLink->mCCritTexMemoryMB.mBody + merginTex &&
	CTexOld.GetIndex() != -1)
	if (mVDF3GL[CTexOld.GetIndex()].IsTexObjectGenInProcess() == TRUE ||
	    mVDF3GL[CTexOld.GetIndex()].IsTexObjectGenFinished() == TRUE){
	    if (mVDF3GL[CTexOld.GetIndex()].DeleteTexObjects(type) == TRUE &&
		type == _RESUMABLE_ENABLE_RESUME)
		return TRUE; 
	    else
		retval = TRUE;
	}
    
    if (DF3GL_cls::mspCProperty->mbUse3DTexture == FALSE){
	if (mspCParentCtrlLink->mXYMemoryMB > mspCParentCtrlLink->mCCritXYMemoryMB.mBody + merginXY &&
	    CXYOld.GetIndex() != -1)
	    if (mVDF3GL[CXYOld.GetIndex()].IsAllocatedXY() == TRUE){
		mVDF3GL[CXYOld.GetIndex()].ReleaseXY();
		if (type == _RESUMABLE_ENABLE_RESUME)
		    return TRUE; 
		else
		    retval = TRUE;
	    }
    }
    
    if (mspCParentCtrlLink->mXYZMemoryMB > mspCParentCtrlLink->mCCritXYZMemoryMB.mBody + merginXYZ &&
	CXYZOld.GetIndex() != -1)
	if (mVDF3GL[CXYZOld.GetIndex()].IsAllocated() == TRUE){
	    mVDF3GL[CXYZOld.GetIndex()].Release();
	    if (type == _RESUMABLE_ENABLE_RESUME)
		return TRUE; 
	    else 
		retval = TRUE;
	} 
    
    return retval;
}

DF3GL_cls* DF3Sequence_cls::
GetPDF3(){
    return &mVDF3GL[GetRemappedIndex()];
}

/*
CheckTreeFile_cls* DF3Sequence_cls::
GetpCheckTreeFile(){
    return &mVCCheckTreeFile[GetRemappedIndex()];
}
*/

// -----

void DF3Sequence_cls::
SetMaxIndex(unsigned int maxIndex){
    mMaxIndex = maxIndex;
    mspCTimeLink->SetMaxFrame(mMaxIndex);
    UpdatePreFetchList();
}

bool DF3Sequence_cls::
IsRemap(){
    return mspCTimeLink->mCbUseTimeRemap.mbBody;
}

float DF3Sequence_cls::
GetRemapInterpolateFactor(){
    return (float)mspCTimeLink->GetRemappedIndexDouble(_TIME_CTRL_CURRENT) - 
	GetRemappedIndex(_TIME_CTRL_CURRENT);
}

unsigned int DF3Sequence_cls::
GetRemappedIndex(int frame){
    int remappedIndex = mspCTimeLink->GetRemappedIndex(frame);
    if (remappedIndex > (int)mMaxIndex) remappedIndex = mMaxIndex;
    return (unsigned int) remappedIndex;
}


// f[^ǂݍݍς݂̍ŏ̃t@CTCY𓾂
unsigned int DF3Sequence_cls::
GetDataSize(int axis){
    for (int i = 0; i <= mMaxIndex; i++){
	int size = mVDF3GL[i].GetCurrSize(axis);
	if (size != 0) return size;
    }
    return 0;
}

// ----------

int DF3Sequence_cls::
GetColorLayerNum(){
    int colorType = mpCFilterCtrl->GetVolumeColorType();
    int textureType = DF3GL_cls::mspCProperty->mCTextureType.mBody;
    if (textureType == _PREVIEW_RGBA) return 1;
    if (colorType == -1) return 0;
    if (colorType == 0) return 1;
    return GCColoring.GetPVVSize(colorType);
}

void DF3Sequence_cls::
SetRGBAtoGL(unsigned int cindex){
    int colorType = mpCFilterCtrl->GetVolumeColorType();
    if (colorType == -1)
        LOOP_RGB mColorRGB[rgb] = 1;
    else if (colorType == 0)
	LOOP_RGB mColorRGB[rgb] = mpCFilterCtrl->GetVolumeColor(rgb);
    else
	GCColoring.CopyRGB(mColorRGB, cindex, colorType);
    
    if (colorType == -1)
	mFactorAlpha = 1; 
    else
	mFactorAlpha = GCColoring.GetAlphaFactor(cindex, colorType);

    if (DF3GL_cls::mspCProperty->mCTextureType.mBody == _PREVIEW_RGBA)
	if (colorType > 0)
	    mFactorAlpha *= 2;
}

float DF3Sequence_cls::
GetLastLayerPovScale(unsigned int axis, unsigned int interpolateType){
    if (interpolateType == 0)
	return 1.0f;
    DF3_cls *pCDF3 = &mVDF3GL[GetRemappedIndex()];
    
    float currSize;
    if (pCDF3->GetCurrSize(axis) == 0){
	pCDF3->ReadHeader(NULL);
	currSize = pCDF3->mTrueSize[axis] / msCDownSizeSrc.mpBody[axis];
    }
    else
	currSize = pCDF3->GetCurrSize(axis);
    
    float value = currSize / (currSize - 1);

    //(float)mVDF3GL[GetRemappedIndex()].GetCurrSize(axis) /
    //(mVDF3GL[GetRemappedIndex()].GetCurrSize(axis)-1);
    //printf("axis %d %f\n", axis, value);
    return value;
}

wxString DF3Sequence_cls::
GetCurrentFWXStr(){
    return mVDF3GL[GetRemappedIndex()].GetFilePathWXStr();
}

/*
void DF3Sequence_cls::
ReadStrLineSceneConf(std::wistream &istream, std::wstring strLine){
    mCConfListScene.ReadStrLineAll(strLine);
    UpdatePreFetchList();
}
*/

void DF3Sequence_cls::
ReadStrLineSequence(std::wistream &istream, std::wstring strLine){
    if (mCSequenceNumber.ReadStrLine(strLine) == TRUE){
	ClearFileSequence();
	for (unsigned int i = 0; i < mCSequenceNumber.mBody;i++){
	    std::wstring strLine;
	    std::getline (istream, strLine);
	    std::wstringstream strTmp(strLine);
	    strTmp >> mDefaultDigit;
	    strTmp >> mDefaultChannel;
	    strTmp >> mDefaultZSliceInit;
	    
	    std::getline (istream, strLine);

	    AppendFileSequence(strLine);
	}
	mDefaultChannel = 0;
	SetIndividualFileNames();
    }
}

wxString DF3Sequence_cls::
SerializeFile(){
    wxString sOut;
    mCSequenceNumber.mBody = (unsigned int)mVCFileSequence.size();
    sOut << mCSequenceNumber.Serialize();
    for (unsigned int i = 0;i < mCSequenceNumber.mBody;i++){
	//wchar_t buf[8];
	//swprintf(buf, 8, L"%d\n", mVCFileSequence[i].mDigit);
	//sOut << buf;
	sOut << mVCFileSequence[i].mDigit << wxT(" ") << mVCFileSequence[i].mChannel << wxT(" ") << mDefaultZSliceInit << wxT("\n");
	sOut << mVCFileSequence[i].mwsPath << wxT("\n");
    }
    //sOut << mCConfListScene.SerializeAll();

    return sOut;
}

std::wstring DF3Sequence_cls::
SerializeFileName(){
    if (mVCFileSequence.size() == 0) return L"";
    std::wstringstream ssInfo;
    ssInfo << L"concat(\""       << mVCFileSequence[0].mwsFileHead 
	   << L"\", Number, \"." << mVCFileSequence[0].mwsExt << L"\")";
    return ssInfo.str();
}

std::wstring DF3Sequence_cls::
SerializeLayerSize(unsigned int interpolateType){
    std::wstringstream ssInfo;
    ssInfo << L"<"
	   << GetLastLayerPovScale(X, interpolateType) << L","
	   << GetLastLayerPovScale(Y, interpolateType) << L"," 
	   << GetLastLayerPovScale(Z, interpolateType) << L">";
    return ssInfo.str();
}

TimeCtrl_cls* DF3Sequence_cls::mspCTimeLink = NULL;
DF3SeqCtrl_cls* DF3Sequence_cls::mspCParentCtrlLink = NULL;
DF3SeqGUI_cls* DF3Sequence_cls::mspCGUILink = NULL;


//-----------------

MaxElement_cls::
MaxElement_cls(int rangeMin, int rangeMax){
    mRangeMin = rangeMin;
    mRangeMax = rangeMax;
    mMax = 0;
    mIndex = -1;
}

unsigned int MaxElement_cls::
GetMax(){
    return mMax;
}

int MaxElement_cls::
GetIndex(){
    return mIndex;
}

void MaxElement_cls::
SetIndexAndElement(int index, unsigned int value){
    if (value > mMax){
	mMax = value;
	mIndex = index;
    }
}

ConfItemUINTARRAY_cls DF3Sequence_cls::msCDownSizeLayer(wxT("DownSizeLayer="), wxT("1 1 1"));
ConfItemUINTARRAY_cls DF3Sequence_cls::msCDownSizeSrc(wxT("DownSizeSRC="), wxT("1 1 1"));
