// -*- c -*- 
// (setq c-basic-offset 4)
// "clsResumableProgress.h"

#include "clsResumableProgress.h"

#include <time.h>

#define TRUE true
#define FALSE false

ResumableProgress_cls::
ResumableProgress_cls(){
    mDuration = CLOCKS_PER_SEC / 40;
    mbFinished = FALSE;
    mbInProgress = FALSE;
    mNext = 0;
}

void ResumableProgress_cls::
Clear(){
    mbFinished = FALSE;
    mbInProgress = FALSE;
    mNext = 0;
}

bool ResumableProgress_cls::
IsCleared(){
    if (mbFinished == FALSE &&
	mbInProgress == FALSE &&
	mNext == 0) return TRUE;
    return FALSE;
}

bool ResumableProgress_cls::
IsFinished(){
    return mbFinished;
}

bool ResumableProgress_cls::
IsInProgress(){
    return mbInProgress;
}

void ResumableProgress_cls::
Initialize(unsigned int max){
    mMax = max;
    mbInProgress = TRUE;
    mStartClock = clock();
}

bool ResumableProgress_cls::
IsFinishConditionSatisfied(){
    if (mNext < mMax) return FALSE;
    return TRUE;
}

bool ResumableProgress_cls::
IsResumeConditionSatisfied(bool type){
    if (type == _RESUMABLE_ENABLE_RESUME &&
	(clock() - mStartClock) >= mDuration) return TRUE;
    return FALSE;
}

void ResumableProgress_cls::
Finalize(){
    mbInProgress = FALSE;
    mbFinished = TRUE;
}

int ResumableProgress_cls::
GetPercent(){
    if (IsFinished() == TRUE) return 100;
    if (IsInProgress() == FALSE) return 0;
    if (mNext > mMax) return 100;
    return 100 * mNext / mMax;
}
