// -*- c -*- 
// (setq c-basic-offset 4)
// "clsBoxCopy.h"

#include "clsBoxCopy.h"

#include "../DF3/clsDF3SeqGUI.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

#define X 0
#define Y 1
#define Z 2

MACRO_FilterConstructor(BoxCopy,,)

BoxCopyGUI_cls::
~BoxCopyGUI_cls(){
    delete mpCMNumCustomA;
}

void BoxCopyGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);
    
#ifdef WIN32
    pCurr->mTextWidth = 60;
#else
    pCurr->mTextWidth = 80;
#endif
    
    int indexCustomA = pCurr->CombinePointerButton
	(buttonCtrlPanelItemsCustomA, _("Copy Number"));
    
    int boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Mirroring"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbMirroring.mpbBody[X], wxT("X"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbMirroring.mpbBody[Y], wxT("Y"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbMirroring.mpbBody[Z], wxT("Z"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Copying"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbCopying.mpbBody[X], wxT("X"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbCopying.mpbBody[Y], wxT("Y"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->mCData.mCbCopying.mpbBody[Z], wxT("Z"));
    
    pCurr->mProportion = 1;
    pCurr->AlignRight(indexCustomA);
    pCurr->FinishSetting(pBoxSizer, FALSE, index);
    
    mpObjectForCustomA = pCurr->mVCPointers[indexCustomA].mpPointerCtrl;

    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);
    SetHookCommonSettings(pCurr, &FuncHookHideItem);
}

MACRO_SetCustomFunctions(BoxCopyGUI_cls,OpenCustomADialog(),,)
MACRO_HideAndShowEmpty(BoxCopyGUI_cls);
MACRO_FuncHookHideItem(BoxCopy);

void BoxCopyGUI_cls::
SetMNumCustomA(wxWindow *pCParentWindow){
    
    mpCMNumCustomA = new MultiNumericalInputs_cls
	(&mpCMNumCustomA, pCParentWindow, wxID_ANY, wxT("Copy Setting"),
	 wxDefaultPosition, wxDefaultSize);
    
    MultiNumericalInputs_cls* pCurr = mpCMNumCustomA;
    pCurr->SetDefaultButtonType(_MN_OK_CANCEL_DEFAULT);
    pCurr->mTextWidth = -1;
    int boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  wxT("X[From:to]"));
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyFrom.mpBody[X]);
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyTo.mpBody[X]);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  wxT("Y[From:to]"));
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyFrom.mpBody[Y]);
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyTo.mpBody[Y]);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  wxT("Z[From:to]"));
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyFrom.mpBody[Z]);
    pCurr->CombinePointer
	(_GP_INTEGER, &mpCParent->mCData.mCCopyTo.mpBody[Z]);
    
    pCurr->FinishSettingDLG(FALSE);
    pCurr->SetScreenRectPos(&mCRectMNumCustomA);
};

void BoxCopyGUI_cls::
OpenCustomADialog(){
    mpCMNumCustomA->UpdateValues();
    mpCMNumCustomA->ShowModal();
}

// -----

BoxCopyData_cls::
BoxCopyData_cls(){
    // ʂ̃Xgɒǉ
    mCConfList.Add(&mCbMirroring, wxT("CopyMirriring="), L"0 0 0");
    mCConfList.Add(&mCbCopying,   wxT("CopyCopying="), L"0 0 0");
    mCConfList.Add(&mCCopyFrom,   wxT("CopyFrom="), L"-1 -1 -1");
    mCConfList.Add(&mCCopyTo,     wxT("CopyTo="), L"1 1 1");
}

void BoxCopyData_cls::
ReDefineList(){
    FilterData_cls::ReDefineListBase();
    mCConfList.Add(&mCbMirroring, wxT("CopyMirriring="));
    mCConfList.Add(&mCbCopying,   wxT("CopyCopying="));
    mCConfList.Add(&mCCopyFrom,   wxT("CopyFrom="));
    mCConfList.Add(&mCCopyTo,     wxT("CopyTo="));
}

MACRO_MakeInstanceAndAddToList(BoxCopy)

// -----

#include "../MYAPI/MsgBox.h"

BoxCopy_cls::
BoxCopy_cls(FilterCtrl_cls *pCParentCtrl, BoxCopyData_cls *pCInitData)
: FilterBase_cls(pCParentCtrl) {
    if (pCInitData != NULL) mCData = *pCInitData;
    ConstructorCommon(pCParentCtrl, _("Box Copy"), _FILTER_BOXCOPY);
    mpCGUIPanel = new BoxCopyGUI_cls(this);
}

MACRO_Filter_Destructor_Basic(BoxCopy);
MACRO_GetPData(BoxCopy);

void BoxCopy_cls::
AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel,
	   unsigned int index){
    ((BoxCopyGUI_cls*)mpCGUIPanel)->
	SetMNumPanel(pBoxSizer, pCFilterPanel, index);
    ((BoxCopyGUI_cls*)mpCGUIPanel)->
	SetMNumCustomA(pCFilterPanel);
    //wxGetTopLevelParent(pCPreviewPanel)->SetFocus();
}

// ----

wxString BoxCopy_cls::
GetFilterStatusStr(){
    wxString strStatus;
    strStatus << wxT("BoxCopy::");
    
    return strStatus;
}

MACRO_SerializeConf(BoxCopy)
MACRO_ReadDataBlock(BoxCopy)
