
#ifndef _FILTER_CENTEROFMASS_H_
#define _FILTER_CENTEROFMASS_H_

#include "../../CONFITEM/clsConfItem.h"
#include "../../FILTER/clsFilterBase.h"
#include "../../PARAMETER/clsParameters.h"

class DF3SeqGUI_cls;
class FilterCenterOfMassData_cls;
class FilterCenterOfMass_cls;

#include <wx/thread.h>

class FilterCenterOfMassGUI_cls : public FilterGUI_cls {
 public:
    /*
    FilterCenterOfMassGUI_cls(FilterCenterOfMass_cls *pCParent);
    FilterCenterOfMass_cls *mpCParent;
   
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    */
    MACRO_DefGUIMainSettings(FilterCenterOfMass);
    MACRO_DefVirtualCustmFunctions;

    int mIndexType;
    int mIndexMessage;

    void UpdateResult();

    static void FuncHookCombo(void *pArg, void *pEvent);
    static void FuncHookHideItem(void *pArg, void *pEvent);
};

class FilterCenterOfMassData_cls : public FilterData_cls {
 public:
    FilterCenterOfMassData_cls();

    void ReDefineList();

    ConfItemUINT_cls  mCType;
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
};

class ThreadCenterOfMass : public wxThread{
 public: 
    ThreadCenterOfMass();
    
    void SetParameters
	(FilterCenterOfMass_cls *pCParent, unsigned char *pSource,
	 int iniX, int finX, int iniY, int finY, int iniZ, int finZ, 
	 unsigned int size[3],
	 double Amomentum[3], double *pMass);

    virtual ExitCode Entry();

    FilterCenterOfMass_cls *pCParent;
    unsigned char *mpSource;
    unsigned int mIniX, mFinX;
    unsigned int mIniY, mFinY;
    unsigned int mIniZ, mFinZ;
    unsigned int mSize[3];
    double *mpMomentum, *mpMass;
};

class FilterCenterOfMass_cls : public FilterBase_cls {
 public:
    FilterCenterOfMass_cls(FilterCtrl_cls *pCParentCtrl,
			   FilterCenterOfMassData_cls* pCInitData = NULL);
    ~FilterCenterOfMass_cls();

    FilterCenterOfMassData_cls mCData;
    FilterData_cls* GetPData();

    // ---
    
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    FilterCenterOfMassData_cls* GetPCData();

    // ----
    
    double mACM[9999][3]; // FIX_ME!!
    double mAAverage[9999]; // FIX_ME!!
    double mCM[3];
    double mAverageDensity;
    double mCenter[3], mScale[3];
    wxString mstrMessage;
    void DoCalc(int frame, unsigned char *pSource, unsigned int size[3]);
    void UpdateResult();

    void DrawBox(int frame, double center[3], double scale[3]);

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static FilterCenterOfMassData_cls ReadDataBlock(std::wistream &istream);
};

#endif


