
#include "FilterUndo.h"

#include "../clsFilterCtrl.h"
#include "../../UNDO/clsUndoManager.h"

ComFilterConfChangeFLOAT::
ComFilterConfChangeFLOAT(FilterCtrl_cls *pCTgt, wxString strTag,
			 int index, float value){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mIndex = index;
    mValue = value;
}

bool ComFilterConfChangeFLOAT::
Execute(bool bFlag){
    mpCTgt->ChangeConfFLOATExecute(mstrTag, mIndex, mValue);
    return _COMMAND_NODEPENDENT;
}

ComFilterConfChangeINT::
ComFilterConfChangeINT(FilterCtrl_cls *pCTgt, wxString strTag,
			 int index, int value){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mIndex = index;
    mValue = value;
}

bool ComFilterConfChangeINT::
Execute(bool bFlag){
    mpCTgt->ChangeConfINTExecute(mstrTag, mIndex, mValue);
    return _COMMAND_NODEPENDENT;
}

ComFilterConfChangeBOOL::
ComFilterConfChangeBOOL(FilterCtrl_cls *pCTgt, wxString strTag,
			int index, bool value){
    mpCTgt = pCTgt;
    mstrTag = strTag;
    mIndex = index;
    mValue = value;
}

bool ComFilterConfChangeBOOL::
Execute(bool bFlag){
    mpCTgt->ChangeConfBOOLExecute(mstrTag, mIndex, mValue);
    return _COMMAND_NODEPENDENT;
}

// ----

ComFilterParamBase_cls::
ComFilterParamBase_cls(FilterCtrl_cls *pCTgt, int index){
    mpCTgt = pCTgt;
    mpCData = NULL;
    mIndex = index;
}

ComFilterParamBase_cls::
~ComFilterParamBase_cls(){
    if (mpCData != NULL) delete mpCData;
}

bool ComFilterParamBase_cls::
Execute(bool bFlag){
    mpCData->MakeFilterInstanceAndAddToList(mIndex, mpCTgt);
    return _COMMAND_NODEPENDENT;
}

ComFilterParamRemove_cls::
ComFilterParamRemove_cls(FilterCtrl_cls *pCTgt, int index):
    ComFilterParamBase_cls(pCTgt, index)
{
}

bool ComFilterParamRemove_cls::
Execute(bool bFlag){
    mpCTgt->DeleteFilterItem(mIndex);
    return _COMMAND_NODEPENDENT;
}

// ----

ComFilterParamSwap_cls::
ComFilterParamSwap_cls(FilterCtrl_cls *pCTgt, int index, int direction):
    ComFilterParamBase_cls(pCTgt, index)
{
    mDirection = direction;
}

bool ComFilterParamSwap_cls::
Execute(bool bFlag){
    mpCTgt->SwapFilterExecute(mIndex, mDirection);
    return _COMMAND_NODEPENDENT;
}
