
#ifndef _FILTER_UNDO_H_
#define _FILTER_UNDO_H_

#include "../../UNDO/clsUndoManager.h"

class ComFilterConfChangeFLOAT : public CommandItem_cls {
 public:
    ComFilterConfChangeFLOAT(FilterCtrl_cls *pCTgt, wxString strTag,
			     int index, float value);
    FilterCtrl_cls *mpCTgt;
    wxString mstrTag;
    int mIndex;
    float mValue;
    
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComFilterConfChangeINT : public CommandItem_cls {
 public:
    ComFilterConfChangeINT(FilterCtrl_cls *pCTgt, wxString strTag,
			    int index, int value);
    FilterCtrl_cls *mpCTgt;
    wxString mstrTag;
    int mIndex;
    int mValue;
    
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComFilterConfChangeBOOL : public CommandItem_cls {
 public:
    ComFilterConfChangeBOOL(FilterCtrl_cls *pCTgt, wxString strTag,
			    int index, bool value);
    FilterCtrl_cls *mpCTgt;
    wxString mstrTag;
    int mIndex;
    unsigned int mValue;
    
    bool Execute(bool bFlag = _COMMAND_REDO);
};

// ----

class ComFilterParamBase_cls : public CommandItem_cls {
 public:
    ComFilterParamBase_cls(FilterCtrl_cls *pCTgt, int index);
    ~ComFilterParamBase_cls();
    FilterCtrl_cls *mpCTgt;
    FilterData_cls *mpCData;
    int mIndex;
    
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComFilterParamRemove_cls : public ComFilterParamBase_cls {
 public:
    ComFilterParamRemove_cls(FilterCtrl_cls *pCTgt,
			     int index);
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComFilterParamSwap_cls : public ComFilterParamBase_cls{
 public:
    ComFilterParamSwap_cls(FilterCtrl_cls *pCTgt, int index, 
			   int direction);
    int mDirection;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

// -----

#define MACRO_CommandHeader(Filter)\
    class Com##Filter##ParamAdd_cls : public ComFilterParamBase_cls {	\
public:\
 Com##Filter##ParamAdd_cls\
 (FilterCtrl_cls *pCTgt, int index, void *pCData);\
};

MACRO_CommandHeader(Isosurface)
MACRO_CommandHeader(CrossSection)
MACRO_CommandHeader(Fog)
MACRO_CommandHeader(BoxCopy)
MACRO_CommandHeader(BlurGauss)
MACRO_CommandHeader(InvDiffuse)
MACRO_CommandHeader(Clipping)
MACRO_CommandHeader(LevelAndGamma)
MACRO_CommandHeader(Volume)
MACRO_CommandHeader(FixPosition)
MACRO_CommandHeader(DataRotate)
MACRO_CommandHeader(LayerColorCurve)
MACRO_CommandHeader(PovObject)
MACRO_CommandHeader(CenterOfMass)
MACRO_CommandHeader(MorphOpenClose)
MACRO_CommandHeader(PovDiffObject)
MACRO_CommandHeader(ThreeView)
MACRO_CommandHeader(PovStreamLine)
MACRO_CommandHeader(PovVelField)

#endif
