
#ifndef _BLUR_GAUSS_H_
#define _BLUR_GAUSS_H_

#include "../COMMON/clsMultiThreadCtrl.h"
#include "../CONFITEM/clsConfItem.h"
#include "../FILTER/clsFilterBase.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

class BlurGauss_cls;

class BlurGaussGUI_cls : public FilterGUI_cls {
 public:
    /*
    BlurGaussGUI_cls(BlurGauss_cls *pCParent);
    
    BlurGauss_cls *mpCParent;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    */
    MACRO_DefGUIMainSettings(BlurGauss);
    MACRO_DefVirtualCustmFunctions;

    int mIndexKernelSize, mIndexAsymSize;
    static void  FuncHookHideItem(void *pArg, void *pEvent);

};

class BlurGaussData_cls : public FilterData_cls {
 public:
    BlurGaussData_cls();

    void ReDefineList();
    ConfItemUINT_cls mCKernelType;
    ConfItemFLOAT_cls mCKernelSize;
    ConfItemFLOATARRAY_cls mCKernelAssimSize;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);

};

class ThreadBluringF : public MultiThreadThread_cls {
 public:

    ThreadBluringF(wxThreadKind kind);
    void SetParameters(BlurGauss_cls *pCParent,
		       float *pTo, float *pFrom, unsigned int size[3],
		       int initZ, int finZ, int direction);

    void BlurLineSSEIfInLoop(const int kernelSize, float *pKernel,
			     const int offsetBase, /*const int offsetScale,*/
			     const int lineWidth,
			     float *pIn, float *pOut);
    void BlurLineSSE(const int kernelSize, float *pKernel,
		     const int offsetBase, const int offsetScale,
		     const int lineWidth,
		     float *pIn, float *pOut);
    /*
    void BlurLine(int kernelSize, float *pKernel,
		  int offsetBase, int offsetScale, int lineWidth,
		  float *pIn, float *pOut);
    */
    virtual ExitCode Entry();
    
    BlurGauss_cls *mpCParent;
    float *mpTo, *mpFrom;
    int mSize[3];
    int mInitZ, mFinZ;
    int mDirection;
    //int mx, my, mz;
    int *mpConditionIndex;
};

class ThreadBluring : public MultiThreadThread_cls {
 public:
    ThreadBluring(wxThreadKind kind);
    void SetParameters(BlurGauss_cls *pCParent,
		       unsigned char *pTo, unsigned char *pFrom, unsigned int size[3],
		       unsigned char *pTmp,
		       int initZ, int finZ, int direction);

    void BlurLineSSE(const int kernelSize, const float *pKernel,
		     const int offsetBase, const int offsetScale, 
		     const int lineWidth,
		     const unsigned char *pIn, unsigned char *pOut);
    void BlurLineIfInLoop(const int kernelSize, float *pKernel,
			  const int offsetBase, const int offsetScale, 
			  const int lineWidth,
			  unsigned char *pIn, unsigned char *pOut);
    void BlurLine(const int kernelSize, float *pKernel,
		  const int offsetBase, const int offsetScale, 
		  const int lineWidth,
		  unsigned char *pIn, unsigned char *pOut);
    virtual ExitCode Entry();
    
    BlurGauss_cls *mpCParent;
    unsigned char *mpTo, *mpFrom, *mpTmp;
    int mSize[3];
    int mInitZ, mFinZ;
    int mDirection;
};

class BlurGauss_cls : public FilterBase_cls {
 public:
    BlurGauss_cls(FilterCtrl_cls *pCParentCtrl,
		  BlurGaussData_cls *pCInitData = NULL);
    ~BlurGauss_cls();

    BlurGaussData_cls mCData;
    FilterData_cls*  GetPData();

    unsigned char *mpTmp;
    bool mbAllocated;
    int mAllocatedSize;

    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);

    //--
    
    bool ProcessXYZDataF(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]);
    bool ProcessXYZDataC(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]);
    void ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3], int totalsize, bool bSSE);
    
    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    
    static BlurGaussData_cls ReadDataBlock(std::wistream &istream);
};

#endif
