
#ifndef _DATA_ROTATE_H_
#define _DATA_ROTATE_H_

class DataRotateData_cls;

#include "../COMMON/clsMultiThreadCtrl.h"
#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

class DataRotate_cls;

class DataRotateGUI_cls : public FilterGUI_cls {
 public:
    MACRO_DefGUIMainSettings(DataRotate);
    MACRO_DefVirtualCustmFunctions;

    void AdvancedSetting();

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class DataRotateData_cls : public FilterWithParameterData_cls {
 public:
    DataRotateData_cls(FilterCtrl_cls* pCCtrl,
		       bool bConnectToStaticParam = TRUE);

    void ReDefineList();
    ConfItemUINT_cls mCAxis;
    ConfItemBOOL_cls mCbTrimOutside;
    ConfItemBOOL_cls mCbBilinear;

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();
    
    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class ThreadRotate : public MultiThreadThread_cls {
 public:
    ThreadRotate(wxThreadKind kind);
    void SetParameters(DataRotate_cls *pCParent,
		       unsigned char *pTo, unsigned char *pFrom, 
		       unsigned int size[3],
		       int S, int T, int U, int layerIni, int layerFin,
		       float *pRotTableFloatX, float *pRotTableFloatY,
		       float *pRotTableFloatZ);

    unsigned char GetSmoothedValue(float x, float y, float z);
    virtual ExitCode Entry();
    
    DataRotate_cls *mpCParent;
    unsigned char *mpTo, *mpFrom;
    float *mpRotTableFloatX, *mpRotTableFloatY, *mpRotTableFloatZ;
    int mSize[3];
    int mS, mT, mU;
    int mLayerIni, mLayerFin;
};

class DataRotate_cls : 
public FilterWithParameter_cls, public MultiThreadCtrl_cls {
 public:
    DataRotate_cls(FilterCtrl_cls *pCParentCtrl,
		   DataRotateData_cls *pCInitData = NULL);
    ~DataRotate_cls();
    
    int mTableS, mTableT;
    float *mpRotTableFloatX, *mpRotTableFloatY, *mpRotTableFloatZ;

    void MakeTable(int S, int T, int U, unsigned int sizeXYZ[3], int sizeS, int sizeT);

    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    DataRotateData_cls* GetPCData();

    //--

    void SetMNumAdvanced(wxWindow *pCParentWindow);

    //--

    bool ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]);

    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static DataRotateData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
};

#endif

