
#include "clsFilterCtrl.h"
#include "clsFilterWithSelect.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsAtoiComboCtrl.h"

#include "../MYAPI/MsgBox.h"

#include <list>

FilterWithTargetGUI_cls::
FilterWithTargetGUI_cls(FilterBase_cls *pCParent) 
  : FilterWithTextureGUI_cls(pCParent)
{
    mIndexTarget = 0;
    mIndexOnList = 0;
    pCParent->mbWithSelect = TRUE;
}

void FilterWithTargetGUI_cls::
UpdateListMain(){
    AtoiComboCtrl_cls* pCCombo = (AtoiComboCtrl_cls*)mpCMNumPanel->mVCPointers[mIndexTarget].mpPointerCtrl;
    pCCombo->Clear();
    
    if (mFilterType == _FILTER_FOG || mFilterType == _FILTER_CLIPPING){
	if (mFilterType == _FILTER_CLIPPING) pCCombo->Append(wxT("All"));
	pCCombo->Append(_("Volume"));
	if (mFilterType == _FILTER_CLIPPING) pCCombo->Append(_("Object"));
	if (mFilterType == _FILTER_FOG) pCCombo->Append(_("Global"));
	int index = 1;
	for (std::list<FilterBase_cls*>::iterator itr = mpCParentBase->mpCParentCtrl->mVpCFilter.begin();
	     itr != mpCParentBase->mpCParentCtrl->mVpCFilter.end(); itr++, index++){
	    int filterInList = (*itr)->mFilterType;
	    if (mFilterType == _FILTER_CLIPPING){
		if (filterInList == _FILTER_ISOSURFACE ||
		    filterInList == _FILTER_FIX_POSITION ||
		    filterInList == _FILTER_CENTEROFMASS ||
		    filterInList == _FILTER_VELOCITY_FIELD)
		    pCCombo->Append((*itr)->GetPData()->mCstrCustomName.msBody);
		if (filterInList == _FILTER_STREAMLINE){
		    pCCombo->Append((*itr)->GetPData()->mCstrCustomName.msBody + wxT("_Root"));
		    pCCombo->Append((*itr)->GetPData()->mCstrCustomName.msBody + wxT("_Clip"));
		}
	    }
	    
	    if (mFilterType == _FILTER_FOG){
		if ((*itr)->mFilterType == _FILTER_ISOSURFACE ||
		    (*itr)->mFilterType == _FILTER_POV_OBJECT)
		    pCCombo->Append((*itr)->GetPData()->mCstrCustomName.msBody/*mstrLabel*/);
	    }
	}
    }
    
    if (mFilterType == _FILTER_ISOSURFACE){
	pCCombo->Append(_("Solid"));
	pCCombo->Append(_("Empty"));
	for (std::list<FilterBase_cls*>::iterator itr = mpCParentBase->mpCParentCtrl->mVpCFilter.begin();
	     itr != mpCParentBase->mpCParentCtrl->mVpCFilter.end(); itr++){
	    if ((*itr)->mFilterType == _FILTER_VOLUME){
		pCCombo->Append((*itr)->mstrLabel);
	    }
	}
    }
}

void FilterWithTargetGUI_cls::
UpdateList(){
    UpdateListMain();
    ((AtoiComboCtrl_cls*)mpCMNumPanel->
     mVCPointers[mIndexTarget].mpPointerCtrl)->UpdateDisplay();
}

void FilterWithTargetGUI_cls::
SetTargetLabelStr(wxString strTarget){
    ((wxComboBox*)mpCMNumPanel->mVCPointers[mIndexTarget].mpPointerCtrl)->
	SetValue(strTarget);

    mIndexOnList = ((AtoiComboCtrl_cls*)mpCMNumPanel->mVCPointers[mIndexTarget].mpPointerCtrl)->UpdateValueFromText();
}

wxString FilterWithTargetGUI_cls::
GetTargetLabelStr(){
    return ((wxComboBox*)mpCMNumPanel->mVCPointers[mIndexTarget].mpPointerCtrl)->
	GetValue();
}

