
#ifndef _FILTER_WITH_TEXTURE_H_
#define _FILTER_WITH_TEXTURE_H_

#include "clsFilterBase.h"
#include "../MYGL/clsTextureProperty.h"

class Parameters_cls;
class PovObject_cls;
class TexPropertyCtrl_cls;
class TexProperty_cls;
class MultiNumericalInputsPanel_cls;

#include <wx/wx.h>

class FilterWithTextureGUI_cls : public FilterGUI_cls{
 public:
    FilterWithTextureGUI_cls(FilterBase_cls *pCParent);

    int mIndexColorType, mIndexColorBar;
    void UpdateColorList();

    PanelColorBar_cls *mpCPanelColorBar;
    void   InitializeColorPanel(wxWindow *pCParentWindow, void *pClue, 
				double (*pFuncGetR)(double, void*), 
				double (*pFuncGetG)(double, void*), 
				double (*pFuncGetB)(double, void*),
				wxString strLabel);
	 
    void RefreshColorBar();
    TexProperty_cls* GetPCTexProperty();
    double GetColor(double value, int rgbIndex);
    static double GetColorR(double value, void *pClue);
    static double GetColorG(double value, void *pClue);
    static double GetColorB(double value, void *pClue);

    static TexPropertyCtrl_cls *mspCLinkTexpropertyCtrl;
    static void LinkTexturePropertyCtrl(TexPropertyCtrl_cls *pTexpropertyCtrl);
    static void FuncHookUpdateTextureDLG(void *pArg, void *pEvent);

    static void FuncHookOpenTextureDLG(void *pArg, void *pEvent);
    void OpenTextureDLG(bool bForceOpen);
};

class FilterWithTextureData_cls {
 public:
    TexProperty_cls mCTexProperty;
};

#endif
