
#ifndef _FILTER_FIX_POSITION_H_
#define _FILTER_FIX_POSITION_H_

#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithSelect.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../PARAMETER/clsParameters.h"

class DF3SeqGUI_cls;
class FilterFixPositionData_cls;
class FilterFixPosition_cls;

#define _TRACK_RANGE_X 10
#define _TRACK_RANGE_Y 10
#define _TRACK_RANGE_Z 10

#include <wx/thread.h>

class FilterFixPositionGUI_cls : public FilterGUI_cls {

    MACRO_DefGUIMainSettings(FilterFixPosition);
    MACRO_DefVirtualCustmFunctions;

    void CopyResult();
    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class FilterFixPositionData_cls : public FilterWithParameterData_cls {
 public:
    FilterFixPositionData_cls(FilterCtrl_cls* pCCtrl, 
			      bool bConnectToStaticParam = TRUE);
    
    void ReDefineList();
    ConfItemBOOLARRAY_cls mCAxisSwitch;
    
    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT]; // 
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class ThreadCalcDifference : public wxThread {
 public:
    ThreadCalcDifference();
    void SetParameters(FilterFixPosition_cls *pCParent,
		       unsigned int size[3],
		       double xIni, double xFin,
		       double yIni, double yFin,
		       double zIni, double zFin,
		       int offsetX, int offsetY, int offsetZ);

    virtual ExitCode Entry();

    FilterFixPosition_cls *mpCParent;
    int mOffsetX, mOffsetY, mOffsetZ;
    unsigned int mSize[3];
    int mIniX, mFinX, mIniY, mFinY, mIniZ, mFinZ;
    bool mbValid;
    bool mbRunning;
};

class FilterFixPosition_cls : public FilterWithParameter_cls {
 public:
    FilterFixPosition_cls(FilterCtrl_cls *pCParentCtrl,
			  FilterFixPositionData_cls *pCInitData);
    ~FilterFixPosition_cls();
    
    //--
    
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    static void InitializeStaticMember(int df3index);
    FilterFixPositionData_cls* GetPCData();
    
    //--

    void SetMNumAdvanced(wxWindow *pCParentWindow);
    
    unsigned int *mpDataPrev, *mpDataCurr;
    bool mbAllocatedDataPrev;
    bool mbDoCalc;
    static int msAdX[7];
    static int msAdY[7];
    static int msAdZ[7];
    double mADifference[9999][3]; // FIX_ME!!
    int mMatrixDifference[_TRACK_RANGE_X*2+1][_TRACK_RANGE_Y*2+1][_TRACK_RANGE_Z*2+1];
    int mFrameIndexPrev;
    void DoCalc(int frame, unsigned char *pSource, unsigned int size[3]);
    void CopyResult();
    void GetTranslate(double pTrans[3], int frame, int frameMax, unsigned int size[3]);
		
    //--

    wxString GetFilterStatusStr();
    //-- parametert̏ꍇGetNewPŏ
    wxString SerializeConf();
    static FilterFixPositionData_cls* 
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl, std::wistream &istream);
};

#endif
