
#ifndef _INV_DIFFUSE_H_
#define _INV_DIFFUSE_H_

#include "../COMMON/clsMultiThreadCtrl.h"
#include "../CONFITEM/clsConfItem.h"
#include "../FILTER/clsFilterBase.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

class InvDiffuse_cls;

#include <wx/wx.h>
#include <wx/thread.h>

class InvDiffuseGUI_cls : public FilterGUI_cls {
 public:
    MACRO_DefGUIMainSettings(InvDiffuse);
    MACRO_DefVirtualCustmFunctions;

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class InvDiffuseData_cls : public FilterData_cls {
 public:
    InvDiffuseData_cls();

    void ReDefineList();
    ConfItemINT_cls mCIteration;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
};

class ThreadDiffuse : public MultiThreadThread_cls {
 public:

    ThreadDiffuse(wxThreadKind kind);
    void SetParameters(InvDiffuse_cls *pCParent,
		       float *pTo, float *pFrom, unsigned int size[3],
		       int initY, int finY, int direction);

    void Initialize(float *pSRC, float *pDST,
		    int sizeX, int sizeY, int sizeZ);
    virtual ExitCode Entry();
    
    InvDiffuse_cls *mpCParent;
    float *mpTo, *mpFrom;
    int mSize[3];
    int mInitY, mFinY;
    int mDirection;

    int *mpConditionIndex;
};

class InvDiffuse_cls : public FilterBase_cls, public MultiThreadCtrl_cls {
 public:
    InvDiffuse_cls(FilterCtrl_cls *pCParentCtrl,
		   InvDiffuseData_cls *pCInitData = NULL);
    ~InvDiffuse_cls();

    InvDiffuseData_cls mCData;
    FilterData_cls*  GetPData();

    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    InvDiffuseData_cls* GetPCData();

    //--
    
    bool ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]);
    
    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    
    static InvDiffuseData_cls ReadDataBlock(std::wistream &istream);
};

#endif
