
#ifndef _LAYER_COLOR_CURVE_H_
#define _LAYER_COLOR_CURVE_H_

class LayerColorCurve_cls;

#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../PARAMETER/clsParameters.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

#include <wx/thread.h>

class ThreadMakeLayer : public wxThread {
 public:
    ThreadMakeLayer(unsigned short *pTmpBuffer, int type, bool bDither,
		    unsigned int size[3], int z, int indexZ, double distance2,
		    double *pInPoint, double *pRelativeVector,
		    int inValue, int outValue);

    virtual ExitCode Entry();

    unsigned short *mpTmpBuffer;
    int mType;
    bool mbDither;
    int mSize[3];
    int mZ, mIndexZ;
    double *mpInPoint, *mpRelativeVector;
    double mDistance2;
    int mInValue, mOutValue;
    
};

class LayerColorCurveGUI_cls : public FilterGUI_cls {
 public:
    MACRO_DefGUIMainSettings(LayerColorCurve);
    MACRO_DefVirtualCustmFunctions;

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class LayerColorCurveData_cls : public FilterWithParameterData_cls {
 public:
    LayerColorCurveData_cls(FilterCtrl_cls* pCCtrl,
			    bool bConnectToStaticParam = TRUE);

    void ReDefineList();

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT]; // 
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();

    ConfItemUINT_cls mCCompositeType;
    ConfItemBOOL_cls mCCompositeDither;
    ConfItemFLOAT_cls mCDensityIn;
    ConfItemFLOAT_cls mCDensityOut;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class LayerColorCurve_cls : public FilterWithParameter_cls {
 public:
    LayerColorCurve_cls(FilterCtrl_cls *pCParentCtrl,
			LayerColorCurveData_cls *pCInitData = NULL);
    ~LayerColorCurve_cls();

    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    static void InitializeStaticMember(int df3index);
    LayerColorCurveData_cls* GetPCData();

    //--

    bool ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, 
			unsigned int size[3]);

    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static LayerColorCurveData_cls* 
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl, 
			     std::wistream &istream);
};

#endif
