
#ifndef _LEVEL_AND_GAMMA_H_
#define _LEVEL_AND_GAMMA_H_

class LevelAndGamma_cls;

#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../PARAMETER/clsParameters.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

#define _LEVEL_IN_MIN 0
#define _LEVEL_IN_MAX 1
#define _LEVEL_OUT_MIN 2
#define _LEVEL_OUT_MAX 3
#define _LEVEL_GAMMA 4
#define _LEVEL_OFFSET 5

#include <wx/thread.h>

class LevelAndGammaGUI_cls : public FilterGUI_cls {
 public:
    /*
    LevelAndGammaGUI_cls(LevelAndGamma_cls *pCParent);
    LevelAndGamma_cls *mpCParent;
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    */
    MACRO_DefGUIMainSettings(LevelAndGamma);
    MACRO_DefVirtualCustmFunctions;

    static void FuncHookHideItem(void *pArg, void *pEvent);
};

class LevelAndGammaData_cls : public FilterWithParameterData_cls {
 public:
    LevelAndGammaData_cls(FilterCtrl_cls* pCCtrl,
			  bool bConnectToStaticParam = TRUE);

    void ReDefineList();
    ConfItemBOOL_cls mCbLevelSmooth;

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT]; // 
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class ThreadLevel : public wxThread {
 public:
    ThreadLevel();
    void SetParameters(LevelAndGamma_cls *pCParent,
		       unsigned char *pTo, unsigned char *pFrom, 
		       int ini, int cfin,
		       unsigned char *pLevelMap);

    virtual ExitCode Entry();
    
    LevelAndGamma_cls *mpCParent;
    unsigned char *mpTo, *mpFrom;
    int mIni, mFin;
    unsigned char *mpLevelMap;
};


class LevelAndGamma_cls : public FilterWithParameter_cls {
 public:
    LevelAndGamma_cls(FilterCtrl_cls *pCParentCtrl, 
		      LevelAndGammaData_cls *pCInitData = NULL);
    ~LevelAndGamma_cls();

    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    LevelAndGammaData_cls*  GetPCData();

    //--

    void SetMNumAdvanced(wxWindow *pCParentWindow);

    //-- 
    
    double GetErfApprox(double value);
    double GetLevelIn(double value);
    double GetLevelMapping(double value);
    void MakeLevelMap(unsigned char ALevelMap[256]);
    bool ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]);

    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static LevelAndGammaData_cls* 
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl, std::wistream &istream);
};

#endif
