// -*- c -*-
// "clsDolly.cpp"

#ifndef _DOLLY_H_
#define _DOLLY_H_

#define _DOLLY_TRANSLATE 0
#define _DOLLY_SCALE  1
#define _DOLLY_ROTATE 2

#include "clsMouseCtrl.h"
#include "../MYGL/clsPositionAndDirection.h"

class MouseNormalized_cls;
class Preference_cls;
class SceneObj_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#include <wx/wx.h>

#define _DOLLY_LINKED 7

class Dolly_cls{
 public:
    Dolly_cls(Preference_cls *pCPreferenceLink);
    
    Preference_cls *mpCPreferenceLink;
    static SceneObj_cls *mspCSelectedObject;
    static double        msSelectedItemPos[3];
    static double        msSelectedItemPosOrg[3];
    static double        msSelectedItemScale[3];
    static double        msSelectedItemDRot[3];
    
    double mSensitivity;
    double mAspectRatio;
    MouseNormalized_cls *mpCMP;
    float  mMouseX, mMouseY;
    int    mDisplayMode;

    double mMatrixModelView[16];
    double mMatrixProjection[16];
    int    mMatrixViewport[4];
    void   GetGLMatrixInfo();
    
    double mPosItemOnW[3];
    double mPosItemOrgOnW[3];

    void SetParameter(double sensitivity, MouseNormalized_cls *pCMP, 
		      wxSize sz, int displayMode);
    bool Gyration  (PositionAndDirection_cls *pCCamPos);
    bool Zoom      (PositionAndDirection_cls *pCCamPos, float *pOrthoScale);
    bool MoveCenter(PositionAndDirection_cls *pCCamPos,
		    Position_cls *pCAncPos);
    void MoveItemTranslate(PositionAndDirection_cls *pCCamPos, 
			   double aspectRatio, double dragX, double dragY,
			   int dragMode);
    void MoveItemRotate(double dragRot, int dragMode);
    void DrawMouseGuide(int moveMode, int dragMode,
			int panelWidth, int PanelHeight,
			int bufferWidth, int bufferHeight);
    bool MoveItem(PositionAndDirection_cls *pCCamPos,
		  bool bDragging, wxSize sz, int dragMode, int moveMode,
		  bool bInv);
    bool ZoomWheel (PositionAndDirection_cls *pCCamPos, 
		    double wheelRotation, float *pOrthoScale);

    void FinishDragging();
};

#endif
