// -*- c -*- 
// (setq c-basic-offset 4)
// ("GLOBJSphere.h")

//iWOʑ̈ȏj` 

//------------------------------------
//ɁAkɂ́@zɗ悤ɂ(2007/3/24)
//------------------------------------

//--------------------------------------------
// ɂɂ\݂̍钸_͏ɂRԖڂɂ 
//--------------------------------------------

#include <math.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include "GLOBJSphere.h"
#include "../COMMON/MyVector.h"

#define GLOBJ_SPHERE1 0.447213595f
#define GLOBJ_SPHERE2 0.894427190f
#define GLOBJ_SPHERE3 0.276393202f
#define GLOBJ_SPHERE4 0.723606797f
#define GLOBJ_SPHERE5 0.525731112f
#define GLOBJ_SPHERE6 0.850650808f

#define X 0
#define Y 1
#define Z 2

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#define M_PI_F 3.131593f

namespace GLOBJ {
    /*!
      @brief XYZW theta-phi Wɕϊ
    */
    void ChangeCoordinate3Dto2D(double vec3D[3], double vec2D[2]){
	int phi = 0, theta = 1;
	vec2D[phi] = atan2(vec3D[Y], -vec3D[X]);
	vec2D[phi] = (vec2D[phi] + M_PI_F)/(2.0f * M_PI_F);
	vec2D[theta] = (double)atan2(vec3D[Z], 
				     (double)sqrt(vec3D[X]*vec3D[X]+vec3D[Y]*vec3D[Y]));
	vec2D[theta] = (vec2D[theta]+M_PI_F/2.0f)/M_PI_F;
    }
    
    /*!
      @brief x[0,1] y[0,1] ͈̔͂͂ݏoW̏C
    */
    void AdjustVec2DOverBoundary(double vector[2], double vectormem[2]){
	for (int xy = 0; xy <= 1; xy++){
	    if (vector[xy]-vectormem[xy] > 0.5)
		vector[xy] = vector[xy] - 1.0f; 
	    if (vector[xy]-vectormem[xy] < -0.5)
		vector[xy] = vector[xy] + 1.0f; 
	}
    }
  
    /*!
      @brief @AeNX`W݂ŁARp`|S\B
    */
    void Sphere::DrawTriangle(double v1[3], double v2[3], double v3[3]){
	double normal1[3],normal2[3],normal3[3];
	double texvector1[2],texvector2[2],texvector3[2];
	LOOP_XYZ{
	    normal1[xyz] = v1[xyz];
	    normal2[xyz] = v2[xyz];
	    normal3[xyz] = v3[xyz]; 
	}
	glBegin(GL_TRIANGLES);

	// @xNgAeNX`WA_W ^ ̂P
	MyVector::Normalize(normal1, 1.0f);
	glNormal3dv(normal1);
	ChangeCoordinate3Dto2D(normal1, texvector1); 
	glTexCoord2dv(texvector1);
	glVertex3dv(v1);
  
	// @xNgAeNX`WA_W ^ ̂Q
	MyVector::Normalize(normal2,(double)1.0);glNormal3dv(normal2);
	ChangeCoordinate3Dto2D(normal2, texvector2); 
	AdjustVec2DOverBoundary(texvector2, texvector1); 
	glTexCoord2dv(texvector2);
	glVertex3dv(v2);

	// @xNgAeNX`WA_W ^ ̂R
	// eNX`Ŵ͂ݏoĂB
	MyVector::Normalize(normal3,(double)1.0);glNormal3dv(normal3);
	ChangeCoordinate3Dto2D(normal3, texvector3); 
	if (texvector3[Y] > 0.99 || texvector3[Y] < 0.01) {
	    texvector3[X] = (texvector1[X] + texvector2[X])/2.0f; 
	}
	else {
	    AdjustVec2DOverBoundary(texvector3, texvector2); 
	}
	glTexCoord2dv(texvector3);
	glVertex3dv(v3);

	glEnd();
    }

    /*!
      @brief ċAIɂRp`|S𕪊āA炩ȋ`悷
     */
    void Sphere::DivideTriangle(double v1[3], double v2[3], double v3[3], int depth){
	double v12[3], v23[3], v31[3];
	
	if (depth <= 0){
	    DrawTriangle(v1,v2,v3);
	    return;}
	
	for (int i=X; i<= Z; i++){
	    v12[i] = v1[i] + v2[i];
	    v23[i] = v2[i] + v3[i];
	    v31[i] = v3[i] + v1[i]; }
	MyVector::Normalize(v12,(double)1.0);
	MyVector::Normalize(v23,(double)1.0);
	MyVector::Normalize(v31,(double)1.0);
	DivideTriangle(v1,v12,v31, depth-1);
	DivideTriangle(v2,v23,v12, depth-1);
	DivideTriangle(v12,v23,v31, depth-1);
	DivideTriangle(v31,v23,v3, depth-1);
    }

    /*!
      @brief Rp`|Sg̕`
      @param[in] depth `[x
      @param[in] iMode `惂[h
      @param[out] VKfBXvCXgԍ
     */
    int Sphere::DListDraw(int depth, int iMode){
	GLdouble icosahedronv[12][3] = {
	    {             0,             0,             1},
	    {             0, GLOBJ_SPHERE2, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1}, 
	    {-GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    {             0,-GLOBJ_SPHERE2,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6,-GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {             0,             0,            -1} };

	GLint icosahedronface[20][3] = {
	    {1,2,0},{2,3,0},{3,4,0},{4,5,0},{5,1,0},
	    {1,6,2},{2,6,7},{2,7,3},{3,7,8},{4,3,8},
	    {4,8,9},{4,9,5},{5,9,10},{5,10,1},{1,10,6},
	    {6,10,11},{7,6,11},{8,7,11},{9,8,11},{10,9,11} };
	
	int    listName = 0;
	double tmpvector0[3], tmpvector1[3], tmpvector2[3];
  
	// TEXTURE̊͂Őݒ肵ĂӖ 
	// ł́AWƃeNX`̈ʒu֌Ŵ݂^ 
  	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ 
	    glNewList (listName, iMode); 
	}

	for (int i=0; i<20; i++){
	    LOOP_XYZ{
		tmpvector0[xyz] = icosahedronv[icosahedronface[i][0]][xyz];
		tmpvector1[xyz] = icosahedronv[icosahedronface[i][1]][xyz];
		tmpvector2[xyz] = icosahedronv[icosahedronface[i][2]][xyz];}
	    DivideTriangle(tmpvector0,tmpvector1,tmpvector2,depth);}
	
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }

}
