// (setq c-basic-offset 4)

#ifndef _IMAGE_IO_H_
#define _IMAGE_IO_H_

#include <string>
#include <wx/wx.h>
#include <wx/thread.h>

class ImageIO_cls;

#define _IMAGE_OUT_MAX_THREAD 4

class ThreadSave_cls : public wxThread {
 public:
    ThreadSave_cls();
    void SetParameters(ImageIO_cls *pCParent,
		       int width, int height, wxString strFileOut,
		       unsigned char *pBuffer = NULL,
		       bool bFreeDataAtEnd = TRUE);
    ImageIO_cls *mpCParent;
    unsigned char *mpBuffer;
    bool mbAllocLocal;
    int mWidth, mHeight;
    wxString mstrFileOut;

    virtual ExitCode Entry();
};

class ImageIO_cls {
 public:
    ImageIO_cls();
    ~ImageIO_cls();

    int mJPEGQuality;
    int mActiveThread;
    bool mbSaveThreadActive[_IMAGE_OUT_MAX_THREAD];
    ThreadSave_cls *mpCThreadSave[_IMAGE_OUT_MAX_THREAD];
    
    wxString mstrLastSavedFile;
    wxString mstrFile;

    bool SaveImageFromData(int width, int height, wxString strFileOut,
			   unsigned char* pBuffer);
    bool SaveImageFromGL(int width, int height);
    bool SaveImageFromGL(int width, int height, wxString strFileOut,
			 int offsetX = 0, int offsetY = 0);
    bool SelectFile(wxString strDefaultFile, wxWindow *pC);
    void SetFilenameStereo(int eyeType);
};

#endif

