// (setq c-basic-offset 4)

#ifndef _IMG_SEQUENCE_H_
#define _IMG_SEQUENCE_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsGLPerspective.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

class ImgSequence_cls;
class ImageIO_cls;

class ImgSequenceGUI_cls : public wxDialogEXKey {
 public:
    ImgSequenceGUI_cls(ImgSequence_cls* pCParent,
		       wxWindow *pC, wxPoint pos, wxSize size);

    ImgSequence_cls* mpCParent;

    void OnButtonReference(wxCommandEvent &event);
    void OnButtonRender(wxCommandEvent &event);
    void OnButtonClose(wxCommandEvent &event);
    void AbortRender();
    void OutputFinish();
    
    MultiNumericalInputsPanel_cls* mpCMNumImgSeqParam;
    void SetMNumImgSeqParam(wxBoxSizer *pBoxSizer);
    
    wxButtonEX *mpCButtonRender;
    //wxButtonEX *mpCButtonAbort;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ImgSequence_cls : 
public DialogControl_cls
{
 public:
    ImgSequence_cls(wxWindow *pCParent);
    //~ImgSequence_cls();

    ImgSequenceGUI_cls *mpCGUI;
    FileSequenceWX_cls mCFileSequence;
    
    ConfItemINT_cls mCInitNum;
    int             mCurrentOffset;
    int             mCurrentStereo;
    bool            mbInRendering;

    int   mClipWidthMax;
    int   mClipHeightMax;
    float mAngleOrg;
    int   mClipWidth;
    int   mClipHeight;
    float mClipAngle;
    int mOffsetX, mOffsetY;
    void SetGeom(int width, int height, float angle,
		 bool bSetTrim = FALSE);
    void CalcOffset(int widthOrg, int heightOrg);
    
    wxString GetWXStrModifiedFilename();
    void SetDefaultPath(wxString strPath);
    bool SaveImageFromGL(ImageIO_cls *pCImageIO, int widthOrg, int heightOrg, int offset, int stereo);
    void Increment(int offset);

    void SetToDefault();
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);

    //void DisableAbort();
    
    void RenderFrameBoxInRender(int width, int height, GLPerspective_cls CGLPerspective);
};

#endif
