// "clsFilePathEditor.h"

#include "clsFilePathEditor.h"
#include "../../wxWidgetEnum.h"
#include "../COMMON/clsFilename.h"
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX*   GpCFileDialog;

FPathEdit_cls::
FPathEdit_cls(){
    mstrBuffer = wxT("");
    mIntegerA = 0; mIntegerB = 0;
    mbEnableA = 0; mbEnableB = 0;
    mbSave = FALSE;
    mpCMNumEditDialog = NULL;
}

void FPathEdit_cls::
SetMNumEditor(wxWindow *pC){
    mpCMNumEditDialog = new MultiNumericalInputs_cls(&mpCMNumEditDialog, pC, wxID_ANY, _("Edit path"));
    
    MultiNumericalInputs_cls* 
	pCurr = mpCMNumEditDialog;
    
    int boxWidth = 3;
    pCurr->SetDefaultButtonType(_MN_OK_CANCEL_DEFAULT | _MN_HELP);
    pCurr->CombinePointer(_GP_WXSTRING, &mstrBuffer);
    pCurr->DisableHookSpace(_MN_LASTITEM);
    
    pCurr->mTextWidth = 120;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Initial sequence"));
    pCurr->mItemWidth = 120;
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mIntegerA);
    pCurr->SetRange(0, 65535);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mIntegerB);
    pCurr->SetRange(0, 65535);
    pCurr->CombinePointerButton(buttonCtrlMainRefEditor, _("Reference"));
    pCurr->mItemWidth = -1;
    
    pCurr->mProportion = 0;
    pCurr->FinishSettingDLG(FALSE);
    mpCMNumEditDialog->SetSize(480, wxDefaultCoord);
}

bool FPathEdit_cls::
OpenModalDialog(wxString strTitle){
    mpCMNumEditDialog->UpdateValues();
    SetDisable();
    mpCMNumEditDialog->SetTitle(wxString::Format
				(_T("%s-%s"), 
				 strTitle.c_str(), _("Edit path")));
    if (mpCMNumEditDialog->ShowModal() == wxID_OK) return TRUE;
    return FALSE;
}

void FPathEdit_cls::
SetDisable(){
    mpCMNumEditDialog->mVCPointers[2].GetPCtrlWindow()->Enable(mbEnableA);
    mpCMNumEditDialog->mVCPointers[3].GetPCtrlWindow()->Enable(mbEnableB);
}

void FPathEdit_cls::
SetString(wxString strBuffer){
    mstrBuffer = strBuffer;
    mpCMNumEditDialog->UpdateValues();
    mpCMNumEditDialog->Raise();
}

void FPathEdit_cls::
ProcFileDialog(wxString strDefaultPath){
    GpCFileDialog->SetMessage(wxT("Coose first file"));
    if (mbSave == TRUE)
	GpCFileDialog->SetStyle(wxFD_SAVE);
    
    if (strDefaultPath != wxT("")){
	SplitPathWX_cls CPath(strDefaultPath);
	GpCFileDialog->SetInitPath(CPath.GetPathWXStr(_FN_DRIVE_DIR));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK)
	SetString(GpCFileDialog->GetPath());
}
