// (setq c-basic-offset 4)
// "clsFilterPanelPain.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "clsFilterPanelPain.h"

#include "../MYAPI/MsgBox.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FilterPanelPain_cls, wxScrolledWindow)
EVT_MOUSE_EVENTS(FilterPanelPain_cls::OnMouse)
EVT_NOTEBOOK_PAGE_CHANGED(ID_BOOK_DATASLOT, FilterPanelPain_cls::OnPageChanged)
//     EVT_KEY_DOWN(PreviewPanel_cls::OnKeyDown)
END_EVENT_TABLE()

wxColour FilterPanelPain_cls::msColourActive[4] = 
{wxColour(255, 32, 32), wxColour(32, 255, 32), wxColour(32, 64, 255), wxColour(255, 255, 255)};
wxColour FilterPanelPain_cls::msColourInactive[4] = 
{wxColour(164, 96, 96), wxColour(96, 164, 96), wxColour(64, 64, 164), wxColour(164, 164, 164)};

FilterPanelPain_cls::
FilterPanelPain_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxScrolledWindow(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxVSCROLL )
{
    SetScrollbars(0, 5, 0, 50);
    EnableScrolling(FALSE, TRUE);
    mpCParentFrame = pCFrame;

    wxBoxSizer  *pCBoxSizerSRC = new wxBoxSizer(wxVERTICAL);

    mpCBookMain = new wxNotebook(this, ID_BOOK_MAINBOX);

    mpCParentFrame->SetMNumBoxInformation(NULL, mpCBookMain);
    mpCParentFrame->SetMNumPlayOption    (NULL, mpCBookMain);
    mpCParentFrame->SetMNumDownSizing    (NULL, mpCBookMain);
    
    mpCBookMain->AddPage(mpCParentFrame->mpCMNumBoxInformation, _("Sim. Box"));
    mpCBookMain->AddPage(mpCParentFrame->mpCMNumPlayOption, _("Play"));
    mpCBookMain->AddPage(mpCParentFrame->mpCMNumDownSizing, _("Down Size"));
    
    pCBoxSizerSRC->Add(mpCBookMain, 0, wxEXPAND);
    
    mpCBookFilter = new wxNotebook(this, ID_BOOK_DATASLOT,
			     wxDefaultPosition, wxSize(-1, 999));

    for (int i = 0; i < _DF3_MAX_SLOT; i++){
	mpCFilterPanels[i] = new FilterPanels_cls(mpCBookFilter, pCFrame);
    }

    pCBoxSizerSRC->Add(220 + 8, 0, 0); // _
    
    mpCBookFilter->AddPage(mpCFilterPanels[0], wxT("Data0"));
    mpCBookFilter->AddPage(mpCFilterPanels[1], wxT("Data1"));
    mpCBookFilter->AddPage(mpCFilterPanels[2], wxT("Data2"));
    mpCBookFilter->AddPage(mpCFilterPanels[3], wxT("Data3"));

    pCBoxSizerSRC->Add(mpCBookFilter, 0, wxEXPAND);

    this->SetSizer(pCBoxSizerSRC);
}

void FilterPanelPain_cls::
RefreshPanels(){
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->RefreshPanels();
	
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->Layout();

    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->Refresh();

    mpCBookFilter->Refresh();

    Layout();
}

void FilterPanelPain_cls::
ProcessEventOnStack(){
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->ProcessEventOnStack();
}

void FilterPanelPain_cls::
OnMouse(wxMouseEvent& event){
    if (event.GetId() == GetId()){
	if (event.RightDown() == TRUE)
	    mpCParentFrame->PopupMenu(mpCParentFrame->mpCMenuFilter, wxDefaultPosition);
	if (event.LeftDown() == TRUE)
	    mpCParentFrame->DeselectAllIf(wxT(""));
    }
    
    event.Skip();
}

void FilterPanelPain_cls::
OnPageChanged(wxNotebookEvent& event){
    int selection = event.GetSelection();
    mpCParentFrame->mpCDF3SeqCtrl->mCConfActiveSlot.mBody = selection;
}
