// -*- c++ -*-
// (setq c-basic-offset 4)
// "clsFilterPanels.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../MYAPI/MsgBox.h"
#include "clsFilterPanelPain.h"
#include "clsFilterPanels.h"

#include <wx/textdlg.h>

extern bool GbGLLockForMultithread;

ItemIntAndPointer_cls::
ItemIntAndPointer_cls(){
    //mpObjectForShow   = NULL;
    mpObjectForDelete = NULL;
    mpPointer = NULL;
}

ItemIntAndPointer_cls::
ItemIntAndPointer_cls(/*void *pObjectForShow,*/ void *pObjectForDelete, 
		      void *pPointer){
    //mpObjectForShow    = pObjectForShow;
    mpObjectForDelete  = pObjectForDelete;
    mpPointer          = pPointer;
}

// ----

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FilterPanels_cls, wxPanel)
     EVT_BUTTON(buttonCtrlPanelItemsDelete,  FilterPanels_cls::OnButtonDelete)
     EVT_BUTTON(buttonCtrlPanelItemsCustomA, FilterPanels_cls::OnButtonCustomA)
     EVT_BUTTON(buttonCtrlPanelItemsCustomB, FilterPanels_cls::OnButtonCustomB)
     EVT_BUTTON(buttonCtrlPanelItemsCustomC, FilterPanels_cls::OnButtonCustomC)
     EVT_MOUSE_EVENTS(FilterPanels_cls::OnMouse)
     EVT_MENU  (FilterMenuUp,       FilterPanels_cls::OnMenuSwap)
     EVT_MENU  (FilterMenuDown,     FilterPanels_cls::OnMenuSwap)
     EVT_MENU  (FilterMenuName,     FilterPanels_cls::OnMenuName)
     EVT_MENU  (FilterMenuAdvanced, FilterPanels_cls::OnMenuAdvanced)
     EVT_MENU  (FilterMenuDelete,   FilterPanels_cls::OnMenuDelete)
     EVT_KEY_DOWN(FilterPanels_cls::OnKeyDown)
END_EVENT_TABLE()

FilterPanels_cls::
FilterPanels_cls(/*FilterPanelPain_cls*/wxWindow *pC, FrameMain_cls *pCFrame) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize){
    mspCParentFrame = pCFrame;
    //mpCParentPreviewWindow = pC;

    wxBoxSizer *pBoxSizer = new wxBoxSizer(wxVERTICAL);
    pBoxSizer->Add(220 + 8, 0, 0); // _

    mpCPopupMenu = new wxMenu;
    mpCPopupMenu->Append(FilterMenuUp, wxT("Up"));
    mpCPopupMenu->Append(FilterMenuDown, wxT("Down"));
    mpCPopupMenu->Append(FilterMenuAdvanced, wxT("Filter Advanced Setting"));
    mpCPopupMenu->AppendSeparator();
    mpCPopupMenu->Append(FilterMenuName, _("Rename"));
    mpCPopupMenu->AppendSeparator();
    mpCPopupMenu->Append(FilterMenuDelete, _("Delete"));

    this->SetSizer(pBoxSizer);
}

FilterPanels_cls::
~FilterPanels_cls(){
    delete mpCPopupMenu;
};

void FilterPanels_cls::
SetFilterCtrlLink(FilterCtrl_cls *pCFilterCtrl){
    mpCFilterCtrlLink = pCFilterCtrl;
}

std::list<ItemIntAndPointer_cls>::iterator FilterPanels_cls::
GetIterator(int index){
    int i = 0;
    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++){
	if (i == index) return itr;
	i++;
    }
    return mPanelListItem.end();
}

void FilterPanels_cls::
PopUpFilterMenu(){
    PopupMenu(mpCPopupMenu, wxDefaultPosition);
}

void FilterPanels_cls::
RefreshPanels(){
    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++){
	((MultiNumericalInputsPanel_cls*)itr->mpPointer)->Refresh(TRUE);
    }

}

void FilterPanels_cls::
UpdateSizer(){
    wxBoxSizer *pSizer = (wxBoxSizer*)GetSizer();
    
    pSizer->Clear();

    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++)
	((MultiNumericalInputsPanel_cls*)itr->mpPointer)->AddToSizer(pSizer);
}

void FilterPanels_cls::
UpdatePanelLayout(){
    GetSizer()->Layout();
    if (GetParent()->GetSizer() != NULL)
	GetParent()->GetSizer()->Layout();
    GetParent()->Refresh();
    GetGrandParent()->Layout();
    GetGrandParent()->FitInside();
    GetGrandParent()->GetParent()->Layout();
}

void FilterPanels_cls::
PanelsTotalSizeChanged(){
    wxCommandEvent com3(wxEVT_COMMAND_MENU_SELECTED, menuItemSplitterResize);
    mspCParentFrame->AddPendingEvent(com3);
}

bool FilterPanels_cls::
IsItemExist(void *pPointer){
    bool bOverwrap = FALSE;
    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++){
	if (pPointer == itr->mpPointer) bOverwrap = TRUE;
    }
    return bOverwrap;
}

void FilterPanels_cls::
AddItemList(void *pObjectForDelete, void* pPointer){
    mPanelListItem.push_back(ItemIntAndPointer_cls(pObjectForDelete, pPointer));
}

void FilterPanels_cls::
RemoveItemList(void *pPointer){
    wxBoxSizer *pSizer = (wxBoxSizer*)GetSizer()/*->GetItem(1)->GetSizer()*/;
    int index = 0;
    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++){
	if (pPointer == itr->mpPointer){
	    // Sizer֘AACeDetach͏
	    pSizer->Detach(_FILTER_PANEL_OFFSET + index); 
	    mPanelListItem.erase(itr);
	    break;
	}
	index++;
    }

    PanelsTotalSizeChanged();
}

void FilterPanels_cls::
SwapItemList(int index, int direction){
    std::list<ItemIntAndPointer_cls>::iterator itr = GetIterator(index);
    if (direction == -1 && itr == mPanelListItem.begin()) return;
    std::list<ItemIntAndPointer_cls>::iterator itr2 = itr;
    if (direction == -1) itr2--;
    if (direction == +1) itr2++;
    if (itr2 == mPanelListItem.end()) return;
    std::swap(*itr, *itr2);
}

void FilterPanels_cls::
OnButtonDelete(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;

    for (std::list<ItemIntAndPointer_cls>::iterator itr = mPanelListItem.begin(); 
	 itr != mPanelListItem.end(); itr++){
	if (event.GetEventObject() == itr->mpObjectForDelete) {
	    mpCFilterCtrlLink->DeleteFilter(itr->mpObjectForDelete);
	    break;
	}
    }
    UpdatePanelLayout();
    
    event.Skip();
}

void FilterPanels_cls::
OnButtonCustomA(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;

    mpCFilterCtrlLink->FilterCustomA(event.GetEventObject());
}

void FilterPanels_cls::
OnButtonCustomB(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;

    mpCFilterCtrlLink->FilterCustomB(event.GetEventObject());
}

void FilterPanels_cls::
OnButtonCustomC(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;

    mpCFilterCtrlLink->FilterCustomC(event.GetEventObject());
}

void FilterPanels_cls::
OnMouse(wxMouseEvent& event){
    if (event.RightDown() == TRUE)
	if (event.GetId() == GetId())
	    mspCParentFrame->PopupMenu(mspCParentFrame->mpCMenuFilter, wxDefaultPosition);
    event.Skip();
}

void FilterPanels_cls::
OnMenuSwap(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;

    int comEvent = FilterMenuUp;
    if (event.GetId() == FilterMenuDown)
	comEvent = FilterMenuDown;
    
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, comEvent);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void FilterPanels_cls::
OnMenuName(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;
    mpCFilterCtrlLink->Rename();
}

void FilterPanels_cls::
OnMenuAdvanced(wxCommandEvent &event){
    //}`XbhFilter͑ҋ@
    if (CheckThreadLocking(event) == TRUE) return;
    mpCFilterCtrlLink->AdvancedSetting();
}

void FilterPanels_cls::
OnMenuDelete(wxCommandEvent &event){
    // Ⴄ̂ŁAPendingEventŏȂƑʖ
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, buttonCtrlPanelItemsDelete);
    com.SetEventObject((wxObject*)mpCFilterCtrlLink->GetPSelectedItemDeleteObject());
    
    AddPendingEvent(com);
}

void FilterPanels_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_DELETE)
	mpCFilterCtrlLink->DeleteSelectedItem();
    if (event.GetKeyCode() == WXK_F2)
	mpCFilterCtrlLink->Rename();
}

bool FilterPanels_cls::
CheckThreadLocking(wxCommandEvent &event){
    if (GbGLLockForMultithread == TRUE){
	PushEventOnStack(event);
	event.Skip();
	return TRUE;
    }
    
    return FALSE;
}

void FilterPanels_cls::
PushEventOnStack(wxCommandEvent &event){
    mVpCEvent.push_back(event.Clone());
}

void FilterPanels_cls::
ProcessEventOnStack(){
    while (mVpCEvent.size() != 0){
	int last = mVpCEvent.size() - 1;
	AddPendingEvent(*mVpCEvent[last]);
	delete mVpCEvent[last];
	mVpCEvent.pop_back();
    }
}
