// "clsPreference.cpp"

#ifndef _PREFERENCE_H_
#define _PREFERENCE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#include "../../clsFrameMain.h"

class Preference_cls; 
class wxNotebook;

#define _MAX_THREAD_NUM 16

class PreferenceGUI_cls : public wxDialogEXKey {
 public:
    PreferenceGUI_cls(Preference_cls* pCParent, 
		      wxWindow *pC, wxPoint pos, wxSize size);
    ~PreferenceGUI_cls();
    
    Preference_cls    *mpCParent;
    wxNotebook        *mpCBook;
    wxBoxSizer        *mpBoxSizerBookMouse;
    wxBoxSizer        *mpBoxSizerBookGL;
    wxBoxSizer        *mpBoxSizerBookPerformance;
    wxBoxSizer        *mpBoxSizerBookTL;
    wxBoxSizer        *mpBoxSizerBookMem;

    bool mbDummy;

    MultiNumericalInputsPanel_cls* mpCMNumMouseParam;
    MultiNumericalInputsPanel_cls* mpCMNumPerformanceParam;
    MultiNumericalInputsPanel_cls* mpCMNumTLParam;
    MultiNumericalInputsPanel_cls* mpCMNumMemParam;
    void SetMNumMouseParam(wxBoxSizer *pBoxSizer);
    void SetMNumPerformanceParam(wxBoxSizer *pBoxSizer);
    void SetMNumTLParam(wxBoxSizer *pBoxSizer);
    void SetMNumMemParam(wxBoxSizer *pBoxSizer);

    void GrayOutItems();
    
    void OnCommandEventTemplate(wxCommandEvent &event);
    void OnCommandEventGrayOut(wxCommandEvent &event);
    void OnCommandEventRefresh(wxCommandEvent &event);

    void OnButtonClose(wxCommandEvent &event);

    unsigned int mTemplateSetting;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class Preference_cls : 
public DialogControl_cls
{ 
 public:
    Preference_cls(FrameMain_cls *pC);
    ~Preference_cls();

    void SetToDefaultGUI(int type);
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void OpenWindow(wxWindow *pC);
    
    void ModulateBTN       (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Gyration  (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Zoom      (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItem  (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Menu      (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4HitTest   (bool bAModifier[4], bool bAMouseBTN[4]);

    unsigned int  GetThreadNumFilter();
    
    PreferenceGUI_cls* mpCGUI;
    FrameMain_cls* mpCParentFrame;
    wxBitmap *mpBitmapLink;

    ConfItemList_cls       mCConfListGUI;
    ConfItemUINT_cls       mCGyrationMouse;
    ConfItemBOOLARRAY_cls  mCbGyrationMod;
    ConfItemUINT_cls       mCZoomMouse;
    ConfItemBOOLARRAY_cls  mCbZoomMod;

    ConfItemUINT_cls       mCCenterMouse;
    ConfItemBOOLARRAY_cls  mCbCenterMod;
    ConfItemUINT_cls       mCItemMouse;
    ConfItemBOOLARRAY_cls  mCbItemMod;
    ConfItemUINT_cls       mCMenuMouse;
    ConfItemBOOLARRAY_cls  mCbMenuMod;

    ConfItemUINT_cls       mCHitTestMouse;
    ConfItemBOOLARRAY_cls  mCbHitTestMod;
    
    ConfItemBOOL_cls       mCbZoomInvert, mCbGyrationInvert;    
    
    ConfItemUINT_cls       mCMButtonEmulate;

    ConfItemList_cls       mCConfListPerformance;
    ConfItemBOOL_cls       mCbMultiThreadImgRead;
    ConfItemUINT_cls       mCThreadNumImgRead;
    ConfItemBOOL_cls       mCbSSEFilter;
    ConfItemUINT_cls       mCThreadNumFilter;
    ConfItemBOOL_cls       mCbMultiThreadFilter;
    ConfItemUINT_cls       mCThreadIsosurfaceLayer;
    ConfItemUINT_cls       mCTexCompress;
    
    void ReadStrLine(std::wstring strLine);
    wxString Serialize();
};

#endif
