// -*- c -*-
// "clsGLGuides.cpp"

#ifndef _GL_GUIDES_H_
#define _GL_GUIDES_H_

#ifdef WIN32
#include <windows.h>
#endif

#include "clsPositionAndDirection.h"
#include "../GLOBJ/GLOBJECTS.h"

#include <GL/gl.h>
#include <vector>

#define _GL_GUIDES_NOLIMIT_FOR_BOX false
#define _GL_GUIDES_WITH_LIMIT true

#define _GUIDES_TRANSLATE 0
#define _GUIDES_SCALE 1
#define _GUIDES_ROTATE 2

class GLGuides_cls{
 public:
    GLGuides_cls(int rotationDim = 4);

    double mArrowDir[3];
    GLuint mBuffer4Selection[100];
    GLint mHitNum;
    int  mRotationDim;
    static int msTableU[3][3];
    static int msTableV[3][3];
    bool mbDirectionInv;
    
    void SetArrowDir(double xlength, double ylength, double zlength);
    void DrawArrow(double length, int type = _GUIDES_TRANSLATE);
    void DrawGuide(double pos[3], double scale, int index,
		   double *pScaleXYZ,
		   PositionAndDirection_cls CParentObjPos,
		   int type = _GUIDES_TRANSLATE, double *YPR = NULL);

    void DrawAxisAndCalcDirection(double X0, double Y0, double Z0,
				  double X1, double Y1, double Z1);
    void DrawRing(double radius, int axis);
    void DrawGuideRotation(double pos[3], double scale, int index,
			   double *pScaleXYZ,
			   PositionAndDirection_cls CParentObjPos,
			   double YPR[4]);
    void DrawGuideArrowBox(double posBox[3], double scale, 
			   double boxScale[3], bool bLimitBox = true);
    std::vector < int > GetObjectFromList();

    void InitializeProjection();
    std::vector < int > GetSelection();
};

#endif
