// -*- c -*-
// "clsGLPerspective.cpp"

#ifndef _GL_PERSPECTIVE_H_
#define _GL_PERSPECTIVE_H_

#include "clsPositionAndDirection.h"

#ifdef WIN32
#include <windows.h> // WIN32GLɂ͕Kv
#endif
#include <GL/glu.h>

class GLPerspective_cls{ 
 public:
    const static double sDefaultCameraPos[7][3];
    const static double sDefaultCameraTop[7][3];

    double GetAspectRatio();

    void SetViewportOnGL();
    void SetPerspectiveOnGL(PositionAndDirection_cls* pCConfigure);
    static void SetModelOrProjectionViewOnGL
	(PositionAndDirection_cls* pCConfigure, GLenum mode = GL_MODELVIEW);
    void SetWindowSize (int width, int height);

    static void Push2DMatrix(int width, int height);
    static void Pop2DMatrix();

 public:
    GLPerspective_cls(int width = 640, int height = 480, 
		      double deg = 45, double depthMIN = 0.003, double depthMAX = 500);
    
    bool   mbPerspective;
    double mDeg;
    double mDepthMIN;
    double mDepthMAX;
    int    mWidth, mHeight;
};

#endif //_GL_PERSPECTIVE_H_
