// -*- c -*-
// "clsKeyFrame.cpp"

#ifndef _KEYFRAME_H
#define _KEYFRAME_H

#include <string>

#include <wx/wx.h>
#include <wx/dcbuffer.h>

#define _PARAM_LINEAR       0
#define _PARAM_HERMITE_AUTO 1
#define _PARAM_HERMITE_ADJ  2
#define _PARAM_HERMITE      3
#define _PARAM_STEP         4
#define _PARAM_BEZIER_AUTO  5
#define _PARAM_BEZIER       6

#define _KEY_NORMAL         0
#define _KEY_DRAG           1

class KeyFrame_cls {
 public: 
    KeyFrame_cls();
    KeyFrame_cls(unsigned int dimention);
    // new  std::vector ̑gݍ킹̓Rs[RXgN^K{
    KeyFrame_cls(const KeyFrame_cls &obj); 
    void CopyWithoutConstruct(const KeyFrame_cls &obj);
    void FullCopy(const KeyFrame_cls &obj);
    ~KeyFrame_cls();

 private:
    unsigned int mDimention;

 public:
    int operator > (const KeyFrame_cls obj); 

    bool   mbSelected;
    unsigned int mType;
    double mDoubleIndex;
    double *mpValue, *mpDValue1, *mpDValue2;
    unsigned int GetDimension();
    void Set(double doubleIndex, unsigned int type, 
	     double *pFrom, double *pFromD1 = NULL, double *pFromD2 = NULL, 
	     bool bSelected = FALSE);
    void SetValue(double *mpValue);
    bool Select(double doubleIndex, double resolution, bool bTest = FALSE);
    bool Toggle(double doubleIndex, double resolution);

    void DrawKey(wxAutoBufferedPaintDC &dc, int x, int mode, bool bOnPanel = TRUE);

    wxString Serialize();
    void ReadStrLine(std::wstring strLine);

    static void InitializeStaticMembers();
    static wxString msAstrInterp[5];
};
#endif
