// -*- c -*-
// "clsParamCommands.cpp"

#ifndef _PARAM_COMMANDS_H
#define _PARAM_COMMANDS_H

#include "../UNDO/clsUndoManager.h"

class ComParamBase_cls {
 public:
    ComParamBase_cls(Parameters_cls* pCTgt);

    Parameters_cls* mpCTgt;
    bool CheckRepeat(bool bFlag);
};

class ComParamSetKey_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamSetKey_cls(Parameters_cls* pCTgt, double doubleIndex,
		       double *pFrom, double *pDValue1, double *pDValue2,
		       unsigned int type);
    ~ComParamSetKey_cls();

    double mDoubleIndex;
    double *mAFrom;
    double *mADValue1;
    double *mADValue2;
    unsigned int mType;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyC_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamSetKeyC_cls(Parameters_cls *pCTgt, KeyFrame_cls CKey);

    KeyFrame_cls mCKey;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamDelKey_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamDelKey_cls(Parameters_cls* pCTgt, unsigned int index);

    unsigned int mIndex;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamOvwtKeyC_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamOvwtKeyC_cls(Parameters_cls* pCTgt, unsigned int index,
			 KeyFrame_cls CKey);
    unsigned int mIndex;
    KeyFrame_cls mCKey;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamMoveKey_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamMoveKey_cls(Parameters_cls* pCTgt, 
			double doubleIndexFrom, double doubleIndexTo,
			double resolution);
    
    double mDoubleIndexFrom, mDoubleIndexTo, mResolution;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyType_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamSetKeyType_cls(Parameters_cls* pCTgt, 
			   unsigned int index, unsigned int type);
    
    unsigned int mIndex, mType;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetKeyTypeMulti_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamSetKeyTypeMulti_cls(Parameters_cls* pCTgt,
				unsigned int listnum,
				unsigned int *listIndex,
				unsigned int *listType);
    ~ComParamSetKeyTypeMulti_cls();

    unsigned int mListnum;
    unsigned int *mAIndex, *mAType;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamClearKey_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamClearKey_cls(Parameters_cls* pCTgt, double *pFrom);
    ~ComParamClearKey_cls();
    
    double *mAFrom;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamSetTimeDependent_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamSetTimeDependent_cls(Parameters_cls *pCTgt, bool bDependent);

    bool mbDependent;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComParamMemento_cls : public CommandItem_cls, ComParamBase_cls {
 public:
    ComParamMemento_cls(Parameters_cls* pCTgt, Parameters_cls* pCFrom = NULL);
    ~ComParamMemento_cls();
    
    Parameters_cls *mpCParamMemento;
    bool Execute(bool bFlag = _COMMAND_REDO);
};

#endif
