// -*- c -*-
// "clsTimeLinePanel.cpp"
// (setq c-basic-offset 4)

#ifndef _TIMELINE_PANEL_H
#define _TIMELINE_PANEL_H

#include <wx/wx.h>
#include <vector>

#include "../DF3/TL/clsTLPanel.h"

#define _TIMELINE_MENU_APPEND 0
#define _TIMELINE_MENU_INSERT 1

class DF3SeqGUI_cls;
class LightSRC_cls;
class Parameters_cls; 
class ParametersPanel_cls; 
class MultiNumericalInputs_cls; 
class HotSpots_cls;

class TimeLinePanel_cls : public wxPanel, public TLPanelBase_cls {
 public:
    TimeLinePanel_cls(Parameters_cls *pCParam, ParametersPanel_cls *parent, /*wxString strTag = wxT("param"),*/ wxString strCustomName = wxT("Custom"), wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, wxWindowID id = wxID_ANY);
    ~TimeLinePanel_cls();

    static void InitializeStaticMembers(LightSRC_cls* pCLightSRC,
					HotSpots_cls* pCHotSpot,
					DF3SeqGUI_cls* pCDF3SeqGUI);
    static TimeLinePanel_cls *mspCurrentThis;
    static DF3SeqGUI_cls *mspCDF3SeqGUILink;
    static LightSRC_cls *mspCLightSRCLink;
    static HotSpots_cls *mspCHotSpotLink;
    Parameters_cls *mpCParam;
    ParametersPanel_cls *mpCParentPanel;

    static bool     msbIsLoadIcon;
    static wxIcon   msCIcon;
    
    static bool     msbShowParameter;

    wxString        /*mstrTag,*/ mstrCustomName;
    void LinkParameter(Parameters_cls *pCParam);
    void AppendMenu(wxWindow *pCCustomTarget, int menuID,
		    wxString strTitle, int type);
    void GrayOutUnusedMenu();
    wxWindow*       mpCCustomTarget;
    int             mCustumMenuID;

    static wxPen    msCPenVeryLightGrey;
    wxMenu          *mpCMenu;
    int             mMenuPosX, mMenuPosY;

    static std::vector < bool > msVBSnippingTag;
    static double msCurrentDoubleIndex;
    static double msDoubleIndexAAMin, msDoubleIndexAAMax;
    static double msDoubleIndexWAMin, msDoubleIndexWAMax;
    static int msMaxFrame, msAAMin, msAAMax;
    static void SetDoubleIndex
	(int maxFrame, int AAMin, int AAMax, double doubleIndex,
	 double doubleIndexAAMin, double doubleIndexAAMax,
	 double doubleIndexWAMix, double doubleIndexWAMax);

    void Activate(bool bActive, bool bExclusive = TRUE);
    
    double *mpParamCache;
    double *mpDValue1Cache;
    double *mpDValue2Cache;
    unsigned int *mpTypeCache;
    void  CreateKeyDLGAtMousePos();
    void  CreateKeyDLG(int posx, int poxy, wxPoint posPanel = wxDefaultPosition);
    void  ConnectParameters(MultiNumericalInputs_cls* pCDLG,
			    int *pFrame);
    static void  ShowAndHideParameters(void* pArg, void *pEvent);

    void  OnPaint(wxPaintEvent& event);
    void  OnMouse(wxMouseEvent& event);
    void  OnKeyDown(wxKeyEvent& event);

    void  OnMenuInsert(wxCommandEvent& event);
    void  OnMenuEditKey(wxCommandEvent& event);
    void  OnMenuHide(wxCommandEvent& event);
    void  OnMenuImport(wxCommandEvent& event);
    void  OnMenuCustom(wxCommandEvent& event);

    // -----

    int   GetCoordinateFromDouble(double doubleIndex);
    void  CalcCoordinateFromDouble(double doubleIndex);
    double CalcResolutionFor1Pixel();
    double Quantize(double doubleIndex);
    double CalcDoubleIndexFromPosition(int x);
    double CalcDoubleIndexFromFrame(int frame);

    bool  mbActive;
    bool  mbSelected;
    bool  mbCaptureMouse;
    bool  mbDragging, mbOnPanel;
    int    mSelected; // KeyFrame
    int    mDraggingFrame;
    double mRegionOrigin;
    double mDragDoubleIndex;
    double mDragDoubleIndexOrigin;
    
    DECLARE_EVENT_TABLE()
};

#endif
