// "clsIsosurfOptimize.h"// (setq c-basic-offset 4)

#include "clsIsosurfOptimize.h"

#include "../../MYAPI/MsgBox.h"

ThreadOptimizeA::
ThreadOptimizeA(wxThreadKind kind,
		float *pVerticesFrom, float *pNormalsFrom,
		int *pAllocSizeFrom,
		std::vector < float > *pVVerticesOpt,
		std::vector < float > *pVNormalsOpt,
		std::vector < unsigned int > *pVVertexIndicesOpt,
		char *pbOptimized)
  : MultiThreadThread_cls(kind),
    mpVerticesFrom(pVerticesFrom), mpNormalsFrom(pNormalsFrom),
    mpAllocSizeFrom(pAllocSizeFrom),
    mpVVerticesOpt(pVVerticesOpt), 
    mpVNormalsOpt(pVNormalsOpt),
    mpVVertexIndicesOpt(pVVertexIndicesOpt),
    mpbOptimized(pbOptimized)
{
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

// O3*3polygin(*3point)xƌIɂ悳
int ThreadOptimizeA::
GetSamePoint(float *pVertex){
    int optSize = (int)mpVVerticesOpt->size();
    if (optSize == 0) return -1;
    int serach_ini = optSize - 27;
    if (serach_ini < 0) serach_ini = 0;
    
    float *pVVerticesOpt = mpVerticesOpt;
    
    for (int i = serach_ini; i < optSize; i+= 3){
	if (pVertex[0] == pVVerticesOpt[i+0] &&
	    pVertex[1] == pVVerticesOpt[i+1] &&
	    pVertex[2] == pVVerticesOpt[i+2])
	    return i;
    }
    return -1;
}

wxThread::ExitCode ThreadOptimizeA::
Entry(){
    float *pVerticesFrom = mpVerticesFrom;
    float *pNormalsFrom = mpNormalsFrom;
    std::vector < float > *pVVerticesOpt = mpVVerticesOpt;
    std::vector < float > *pVNormalsOpt = mpVNormalsOpt;
    std::vector < unsigned int > *pVVertexIndicesOpt = mpVVertexIndicesOpt;
    int allocSizeFrom = *mpAllocSizeFrom;

    if (allocSizeFrom == 0){
	*mpbReadyFlag = TRUE;
	return 0;
    }

    pVVertexIndicesOpt->reserve(allocSizeFrom/3);

    // ŏ3͕KBvertor󂾂Ƃ܂̂ŐɏB
    for (int i = 0; i < 9; i+=3){
	pVVertexIndicesOpt->push_back((int)mpVVerticesOpt->size()/3);
	pVVerticesOpt->push_back(pVerticesFrom[i]);
	pVVerticesOpt->push_back(pVerticesFrom[i+1]);
	pVVerticesOpt->push_back(pVerticesFrom[i+2]);
	pVNormalsOpt->push_back(pNormalsFrom[i]);
	pVNormalsOpt->push_back(pNormalsFrom[i+1]);
	pVNormalsOpt->push_back(pNormalsFrom[i+2]);
    }

    // 擪̃|C^𓾂ĂΑƎv
    // vectorTCYĂƃ|C^ʒuς邩
    // ǉxʒuT̂ŁA 
    mpVerticesOpt = &((*pVVerticesOpt)[0]); 
    for (int i = 9; i < allocSizeFrom; i+= 3){
	int samePoint = GetSamePoint(pVerticesFrom+i);
	if (samePoint != -1)
	    pVVertexIndicesOpt->push_back(samePoint/3);
	else {
	    pVVertexIndicesOpt->push_back((int)pVVerticesOpt->size()/3);
	    pVVerticesOpt->push_back(pVerticesFrom[i]);
	    pVVerticesOpt->push_back(pVerticesFrom[i+1]);
	    pVVerticesOpt->push_back(pVerticesFrom[i+2]);
	    pVNormalsOpt->push_back(pNormalsFrom[i]);
	    pVNormalsOpt->push_back(pNormalsFrom[i+1]);
	    pVNormalsOpt->push_back(pNormalsFrom[i+2]);
	    mpVerticesOpt = &((*pVVerticesOpt)[0]);
	}
    }
    
    if (allocSizeFrom != 0){
	free(pVerticesFrom);
	free(pNormalsFrom);
	*mpAllocSizeFrom = 0;
	*mpbOptimized = TRUE;
    }

    *mpbReadyFlag = TRUE;
    return 0;
}

// ----

ThreadOptimizeFull::
ThreadOptimizeFull(wxThreadKind kind,
		   std::vector < float > *pVVerticesFrom, 
		   std::vector < float > *pVNormalsFrom,
		   std::vector < unsigned int > *pVVertexIndicesFrom,
		   int allocSizeFrom,
		   std::vector < float > *pVVerticesOpt,
		   std::vector < float > *pVNormalsOpt,
		   std::vector < unsigned int > *pVVertexIndicesOpt,
		   double sizeY,
		   char *pbOptimized) 
    : MultiThreadThread_cls(kind),
      mpVVerticesFrom(pVVerticesFrom), mpVNormalsFrom(pVNormalsFrom),
      mpVVertexIndicesFrom(pVVertexIndicesFrom),
      mAllocSizeFrom(allocSizeFrom),
      mpVVerticesOptFull(pVVerticesOpt), 
      mpVNormalsOptFull(pVNormalsOpt),
      mpVVertexIndicesOptFull(pVVertexIndicesOpt),
      mSizeY(sizeY),
      mpbOptimized(pbOptimized)
{
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

int ThreadOptimizeFull::
GetSamePoint(float *pVertex){
    int optSize = (int)mpVVerticesOptFull->size();
    if (optSize == 0) return -1;
    double crit = 1.0/mSizeY * 3;
    
    float *pVVerticesOptFull = &((*mpVVerticesOptFull)[0]);
    
    for (int i = optSize - 3; i >= 0; i-= 3){
	if (pVertex[0] == pVVerticesOptFull[i+0] &&
	    pVertex[1] == pVVerticesOptFull[i+1] &&
	    pVertex[2] == pVVerticesOptFull[i+2])
	    return i;
	if (pVertex[1] > pVVerticesOptFull[i+1] + crit)
	    i = 0;
    }
    
    return -1;
}

wxThread::ExitCode ThreadOptimizeFull::
    Entry(){

    std::vector < int > VTable;
    VTable.reserve(mAllocSizeFrom/3);
    int offset = 0;

    float *pVVerticesFrom = &((*mpVVerticesFrom)[0]);
    float *pVNormalsFrom = &((*mpVNormalsFrom)[0]);
    unsigned *pVVertexIndicesFrom = &((*mpVVertexIndicesFrom)[0]);
    std::vector < float > *pVVerticesOptFull = mpVVerticesOptFull;
    std::vector < float > *pVNormalsOptFull = mpVNormalsOptFull;
    std::vector < unsigned int > *pVVertexIndicesOptFull = mpVVertexIndicesOptFull;
    
    int allocSizeFrom = mAllocSizeFrom;
    for (int i = 0; i < allocSizeFrom; i+= 3){
	int samePoint = GetSamePoint(&(*mpVVerticesFrom)[i]);
	if (samePoint != -1){
	    VTable.push_back(samePoint/3);
	    offset++;
	}
	else {
	    VTable.push_back(i/3 - offset);
	    pVVerticesOptFull->push_back(pVVerticesFrom[i]);
	    pVVerticesOptFull->push_back(pVVerticesFrom[i+1]);
	    pVVerticesOptFull->push_back(pVVerticesFrom[i+2]);
	    pVNormalsOptFull->push_back(pVNormalsFrom[i]);
	    pVNormalsOptFull->push_back(pVNormalsFrom[i+1]);
	    pVNormalsOptFull->push_back(pVNormalsFrom[i+2]);
	}
    }

    size_t indexSize = mpVVertexIndicesFrom->size();
    pVVertexIndicesOptFull->reserve(indexSize);
    for (size_t i = 0; i < indexSize; i++)
	pVVertexIndicesOptFull->push_back
	    (VTable[pVVertexIndicesFrom[i]]);

    if (mpVVertexIndicesFrom->size() != 0){
	mpVVerticesFrom->clear();
	mpVNormalsFrom->clear();
	mpVVertexIndicesFrom->clear();
	*mpbOptimized = TRUE;
    }
    
    *mpbReadyFlag = TRUE;

    return 0;
}
