
#ifndef _ISOSURFACE_OPTIMIZE_H_
#define _ISOSURFACE_OPTIMIZE_H_

#include "../../COMMON/clsMultiThreadCtrl.h"

#include <vector>

class ThreadOptimizeA : public MultiThreadThread_cls {
 public:
    ThreadOptimizeA(wxThreadKind kind,
		    float *pVerticesFrom, float *pNormalsFrom,
		    int *pAllocSizeFrom,
		    std::vector < float > *pVVerticesOpt,
		    std::vector < float > *pVNormalsOpt,
		    std::vector < unsigned int > *pVVertexIndicesOpt,
		    char *pbOptimized);

    int GetSamePoint(float *pVertex);
    virtual ExitCode Entry();

    float * const mpVerticesFrom;
    float * const mpNormalsFrom;
    int *mpAllocSizeFrom;
    char *mpbOptimized;
    std::vector < float > *mpVVerticesOpt;
    std::vector < float > *mpVNormalsOpt;
    std::vector < unsigned int > *mpVVertexIndicesOpt;
    float *mpVerticesOpt;
};

class ThreadOptimizeFull : public MultiThreadThread_cls {
 public:
    ThreadOptimizeFull(wxThreadKind kind,
		       std::vector < float > *pVVerticesFrom, 
		       std::vector < float > *pVNormalsFrom,
		       std::vector < unsigned int > *pVVertexIndicesFrom,
		       int allocSizeFrom,
		       std::vector < float > *pVVerticesOpt,
		       std::vector < float > *pVNormalsOpt,
		       std::vector < unsigned int > *pVVertexIndicesOpt,
		       double sizeY,
		       char *pbOptimized);

    int GetSamePoint(float *pVertex);
    virtual ExitCode Entry();

    double mSizeY;
    
    std::vector < float > *mpVVerticesFrom;
    std::vector < float > *mpVNormalsFrom;
    std::vector < unsigned int > *mpVVertexIndicesFrom;
    int mAllocSizeFrom;
    char *mpbOptimized;
    std::vector < float > *mpVVerticesOptFull;
    std::vector < float > *mpVNormalsOptFull;
    std::vector < unsigned int > *mpVVertexIndicesOptFull;
};

#endif
