// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovBG.h"

#include "clsPovBG.h"

#include "../clsPovRay.h"
#include "../../../wxWidgetEnum.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"

#define ENDLWX wxT("\n")

#define R 0
#define G 1
#define B 2
#define LOOP_RGB for (int rgb = 0; rgb < 3; rgb++)

// ftHgStarField͗ǂȂBGalaxy.incɑSʈˑ

PovBG_cls::
PovBG_cls(){
}

void PovBG_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCSkySphereType, wxT("PovSkySphereType="), L"0");
    mCConfList.Add(&mCColor0, wxT("PovBGColor0="), L"0 0 0");
    mCConfList.Add(&mCColor1, wxT("PovBGColor1="), L"0 0 0");
    mCConfList.Add(&mCBGType, wxT("PovBGType="), L"0");
    mCConfList.Add(&mCCloudyness, wxT("PovBGCloudyness="), L"0.5");
    mCConfList.Add(&mCCloudScaling, wxT("PovBGCloudScale="), L"1");
    mCConfList.Add(&mCCloudTurb, wxT("PovBGCloudTurbulence="), L"0.76");
    mCConfList.Add(&mCCloudType, wxT("PovBGCloudType="), L"0");
    mCConfList.Add(&mCCloudFade, wxT("PovBGCloudFade="), L"1");
    mCConfList.Add(&mCNebulaType, wxT("PovBGNebulaType="), L"0");
    mCConfList.Add(&mCNebulaDirection, wxT("PovBGNebulaDirection="), L"0");
    mCConfList.Add(&mCNebulaScale, wxT("PovBGNebulaScale="), L"1");
    mCConfList.Add(&mCNebulaFlat, wxT("PovBGNebulaFlat="), L"0.2");
    mCConfList.Add(&mCNebulaRotate, wxT("PovBGNebulaRotate="), L"0");
    mCConfList.Add(&mCNColor1, wxT("PovBGNebulaColor1="), L"1 0.83 0.91");
    mCConfList.Add(&mCNColor2, wxT("PovBGNebulaColor2="), L"1 0.3 0.6");
    mCConfList.Add(&mCNColor3, wxT("PovBGNebulaColor3="), L"0 0 0");
    mCConfList.Add(&mCStarCount, wxT("PovBGStarCount="), L"20");
}

void PovBG_cls::
SetMNumBG(wxBoxSizer *pBoxSizer, wxWindow* pCParentPanel){
    MultiNumericalInputsPanel_cls* pCurr = 
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumBG, pCParentPanel);

    pCurr->mTextWidth  = 80;
    pCurr->mComboWidth = 100;

    int boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Sky Sphere"));
    wxString skysphereType[3] =
	{_("MonoColor"), _("HemiSphere"), _("FullSphere")};
    mIndexSkySphereType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCSkySphereType.mBody,
	 wxT(""), TRUE, 3, skysphereType);

    wxString BGType[3] =
	{_("SimpleBG"), _("Layer cloud"), _("Nebular (require Galaxy.inc)")};
    mIndexBGType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCBGType.mBody,
	 wxT(""), TRUE, 3, BGType);
    
    pCurr->mTextWidth  = -1;
    boxWidth = 3;
    mIndexColors = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("BG Color"));
    mIndexColor0 = pCurr->CombinePointerButton(btnPovBG0, _("BG Color 0"));
    mIndexColor1 = pCurr->CombinePointerButton(btnPovBG1, _("BG Color 1"));
    pCurr->mVCPointers[mIndexColor0].mpConnectColorFloat = mCColor0.mpBody;
    pCurr->mVCPointers[mIndexColor1].mpConnectColorFloat = mCColor1.mpBody;
    mIndexPluginHelp = pCurr->CombinePointerButton(btnPovPluginHelp, wxT("Plugin Help"));

    mIndexStarCount = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("StarCount(x100)"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCStarCount.mBody);
    pCurr->SetRange(10, 100);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCStarCount.mBody);
    pCurr->SetRange(10, 100);

    boxWidth = 3;
    mIndexNebulaParam0 = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Nebura/Direction"));
    wxString nebulaType[17] = 
	{_("No Nebula"), wxT("Nebula1"), wxT("Nebula2"), wxT("Nebula3"), wxT("Nebula4"), wxT("Nebula5"), wxT("Nebula6"), wxT("Galaxy1"), wxT("Galaxy2"), wxT("Galaxy3"), wxT("Galaxy4"), wxT("Galaxy5"), wxT("Comet1"), wxT("Comet2"), wxT("Comet3"), wxT("Metero1"), wxT("Meteor2")};
    mIndexNebulaType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCNebulaType.mBody,
	 wxT(""), TRUE, 17, nebulaType);
    wxString nebulaDirection[6] = 
	{wxT("+x"), wxT("-x"), wxT("+y"), wxT("-y"), wxT("+z"), wxT("-z")};
    mIndexNebulaDirection = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCNebulaDirection.mBody,
	 wxT(""), TRUE, 6, nebulaDirection);

    boxWidth = 3;
    mIndexNebulaColors = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth);
    mIndexNColor1 = pCurr->CombinePointerButton(btnPovBGN1, _("NebulaColor 1"));
    mIndexNColor2 = pCurr->CombinePointerButton(btnPovBGN2, _("NebulaColor 2"));
    mIndexNColor3 = pCurr->CombinePointerButton(btnPovBGN3, _("NebulaColor 3"));
    pCurr->mVCPointers[mIndexNColor1].mpConnectColorFloat = mCNColor1.mpBody;
    pCurr->mVCPointers[mIndexNColor2].mpConnectColorFloat = mCNColor2.mpBody;
    pCurr->mVCPointers[mIndexNColor3].mpConnectColorFloat = mCNColor3.mpBody;

    pCurr->mTextWidth  = 120;
    mIndexNebulaParam1 = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("S/F/R"));
    mIndexNebulaScale = pCurr->CombinePointer(_GP_FLOAT, &mCNebulaScale.mBody);
    mIndexNebulaFlat = pCurr->CombinePointer(_GP_FLOAT, &mCNebulaFlat.mBody);
    mIndexNebulaRotate = pCurr->CombinePointer(_GP_FLOAT, &mCNebulaRotate.mBody);

    pCurr->mTextWidth  = 80;
    boxWidth = 2;
    mIndexCloudParam0 = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Cloud Style"));
    wxString CloudType[3] =
	{_("monolayer"), _("multi-layer"), _("multi-layer(HQ)")};
    mIndexCloudType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCCloudType.mBody,
	 wxT(""), TRUE, 3, CloudType);
    wxString FadeType[3] =
	{_("Constant Cloud"), _("Cloud Fade Off"), _("Cloudy")};
    mIndexCloudFade = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCCloudFade.mBody,
	 wxT(""), TRUE, 3, FadeType);

    pCurr->mTextWidth  = 120;
    boxWidth = 3;
    mIndexCloudParam1 = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("C/S/T"));
    mIndexCloudyness = pCurr->CombinePointer(_GP_FLOAT, &mCCloudyness.mBody);
    mIndexCloudScale = pCurr->CombinePointer(_GP_FLOAT, &mCCloudScaling.mBody);
    mIndexCloudTurb = pCurr->CombinePointer(_GP_FLOAT, &mCCloudTurb.mBody);
    
    #ifdef WIN32
    pCurr->mMinimumWidth = 320;
#else
    pCurr->mMinimumWidth = 340;
#endif
    //pCurr->mProportion = 1;
    pCurr->FinishSetting(pBoxSizer, TRUE);

    pCurr->SetFuncHook(&PovRay_cls::HookBG, _MN_HOOK_COMBOBOX);

    HideAndShow();
}

void PovBG_cls::
HideAndShow(){
    MultiNumericalInputsPanel_cls *pCurr = mpCMNumBG;
    bool bUseColor1 = (mCSkySphereType.mBody != _POV_BG_MONOCOLOR);
	
    bool bCloud = (mCBGType.mBody == _POV_BG_CLOUD);

    pCurr->mVCPointers[mIndexColor1].Enable(bUseColor1);
    pCurr->mVCPointers[mIndexColor0].UpdateValue();
    pCurr->mVCPointers[mIndexColor1].UpdateValue();

    pCurr->ShowItems(mIndexCloudParam0, 3, bCloud);
    pCurr->ShowItems(mIndexCloudParam1, 4, bCloud);

    bool bGalaxy = (mCBGType.mBody == _POV_BG_GALAXY);
    pCurr->ShowItems(mIndexPluginHelp, 1, bGalaxy);
    pCurr->ShowItems(mIndexStarCount, 3, bGalaxy);
    pCurr->ShowItems(mIndexNebulaParam0, 3, bGalaxy);

    bool bNebula = (mCNebulaType.mBody != 0); 
    pCurr->ShowItems(mIndexNebulaParam1, 4, bGalaxy & bNebula);
    pCurr->ShowItems(mIndexNebulaColors, 4, bGalaxy & bNebula);

    pCurr->Layout();
}

wxColour PovBG_cls::
GetColourBG(int index){
    if (index == 0)
	return wxColour(mCColor0.mpBody[R] * 255,
			mCColor0.mpBody[G] * 255,
			mCColor0.mpBody[B] * 255);
    else
	return wxColour(mCColor1.mpBody[R] * 255,
			mCColor1.mpBody[G] * 255,
			mCColor1.mpBody[B] * 255);
}

wxColour PovBG_cls::
GetColourBGN(int index){
    if (index == 1)
	return wxColour(mCNColor1.mpBody[R] * 255,
			mCNColor1.mpBody[G] * 255,
			mCNColor1.mpBody[B] * 255);
    else if (index == 2)
	return wxColour(mCNColor2.mpBody[R] * 255,
			mCNColor2.mpBody[G] * 255,
			mCNColor2.mpBody[B] * 255);
    else
	return wxColour(mCNColor3.mpBody[R] * 255,
			mCNColor3.mpBody[G] * 255,
			mCNColor3.mpBody[B] * 255);
}

void PovBG_cls::
ChangeBGColor(float *pRGB, int index){
    if (index == 0)
	LOOP_RGB mCColor0.mpBody[rgb] = pRGB[rgb];
    else
	LOOP_RGB mCColor1.mpBody[rgb] = pRGB[rgb];
}

void PovBG_cls::
ChangeBGNColor(float *pRGB, int index){
    if (index == 1)
	LOOP_RGB mCNColor1.mpBody[rgb] = pRGB[rgb];
    else if (index == 2)
	LOOP_RGB mCNColor2.mpBody[rgb] = pRGB[rgb];
    else
	LOOP_RGB mCNColor3.mpBody[rgb] = pRGB[rgb];
}

wxString PovBG_cls::
GetPovStrCloud(bool bRadiosity){
    //WIVeB̂ꍇ͌Diffuseキ
    //V̉e}ĂB
    
    wxString strCloud;
    
    float baseColor[4] = {1, 1, 1, 1};
    if (bRadiosity == FALSE)
	LOOP_RGB baseColor[rgb] = mCColor0.mpBody[rgb];
    
    float crit = 1.0 - mCCloudyness.mBody;
    strCloud << wxT("#declare CloudFunction = function {");
    switch(mCCloudFade.mBody){
    case 0:
	strCloud << wxT("f_bozo(x,y,z) }"); break;
    case 1:
	strCloud << wxT("f_bozo(x,y,z) / (") << 0.01 * mCCloudScaling.mBody << wxT("*sqrt(x*x + y*y)+1) }"); break;
    case 2:
	strCloud << wxT("1 - (1 - f_bozo(x,y,z)) / (") << 0.02 * mCCloudScaling.mBody << wxT("*sqrt(x*x + y*y)+1) }"); break;
    }
    strCloud << ENDLWX;
	
    strCloud << wxT("#macro CloudLayer(Height, CloudCrit)") << ENDLWX
	     << wxT("plane{<0,0,1>,0 hollow") << ENDLWX
	     << wxT("\ttexture{ pigment{ function { CloudFunction (x,y,z + 0.01*Height) } turbulence ") << mCCloudTurb.mBody 
	     << wxT(" scale ") << mCCloudScaling.mBody << ENDLWX
	     << wxT("\t\tcolor_map {") << ENDLWX
	     << wxT("\t\t\t[ CloudCrit") << PovOut4f(wxT(" rgbt"), baseColor) << wxT("]") << ENDLWX;
    if (mCCloudType.mBody == 0)
	strCloud << wxT("\t\t\t[CloudCrit+0.1") << wxT(" rgbt <1,1,1,0.1>]") << ENDLWX
		 << wxT("\t\t\t[1.0 rgbt <0.5,0.5,0.5,0.1>]} }") << ENDLWX;
    else if (mCCloudType.mBody == 1)
	strCloud << wxT("\t\t\t[CloudCrit+0.1") << wxT(" rgbt <1,1,1,0.8>]} }") << ENDLWX;
    else
	strCloud << wxT("\t\t\t[CloudCrit+0.1") << wxT(" rgbt <1,1,1,0.85>]} }") << ENDLWX;
	
    if (mCCloudType.mBody != 0){
	float cloudDiffuse = (bRadiosity == 1) ? 0.6 : 2;
	strCloud << wxT("\t\tfinish {ambient 0 diffuse 0,") << cloudDiffuse << wxT("} }") << ENDLWX;
    }
    else if (bRadiosity == FALSE)
	strCloud << wxT("\t\tfinish {ambient 1 diffuse 0} }") << ENDLWX;
    else
	// Č鐬̂
	strCloud << wxT("\t\tfinish {ambient 0 diffuse 0,1} }") << ENDLWX;
		      
    strCloud << wxT("\tscale 100 + Height*0.6") << ENDLWX
	     << wxT("\ttranslate z*(100+Height) }") << ENDLWX
	     << wxT("#end") << ENDLWX << ENDLWX;
	
    if (mCCloudType.mBody == 0){
	strCloud << wxT("CloudLayer(0, ") << crit << wxT(")") << ENDLWX;
	return strCloud;
    }
    
    strCloud << wxT("light_group{") << ENDLWX
	     << wxT("\tlight_source{") << ENDLWX
	     << wxT("\t\t< 288675, 288675, 288675 >") << ENDLWX;
    if (bRadiosity == TRUE)
	strCloud << wxT("\t\tcolor rgb < 2.4, 2.4, 2.4 >") << ENDLWX;
    else
	strCloud << wxT("\t\tcolor rgb < 1.2, 1.2, 1.2 >") << ENDLWX;
    strCloud << wxT("\t\tparallel") << ENDLWX
	     << wxT("\t}") << ENDLWX ;

    if (mCCloudType.mBody == 1)
	for (int i = 0; i < 8; i++)
	    strCloud << wxT("\tCloudLayer(") << 4*i << wxT(",") << crit + 0.04*i << wxT(")") << ENDLWX;
    else 
	for (int i = 0; i < 12; i++)
	    strCloud << wxT("\tCloudLayer(") << 3*i << wxT(",") << crit + 0.03*i << wxT(")") << ENDLWX;
    
    strCloud << wxT("\tglobal_lights off") << ENDLWX
	     << wxT("}") << ENDLWX;
    
    return strCloud;
}

wxString PovBG_cls::
GetPovStrGalaxy(){
    wxString strGalaxy;
    
    int num = mCStarCount.mBody;
    strGalaxy << wxT("#declare star_count = ") << num*100 << wxT(";") << ENDLWX
	      << wxT("#declare star_scale = .4;") << ENDLWX;
    strGalaxy << wxT("#include \"galaxy/GALAXY.SF\"") << ENDLWX;

    strGalaxy << wxT("#declare galaxy_seed = 2;") << ENDLWX
	      << wxT("#declare star_count = ") << num*25 << wxT(";") << ENDLWX
	      << wxT("#declare star_colour = <1, .6, .5>;") << ENDLWX
	      << wxT("#declare star_scale = 0.5;") << ENDLWX;
    strGalaxy << wxT("#include \"galaxy/GALAXY.SF\"") << ENDLWX;

    strGalaxy << wxT("#declare galaxy_seed = 5;") << ENDLWX
	      << wxT("#declare star_count = ") << num*10 << wxT(";") << ENDLWX
	      << wxT("#declare star_type = 3;") << ENDLWX
	      << wxT("#declare star_colour = <.7, .9, 1>;") << ENDLWX
	      << wxT("#declare star_scale = 0.75;") << ENDLWX;
    strGalaxy << wxT("#include \"galaxy/GALAXY.SF\"") << ENDLWX;

    if (mCNebulaType.mBody == 0) return strGalaxy;

    wxString strNebula;
    switch (mCNebulaType.mBody){
    case _POV_BG_NEBULA1: strNebula = wxT("Nebula1"); break;
    case _POV_BG_NEBULA2: strNebula = wxT("Nebula2"); break;
    case _POV_BG_NEBULA3: strNebula = wxT("Nebula3"); break;
    case _POV_BG_NEBULA4: strNebula = wxT("Nebula4"); break;
    case _POV_BG_NEBULA5: strNebula = wxT("Nebula5"); break;
    case _POV_BG_NEBULA6: strNebula = wxT("Nebula6"); break;
    case _POV_BG_GALAXY1: strNebula = wxT("Galaxy1"); break;
    case _POV_BG_GALAXY2: strNebula = wxT("Galaxy2"); break;
    case _POV_BG_GALAXY3: strNebula = wxT("Galaxy3"); break;
    case _POV_BG_GALAXY4: strNebula = wxT("Galaxy4"); break;
    case _POV_BG_GALAXY5: strNebula = wxT("Galaxy5"); break;
    case _POV_BG_COMET1: strNebula = wxT("Comet1"); break;
    case _POV_BG_COMET2: strNebula = wxT("Comet2"); break;
    case _POV_BG_COMET3: strNebula = wxT("Comet3"); break;
    case _POV_BG_METEOR1: strNebula = wxT("Meteor1"); break;
    case _POV_BG_METEOR2: strNebula = wxT("Meteor2"); break;
    }

    // PINK NEBULA
    strGalaxy << wxT("#declare galaxy_declare_only = true;") << ENDLWX
	      << wxT("#declare galaxy_colour1 = 1.2 * ") << PovOut3f(wxT(""), mCNColor1.mpBody) << wxT(";") << ENDLWX;
    if (mCNColor2.mpBody[0] != 0 || mCNColor2.mpBody[1] != 0 || mCNColor2.mpBody[2] != 0)
	strGalaxy << wxT("#declare galaxy_colour2 = ") << PovOut3f(wxT(""), mCNColor2.mpBody)<< wxT(";") << ENDLWX;
    if (mCNColor3.mpBody[0] != 0 || mCNColor3.mpBody[1] != 0 || mCNColor3.mpBody[2] != 0)
	strGalaxy << wxT("#declare galaxy_colour3 = ") << PovOut3f(wxT(""), mCNColor3.mpBody)<< wxT(";") << ENDLWX;
    strGalaxy << wxT("#declare galaxy_pattern_origin = x * 1;") << ENDLWX
	      << wxT("#declare galaxy_turb_origin = x * -4;") << ENDLWX
	      << wxT("#declare galaxy_object_name = \"") << strNebula << wxT("\"") << ENDLWX
	      << wxT("#declare galaxy_object_scale = ") << mCNebulaScale.mBody <<wxT(";") << ENDLWX
	      << wxT("#declare galaxy_object_flatten = ") << mCNebulaFlat.mBody <<wxT(";") << ENDLWX
	      << wxT("#declare galaxy_object_position = <0, 0, 0>;") << ENDLWX
	      << wxT("#declare galaxy_cluster_name = \"\"") << ENDLWX;
    strGalaxy << wxT("#include \"galaxy/GALAXY.OBJ\"") << ENDLWX;
    
    strGalaxy << wxT("object {") << ENDLWX
	      << wxT("\t_GX_object scale galaxy_object_scale * <1, 1-galaxy_object_flatten, 0>") << ENDLWX
	      << wxT("translate z rotate <-1, 1, 0> * galaxy_object_position") << ENDLWX
	      << wxT("scale galaxy_distance rotate ") 
	      << PovOut3(wxT(""), 0, 0, mCNebulaRotate.mBody) << wxT(" rotate ");
    switch(mCNebulaDirection.mBody){
    case 0: strGalaxy << PovOut3(wxT(""),0,90,0); break;
    case 1: strGalaxy << PovOut3(wxT(""),0,-90,0); break;
    case 2: strGalaxy << PovOut3(wxT(""),-90, 0, 0); break;
    case 3: strGalaxy << PovOut3(wxT(""),90, 0, 0); break;
    case 4: strGalaxy << PovOut3(wxT(""),0, 0, 0); break;
    case 5: strGalaxy << PovOut3(wxT(""), 180, 0, 0); break;
    }
    strGalaxy << wxT(" }") << ENDLWX;
    
    return strGalaxy;
}

wxString PovBG_cls::
GetPovStr(bool bRadiosity){
    wxString strSky;

    if (mCSkySphereType.mBody == _POV_BG_MONOCOLOR)
	strSky << wxT("background { ")
	       << PovOut3f(wxT("rgb"), mCColor0.mpBody) << wxT("}");
    else{
	strSky << wxT("sky_sphere {") << ENDLWX
	       << wxT("\tpigment {") << ENDLWX
	       << wxT("\t\tgradient z") << ENDLWX
	       << wxT("\t\tcolor_map {") << ENDLWX;
	if (mCSkySphereType.mBody == _POV_BG_SPHERE)
	    strSky << wxT("\t\t\t[ 0.0 color ") << PovOut3f(wxT("rgb"), mCColor1.mpBody) << wxT("]") << ENDLWX;
	strSky << wxT("\t\t\t[ 0.5 color ") << PovOut3f(wxT("rgb"), mCColor0.mpBody) << wxT("]") << ENDLWX
	       << wxT("\t\t\t[ 1.0 color ") << PovOut3f(wxT("rgb"), mCColor1.mpBody) << wxT("]") << ENDLWX
	       << wxT("\t\t}") << ENDLWX
	       << wxT("\t\tscale 2") << ENDLWX << wxT("\t\ttranslate -1") << ENDLWX
	       << wxT("\t}") << ENDLWX << wxT("}") ;
    }
    
    strSky << ENDLWX << ENDLWX;

    switch(mCBGType.mBody){
    case _POV_BG_CLOUD: 
	strSky << GetPovStrCloud(bRadiosity); break;
    case _POV_BG_GALAXY:
	strSky << GetPovStrGalaxy(); break;
    }
    
    return strSky;
}

void PovBG_cls::
ReadStrLine(std::wstring strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString PovBG_cls::
SerializeConf(){
    return mCConfList.SerializeAll();
}

