
#ifndef _POV_BG_H_
#define _POV_BG_H_

#include "../clsPovSerialize.h"
#include "../../COMMON/clsFilename.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../../WIDGETCTRL/EX/clsButtonEX.h"
#include "../../WIDGETCTRL/clsAtoWXSTextCtrl.h"

class PovRay_cls;

#define _POV_BG_MONOCOLOR 0
#define _POV_BG_HEMISPHERE 1
#define _POV_BG_SPHERE 2
#define _POV_BG_STARFIELD 3

#define _POV_BG_CLOUD 1
#define _POV_BG_GALAXY 2

#define _POV_BG_NEBULA1 1
#define _POV_BG_NEBULA2 2
#define _POV_BG_NEBULA3 3
#define _POV_BG_NEBULA4 4
#define _POV_BG_NEBULA5 5
#define _POV_BG_NEBULA6 6
#define _POV_BG_GALAXY1 7
#define _POV_BG_GALAXY2 8
#define _POV_BG_GALAXY3 9
#define _POV_BG_GALAXY4 10
#define _POV_BG_GALAXY5 11
#define _POV_BG_COMET1 12
#define _POV_BG_COMET2 13
#define _POV_BG_COMET3 14
#define _POV_BG_METEOR1 15
#define _POV_BG_METEOR2 16

class PovBG_cls : public PovSerialize_cls {
 public:
    PovBG_cls();
    
    void SetToDefault();

    //PovRay_cls *mpCParent;

    wxButtonEX *mpCBTNBG;
    MultiNumericalInputsPanel_cls* mpCMNumBG;
    void SetMNumBG(wxBoxSizer *pBoxSizer, wxWindow *pCParentPanel);

    void HideAndShow();

    int  mIndexSkySphereType, mIndexColors, mIndexColor0, mIndexColor1;
    int  mIndexBGType, mIndexPluginHelp;
    int  mIndexCloudParam0, mIndexCloudyness, mIndexCloudScale;
    int  mIndexCloudParam1, mIndexCloudType, mIndexCloudFade, mIndexCloudTurb;
    int  mIndexStarCount;
    int  mIndexNebulaParam0, mIndexNebulaType, mIndexNebulaDirection;
    int  mIndexNebulaParam1, mIndexNebulaScale, mIndexNebulaFlat, mIndexNebulaRotate;
    int  mIndexNebulaColors, mIndexNColor1, mIndexNColor2, mIndexNColor3;
    ConfItemList_cls       mCConfList;
    ConfItemUINT_cls       mCSkySphereType;
    ConfItemFLOATARRAY_cls mCColor0;
    ConfItemFLOATARRAY_cls mCColor1;
    ConfItemUINT_cls       mCBGType;
    ConfItemFLOAT_cls      mCCloudyness;
    ConfItemFLOAT_cls      mCCloudScaling;
    ConfItemFLOAT_cls      mCCloudTurb;
    ConfItemUINT_cls       mCCloudType;
    ConfItemUINT_cls       mCCloudFade;
    ConfItemUINT_cls       mCNebulaDirection;
    ConfItemUINT_cls       mCNebulaType;
    ConfItemFLOAT_cls      mCNebulaScale;
    ConfItemFLOAT_cls      mCNebulaFlat;
    ConfItemFLOAT_cls      mCNebulaRotate;
    ConfItemFLOATARRAY_cls mCNColor1;
    ConfItemFLOATARRAY_cls mCNColor2;
    ConfItemFLOATARRAY_cls mCNColor3;
    ConfItemINT_cls        mCStarCount;
        
    wxColour GetColourBG(int index);
    wxColour GetColourBGN(int index);
    void     ChangeBGColor(float *pRGB, int index);
    void     ChangeBGNColor(float *pRGB, int index);
    wxString GetPovStrCloud(bool bRadiosity);
    wxString GetPovStrGalaxy();
    wxString GetPovStr(bool bRadiosity);

    void ReadStrLine(std::wstring strLine);
    wxString SerializeConf();
};

#endif
