// "clsPovCrossSectionCommon.cpp"
// (c-basic-offset 4)

#ifndef _POV_CROSS_SECTION_COMMON_H_
#define _POV_CROSS_SECTION_COMMON_H_

#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"

class FilterCtrl_cls;

#include <math.h>
#include <vector>

#include <wx/thread.h>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

class ThreadCalcNormal : public wxThread {
 public: 
    ThreadCalcNormal();

    void SetParameters(std::vector < std::vector < unsigned char > > *pVVField,
		       std::vector < std::vector < double > > *pNormalU,
		       std::vector < std::vector < double > > *pNormalV,
		       std::vector < std::vector < double > > *pNormalW,
		       int sizeU, int iniV, int finV,
		       double embossU, double embossV);

    virtual ExitCode Entry();

    std::vector < std::vector < unsigned char > > *mpVVField;
    std::vector < std::vector < double > > *mpVVNormalU;
    std::vector < std::vector < double > > *mpVVNormalV;
    std::vector < std::vector < double > > *mpVVNormalW;
    int mSizeU;
    int mIniV, mFinV;
    double mEmbossU, mEmbossV;
};

// ------------------

class PovCrossSectionCommon_cls : public FilterWithParameter_cls {
 public:
    PovCrossSectionCommon_cls(FilterCtrl_cls *pCParentCtrl);

    int mSizeX, mSizeY, mSizeZ;

    void DrawVertexArray(int colorType, int sizeUm, int sizeVm, 
			 float *pTexture, float *pNormals, float *pVerticies,
			 unsigned int *pPolyIndices, bool bFlip = FALSE);

    void ConstructVerticesCoreX
	(unsigned char *pData, double layer, 
	 std::vector < std::vector < unsigned char > > *pVVField);
    void ConstructVerticesCoreY
	(unsigned char *pData, double layer, 
	 std::vector < std::vector < unsigned char > > *pVVField);
    void ConstructVerticesCoreZ
	(unsigned char *pData, double layer, 
	 std::vector < std::vector < unsigned char > > *pVVField);

    
    
    void CalcNormal(std::vector < std::vector < unsigned char > > *pVVField,
		    std::vector < std::vector < double > > *pVVNormalU,
		    std::vector < std::vector < double > > *pVVNormalV,
		    std::vector < std::vector < double > > *pVVNormalW,
		    int sizeU, int sizeV, double emboss, bool bInvert = FALSE);
    
    void RecalcNorm(std::vector < std::vector < double > > *pVVNormalU,
		    std::vector < std::vector < double > > *pVVNormalV,
		    std::vector < std::vector < double > > *pVVNormalW,
		    double scale[3], int sizeU, int sizeV,
		    int baseAxis, int axisU, int axisV, int axisW);

    double mScalePrev[3][3];
};

#endif
