// "clsDiffPovObject.cpp"
// (c-basic-offset 4)

#ifndef _POV_DIFF_OBJECT_H_
#define _POV_DIFF_OBJECT_H_

#include "clsPovObjectCommon.h"

#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../FILTER/clsFilterWithTexture.h"

class PovDiffObject_cls;
class GLGuides_cls;

class PovDiffObjectGUI_cls : public FilterGUI_cls {
    
    MACRO_DefGUIMainSettings(PovDiffObject);
    MACRO_DefVirtualCustmFunctions;

    int mIndexObjType, mIndexShapeParam;

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class PovDiffObjectData_cls : public FilterWithParameterData_cls {
 public:
    PovDiffObjectData_cls(FilterCtrl_cls* pCCtrl, 
			  bool bConnectToStaticParam = TRUE,
			  int initType = 1);
    
    void ReDefineList();

    int mInitType;
    ConfItemUINT_cls     mCObjType;
    ConfItemFLOAT_cls    mCShapeParam;
    ConfItemBOOL_cls     mCbHideWireframe;

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();
    
    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class PovDiffObject_cls : public PovSerialize_cls, public FilterWithParameter_cls, public FilterObject_cls, public PovObjectCommon_cls {
 public: 
    PovDiffObject_cls(FilterCtrl_cls *pCParentCtrl,
		      PovDiffObjectData_cls *pCInitData = NULL);
    ~PovDiffObject_cls();

    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovDiffObjectData_cls* GetPCData();
    // --

    void SetMatrix(Parameters_cls *pParam, int keyIndex,
		   double dpos[3], int flag);
    void DrawGlobal(double viewscale);
    void DrawGLGuide(GLGuides_cls *pCGLGuides, double dpos[3], double scale,
		     int manipMode, double dScale[3], double dRot[4]);

    wxString GetPovStrDiffObj(wxString strCoordinate);

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovDiffObjectData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
};

#endif
