
#ifndef _POV_ISOSURFACE_H_
#define _POV_ISOSURFACE_H_

#include <string>

class PovIsosurfaceData_cls;

#include "clsPovSerialize.h"
#include "ISOSURFACE/clsMarchingCube.h"
#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../FILTER/clsFilterWithTexture.h"
#include "../PARAMETER/clsParameters.h"
#include "../FILTER/clsFilterWithSelect.h"

class DF3SeqGUI_cls;
class PovIsosurface_cls;
class TexProperty_cls;

#define _ISO_CRIT 0
#define _ISO_ALPHA 1

#define _ISO_LINK_TO_DF3 0
#define _ISO_LINK_TO_POV 1
#define _ISO_PACK_IN_POV 2

class PovIsosurfaceGUI_cls : public FilterWithTargetGUI_cls {

    MACRO_DefGUIMainSettings(PovIsosurface)
    MACRO_DefVirtualCustmFunctions;
    
    static void HookButton(void *pArg, void *pEvent);
    static void HookButton2(void *pArg, void *pEvent);

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class PovIsosurfaceData_cls : public FilterWithParameterData_cls, public FilterWithTextureData_cls {
 public:
    PovIsosurfaceData_cls(FilterCtrl_cls* pCCtrl, 
			  bool bConnectToStaticParam = TRUE);

    void ReDefineList();

    ConfItemBOOL_cls     mCbInverse;
    ConfItemSTR_cls      mCConfTargetStr;

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

// ----

class PovIsosurface_cls : public PovSerialize_cls, public FilterWithParameter_cls, public FilterObject_cls {
 public:
    PovIsosurface_cls(FilterCtrl_cls *pCParentCtrl,
		      PovIsosurfaceData_cls *pCInitData = NULL);
    ~PovIsosurface_cls();
    
    void     UpdateTarget();
    void     UpdateTargetInfo();
    MarchingCube_cls mCMarchingCube;
    
    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovIsosurfaceData_cls* GetPCData();
    
    //--

    static wxRect msCRectMNumStaticMembers;
    
    static PovIsosurface_cls *mspCConnectedToDLG;
    void SetMNumAdvanced(wxWindow *pCParentWindow);
    void AdvancedSetting();
    void UpdateColors();
    void ExportWavefrontOBJ(wxString strFilePath);
    void ExportMesh2Pov(wxString strFilePath);
    
    static ConfItemINT_cls   msCMaxTrace;
    static ConfItemUINT_cls  msCTypeGradient;
    static ConfItemFLOAT_cls msCMaxGradient;
    static ConfItemFLOAT_cls msCAccuracy;
    static ConfItemFLOATARRAY_cls msCEvaluate;
    static ConfItemBOOL_cls  msCbCullFace;
    static ConfItemBOOL_cls  msCbTrimEdge;
    static ConfItemBOOL_cls  msCbReTexOptimize;
    static ConfItemBOOL_cls  msCbOffset05;
    static ConfItemBOOL_cls  msCbExportNormal;
    static ConfItemBOOL_cls  msCbHighPrecNormal;
    static ConfItemBOOL_cls  msCbClipForPeriodic;
    static ConfItemUINT_cls  msCOutputType;
    static ConfItemBOOL_cls  msCbMesh2Sequential;
    static ConfItemSTR_cls   msCMesh2Path;
    static ConfItemUINT_cls  msCShowMode;

    static wxString msstrWorkingDir;
    
    bool IsReprocessRequired();
    double mTargetValue;
    void ClearIsosurface();
    void RefreshFilter(unsigned char *pData/*, wxString strFilterStat*/);
    void DrawBox(double center[3], double scale[3]);
   
    wxString GetMesh2PovFilePath(wxString strTag);
 
    void GetPovStrIsosurfBox
	(wxString *pstrTarget,
	 wxString strTag, wxString strFilePath,
	 wxString strGeometry, float treeDivideParam,
	 unsigned int depth,
	 double baseAlpha, double clipForPeriodicBoundary[3],
	 DrawingBlock_cls* pCDrawingBlock);

    wxString GetPovStrIsoFunction
	(wxString strTag, wxString strDensityFile, wxString strGeometry);
    wxString GetPovStrIsoSurf
	(wxString strTag, wxString strFunc, double clipForPeriodicBoundary[3]);
    wxString GetPovStrIsoTex(wxString strTag, wxString strFilePath);

    wxString GetPovStrIsoBox(wxString strBoxLabel, wxString strTag,
			     double clipForPeriodicBoundary[3],
			     DrawingBlock_cls* pCDrawingBlock); 

    // --

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovIsosurfaceData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
    
    static wxString SerializeStaticConf();
    static void ReadStrLineStaticConf(std::wstring strLine);
};

#endif
