// "clsPovObjectCommon.cpp"
// (c-basic-offset 4)

#ifndef _POV_OBJECT_COMMON_H_
#define _POV_OBJECT_COMMON_H_

#define _OBJECT_TYPE_PLANE 0
#define _OBJECT_TYPE_BOX 1 
#define _OBJECT_TYPE_SPHERE 2
#define _OBJECT_TYPE_CONE 3
#define _OBJECT_TYPE_ARROW 4
#define _OBJECT_TYPE_TEXT 5
#define _OBJECT_TYPE_WIRED_BOX 6
#define _OBJECT_TYPE_MESH 7
#define _OBJECT_TYPE_PLUGIN 8

#define _OBJECT_TRANS_X 0
#define _OBJECT_TRANS_Y 1
#define _OBJECT_TRANS_Z 2
#define _OBJECT_SCALE_X 3
#define _OBJECT_SCALE_Y 4
#define _OBJECT_SCALE_Z 5
#define _OBJECT_ROT_Y 6
#define _OBJECT_ROT_P 7
#define _OBJECT_ROT_R 8
#define _OBJECT_ROT_Y2 9
#define _OBJECT_ALPHA 10 

#include "../MYGL/clsDrawPath.h"

class GLGuides_cls;

class PovObjectCommon_cls : public DrawPath_cls {
 public:
    void SetGLMatrix(double *pInterpolated, double dRot[4]);
    void DrawWireframePlane();
    void DrawWireframeBox();
    void DrawWireframeSphere();
    void DrawWireframeCone(float shapeParam);
    void DrawWireframeArrow(float shapeParam);
    void DrawWireframe(double dScale[3], double dRot[4],
		       double *pInterpolated,
		       int objType, float shapeParam);
    void DrawBox();
    void DrawGLGuideCommon
	(GLGuides_cls *pCGLGuide, double dpos[3], double scale,
	 int manipMode, double dScale[3], double dRot[4], double *pInterpolated,
	 int objType, float shapeParam = 1, bool bHideWire = FALSE);
};

#endif
