
#ifndef _POV_RAY_H_
#define _POV_RAY_H_

#include "clsPovSerialize.h"
#include "../CONFITEM/clsConfItemWXGUI.h"
#include "../DF3/GL/clsColoring.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include <wx/wx.h>

extern Coloring_cls GCColoring;

class AtoiTextCtrl_cls; 
class AtoiSpinCtrl_cls;
class AtoWXSTextCtrl_cls;
class DF3SeqCtrl_cls;
class DrawingBlock_cls;
class FilterCtrl_cls;
class FrameMain_cls;
class GraphPanel_cls; 
class Main_cls;
class ThreadPovRay;
class PovBG_cls;
class PovFocalBlur_cls;
class PovRay_cls; 
class PovRadiosity_cls;
class PovPhotons_cls;
class PovVolume_cls;
class MultiNumericalInputsPanel_cls;

//#include "../../clsFrameMain.h"

#define _POV_SNAP 0
#define _POV_ANIM 1

#define _POV_PERSPECTIVE  0
#define _POV_ORTHOGRAPHIC 1
#define _POV_FISHEYE      2
#define _POV_CYLINDER     3

#define _POV_FORMAT_NUMBER 8
#define _POV_PNG_8BIT  0
#define _POV_PNG_12BIT 1
#define _POV_PNG_16BIT 3
#define _POV_SYSTEM    3
#define _POV_PPM       4
#define _POV_JPG       5
#define _POV_EXR       6
#define _POV_HDR       7

#define _POV_RENDER_WORKAREA  0
#define _POV_RENDER_FULLSCENE 1
#define _POV_RENDER_CUSTOM    2

#define _POV_FOLLOW_CAMERA     0
#define _POV_SAME_AS_PREVIEW0  1
#define _POV_SAME_AS_PREVIEW1  2
#define _POV_SAME_AS_PREVIEW2  3
#define _POV_SAME_AS_PREVIEW3  4

#define _POVRAY_36 0
#define _POVRAY_37 1

#define _POVRAY_MAX_THREAD 16

#define _POV_EXPORT 0
#define _POV_RENDER 1

class PovIsosurfaceData_cls;
class FilterBase_cls;
class wxNotebook;

class PovRayGUI_cls : public wxDialogEXKey/*, public MinimizeButton_cls */{
 public:
    PovRayGUI_cls(PovRay_cls* pCParent, 
		  wxWindow *pC, wxPoint pos, wxSize size);
    ~PovRayGUI_cls();

    static PovRayGUI_cls *mspCThis;

    //void UpdateGraph();
    void UpdateDisplay();

    void OnButtonWorkingDir(wxCommandEvent &event);
    void OnButtonPathPovray(wxCommandEvent &event);
    void OnButtonExportSnap(wxCommandEvent &event);
    void OnButtonExportAnim(wxCommandEvent &event);
    void OnButtonRenderSnap(wxCommandEvent &event);
    void OnButtonRenderAnim(wxCommandEvent &event);
    void OnButtonDefault   (wxCommandEvent &event);
    void OnButtonAdvanced  (wxCommandEvent &event);
    void OnButtonBGColor0 (wxCommandEvent &event);
    void OnButtonBGColor1 (wxCommandEvent &event);
    void OnButtonPluginHelp(wxCommandEvent &event);
    void OnButtonBGNColor1 (wxCommandEvent &event);
    void OnButtonBGNColor2 (wxCommandEvent &event);
    void OnButtonBGNColor3 (wxCommandEvent &event);
    bool CheckConsistency  (int type = _POV_RENDER);
    void Assign            ();
    void OnButtonApply     (wxCommandEvent &event);
    void OnButtonClose     (wxCommandEvent &event);

    PovRay_cls    *mpCParent;

    wxPanel  *mpCCheckPovray;
    wxPanel  *mpCCheckWorkDir;
    wxButtonEX *mpCButtonExportAnim;
    wxButtonEX *mpCButtonRenderAnim;
    bool CheckFileExistence(int type = _POV_RENDER);

    wxNotebook    *mpCBook1, *mpCBook2;
    MultiNumericalInputsPanel_cls* mpCMNumVolume;
    MultiNumericalInputsPanel_cls* mpCMNumIsosurf;
    MultiNumericalInputsPanel_cls* mpCMNumFormat;
    MultiNumericalInputsPanel_cls* mpCMNumTypeParam;
    MultiNumericalInputs_cls* mpCMNumCameraParamAdvanced;

    int mIndexIntervals, mIndexVolumeAA;
    int mIndexIsosurfaceType, mIndexIsosurfacePath;
    int mIndexAccuracy, mIndexGradient, mIndexStatic, mIndexDynamic;

    int  mIndexGeomTemplate, mMNumIndexStereo;
    int  mIndexOutputGeometry;
    int  mMNumIndexCamSelect;
    
    int  mIndexGamma, mIndexThread, mIndexPartition, mIndexBufferSize;
    int  mIndexSSSQuality, mIndexJitter, mIndexJitterAmount;
    int  mIndexVersion;

    void UpdateComboboxList();

    void SetMNumVolume(wxBoxSizer *pBoxSizer, wxWindow *pCParent);
    void SetMNumIsosurf(wxBoxSizer *pBoxSizer, wxWindow *pCParent);
    void SetMNumFormat(wxBoxSizer *pBoxSizer, wxWindow *pCParent);
    void SetMNumTypeParam(wxBoxSizer *pBoxSizer, wxWindow *pCParent);
    void SetMNumCameraParamAdvanced();
    //void SetMNumFogParam   (wxBoxSizer *pBoxSizer);

    void HideAndShowVolume();
    void HideAndShowIsosurf();
    void HideAndShowFormat();
    
    void RecalcSize();

    //static void HookGeometryTemplate(void *pArg, void *pEvent);
    static void HookHideAndShow(void *pArg, void *pEvent);
    
    wxButtonEX *mpCBTNVolume, *mpCBTNIsosurf, *mpCBTNFormat;
    
    int mDummy;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class PovRay_cls : 
public DialogControl_cls,
public PovSerialize_cls
{ 
 public:
    PovRay_cls(FrameMain_cls *pC, DF3SeqCtrl_cls *pCDF3SeqCtrl,
	       wxBitmap *pBitmap);
    ~PovRay_cls();
    
    static PovRay_cls *mspCThis;
    PovRayGUI_cls*  mpCGUI;
    FrameMain_cls*  mpCParentFrame;
    wxBitmap *mpBitmapLink;
    static DF3SeqCtrl_cls* mspCDF3SeqCtrlLink;
    //wxRect mCScreenRect;

    bool mbPovRayThreadActive[_POVRAY_MAX_THREAD];
    ThreadPovRay *mpCThreadPovRay[_POVRAY_MAX_THREAD];
    
    bool mbRenderingTwoSnap;
    bool mbExportingAnim, mbRenderingAnim;
    int  mCurrentAnim;
    ThreadPovRay *mpCThreadPovRayAnim;
    std::vector < wxString > mVstrAnimCommand;
    std::vector < wxString > mVstrAnimPostSceneCommand;

    void HideAndShow();
    static void HookRadiocity(void *pArg, void *pEvent);
    static void HookPhotons(void *pArg, void *pEvent);
    static void HookFocalBlur(void *pArg, void *pEvent);
    static void HookBG(void *pArg, void *pEvent);
    //static void HookGeometryTemplate(void *pArg, void *pEvent);
    static void HookPovrayVersion(void *pArg, void *pEvent);
    static void EnableDisablePovrayVersion(void *pCDLG, void *pDummy);
    
    //--
    
    ConfItemSTRWXGUI_cls mCConfPathPovray;
    ConfItemSTRWXGUI_cls mCConfWorkingDir;
    ConfItemSTRWXGUI_cls mCConfSnapFile;
    ConfItemSTRWXGUI_cls mCConfAnimFile;
    ConfItemBOOL_cls  mCbConfAbsolutePath;
    wxString mstrPostSceneCommand;
    void CheckIllegalFileName();
        
    int mSnapNumber;
    AtoiSpinCtrl_cls *mpCSnapNumber;

    PovRadiosity_cls *mpCRadiosity;
    PovPhotons_cls   *mpCPhotons;
    PovFocalBlur_cls *mpCFocalBlur;
    PovBG_cls        *mpCBG;

    bool mbPovOutForRender;

    void SetToDefault();
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    
    int   GetStereoId(int index);
    int   GetStereoTmpFileIOMode(int index);
    wxString GetFileStr(unsigned int type, unsigned int stereoId);
    wxString GetWorkingDirWithSep(bool bForceAbs = FALSE);
    int   GetCameraGeometry();
    int   GetCameraIndex();
    double GetVAngle();
    void CoupleToStereogram();
    
    void ReadStrLine(std::wistream &istream, std::wstring strLine);

    wxString SerializeConf(bool flag);
    wxString InsertTab(wxString strLines);
    //wxString SerializeClipping(double *pPos, wxString strLines);
    wxString GetPovStrCommon();
			
    wxString SerializeCameraGeometryType();
    wxString SerializeRight();
    wxString GetPovStrCamInfo(PositionAndDirection_cls CCamPos,
			      wxString strCamPos, double doubleIndex);

    wxString GetPovStrIniFile(std::wstring strPovFile = L"povout",
			      int jpegCompress = 85);
    static wxString GetPovStrPhotonSetting
	(double alpha, double reflectMin, double reflectMax,
	 bool bKillTarget = FALSE);

    wxString GetPovRayCommand(wxString filename);
    void  PushBackCommands(unsigned int stereo, unsigned int frame);
    void  ExportPovAnim();
    void  WaitingForExport(bool bFlag);
    bool  RenderByPovSnap(unsigned int stereo);
    void  RenderByPovAnim(unsigned int init, unsigned int fin);
    void  ProcessRenderAnim();
    void  StopRenderAnim();
    void  StopExportAnim();
        
    //void  SetBGColor(float *pRGB0, float *pRGB1);

    // ---
    wxString SerializeAngle();
    // ---

    float GetRadianForVisCheck();
    std::wstring msAFormat[_POV_FORMAT_NUMBER];

    double mSplit;
    float mTreeDepthParam[5];
        
    unsigned int          mGeometryTemplate;
    ConfItemList_cls      mCConfListDisp;
    ConfItemINT_cls       mCMaxTraceLevel;
    ConfItemUINT_cls      mCPovRayVersion;
    ConfItemFLOAT_cls     mCFileGamma, mCDisplayGamma;
    ConfItemFLOAT_cls     mCAssumedGamma;
    ConfItemUINT_cls      mCWorkThread;
    ConfItemUINT_cls      mCRenderBlockSize;
    ConfItemUINT_cls      mCBoundingMethod;
    ConfItemUINT_cls      mCBufferSize;
    ConfItemINT_cls       mCSSSQuality1, mCSSSQuality2;
    ConfItemINT_cls       mCWidth, mCHeight;
    ConfItemUINT_cls      mCRegionType;
    ConfItemUINT_cls      mCCameraType;
    ConfItemUINT_cls      mCOutputFormat;
    ConfItemBOOL_cls      mCbAntiAlias, mCbDisplay, mCbPause, mCbPreview;
    ConfItemBOOL_cls      mCbJitter, mCbOutputAlpha;
    ConfItemINT_cls       mCStereoEye;
    ConfItemFLOAT_cls     mCAntiAliasThreshold, mCJitterAmount;
    ConfItemINT_cls       mCAntiAliasDepth;
    ConfItemUINT_cls      mCRemoveFile;
    ConfItemUINT_cls      mCShowTweaks;

    /*
    ConfItemList_cls      mCConfListLayout;
    ConfItemBOOL_cls      mCConfBTNVolume;
    ConfItemBOOL_cls      mCConfBTNIsosurf;
    ConfItemBOOL_cls      mCConfBTNFormat;
    ConfItemBOOL_cls      mCConfBTNRadiosity;
    ConfItemBOOL_cls      mCConfBTNPhotons;
    ConfItemBOOL_cls      mCConfBTNFocalBlur;
    ConfItemBOOL_cls      mCConfBTNBG;
    */
    
    ConfItemBOOL_cls      mCbSubsetRow;
    ConfItemINT_cls       mCSubsetRowStart, mCSubsetRowEnd;
    //ConfItemFLOATARRAY_cls mCBGColor0, mCBGColor1;
    
    ConfItemList_cls  mCConfListFog;
    //ConfItemBOOL_cls  mCbClipSphere;
    //ConfItemFLOAT_cls mCClipSphereRadius;
    ConfItemBOOL_cls  mCbWinePov;
};

#endif
