// "clsPovThreeView.cpp"
// (c-basic-offset 4)

#ifndef _POV_THREEVIEW_H_
#define _POV_THREEVIEW_H_

#include <string>

class PovThreeViewData_cls;

#include "clsPovSerialize.h"
#include "clsPovCrossSectionCommon.h"
#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../FILTER/clsFilterWithTexture.h"
#include "../MYGL/clsTextureMapping.h"
#include "../PARAMETER/clsParameters.h"

#define _THREEVIEW_AVERAGE 0
#define _THREEVIEW_MAX 1
#define _THREEVIEW_MIN 2
#define _THREEVIEW_CROSSSECTION 3

class DF3SeqGUI_cls;
class PovRay_cls;
class PovThreeView_cls;
class TexProperty_cls;

// 3ɂĂꂼ
#define _THREE_LAYER 0
#define _THREE_EMBOSS 3 
#define _THREE_ALPHA 4
#define _THREE_CRIT 5

#include <wx/thread.h>

class PovThreeViewGUI_cls : public FilterWithTextureGUI_cls {

    MACRO_DefGUIMainSettings(PovThreeView);
    MACRO_DefVirtualCustmFunctions;

    int mIndexLayer[3];
    int mIndexOffset[3];
    int mIndexCrit;
    void SetLayerIndexRange(int axis, int max);

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class PovThreeViewData_cls : public FilterWithParameterData_cls, public FilterWithTextureData_cls {
 public:
    PovThreeViewData_cls(FilterCtrl_cls* pCCtrl, 
			 bool bConnectToStaticParam = TRUE);
    
    void ReDefineList();

    ConfItemBOOL_cls    mCbShade, mCbTransNullRegion, mCbSmooth;
    ConfItemBOOLARRAY_cls mCbShow0, mCbShow1;
    ConfItemBOOL_cls mCbAddFiller;
    ConfItemUINT_cls mCMode;
    ConfItemFLOATARRAY_cls mCOffset;
    ConfItemBOOL_cls mCbMultiply, mCbDrawFrame;
    
    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

// ----

class PovThreeView_cls : public PovSerialize_cls, public PovCrossSectionCommon_cls, /*public FilterWithParameter_cls,*/ public TextureMapping_cls, FilterObject_cls {
 public:
    PovThreeView_cls(FilterCtrl_cls *pCParentCtrl,
		       PovThreeViewData_cls *pCInitData = NULL);
    ~PovThreeView_cls();
    
    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovThreeViewData_cls* GetPCData();
    
    //--

    void SetMNumAdvanced(wxWindow *pCParentWindow);
    void AdvancedSetting();
    void UpdateColors();

    bool IsReprocessRequired();
    int mPrevMode;
    double mPrevEmboss;
    double mPrevLayer[3];
    bool mPrevShow[3];
    
    void RefreshFilter(unsigned char *pData);
    void ClearFieldData(int axis);
    void AllocFieldData(int axis, int sizeU, int sizeV);
    void ConstructVerticesX(unsigned char *pData, double emboss);
    void ConstructVerticesY(unsigned char *pData, double emboss);
    void ConstructVerticesZ(unsigned char *pData, double emboss);

    void SettingForDrawFrame();
    double GetEmboss();
    double GetCritOffset();

    void DrawFillerXQuadStripCore
	(double value, int directionA, float normalV[3],
	 double coX, double coY, double coZ0, double coZ1);
    void DrawFillerYQuadStripCore
	(double value, int directionA, float normalV[3], 
	 double coX, double coY, double coZ0, double coZ1);
    void DrawFillerZQuadStripCore
	(double value, int directionA, float normalV[3], 
	 double coX, double coY0, double coY1, double coZ);
    
    void DrawFillerXQuadStrip
	(double value, int directionA, int directionB, float normalV[3],
	 double coX, double y0, double y1, double z0, double z1);
    void DrawFillerYQuadStrip
	(double value, int directionA, int directionB, float normalV[3],
	 double coY, double x0, double x1, double z0, double z1);
    void DrawFillerZQuadStrip
	(double value, int directionA, int directionB, float normalV[3],
	 double coZ, double x0, double x1, double y0, double y1);
    
    
    void AddFillerX(double scale[3], int directionA, 
		    bool bShowYMinus, bool bShowYPlus, float offsetY,
		    bool bShowZMinus, bool bShowZPlus, float offsetZ);
    void AddFillerY(double scale[3], int directionA, 
		    bool bShowXMinus, bool bShowXPlus, float offsetX,
		    bool bShowZMinus, bool bShowZPlus, float offsetZ);
    void AddFillerZ(double scale[3], int directionA, 
		    bool bShowXMinus, bool bShowXPlus, float offsetX,
		    bool bShowYMinus, bool bShowYPlus, float offsetY);
    
    void AddFiller(double scale[3], int direction);    
    void DrawFieldX(double scale[3], int mappingType, int patternType, 
		    int colorType, int mappingCoord, double emboss, int direction);
    void DrawFieldY(double scale[3], int mappingType, int patternType,
		    int colorType, int mappingCoord, double emboss, int direction);
    void DrawFieldZ(double scale[3], int mappingType, int patternType,
		    int colorType, int mappingCoord, double emboss, int direction);
    void DrawBox(double center[3], double scale[3]);
    bool DoesUseMapping();
    void MakeUV1D(TexProperty_cls *pCTexProp,
		  double offset[3], double scale[3]); 

    //int mSizeX, mSizeY, mSizeZ;
    int mAllocU[3], mAllocV[3];
    //double mScalePrev[3];
    std::vector < std::vector < unsigned char > > mVVField[3];
    std::vector < std::vector < double > > mVVNormalU[3];
    std::vector < std::vector < double > > mVVNormalV[3];
    std::vector < std::vector < double > > mVVNormalW[3];

    void AllocArray(int aixs, int sizeV, int sizeUm);
    int mAllocArrayV[3], mAllocArrayUm[3];
    float *mpTexture[3], *mpNormals[3], *mpVertices[3];
    unsigned *mpPolyIndices[3];

    wxString GetPovStrThreeView
	(int axis, wxString strTag, wxString strFilePath,
	 wxString strGeometry, float treeDivideParam, unsigned int depth,
	 double baseAlpha, double clipForPeriodicBoundary[3], 
	 PositionAndDirection_cls CCamLocalCoord, int frame,
	 DrawingBlock_cls* pCDrawingBlock);

    wxString GetPovStrThreeViewGeom
	(int axis, wxString strTag, 
	 double clipForPeriodicBoundary[3], int frame);
    wxString GetPovStrThreeViewColorMap(wxString strTag);
    wxString GetPovStrThreeViewTex(int axis, wxString strTag, bool bFlip);
    wxString GetPovStrThreeViewFiller(int axis, int direction);
    wxString GetPovStrThreeViewObjBase
	(int axis, int direction, wxString strBoxLabel, double critoffset,
	 bool bIndependentTex);
    wxString GetPovStrThreeViewTranslate
	(int axis, int direction, double critoffset, double alt);
    wxString GetPovStrThreeViewIndependentTex
	(wxString strBoxLabel, wxString strTag, 
	 bool bFlip, DrawingBlock_cls* pCDrawingBlock);
    
    wxString GetPovStrThreeViewObj
	(int axis, int direction, wxString strBoxLabel, 
	 wxString strTag, bool bFlip, DrawingBlock_cls *pCDrawingBlock); 
    wxString GetPovStrThreeViewObjIndependentTex
	(int axis, int direction, wxString strBoxLabel, 
	 wxString strTag, bool bFlip, DrawingBlock_cls *pCDrawingBlock); 

    // --

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovThreeViewData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
    
    static wxString SerializeStaticConf();
    static void ReadStrLineStaticConf(std::wstring strLine);
};

#endif
