
#ifndef _STEREO_GRAM_H_
#define _STEREO_GRAM_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

class StereoGram_cls; 

#include "../../clsFrameMain.h"
#include "../PARAMETER/clsParameters.h"
#include "../MYGL/clsPositionAndDirection.h"

#define _STEREO_NONE    0
#define _STEREO_OFFAXIS 1
#define _STEREO_TOEIN   2

#define _STEREO_LFT 1
#define _STEREO_RGT 2
#define _STEREO_SCANLINE 3
#define _STEREO_RED_CYAN 4
#define _STEREO_YELLOW_BLUE 5

//#define _STEREO_DOME 1

class StereoGramGUI_cls : public wxDialogEXKey {
 public:
    StereoGramGUI_cls(StereoGram_cls *pCParent,
		      wxWindow *pC,
		      wxPoint pos, wxSize size);
    ~StereoGramGUI_cls();

    unsigned int mIndexEye, mIndexToeIn, mIndexDistance, mIndexDistanceFocus;
    void HideAndShowItems();

    void OnButtonDefault   (wxCommandEvent &event);
    void OnButtonClose     (wxCommandEvent &event);
    static void FuncHookComboBox(void *pArg, void *pEvent);
    static void FuncHookAssign(void *pArg, void *pEvent);
    
    static StereoGram_cls    *mspCParent;
    static MultiNumericalInputsPanel_cls* mpCMNumMainParam;
    void SetMNumMainParam(wxBoxSizer *pBoxSizer);


 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class StereoGram_cls : 
public DialogControl_cls
{
    friend class DF3SeqGUI_cls; 
    friend class CameraPath_cls; 
    friend class StereoGramGUI_cls; 
    
 public:
    StereoGram_cls(FrameMain_cls *pC, wxBitmap *pBitmap);
    ~StereoGram_cls();

 public:
    FrameMain_cls* mpCParentFrame;
    wxBitmap *mpBitmapLink;
    StereoGramGUI_cls* mpCGUI;
    wxRect mCScreenRect;

    void UpdateItems(bool bForce = FALSE);
    void SetToDefault();
    void InitGUI(wxWindow *pC);

    Parameters_cls mCDistanceOfEyes;
 
 public: //protected:   
    ConfItemList_cls mCConfList;
    ConfItemDOUBLE_cls mCToeInAngle;
    ConfItemDOUBLE_cls mCPitchAngle;
    ConfItemUINT_cls mCType;
    ConfItemUINT_cls mCEye;
    //ConfItemUINT_cls mCDome;
    double mDistanceToFocus;
    double GetDomePitchAngle();

 public:
    void ModifyByStereogram(PositionAndDirection_cls *pCCam, int stereoEye);
    void DrawFocus(PositionAndDirection_cls CCamPos, 
		   double doubleIndex, double scale);

    unsigned int GetEye();
    double GetDistanceToFocus(double doubleIndex);
    double GetStereogramYawAngle(int stereoEye);
    double GetOffsetRight(int eyeMode);
    void   SetColorMaskBegin(int stereo, bool bFlip);
    void   SetColorMaskEnd();
    
    //bool  UpdateValues();
    bool  IsGUIShownOnScreen();

    void ReadStrLine(std::wistream &istream, std::wstring strLine);
    wxString Serialize();
};

#endif
