
#ifndef _TREE_BOX_RULE_H_
#define _TREE_BOX_RULE_H_

#include <wx/wx.h>

class TreeBoxRule_cls; 

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#define _TREE_OCTOTREE 0
#define _TREE_NESTED 1

#define _TREEFOCUS_CAMPOS 0
#define _TREEFOCUS_STEREOFOCUS 1
#define _TREEFOCUS_ANCPOS 2

class TreeBoxRule_cls; 

class TreeBoxRuleGUI_cls : public wxDialogEXKey {
 public:
    TreeBoxRuleGUI_cls(TreeBoxRule_cls* pCParent, 
		       TreeBoxRuleGUI_cls **ppToThis, wxWindow *pC,
		       wxPoint pos, wxSize size);
    ~TreeBoxRuleGUI_cls();

    static TreeBoxRuleGUI_cls *mspCThis;
    
    TreeBoxRule_cls    *mpCParent;
    TreeBoxRuleGUI_cls **mppToThis;
    
    //wxStaticText *mpCCurrentPath;
    //wxStaticText *mpCConvertedPath;
    wxString mstrCurrentPath, mstrConvertedPath;

    int mIndexCurrentPath, mIndexConvertedPath;
    int mIndexAlias, mIndexReplaceFrom, mIndexReplaceTo;

    int mIndexTreeFocus;
    int mIndexFocusType;
    int mIndexNestScale, mIndexNestOffset;
    int mIndexRoudedCurve;
    int mIndexCrit;
    int mIndexVolumeQuality;

    static MultiNumericalInputsPanel_cls* mpCMNumRuleA;
    static MultiNumericalInputsPanel_cls* mpCMNumRuleB;
    void   SetMNumRuleA(wxBoxSizer *pBoxSizer);
    void   SetMNumRuleB(wxBoxSizer *pBoxSizer);
    
    void UpdateDisplay();
    void HideAndShow();
    
    void OnButtonClose     (wxCommandEvent &event);

    static void HookAssign(void *pArg, void *pEvent);
    static void HookComboBox(void *pArg, void *pEvent);

private:
     // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class TreeBoxRule_cls :
public DialogControl_cls
{ 
 public:
    TreeBoxRule_cls(wxWindow *pC, wxBitmap *pBitmap);
    ~TreeBoxRule_cls();
    
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    
    TreeBoxRuleGUI_cls *mpCGUI;
    wxWindow           *mpCParent;
    wxBitmap           *mpBitmapLink;

    ConfItemList_cls   mCConfList;
    ConfItemUINT_cls   mCType;
    ConfItemFLOATARRAY_cls mCNestOffset;
    ConfItemFLOAT_cls   mCRoundedCurve, mCNestScale;
    ConfItemUINT_cls   mCFocusType;
    ConfItemUINT_cls   mCUseReplaceRule;
    ConfItemSTR_cls    mCRuleFrom;
    ConfItemSTR_cls    mCRuleTo;
    ConfItemBOOL_cls   mCbCheckFile;
    ConfItemUINT_cls   mCDepthMax;
    ConfItemUINT_cls   mCDepthMin;
    ConfItemUINT_cls   mCVolumeQuality;
    ConfItemDOUBLE_cls mCCritScale;
    ConfItemDOUBLE_cls mCTreeDepthParam[5];

    static ConfItemSTR_cls msCStrDataSlot;
    
    std::vector < wxString > GetConvertedStrVector();
    wxString GetConvertedStrWX();

    void GetChildNestPos(float minPos[3], float maxPos[3]);
    void GetCoordinateInChild(float coef1[3], float coef0[3]);

    //--
    wxString SerializeConf();
    void ReadStrLine(std::wstring strLine);
};

#endif 
