// -*- c -*- 
// (setq c-basic-offset 4)
// "clsTreeBoxRule.h"

#include "clsTreeBoxRule.h"
#include "../../wxWidgetEnum.h"
#include "../../clsDrawingBox.h"

#include "../../clsFrameMain.h"
#include "../../clsMain.h"

#include <wx/statline.h>
#include "../WIDGETCTRL/EX/clsButtonEX.h"

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

extern FrameMain_cls* GpCMainFrameCLS;

MultiNumericalInputsPanel_cls* TreeBoxRuleGUI_cls::mpCMNumRuleA;
MultiNumericalInputsPanel_cls* TreeBoxRuleGUI_cls::mpCMNumRuleB;

BEGIN_EVENT_TABLE(TreeBoxRuleGUI_cls, wxDialog)
     //EVT_BUTTON(buttonCtrlTreeClose, TreeBoxRuleGUI_cls::OnButtonClose)
     EVT_BUTTON(wxID_CANCEL, TreeBoxRuleGUI_cls::OnButtonClose)
     EVT_BUTTON(buttonCtrlTreeApply, TreeBoxRuleGUI_cls::OnButtonApply)
     //EVT_BUTTON(buttonCtrlTreeHotSpot, TreeBoxRuleGUI_cls::OnButtonHotSpot)
     END_EVENT_TABLE()

     TreeBoxRuleGUI_cls::
TreeBoxRuleGUI_cls(TreeBoxRule_cls* pCParent, TreeBoxRuleGUI_cls **ppToThis,
		   wxWindow *pC, wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Tree Configure"),
		  pos, size)
{
    mppToThis = ppToThis;
    mpCParent = pCParent;
    //SetCloseButtonID(buttonCtrlTreeClose);
    SetScreenRectPos(&pCParent->mCScreenRect);
    
#ifdef WIN32
    wxIcon icon(wxT("ICONS/Tree.ico"), wxBITMAP_TYPE_ICO);
#else
    wxIcon icon(wxT("ICONS/Tree.png"), wxBITMAP_TYPE_PNG);
#endif
    SetIcon(icon);

    // サイザーを作る
    wxBoxSizer       *pBoxSizerSrc   = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer       *pBoxSizerBTM_L = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerBTM_R = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer       *pBoxSizerBTM   = new wxBoxSizer(wxHORIZONTAL);

    mpCCurrentPath = new wxStaticText
	(this, wxID_ANY, GpCMainFrameCLS->GetCurrentFileWXStr());

    wxStaticLine *pCStaticLine1 = new wxStaticLine(this);
    
    mpCConvertedPath = new wxStaticText
	(this, wxID_ANY, GpCMainFrameCLS->GetCurrentFileWXStr());
    
    pBoxSizerSrc->Add( mpCCurrentPath, 0, wxEXPAND);
    pBoxSizerSrc->Add( pCStaticLine1, 0, wxEXPAND);
    pBoxSizerSrc->Add( mpCConvertedPath, 0, wxEXPAND);

    // PARAM
    SetMNumRuleA(pBoxSizerSrc);

    wxStaticLine *pCStaticLine2 = new wxStaticLine(this);
    pBoxSizerSrc->Add( pCStaticLine2, 0, wxEXPAND);

    SetMNumRuleB(pBoxSizerSrc);

    // BTM_R
    wxButtonEX *pCButtonApply  = new wxButtonEX (this, buttonCtrlTreeApply,
						 wxT("Apply"));
    wxButtonEX *pCButtonClose  = new wxButtonEX (this, wxID_CANCEL,
						 wxT("Close"));
    
    pBoxSizerBTM_R->Add( pCButtonApply,  0, wxEXPAND);
    pBoxSizerBTM_R->Add( pCButtonClose,  0, wxEXPAND);

    // SRC
    pBoxSizerBTM->Add( pBoxSizerBTM_L, 0, wxEXPAND);
    pBoxSizerBTM->Add( -1, -1, 1, wxEXPAND);
    pBoxSizerBTM->Add( pBoxSizerBTM_R, 0, wxALIGN_RIGHT);
    pBoxSizerSrc->Add( pBoxSizerBTM,  0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);

    pCButtonClose->SetFocus();
}

void TreeBoxRuleGUI_cls::
SetMNumRuleA(wxBoxSizer *pBoxSizer){
    mpCMNumRuleA = new MultiNumericalInputsPanel_cls
	(&mpCMNumRuleA, this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxBORDER_SIMPLE);
    
    MultiNumericalInputsPanel_cls* pCurr = mpCMNumRuleA;
    
    int boxWidth = 2;
    pCurr->SetDefaultButtonType(_MN_NO_BUTTONS);
    pCurr->mTextWidth       = 140;

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Use different file"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbUseReplaceRule.mbBody,
			  _("replace by the rule below"));
    pCurr->CombinePointer(_GP_STATIC_TEXT, NULL);
    pCurr->CombinePointer(_GP_WXSTRING, &mpCParent->mstrRuleFrom/*&mpCParent->mCRuleFrom.msBody*/, 
			  _("replace from"));
    pCurr->CombinePointer(_GP_WXSTRING, &mpCParent->mstrRuleTo/*&mpCParent->mCRuleTo.msBody*/,
			  _("replace to"));

    pCurr->FinishSetting(pBoxSizer, TRUE);
}

void TreeBoxRuleGUI_cls::
SetMNumRuleB(wxBoxSizer *pBoxSizer){
    mpCMNumRuleB = new MultiNumericalInputsPanel_cls
	(&mpCMNumRuleB, this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxBORDER_SIMPLE);
    
    MultiNumericalInputsPanel_cls* pCurr = mpCMNumRuleB;
    
    pCurr->SetDefaultButtonType(_MN_NO_BUTTONS);
    pCurr->mTextWidth       = 140;
    
    int boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Use Tree"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &GpCMainFrameCLS->mpCParent->mpCDBoxMain->mCb8Tree.mbBody,
			  _("Main Box"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &GpCMainFrameCLS->mpCParent->mpCDBoxMain->mCb8TreeForCopy.mbBody,
			  _("Copied Boxes"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Scan Files"));
    pCurr->CombinePointer(_GP_BOOL,
			  &mpCParent->mCbCheckFile.mbBody,
			  _("Real Time"));
    pCurr->CombinePointer(_GP_STATIC_TEXT, NULL);

    boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Min / Max / Offset"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, &mpCParent->mCDepthMin.mBody);
    pCurr->CombinePointer(_GP_UNSIGNED_INT, &mpCParent->mCDepthMax.mBody);
    pCurr->CombinePointer(_GP_UNSIGNED_INT, &mpCParent->mCDepthOffset.mBody);
    
    boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Critical Factor"));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, &mpCParent->mCCritScale.mBody);
    pCurr->SetRange(0, 60, _MN_LASTITEM, 20);
    pCurr->CombinePointer(_GP_DOUBLE, &mpCParent->mCCritScale.mBody);

    /*
    for (int i = 0; i < 5; i++){
	pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			      wxString::Format(_T("%s %d"),
					       _("Depth Factor"), i+1));
	pCurr->CombinePointer(_GP_DOUBLE_SLIDER, &mpCParent->mCTreeDepthParam[i].mBody);
	pCurr->SetRange(70, 130, _MN_LASTITEM, 100);
	pCurr->CombinePointer(_GP_DOUBLE, &mpCParent->mCTreeDepthParam[i].mBody);
    }
        
    pCurr->mButtonWidth = 40;

    pCurr->CombinePointer(_GP_BOOL, &DrawingBlock_cls::msThread,
			  wxT("thread"));
    */

    //pCurr->CombinePointerButton(buttonCtrlTreeHotSpot, wxT("Set Hot Spot"));
    
    pCurr->FinishSetting(pBoxSizer, TRUE);
}


TreeBoxRuleGUI_cls::
~TreeBoxRuleGUI_cls(){
    *mppToThis = NULL;
}

void TreeBoxRuleGUI_cls::
UpdateDisplay(){
    mpCCurrentPath  ->SetLabel(GpCMainFrameCLS->GetCurrentFileWXStr());
    mpCConvertedPath->SetLabel(mpCParent->GetConvertedStrWX());
    mpCMNumRuleA->UpdateValues();
}

void TreeBoxRuleGUI_cls::
OnButtonApply(wxCommandEvent &event){
    wxCommandEvent dummy;
    mpCMNumRuleA->OnAssign(dummy);
    mpCMNumRuleB->OnAssign(dummy);
    UpdateDisplay();
}

void TreeBoxRuleGUI_cls::
UpdateValues(){
    mpCMNumRuleA->UpdateValues();
    mpCMNumRuleB->UpdateValues();
}

void TreeBoxRuleGUI_cls::
OnButtonClose(wxCommandEvent &event){
    //UpdateDisplay();
    UpdateValues();
    CloseEXKey();
}

/*
void TreeBoxRuleGUI_cls::
OnButtonHotSpot(wxCommandEvent &event){
    DrawingBlock_cls::msCHotSpot.OpenWindow(this);
    DrawingBlock_cls::msCHotSpot.UpdateInterpolatedValues();
}
*/

// ----------------------

TreeBoxRule_cls::
TreeBoxRule_cls(wxWindow *pC)
{
    mCConfList.Clear();
    mCConfList.Add(&mCbUseReplaceRule, L"AliasRuleUse=", L"0");
    mCConfList.Add(&mCRuleFrom,        L"AliasRuleBaseFrom=", L"from");
    mCConfList.Add(&mCRuleTo,          L"AliasRuleBaseTo="  , L"to");
    mCConfList.Add(&mCbCheckFile,      L"TreeScanFile="    , L"0");
    mCConfList.Add(&mCDepthMax,        L"TreeDepthMax="    , L"3");
    mCConfList.Add(&mCDepthMin,        L"TreeDepthMin="    , L"0");
    mCConfList.Add(&mCDepthOffset,     L"TreeDepthOffset=" , L"0");
    mCConfList.Add(&mCCritScale,       L"TreeCritScale="   , L"1");
    mCConfList.Add(&mCTreeDepthParam[0],  L"TreeDepthParam0="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[1],  L"TreeDepthParam1="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[2],  L"TreeDepthParam2="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[3],  L"TreeDepthParam3="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[4],  L"TreeDepthParam4="  , L"1");
    InitGUI(pC);
}

TreeBoxRule_cls::
~TreeBoxRule_cls(){
    if (mpCGUI != NULL) delete mpCGUI;
}

#include "../MYAPI/MsgBox.h"

void TreeBoxRule_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new TreeBoxRuleGUI_cls(this, &mpCGUI, pC, 
				    mCScreenRect.GetPosition(),
				    mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}

void TreeBoxRule_cls::
UpdateItems(){
    mpCGUI->mpCMNumRuleA->UpdateValues();
    mpCGUI->mpCMNumRuleB->UpdateValues();
}

bool TreeBoxRule_cls::
UpdateValues(){ 
    if (mpCGUI == NULL) return FALSE;
    mpCGUI->UpdateValues();
    mpCGUI->UpdateDisplay();
    return TRUE;
}

std::wstring TreeBoxRule_cls::
GetConvertedStr(){
    std::wstring strOrg = 
	wxConvLibc.cWX2WC(GpCMainFrameCLS->GetCurrentFileWXStr());
    std::wstring::size_type pos = 
	strOrg.find(mCRuleFrom.msBody);
    if (pos != std::wstring::npos)
	strOrg.replace(pos,
		       mCRuleFrom.msBody.size(),
		       mCRuleTo.msBody);
    return strOrg;
}

wxString TreeBoxRule_cls::
GetConvertedStrWX(){
    //return wxConvFile.cWC2WX(GetConvertedStr().c_str());
    wxString strOrg = GpCMainFrameCLS->GetCurrentFileWXStr();
    int pos = strOrg.find(mstrRuleFrom);
    if (pos == wxNOT_FOUND) return strOrg;
    wxString strRep = strOrg.SubString(0, pos-1) + mstrRuleTo + strOrg.SubString(pos + mstrRuleFrom.size(), strOrg.Length());
    return strRep;
}

wxString TreeBoxRule_cls::
SerializeConf(){
    return mCConfList.SerializeAll();
}

void TreeBoxRule_cls::
ReadStrLine(std::wstring strLine){
    mCConfList.ReadStrLineAll(strLine);
}

