
#ifndef _UNDO_MANAGER_H_
#define _UNDO_MANAGER_H_

#include <vector>

#include <stdio.h>

#define _COMMAND_UNDO true
#define _COMMAND_REDO false

#define _COMMAND_CHAIN_PREV -1
#define _COMMAND_CHAIN_NEXT 1
#define _COMMAND_NODEPENDENT FALSE

#define _COMMAND_TYPE_NORMAL 0
#define _COMMAND_TYPE_BLOCK_OPEN 1
#define _COMMAND_TYPE_BLOCK_CLOSE 2
// bitŃ`FbN
#define _COMMAND_TYPE_REQUIRE_RETEX 4
#define _COMMAND_TYPE_REQUIRE_RECOLOR 8


class CommandItem_cls; 
#include "../PARAMETER/clsParameters.h"
#include "../FILTER/clsFilterBase.h"

class CommandItem_cls {
public:
    CommandItem_cls();
    virtual ~CommandItem_cls();
    
    virtual bool Execute(bool bFlag = _COMMAND_REDO) = 0;
    
    int mCommandType;
};

// ----------- UNDO BLOCK -------------

class ComBlockOpen : public CommandItem_cls {
public:
    ComBlockOpen();
    bool Execute(bool bFlag = _COMMAND_REDO);
};

class ComBlockClose : public CommandItem_cls {
public:
    ComBlockClose();
    bool Execute(bool bFlag = _COMMAND_REDO);
};

// -----------------------------------

class UndoManager_cls {
 public:
    UndoManager_cls();
    ~UndoManager_cls();

    std::vector < CommandItem_cls* > mVPCRedoList;
    std::vector < CommandItem_cls* > mVPCUndoList;
    unsigned int mCurrentIndex;

    int  mBlockDepth;

    void Clear();
    void RemoveItem(unsigned int i);
    void OpenBlock();
    void CloseBlock();

    void SetNewCommand(CommandItem_cls* pComRedo, CommandItem_cls* pComUndo);
    void PushNewCommand(CommandItem_cls* pComRedo, CommandItem_cls* pComUndo);
    int  GetRedoCommandType(int level = 1);
    int  GetUndoCommandType(int level = 1); 
    void SkipCurrent();
    void ExecCurrent();
    //CommandItem_cls* GetPCurrent();

    bool UndoCurrent();
};

#endif
