// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoiTextCtrl.h"

#include "clsAtoiComboCtrl.h"
//#include "../MYAPI/MsgBox.h"

AtoiComboCtrl_cls::
AtoiComboCtrl_cls(wxWindow *parent, wxWindowID id, wxString initStr, unsigned int max, wxString *pChoiceList, unsigned int offset, wxSize size)  
    : wxComboBox(parent, id, initStr, wxDefaultPosition, size, max, pChoiceList,
		 wxCB_DROPDOWN | wxCB_READONLY)
{
    mMax = max;
    mOffset = offset;
    for (unsigned int i = 0; i < mMax; i++)
	mVChoiceList.push_back(pChoiceList[i]);

    UpdateValueFromText();

    mMax = max;
    SetWindowStyle(GetWindowStyle() | wxWANTS_CHARS);
    
    Connect(id, wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(AtoiComboCtrl_cls::OnComboBox));
    Connect(id, wxEVT_CHAR,
	    wxKeyEventHandler(AtoiComboCtrl_cls::OnChar));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(AtoiComboCtrl_cls::OnKeyDown));
}

int AtoiComboCtrl_cls::
UpdateValueFromText(){
    mValue = mOffset;
    for (unsigned int i = 0; i < mMax; i++)
	if (GetValue() == mVChoiceList[i]) mValue = i + mOffset;
    
    return mValue;
}

bool AtoiComboCtrl_cls::
CheckRange(){
    bool bRet = FALSE;
    if (mValue - mOffset < 0){
	mValue = mOffset; bRet = TRUE; }
    if (mValue - mOffset >= GetCount()) {
	mValue = mOffset; bRet = TRUE; }
    UpdateDisplay();
    return bRet;
}

void AtoiComboCtrl_cls::
OnComboBox(wxCommandEvent& event){
    UpdateValueFromText();
    event.Skip();
}

#include "../MYAPI/MsgBox.h"

int AtoiComboCtrl_cls::msDebug = 0;

void AtoiComboCtrl_cls::
UpdateDisplay(){
    unsigned int offsetted = mValue - mOffset;
    if (offsetted < mMax){
	if (mVChoiceList[mValue - mOffset] != GetValue())
	    SetValue(mVChoiceList[mValue - mOffset]);
    }
}

void AtoiComboCtrl_cls::
SetValueInt(int value){
    mValue = value;
    UpdateDisplay();
}

void AtoiComboCtrl_cls::
Clear(){
    mVChoiceList.clear();
    mMax = 0;
    wxComboBox::Clear();
}

void AtoiComboCtrl_cls::
Append(const wxString& item){
    mVChoiceList.push_back(item);
    mMax = (unsigned int)mVChoiceList.size();
    wxComboBox::Append(item);
}

void AtoiComboCtrl_cls::
OnChar(wxKeyEvent& event){
    // $B>e$N(Bwindow$B$G%?%V0\F0$5$l$J$1$l$P$3$3%$%Y%s%H$,Mh$k$N$G<+A0$G(B
    if (event.GetKeyCode() == WXK_TAB){
	if (OnCharTab(event) == FALSE){
	    if ((event.GetModifiers() & wxMOD_SHIFT) ||
		(event.GetModifiers() & wxMOD_CONTROL))
		Navigate(wxNavigationKeyEvent::IsBackward);
	    else
		Navigate(wxNavigationKeyEvent::IsForward);
	}
#ifndef WIN32
	// KillFocus$B$NJ}$,CY$/$J$k$N<+A0$G$b=hM}(B
	/*
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	wxChildFocusEvent dummyEvent2;
	GetParent()->AddPendingEvent(dummyEvent2);
	*/
#endif 	
	//event.Skip();
	return;
    }

    /*
    if (event.GetKeyCode() == WXK_SPACE){
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	SetSelection(-1, -1);
	GetParent()->AddPendingEvent(event);
	return;
    }

    if (event.GetKeyCode() == WXK_RETURN){
#ifndef WIN32
	// KillFocus$B$NJ}$,CY$/$J$k$N<+A0$G$b=hM}(B
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	wxChildFocusEvent dummyEvent2;
	GetParent()->AddPendingEvent(dummyEvent2);
#endif 	
	GetParent()->AddPendingEvent(event);
	if (mpNextWindow != NULL)
		mpNextWindow->SetFocus();
	return;
    }
    */

    event.Skip();
}

void AtoiComboCtrl_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_NONE || event.GetKeyCode() == WXK_TAB)
	event.Skip();
    if (event.GetKeyCode() != WXK_TAB)
	wxPostEvent(GetParent()->GetEventHandler(), event);
}
