// -*- c -*- 
// "clsBitmapPanel.h"

#include "clsBitmapPanel.h"

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

BEGIN_EVENT_TABLE(BitmapPanel_cls, wxPanel)
     EVT_PAINT       (BitmapPanel_cls::OnPaint)
     EVT_MOUSE_EVENTS(BitmapPanel_cls::OnMouse)
END_EVENT_TABLE()

BitmapPanel_cls::
BitmapPanel_cls(wxWindow *parent, wxWindowID id, 
	       wxPoint pos, wxSize size) :
    wxPanel(parent, id, pos, size, wxNO_BORDER),
    mpBitmapDisable(NULL)
{
    mState = 0;
    mbPushed = 0;
    mOffsetX = 1;
    mOffsetY = 2;

    Connect(GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(BitmapPanel_cls::OnKeyDown));
}

void BitmapPanel_cls::
SetOffset(int offsetX, int offsetY){
    mOffsetX = offsetX;
    mOffsetY = offsetY;
}

void BitmapPanel_cls::
AddBitmapP(wxBitmap* pBitmap){
    mVPBitmap.push_back(pBitmap);
}

void BitmapPanel_cls::
SetBitmapPDisable(wxBitmap *pBitmap){
    mpBitmapDisable = pBitmap;
}

void BitmapPanel_cls::
UpdateDisplay(){
    wxPaintDC dc(this);

    if (mVPBitmap.size() == 0) return;
    if ((IsEnabled() == FALSE) && (mpBitmapDisable != NULL)){
	dc.DrawBitmap(*mpBitmapDisable, mOffsetX, mOffsetY, TRUE);
	return;
    }

    dc.DrawBitmap(*mVPBitmap[mState], mOffsetX, mOffsetY, TRUE);
}

void BitmapPanel_cls::
OnPaint(wxPaintEvent& event){
    event.Skip();
    UpdateDisplay();
}

void BitmapPanel_cls::
OnMouse(wxMouseEvent& event){
    if (event.Leaving() == TRUE){
	mbPushed = FALSE;
	SetBackgroundColour(wxColour(wxNullColour));
	Refresh(TRUE);
    }

    if (event.ButtonDown(wxMOUSE_BTN_LEFT)){
	mbPushed = TRUE;
	SetBackgroundColour(wxColour(wxT("GREY")));
	Refresh(TRUE);
    }

    if ((event.ButtonUp(wxMOUSE_BTN_LEFT) && mbPushed == TRUE) ||
	event.ButtonDClick(wxMOUSE_BTN_LEFT)){
	mState++;
	if (mState >= mVPBitmap.size()) mState = 0;
	mbPushed = FALSE;
	SetBackgroundColour(wxColour(wxNullColour));
	Refresh(TRUE);
	wxMouseEvent dummyEvent(wxEVT_LEFT_UP);
	dummyEvent.SetId(GetId());
	GetParent()->AddPendingEvent(dummyEvent);
    }

    event.Skip();
}

wxWindow* BitmapPanel_cls::
GetPWindow(){
    return this;
}

void BitmapPanel_cls::
OnKeyDown(wxKeyEvent& event){
    ProcessKeyEvent(event);
}
