// -*- c -*- 
// "clsDialogEX.h"

#include "clsDialogEXKey.h"
#include "clsMultiNumericalInputs.h"

#include "../../wxWidgetEnumMenu.h"

wxDialogEXKey::
wxDialogEXKey(wxWindow* parent, wxWindowID id, const wxString& label,
	      const wxPoint& pos, const wxSize& size,
	      wxBitmap *pBitmap,
	      long style, const wxString& name) :
    wxDialog(parent, id, label, pos, size, style, name),
    mIDCloseButton(wxID_CANCEL), mpCRectPos(NULL),
    mbPreventDestroy(TRUE)
{
    SetBackgroundColour(wxColour(wxT("WHEAT")));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(wxDialogEXKey::OnKeyDown));
    if (pBitmap != NULL){
	wxIcon icon; icon.CopyFromBitmap(*pBitmap);
	SetIcon(icon);
    }
}

wxDialogEXKey::
~wxDialogEXKey(){
    MakeModal(FALSE);
}

MultiNumericalInputsPanel_cls* wxDialogEXKey::
InitializeMNumPanel(MultiNumericalInputsPanel_cls **ppMNum,
		    wxWindow *pCParent,
		    int buttonType){
    *ppMNum = new MultiNumericalInputsPanel_cls
	(ppMNum, pCParent, wxID_ANY, wxDefaultPosition, wxSize(-1,-1), wxBORDER_SIMPLE);
    (*ppMNum)->mDefaultButton = buttonType;
    return *ppMNum;
}

MultiNumericalInputs_cls* wxDialogEXKey::
InitializeMNumDLG(MultiNumericalInputs_cls **ppMNum,
		  wxWindow *pCParent, wxString strTitle,
		  int buttonType){
    *ppMNum = new MultiNumericalInputs_cls
	(ppMNum, pCParent, wxID_ANY, strTitle, wxDefaultPosition, wxSize(-1,-1));
    (*ppMNum)->mDefaultButton = buttonType;
    return *ppMNum;
}

void wxDialogEXKey::
SetCloseButtonID(int IDCloseButton){
    mIDCloseButton = IDCloseButton;
}

void wxDialogEXKey::
SetScreenRectPos(wxRect *pCRectPos){
    mpCRectPos = pCRectPos;
}

#include "../MYAPI/MsgBox.h"

void wxDialogEXKey::
CloseEXKey(int retCode){
    if (mpCRectPos != NULL) *mpCRectPos = GetScreenRect();
#ifdef WIN32
    if (IsModal() == TRUE){
	// ComboBox$B$K%U%)!<%+%9$,$"$C$F$$$k$H%P%.!<$J$N$r2sHr(B
	SetFocusIgnoringChildren();
	EndModal(retCode);
	wxCommandEvent event(wxEVT_COMMAND_MENU_SELECTED, menuItemSetFocus);
	GetParent()->AddPendingEvent(event);
    }
    else
	Show(FALSE);
#else
    // $B$3$l$G$$$$$N$+!)(B
    if (IsModal() == TRUE)
	EndModal(retCode);
    else{
	if (mbPreventDestroy == TRUE)
	    Show(FALSE); 
	else
	    Destroy();
    }
#endif

}

void wxDialogEXKey::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    /*
    if (event.GetKeyCode() == WXK_ESCAPE)
	MsgBox(this, "ESC2", "ESC2");
    */
    switch(code){
    case 'W':
	if (event.GetModifiers() != wxMOD_CONTROL || 
	    mIDCloseButton == wxID_NONE)
	    break;
    case WXK_ESCAPE:
	wxCommandEvent event(wxEVT_COMMAND_BUTTON_CLICKED, wxID_CANCEL);
	GetEventHandler()->AddPendingEvent(event);
	break;
    }
    
    if (IsModal() == FALSE)
	wxPostEvent(GetParent()->GetEventHandler(), event);

#ifndef WIN32
    event.Skip();
#endif
}

void wxDialogEXKey::
OnSize(wxSizeEvent& event){
    event.Skip();
    SetSizerAndFit(GetSizer());
}

void wxDialogEXKey::
ResizeDialog(){
    GetSizer()->Layout();
    SetSizerAndFit(GetSizer());
}
