// -*- c -*-
// "clsEditString.cpp"
// (setq c-basic-offset 4)

#ifndef _EDIT_STRING_H_
#define _EDIT_STRING_H_

#include <wx/wx.h>

#define _STREDIT_LABEL_TXT 0
#define _STREDIT_LABEL_BUTTON 1

class EditString_cls {
 public:
    void SetItems(wxWindow *pCParent, std::string strLabel, 
		  wxSize size = wxDefaultSize, int type = _STREDIT_LABEL_TXT, 
		  int ID = wxID_ANY);

    wxWindow    *mpCParent;
    std::string msLabel, msBody;

    int  mType;
    wxStaticText *mpCTextLabel;
    wxButton     *mpCButtonLabel;

    wxStaticText *mpCBody;

    //-----

    void SetEdit  (int ID = wxID_ANY, 
		   wxPoint pos  = wxDefaultPosition,
		   wxSize  size = wxSize(40, -1),
		   wxString strLabel=wxT("Edit"));
    void SetSelect(int ID = wxID_ANY, 
		   wxPoint pos  = wxDefaultPosition,
		   wxSize  size = wxSize(40, -1),
		   wxString strLabel=wxT("/.."));
    wxButton     *mpCButtonEdit;
    wxButton     *mpCButtonSelect;

    void Connect2Sizer(wxFlexGridSizer *pSizer);

    //-----
    
    void SelectFile(wxString strFilter=wxT("all files|*"),
		    wxString strLabel=wxT("Choose a file"));
    void SelectDirectory(wxString strLabel=wxT("Choose a directory"));
    
    //-----

    void SetLabels();
    bool ReadItems(std::string strLine);
    void ConvertDos2UNIX();
};

#endif
