// -*- c -*- 
// "clsGraphPanel.cpp"

#ifndef _GRAPH_PANEL_H_
#define _GRAPH_PANEL_H_

#include <wx/wx.h>
#include <vector>

// $B4X?t%]%$%s%?$r(Bvetctor$B$KF~$l$k$?$a$N9=B$BN(B
struct structFuncPointer{
    double (*mpFuncGetValue)(double, void*);
};

struct structKeyPoint{
    double mX;
    double mY;
};

class GraphPanel_cls : public wxPanel {
 public:
    GraphPanel_cls(wxWindow *parent, wxWindowID id, 
		   wxPoint pos = wxDefaultPosition,
		   wxSize size = wxDefaultSize);
    
    std::vector < structFuncPointer > mVGraph;
    std::vector < unsigned int > mVResolution;
    std::vector < wxColour > mVColor;
    std::vector < std::vector < structKeyPoint > > mVVKeyPoint;
    void SetFunction(double (*pFuncGetValue)(double, void*), 
		     unsigned int resolution = 100);
    void SetColorLastItem(wxColour color);
    
    void SetMemberSize(wxSize size);

    void DrawCurrentIndex(wxPaintDC &dc);
    
    void ClearKeyPoint();
    void SetKeyPoint(unsigned int intex, double x, double y);
    void DrawKeyPoint(wxPaintDC &dc);

    virtual void UpdateDisplay();
    void OnPaint(wxPaintEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnMouse(wxMouseEvent& event);
    
    int mPanelSize[2], mOffset[2], mBorderSizeOffset[2];
    double mIni[2], mFin[2];
    bool mbDisplayCurrent, mbDisplayKeyPoint, mbDisplayBorder;
    double mCurrentDoubleIndex;
    void *mpClue; // $B4X?t$r(Bstatic$B$G8F$S=P$9I,MW$,$"$k$N$G!"<j$,$+$j$K$J$k2?$+$r(B
        
    int mX0, mY0, mX1, mY1;
    void CalcCoordinates(double valuex0, double valuey0,
			 double valuex1, double valuey1);
    int   GetCoordinate(double norm, unsigned int index);

    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class PanelColorBar_cls : public GraphPanel_cls{
 public:
    PanelColorBar_cls(wxWindow *parent, wxWindowID id, 
		      wxPoint pos = wxDefaultPosition,
		      wxSize size = wxDefaultSize);

    wxString mstrLabel;
    void UpdateDisplay();
};

#endif
