// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "clsFrameMain.h"

#include "clsAboutBox.h"
#include "clsCameraPath.h"
#include "clsMain.h"
#include "clsTimeCtrl.h"


#include "SRC/DRAWBOX/clsBoxCopy.h"
#include "SRC/FILTER/clsFilterCtrl.h"
#include "SRC/FILTER/FILTERUNDO/FilterUndo.h"
#include "SRC/GLCANVAS/clsGLCanvasCtrl.h"
#include "SRC/GLCANVAS/clsMainGLCanvas.h"
#include "SRC/GLCANVAS/clsMouseCtrl.h"

#include "SRC/MAINCANVAS/clsControlPanel.h"
#include "SRC/MAINCANVAS/clsDragAndDrop.h"
#include "SRC/MAINCANVAS/clsGLExtraFrame.h"
#include "SRC/MAINCANVAS/clsPreviewPanel.h"
#include "SRC/MAINCANVAS/clsFilterPanelPain.h"
#include "SRC/MAINCANVAS/clsFrameMainInitializer.h"
#include "SRC/MAINCANVAS/clsScene.h"

#include "SRC/POVRAY/clsLightSource.h"
#include "SRC/POVRAY/clsPovRay.h"
#include "SRC/POVRAY/clsPovVolume.h"
#include "SRC/POVRAY/clsPovIsosurface.h"
#include "SRC/POVRAY/clsPovObject.h"
#include "SRC/POVRAY/clsStereoGram.h"
#include "SRC/POVRAY/clsTreeBoxRule.h"
#include "SRC/POVRAY/OPTIONAL/clsPovRadiosity.h"

#include "SRC/UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;

#include "SRC/COMMON/clsMultiThreadCtrl.h"
#include "SRC/COMMON/clsXVM.h"

#include "SRC/DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
#include "SRC/DF3/GL/clsPreviewProperty.h"

#include "SRC/MYAPI/MsgBox.h"
#include "SRC/DF3/clsDF3SeqCtrl.h"
#include "SRC/DF3/clsDF3Sequence.h"
#include "SRC/DF3/clsDF3SeqGUI.h"
#include "SRC/DF3/GL/clsDraw3DTexBoxA.h"
#include "SRC/DF3/GL/clsDraw3DTexBoxB.h"
#include "SRC/DF3/TL/clsTLPanel.h"

#include "SRC/CONFITEM/clsImportList.h"
#include "SRC/GRAPHIC/clsImgSequence.h"
#include "SRC/MYGL/clsFBO.h"
#include "SRC/MYGL/clsGLInfo.h"

#include "SRC/WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "SRC/WIDGETCTRL/EX/clsColourDialogEX.h"
#include "SRC/WIDGETCTRL/EX/clsFileDialogEX.h"
#include "SRC/WIDGETCTRL/EX/clsSliderEX.h"

#include <fstream>
#include <sstream>
#include <wx/cursor.h>
#include <wx/choicdlg.h>
#include <wx/file.h>
#include <wx/datetime.h>
#include <wx/numdlg.h>
#include <wx/notebook.h>
#include <wx/stopwatch.h>
#include <wx/tglbtn.h>
#include <wx/thread.h>
#include <wx/tooltip.h>
#include <wx/vscroll.h>

#include "wxWidgetEnum.h"
#include "wxWidgetEnumMenu.h"
#include "wxWidgetString.h"

extern bool GbGLLockForMultithread;
extern bool GbGLForceWaitThreadEnd;
bool GbGLUnlockOK = TRUE;
//bool GbInitalizedOnIdle = FALSE;
extern bool GbGLLockForLoading;

#define ENDL std::endl //wxT("\n")
#define ENDLWX wxT("\n")

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

#ifdef WIN32
#define _WSIZE_OFFSET_X 0
#define _WSIZE_OFFSET_Y 0
#else
#define _WSIZE_OFFSET_X 10
#define _WSIZE_OFFSET_Y 24
#endif

//O[oϐ

wxFrame* GpCMainFrame = NULL;          // StbVȂǂɎgp
FrameMain_cls* GpCMainFrameCLS = NULL; // ɗ͎gȂ

int  GVbShareLists = FALSE;

MainGLCanvas_cls* GpCurrentGLPanel = NULL;
MainGLCanvas_cls* GpGLPanelJustHandled = NULL;
wxColourDialogEX* GpCClrDialog = NULL;
wxFileDialogEX*   GpCFileDialog = NULL;

wxString GstrDebug;

// ÓIo
GLCanvasCtrl_cls* FrameMain_cls::mpCCanvas[4];

MultiNumericalInputsPanel_cls* FrameMain_cls::mpCMNumBoxInformation = NULL;
MultiNumericalInputsPanel_cls* FrameMain_cls::mpCMNumPlayOption     = NULL;
MultiNumericalInputsPanel_cls* FrameMain_cls::mpCMNumDownSizing     = NULL;

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FrameMain_cls, wxFrame)
EVT_PAINT(FrameMain_cls::OnPaint)
EVT_MENU(Minimal_Quit,  FrameMain_cls::OnQuit)
EVT_MENU(Minimal_About, FrameMain_cls::OnAbout)
EVT_MENU(menuItemFileOpen, FrameMain_cls::OnOpen)
EVT_MENU(menuItemFileAdd,  FrameMain_cls::OnAdd)
EVT_MENU(menuItemFileOpenEdit,   FrameMain_cls::OnOpenEdit)
EVT_MENU(menuItemFileAddEdit,    FrameMain_cls::OnAddEdit)
EVT_MENU(menuItemProjectOpen,    FrameMain_cls::OnProjectOpen)
EVT_MENU(menuItemProjectSave,    FrameMain_cls::OnProjectSave)
EVT_MENU(menuItemProjectSaveAs,  FrameMain_cls::OnProjectSaveAs)
EVT_MENU(menuItemImportPath,     FrameMain_cls::OnImportPath)
EVT_MENU(menuItemImportRenderParam, FrameMain_cls::OnImportRenderParam)
EVT_MENU(menuItemExportDF3,      FrameMain_cls::OnExportDF3)
EVT_MENU(menuItemExportDF3Seq,   FrameMain_cls::OnExportDF3Seq)
EVT_MENU(menuItemExportImgSeq,   FrameMain_cls::OnExportImgSeq)
EVT_MENU(menuItemExportIsosurfOBJ, FrameMain_cls::OnExportIsosurfaceOBJ)
EVT_MENU(menuItemExportIsosurfPOV, FrameMain_cls::OnExportIsosurfacePOV)
EVT_MENU(menuItemSaveImage,      FrameMain_cls::OnSaveImage)
EVT_MENU(menuItemSaveImageSeq,   FrameMain_cls::OnSaveImgSeq)
EVT_MENU(menuItemSaveImgSeqBegin,FrameMain_cls::OnSaveImgSeqBegin)
EVT_MENU(menuItemCloseData,      FrameMain_cls::OnCloseData)
EVT_MENU(menuItemPlayTex,        FrameMain_cls::OnPlayTex)
EVT_MENU(menuItemPlayTexInv,     FrameMain_cls::OnPlayTexInv)
EVT_MENU(menuItemPlayStop,       FrameMain_cls::OnPlayTexStop)
EVT_MENU(menuItemRedo,           FrameMain_cls::OnRedo)
EVT_MENU(menuItemUndo,           FrameMain_cls::OnUndo)
EVT_MENU(menuItemConfLightSource, FrameMain_cls::OnMenuLightSource)
EVT_MENU(menuItemAddLight,        FrameMain_cls::OnMenuAddLight)
EVT_MENU(menuItemAddHotSpot,     FrameMain_cls::OnMenuAddHotSpot)
EVT_MENU(menuItemPreference,     FrameMain_cls::OnMenuPreference)
EVT_MENU(menuItemScene,          FrameMain_cls::OnMenuScene)
EVT_MENU(menuItemTextureDLG,     FrameMain_cls::OnMenuTextureDLG)
EVT_MENU(menuItemCustomColor,    FrameMain_cls::OnMenuCustomColor)
EVT_MENU(menuItemConfHotSpot,    FrameMain_cls::OnMenuHotSpot)
EVT_MENU(FilterMenuUp,           FrameMain_cls::OnMenuFilterSwapUp)
EVT_MENU(FilterMenuDown,         FrameMain_cls::OnMenuFilterSwapDown)
EVT_MENU(menuItemIsosurface,     FrameMain_cls::OnMenuIsosurface)
EVT_MENU(menuItemFog,            FrameMain_cls::OnMenuFog)
EVT_MENU(menuItemBoxCopy,        FrameMain_cls::OnMenuBoxCopy)
EVT_MENU(menuItemClipping,       FrameMain_cls::OnMenuClipping)
EVT_MENU(menuItemVolume,         FrameMain_cls::OnMenuVolume)
EVT_MENU(menuItemBlurGauss,      FrameMain_cls::OnMenuBlurGauss)
EVT_MENU(menuItemInvDiffuse,     FrameMain_cls::OnMenuInvDiffuse)
EVT_MENU(menuItemLevelAndGamma,  FrameMain_cls::OnMenuLevelAndGamma)
EVT_MENU(menuItemFixPosition,    FrameMain_cls::OnMenuFixPosition)
EVT_MENU(menuItemDataRotate,     FrameMain_cls::OnMenuDataRotate)
EVT_MENU(menuItemLayerColorCurve,FrameMain_cls::OnMenuLayerColorCurve)
EVT_MENU(menuItemCrossSection,   FrameMain_cls::OnMenuCrossSection)
EVT_MENU(menuItemPovThreeView,   FrameMain_cls::OnMenuThreeView)
EVT_MENU(menuItemPovObjPlane,    FrameMain_cls::OnMenuPovObjPlane)
EVT_MENU(menuItemPovObjBox,      FrameMain_cls::OnMenuPovObjBox)
EVT_MENU(menuItemPovObjWiredBox, FrameMain_cls::OnMenuPovObjWiredBox)
EVT_MENU(menuItemPovObjSphere,   FrameMain_cls::OnMenuPovObjSphere)
EVT_MENU(menuItemPovObjCone,     FrameMain_cls::OnMenuPovObjCone)
EVT_MENU(menuItemPovObjArrow,    FrameMain_cls::OnMenuPovObjArrow)
EVT_MENU(menuItemPovObjText,     FrameMain_cls::OnMenuPovObjText)
EVT_MENU(menuItemPovObjMesh,     FrameMain_cls::OnMenuPovObjMesh)
EVT_MENU(menuItemPovObjPlugin,   FrameMain_cls::OnMenuPovObjPlugin)
EVT_MENU(menuItemAnalyzeCenterOfMass,  FrameMain_cls::OnMenuCenterOfMass)
EVT_MENU(menuItemAnalyzeMorphOpenClose,  FrameMain_cls::OnMenuMorphOpenClose)
EVT_MENU(menuItemPovDiffObj,     FrameMain_cls::OnMenuPovDiffObject)
EVT_MENU(menuItemPovStreamLine,  FrameMain_cls::OnMenuPovStreamLine)
EVT_MENU(menuItemPovVelocityField, FrameMain_cls::OnMenuPovVelField)
EVT_MENU(menuItemFilterAdvanced, FrameMain_cls::OnMenuFilterAdvanced)
EVT_MENU(menuItemConfPovRay,     FrameMain_cls::OnMenuPovRay)
EVT_MENU(menuItemConfPovRayAdvanced, FrameMain_cls::OnMenuPovRayAdvanced)
EVT_MENU(menuItemConfTree,       FrameMain_cls::OnMenuTree)
EVT_MENU(menuItemConfStereogram, FrameMain_cls::OnMenuStereogram)
EVT_MENU(menuItemConfCameraPath, FrameMain_cls::OnMenuCameraPath)
EVT_MENU(menuItemTimeRemap,      FrameMain_cls::OnMenuTimeRemap)
EVT_MENU(menuItemGoFrame,        FrameMain_cls::OnMenuGoFrame)
EVT_MENU(menuItemPreviewConfig,  FrameMain_cls::OnCommandPreviewConfig)
EVT_MENU(menuItemSetAnchorToPath,FrameMain_cls::OnMenuSetAnchorPath)
EVT_MENU(menuItemSetAnchorToZero,FrameMain_cls::OnMenuSetAnchorZero)
EVT_MENU(menuItemPovSnap,        FrameMain_cls::OnMenuExportPovRaySnap)
EVT_MENU(menuItemPovAnim,        FrameMain_cls::OnMenuExportPovRayAnim)
EVT_MENU(menuItemRenderSnap,     FrameMain_cls::OnMenuRenderPovRaySnap)
EVT_MENU(menuItemRenderAnim,     FrameMain_cls::OnMenuRenderPovRayAnim)
EVT_MENU(menuItemPovWine,        FrameMain_cls::OnMenuPovWine)
EVT_MENU(menuItemPovError,       FrameMain_cls::OnMenuPovRayError)
EVT_MENU(menuItemAutoRescale,    FrameMain_cls::OnMenuAutoRescale)
EVT_MENU(menuViewMainPanelType0, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType1, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType2, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType3, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType4, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewExtraPanel,     FrameMain_cls::OnMenuViewExtra)
EVT_MENU(menuItemToolTip,            FrameMain_cls::OnMenuToolTip)
EVT_MENU(menuItemSetCamPos,          FrameMain_cls::OnMenuSetCamPos)
EVT_MENU(menuItemSetAncPos,          FrameMain_cls::OnMenuSetAncPos)
EVT_MENU(menuItemRefresh,        FrameMain_cls::OnMenuRefresh)
EVT_MENU(menuItemRefreshTL,      FrameMain_cls::OnMenuRefreshTL)
EVT_MENU(menuItemRefreshVList,   FrameMain_cls::OnMenuRefreshViewList)
EVT_MENU(menuItemReTexture,      FrameMain_cls::OnMenuReTexture)
EVT_MENU(menuItemRemoveCacheMain,FrameMain_cls::OnMenuReLoad)
EVT_MENU(menuItemRemoveCacheSnap,FrameMain_cls::OnMenuReLoadSnap)
EVT_MENU(menuItemRefreshPanels,  FrameMain_cls::OnMenuRefreshPanels)
EVT_MENU(menuItemRefreshCamera,  FrameMain_cls::OnMenuRefreshCameraNumerical)
EVT_MENU(menuItemRefreshCamCom,  FrameMain_cls::OnMenuRefreshCameraCombobox)
EVT_MENU(menuItemRefreshCombo,   FrameMain_cls::OnMenuRefreshCombo)
EVT_MENU(menuItemRefreshColorBar,FrameMain_cls::OnMenuRefreshColorBar)
EVT_MENU(menuItemSetFocus,       FrameMain_cls::OnMenuSetFocus)
EVT_MENU(menuItemSplitterResize, FrameMain_cls::OnMenuSplitterResize)
EVT_MENU(menuItemDF3GUIChanged,  FrameMain_cls::OnMenuDF3GUIChanged)
EVT_BUTTON(buttonCtrlDisplayDetail,  FrameMain_cls::OnCommandPreviewConfig)
//EVT_BUTTON(buttonCtrlMainDownSize, FrameMain_cls::OnButtonDownSizeConf)
EVT_BUTTON(buttonCtrlMainRefEditor, FrameMain_cls::OnButtonRefEditor)
EVT_LEFT_DOWN(FrameMain_cls::OnMouseMotion)

//   EVT_KEY_UP     (FrameMain_cls::OnKeyUp)
EVT_KEY_DOWN   (FrameMain_cls::OnKeyDown)
EVT_IDLE       (FrameMain_cls::OnIdle)
END_EVENT_TABLE()

FrameMain_cls::
~FrameMain_cls(){
    delete mpCGLInfo;
    delete mpCPovRay;
    delete mpCStereo;
    delete mpCSplitterMain;
    MainGLCanvas_cls::DeleteInstancePreference();
    delete DF3GL_cls::mspCDraw3DTexBoxA;
    delete DF3GL_cls::mspCDraw3DTexBoxB;
    delete mpCPathCtrl;
    delete mpCDF3SeqCtrl;
    delete DF3GL_cls::mspCProperty;
    delete DrawingBlock_cls::mspCTexture;

    delete mpBitmapPreviewConfig;
    delete mpBitmapCameraConfig;
    delete mpBitmapStereo;
    delete mpBitmapTexture;
    delete mpBitmapPovray;
    delete mpBitmapPreference;
    delete mpBitmapScene;
    delete mpBitmapTree;
    delete mpBitmapQuit;

    delete GpCClrDialog;
    delete GpCFileDialog;
}

FrameMain_cls::
FrameMain_cls(const wxString& title, Main_cls *pMain, int posx, int posy,
	      int width, int height) :
    wxFrame(NULL, wxID_ANY, title, wxPoint(posx, posy), wxSize(width, height)),
    mCRectMNumScene     (wxDefaultPosition, wxDefaultSize),
    mCRectMNumDownSizing(wxDefaultPosition, wxDefaultSize),
    mCRectMNumCopy      (wxDefaultPosition, wxDefaultSize)
{
    mspCThis = this;
    mpCParent = pMain;
    GpCMainFrame = this;
    GpCMainFrameCLS = this;
    mParamForDebugginng = 0;
    mbHasOpenedProject = FALSE;
    mbViaIdle = FALSE;

    FrameMainInitializer01_cls CInitializer01(wxTHREAD_JOINABLE, this);
    CInitializer01.SetParameters();
    CInitializer01.Run(); 
#ifndef WIN32
    CInitializer01.Wait(); // X댯悤Ȃ̂łB
#endif

#ifdef WIN32
    wxIcon icon(wxT("ICONS/OosawaS.ico"), wxBITMAP_TYPE_ICO);
#else
    wxIcon icon(wxT("ICONS/OosawaS.png"), wxBITMAP_TYPE_PNG);
#endif
    SetIcon(icon); // set the frame icon

    //Drag'nDrop
    SetDropTarget(new DnDFile_cls(this));
    
    mpCGLInfo = new GLInfo_cls;
    for (int i = 0; i < 3; i++) mStatusBarStack[i] = 0;

    SetExtraStyle(wxWS_EX_PROCESS_IDLE);

    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH);
    mpCSplitterMain->SetSashGravity(0.7);
    Connect(mpCSplitterMain->GetId(),
	    wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED,
	    wxCommandEventHandler(FrameMain_cls::OnSash));
    
    mpBitmapCameraConfig = 
	new wxBitmap(wxT("ICONS/Camera.png"), wxBITMAP_TYPE_PNG);
    mpBitmapStereo = 
	new wxBitmap(wxT("ICONS/StereoGram.png"), wxBITMAP_TYPE_PNG);
    mpBitmapTexture = 
	new wxBitmap(wxT("ICONS/Texture.png"), wxBITMAP_TYPE_PNG);
    mpBitmapPreviewConfig =
	new wxBitmap(wxT("ICONS/GL.png"), wxBITMAP_TYPE_PNG);
    
#ifdef WIN32
    CInitializer01.Wait();
#endif
    
    FrameMainInitializer02_cls CInitializer02(wxTHREAD_JOINABLE, this);
    CInitializer02.SetParameters();
    CInitializer02.Run(); 
#ifndef WIN32
    CInitializer02.Wait(); // X댯悤Ȃ̂łB
#endif
    
    //--- Class with Dialogs (݂Ɉˑ̂ŏ̏ԏdv)
    mpCStereo      = new StereoGram_cls    (this, mpBitmapStereo);
    mpCPathCtrl    = new CameraPathCtrl_cls(this, mpCStereo, 
					    mpBitmapCameraConfig);
    mpCDF3SeqCtrl  = new DF3SeqCtrl_cls(mpCSplitterMain,
					mpCPathCtrl->mVpCPath[0],
					mpCParent->mpCTime);
    mpCPovRay      = new PovRay_cls     (this, mpCDF3SeqCtrl, mpBitmapPovray);
    //---
    
    DF3Sequence_cls::mspCGUILink = mpCDF3SeqCtrl->mpCGUI;
    DF3SeqGUI_cls::mspCFilterCtrlLink = mpCDF3SeqCtrl->GetPFilterCtrl(0);
    TimeCtrl_cls::mspCDF3SeqCtrlLink = mpCDF3SeqCtrl;
    TLPanel_cls::mspCTimeLink        = mpCParent->mpCTime;
    TexProperty_cls::mspCPovRayLink  = mpCPovRay;
    MainGLCanvas_cls::InitializeStaticMembers(this, mpCDF3SeqCtrl, mpCDF3SeqCtrl->GetPFilterCtrl(0));
    ReadBodyImgSeq_cls::InitializeStaticMembers(MainGLCanvas_cls::mspCPreference);
    KeyFrame_cls::InitializeStaticMembers();
    DF3GL_cls::InitializeStaticMembers(this, mpCDF3SeqCtrl, mpBitmapPreviewConfig, MainGLCanvas_cls::mspCPreference);
    MultiParameters_cls::InitializeStaticMembers(mpCDF3SeqCtrl->mpCGUI);
    MultiThreadCtrl_cls::mspCPreferenceLink = MainGLCanvas_cls::mspCPreference;
    
    mbForceFocus = FALSE;
    mbDragCtrlKey = FALSE;
    mUpdateLevel = 0;
    mMilliSleep = 25;
    mbIdle = FALSE;

    CreateStatusBar(2);
    SetStatusText(wxT("Powered by wxWidgets"));

    // TCU[
    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);

    mpCFilterPain = NULL;
    //mpCFilterPain = new FilterPanelPain_cls(mpCSplitterMain, this);
    mpCPanelTop = new PreviewPanel_cls(mpCSplitterMain, this);
    for (int i = 0; i < _DF3_MAX_SLOT; i++)
	mpCDF3SeqCtrl->GetPDF3Seq(i)->mpCFilterCtrl->
	    SetFilterPanelsLinkMutual(mpCFilterPain->mpCFilterPanels[i]);

    mpCConnectedGLPanel  = mpCCanvas[0]->mpCGLCanvas;
    GpCurrentGLPanel     = mpCCanvas[0]->mpCGLCanvas;
    GpGLPanelJustHandled = mpCCanvas[0]->mpCGLCanvas;

    std::vector < MultiNumericalInputsBase_cls* > VpList;
    VpList.push_back(mpCMNumBoxInformation);
    VpList.push_back(mpCMNumPlayOption);
    
    MultiNumericalInputsBase_cls::SetTabRing(VpList);
    
    //EBhE
    mpCSplitterMain->SplitHorizontally(mpCPanelTop, 
				       mpCDF3SeqCtrl->mpCGUI, -30);

    pBoxSizerSrc->Add(mpCSplitterMain, 1, wxEXPAND);
    
    //{^
    int flags = wxEXPAND | wxALIGN_CENTER_VERTICAL;

    mpCControlPanel = new ControlPanel_cls (this, this, mpCDF3SeqCtrl);
    
    pBoxSizerSrc->Add(mpCControlPanel, 0, flags);

    // ---

#ifdef WIN32    
    CInitializer02.Wait();
#endif
    SetMenuBar(mpCMenuBar);

    this->SetSizer(pBoxSizerSrc);

    FitSplitterWindow(TRUE);
    
    SetFocus();
    Refresh(false);

    mpCParent->mpCTime->mCMaxFrame.mBody = 99;
    //GFuncCheckPlayOption();

    int statusBarWidth[3] = {-1, -1, 180};
    GetStatusBar()->SetFieldsCount(3, statusBarWidth);
    GetStatusBar()->PushStatusText(wxT("field_1"), 1);
    GetStatusBar()->PushStatusText(wxT("field_2"), 2);

    // ŏ̃tB^
    mpCDF3SeqCtrl->GetPDF3Seq(0)->mpCFilterCtrl->AddVolume(-1, NULL); 
    // Ad_hoc ǃTCU[𐮗ăoỎ
    mpCFilterPain->mpCFilterPanels[0]->UpdateSizer();

    mpCGLExtFrame = new GLExtraFrame_cls(this, mpCCanvas[0]->mpCGLCanvas->mpCGLContext);
    //mpCGLExtFrame->Show();

    for (int i = 0; i < 5; i++){	
	GetPCGLCanvas(i)->mpCMouseCtrl = 
	    new MouseCtrl_cls(MainGLCanvas_cls::mspCPreference);
	for (int j = 0; j < 5; j++){
	    if (i == j) continue;
	    GetPCGLCanvas(i)->RegistPOtherCanvas(GetPCGLCanvas(j));
	}
    }
}

// ----------------------

bool FrameMain_cls::
IsPanelActive(wxString strTag){
    return mpCDF3SeqCtrl->mpCGUI->IsPanelActive(strTag);
}

void FrameMain_cls::
FitSplitterWindow(bool bForce){
    //mpCDF3SeqCtrl->mpCGUI->Fit();
    int DF3PanelHeight = mpCDF3SeqCtrl->mpCGUI->GetSizer()->GetMinSize().GetHeight();
    if (DF3PanelHeight > 120) DF3PanelHeight = 120;
    int sashPos = mpCSplitterMain->GetSashPosition();
    int windowSize = mpCSplitterMain->GetClientSize().GetHeight();
    int sashCandid = windowSize - DF3PanelHeight;
    mpCSplitterMain->SetMinimumPaneSize(DF3PanelHeight);
    if (bForce || (sashPos > sashCandid)){
	mpCSplitterMain->SetSashPosition(sashCandid, TRUE);
	Refresh(TRUE);
    }

    mpCDF3SeqCtrl->mpCGUI->RechckSize();
}

void FrameMain_cls::
PushStatusTextMain(wxString strStatus, int index){
    if (mstrStatus[index] == strStatus) return;

    PopStatusTextMain(index);
    tm ts = *wxDateTime::GetTmNow();
    if (index == 0)
	strStatus << wxT(" ") << wxString::Format(wxT("%02d"), ts.tm_hour) 
		  << wxT(":") << wxString::Format(wxT("%02d"), ts.tm_min)
		  << wxT(":") << wxString::Format(wxT("%02d"), ts.tm_sec);
    GetStatusBar()->PushStatusText(strStatus, index);
    mStatusBarStack[index]++;
    mstrStatus[index] = strStatus;
}

void FrameMain_cls::
PopStatusTextMain(int index){
    if (mStatusBarStack[index] > 0){
	GetStatusBar()->PopStatusText(index);
	mStatusBarStack[index]--;
    }
}

void FrameMain_cls::
UpdateMenu(){
    mpCMenuEdit->Check(menuItemTimeRemap, mpCParent->mpCTime->mCbUseTimeRemap.mbBody);
}

void FrameMain_cls::
UpdateStatusBar(){
    if (mpCParent->mpCTreeBoxRule->mpCGUI != NULL)
	mpCParent->mpCTreeBoxRule->mpCGUI->UpdateDisplay();
    
    SplitPathWX_cls CCurrent(mpCDF3SeqCtrl->GetPDF3SeqActive()->GetPDF3()->GetFilePathWXStr());
    GetStatusBar()->SetStatusText(CCurrent.GetPathDirLast() + CCurrent.GetPathWXStr(_FN_FNAME_EXT), 1);
}

//------------------------

GLCanvasCtrl_cls* FrameMain_cls::
GetPCGLCanvasCtrl(int index){
    if (index == 4)
	return mpCGLExtFrame->mpCGLCtrl;
    return mpCCanvas[index];
}

MainGLCanvas_cls* FrameMain_cls::
GetPCGLCanvas(int index){
    if (index == 4)
	return mpCGLExtFrame->mpCGLCtrl->mpCGLCanvas;
    return mpCCanvas[index]->mpCGLCanvas;
}

void FrameMain_cls::
ReconnectCameraPathGUI(){
    if (mpCPathCtrl->mpCGUI != NULL)
	mpCPathCtrl->mpCGUI->ReconnectView();
}

void FrameMain_cls::
SetMNumBoxInformation(wxBoxSizer *pBoxSizer, wxWindow *pC){
    MultiNumericalInputsPanel_cls* pCurr = 
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumBoxInformation, pC);

    Parameters_cls *pCBoxSize = DrawingBlock_cls::mspCBoxSize;
    Parameters_cls *pCRotate = DrawingBlock_cls::mspCRotate;

    pCurr->mTextWidth = 50;
    int boxWidth = 2;
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Xrange"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[0],
			  wxT("xmin"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[3],
			  wxT("xmax"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Yrange"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[1],
			  wxT("ymin"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[4],
			  wxT("ymax"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Zrange"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[2],
			  wxT("zmin"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCBoxSize->mpInterpolatedValue[5],
			  wxT("zmax"));
    
    boxWidth = 4;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Rot(zxyz)"));
    pCurr->CombinePointer(_GP_DOUBLE, &pCRotate->mpInterpolatedValue[0]);
    pCurr->CombinePointer(_GP_DOUBLE, &pCRotate->mpInterpolatedValue[1]);
    pCurr->CombinePointer(_GP_DOUBLE, &pCRotate->mpInterpolatedValue[2]);
    pCurr->CombinePointer(_GP_DOUBLE, &pCRotate->mpInterpolatedValue[3]);

    boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Alpha"));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, mpCDF3SeqCtrl->mCBaseAlpha.mpInterpolatedValue);
    pCurr->SetRange(0, 128, _MN_LASTITEM, 1);
    pCurr->CombinePointer(_GP_DOUBLE, mpCDF3SeqCtrl->mCBaseAlpha.mpInterpolatedValue);
    
    pCurr->mProportion = 1;
    pCurr->FinishSetting(pBoxSizer, TRUE);

    pCurr->SetFuncHook(&FuncHookParamChanged, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FuncHookBoxInfoChanged, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FuncHookMouseOnBoxConf, _MN_HOOK_MOUSE);
    pCurr->SetFuncHook(&FuncHookPanelLayout, _MN_HOOK_SHOW);
}

void FrameMain_cls::
SetMNumPlayOption(wxBoxSizer *pBoxSizer, wxWindow *pC){
    MultiNumericalInputsPanel_cls* pCurr =
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumPlayOption, pC);

    int boxWidth = 2;
    pCurr->mTextWidth = 60;
    wxString playType[4] =
	{wxT("On Texture"), wxT("On Memory XYZ"), wxT("On Memory Z"), wxT("Full")};
    pCurr->mComboWidth = 108;
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mpCTime->mPlayMode,
			  _("Play Range"), TRUE, 4, playType, 3);
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Interval"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mpCParent->mpCTime->mCStep.mBody);
    pCurr->SetRange(1, 30);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mpCParent->mpCTime->mCStep.mBody);
    pCurr->SetRange(1, 30);
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Wait(ms)"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mMilliSleep);
    pCurr->SetRange(25, 1000);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mMilliSleep);
    pCurr->SetRange(25, 1000);
    
    pCurr->FinishSetting(pBoxSizer, TRUE);
    
    pCurr->SetFuncHook(&FuncHookPanelLayout, _MN_HOOK_SHOW);

    Connect(pCurr->mVCPointers[1].mID, wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(FrameMain_cls::OnMenuRefresh));
    /*
    pCurr->mVCPointers[1].GetPCtrlWindow()->SetToolTip(_("Play Range Tip"));
    */
}

void FrameMain_cls::
SetMNumDownSizing(wxBoxSizer *pBoxSizer, wxWindow *pC){
    MultiNumericalInputsPanel_cls* pCurr = 
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumDownSizing, pC);

    int boxWidth = 3;
    pCurr->mTextWidth = 50;

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Layer"));

    pCurr->CombinePointer(_GP_UINT_SPIN, /*&mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0_FIX_ME)->mDownSizeLayer[X]*/&DF3Sequence_cls::msCDownSizeLayer.mpBody[X]);
    pCurr->SetRange(1, 8);
    
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &DF3Sequence_cls::msCDownSizeLayer.mpBody[Y]);
    pCurr->SetRange(1, 8);

    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &DF3Sequence_cls::msCDownSizeLayer.mpBody[Z]);
    pCurr->SetRange(1, 8);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Source Date"));
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &DF3Sequence_cls::msCDownSizeSrc.mpBody[X]);
    pCurr->SetRange(1, 8);

    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &DF3Sequence_cls::msCDownSizeSrc.mpBody[Y]);
    pCurr->SetRange(1, 8);
    
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &DF3Sequence_cls::msCDownSizeSrc.mpBody[Z]);
    pCurr->SetRange(1, 8);
    pCurr->FinishSetting(pBoxSizer, TRUE);
    pCurr->SetFuncHook(&FuncHookDownSizingChanged, _MN_HOOK_ASSIGN);
}

// --------------------------

void FrameMain_cls::
DeselectAllIf(wxString labelStr){
    if (labelStr == wxT("") ||
	(MainGLCanvas_cls::mspCSelectedItem != NULL &&
	 MainGLCanvas_cls::mspCSelectedItem->mLabelStr == labelStr)){
	MainGLCanvas_cls::SelectItem(NULL);
	mpCDF3SeqCtrl->mpCGUI->DeactivateAllPanel(TRUE);
    }
}

void FrameMain_cls::
SetKeyPath(unsigned int type){
    if (GpGLPanelJustHandled == NULL) return;
    
    int index = GpGLPanelJustHandled->mSelfIndex;
    switch (type){
    case 0: 
	if (mpCCanvas[index]->GetDisplayMode() == _DIRECTION_FREE ||
	    mpCCanvas[index]->GetDisplayMode() >= _GL_CANVAS_LINKED_CAM0){
	    GCUndoList.OpenBlock();
	    mpCPathCtrl->GetActivePath()->SetKeyPos
		(mpCParent->mpCTime->GetDoubleIndex(), 
		 mpCCanvas[index]->mpCGLCanvas->mCCameraPos);
	    GCUndoList.CloseBlock();
	}
	break;

    case 1:
	mpCPathCtrl->GetActivePath()->SetKeyAnc
	    (mpCParent->mpCTime->GetDoubleIndex(), 
	     mpCCanvas[index]->mpCGLCanvas->msCAnchorPos);
	break;
    }
    mbPathChanged = TRUE;

    PaintGLPanel();
    mpCParent->mpCTime->UpdateDF3SeqGUI();
    mpCPathCtrl->UpdateItems();
}

// -----

void FrameMain_cls::
FuncHookParamChanged(void *WXUNUSED(pArg), void *WXUNUSED(pEvent)){
    mspCThis->mpCDF3SeqCtrl->mCBaseAlpha.SetKeyIfChanged(mspCThis->mpCParent->mpCTime->GetDoubleIndex());
    DrawingBlock_cls::mspCBoxSize->SetKeyIfChanged(mspCThis->mpCParent->mpCTime->GetDoubleIndex());
    DrawingBlock_cls::mspCRotate->SetKeyIfChanged(mspCThis->mpCParent->mpCTime->GetDoubleIndex());
    mspCThis->PaintGLPanel();
    mspCThis->mpCParent->mpCTime->UpdateDF3SeqGUI();
}

void FrameMain_cls::
FuncHookBoxInfoChanged(void *WXUNUSED(pArg), void *WXUNUSED(pEvent)){
    mspCThis->mpCParent->mpCDBoxMain->CheckMinAndMax();
    mspCThis->UpdateStatusBar();
}

void FrameMain_cls::
FuncHookDownSizingChanged(void *WXUNUSED(pArg), void *WXUNUSED(pEvent)){
    /*
    for (int i = 1; i < _DF3_MAX_SLOT; i++)
	LOOP_XYZ
	    mspCThis->mpCDF3SeqCtrl->GetPDF3Seq(i)->mDownSizeLayer[xyz] = 
	    mspCThis->mpCDF3SeqCtrl->GetPDF3Seq(0)->mDownSizeLayer[xyz];
    for (int i = 1; i < _DF3_MAX_SLOT; i++)
	LOOP_XYZ
	    mspCThis->mpCDF3SeqCtrl->GetPDF3Seq(i)->mDownSizeSrc[xyz] = 
	    mspCThis->mpCDF3SeqCtrl->GetPDF3Seq(0)->mDownSizeSrc[xyz];
    */
	
    mspCThis->mpCDF3SeqCtrl->SetFileChangedTagAllChannel();
}

void FrameMain_cls::
FuncHookMouseOnBoxConf(void *WXUNUSED(pArg), void *pEvent){
    wxMouseEvent event = *(wxMouseEvent*)pEvent;

    if (event.LeftDown() == TRUE || event.RightDown() == TRUE){
	mspCThis->mpCParent->mpCTexPropertyCtrl->ConnectProperty
	    (DrawingBlock_cls::mspCTexture, wxT("VolumeBox"));
	mspCThis->mpCDF3SeqCtrl->mpCGUI->
	    DeactivateAllPanel();
	mspCThis->mpCDF3SeqCtrl->mpCGUI->
	    ActivatePanel(wxT("[Box Size]"), TRUE, TRUE);
    }
}

void FrameMain_cls::
FuncHookPanelLayout(void *WXUNUSED(pArg), void *pEvent){

    mspCThis->mpCFilterPain->mpCFilterPanels[0]->UpdatePanelLayout();
    wxCommandEvent com1 = wxCommandEvent(wxEVT_COMMAND_MENU_SELECTED, 
					 menuItemRefreshPanels);
    mspCThis->AddPendingEvent(com1);
}

void FrameMain_cls::
OnCommandEventRefresh(wxCommandEvent &event){
    PaintGLPanel();
}

void FrameMain_cls::
OnButtonRefEditor(wxCommandEvent &event){
    mpCParent->mCFPathEditDLG.ProcFileDialog(mCLastOpenedFileDF3.msBody);
}

// ---------------------------

void FrameMain_cls::
GainDrawingBlockCopies(std::vector < DrawingBlock_cls > &DrawingBlockCopies,
		       bool bForceCheck, bool bForceMake){

    /*
    mpCParent->mpCDBoxMain->mDepthOffset =
	mpCParent->mpCTreeBoxRule->mCDepthOffset.mBody;
    */
    
    if (bForceCheck == _CHECK_TREE_FORCE_FILE_CHECK
	|| mpCParent->mpCTreeBoxRule->mCbCheckFile.mbBody == TRUE){
	DrawingBlock_cls::GainDrawingBlockCopies
	    (DrawingBlockCopies,
	     mpCParent->mpCDBoxMain,
	     mpCParent->mpCTreeBoxRule->GetConvertedStrVector(),
	     mpCDF3SeqCtrl->GetPCheckTreeFile(),
	     bForceMake);
	return; 
    }
    DrawingBlock_cls::GainDrawingBlockCopies
	(DrawingBlockCopies,
	 mpCParent->mpCDBoxMain,
	 mpCParent->mpCTreeBoxRule->GetConvertedStrVector(), 
	 NULL, bForceMake);
    return;
}

wxString FrameMain_cls::
GetPovStrObjects(std::vector < DrawingBlock_cls > &VCDrawingCls){
    wxString strObj;
    
    for (unsigned int i = 0; i < VCDrawingCls.size(); i++){
	if (mpCDF3SeqCtrl->DoesVolumeBoxRequiredAll() == TRUE){
	    //strObj << wxT("difference {") << ENDLWX;
	    strObj << VCDrawingCls[i].GetPovStrDataBlock(wxT(""), _DBOX_VOLUME);
	    //strObj << wxT("\tLIGHTSRC_SPHERE()") << ENDLWX;
	    //strObj << wxT("}") << ENDLWX;
	}
    }
    
    strObj << mpCDF3SeqCtrl->GetPovStrPolygonObject(VCDrawingCls);
    
    return strObj;
}

void FrameMain_cls::
ReadConfigure(std::wstring strFileIn){
    FilterCtrl_cls::PushListOmit();
#ifdef WIN32
    std::wifstream ifstream(strFileIn.c_str(), std::ios::in);
    ifstream.imbue(std::locale("japanese"));
#else 
    wxString wxFileIn = wxConvFile.cWC2WX(strFileIn.c_str());
    std::wifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif

    if (ifstream.fail()) {
	mpCMNumBoxInformation->UpdateValues();
	mpCMNumPlayOption->UpdateValues();
	mpCPovRay->UpdateItems();
	mpCParent->mpCTreeBoxRule->UpdateItems();
	for (unsigned int i = 0; i < 5; i++)
	    GetPCGLCanvasCtrl(i)->UpdateToggleButtonsAndParams();
	FilterCtrl_cls::PopListOmit();
	mpCDF3SeqCtrl->UpdateFilterPanelListAll();
	return;
    }

    // USɂ߂Ă݂B10KBxȂ̂ŕωȂB
    // łȂ΂ď͌ʂH
    // ؂ւ͒Psstreamifstreamς邾łB
    int len;
    ifstream.seekg (0, std::ios::end); 
    len = ifstream.tellg ();
    ifstream.seekg (0, std::ios::beg);
    wchar_t* buf = new wchar_t [len];
    ifstream.read (buf, len);
    std::wistringstream sstream((std::wstring)buf);
    delete buf;

    std::wstring strLine;
    while ( std::getline (sstream, strLine)){
	mpCDF3SeqCtrl->ReadStrLineAllDF3Sequence(sstream, strLine);
	mpCParent->ImportParamMain(sstream, strLine);
	mCLastOpenedFileDF3.ReadStrLine(strLine);
	mCLastOpenedFileOSP.ReadStrLine(strLine);
	mCLastOpenedFileIMG.ReadStrLine(strLine);
	mCLastExportedFileDF3.ReadStrLine(strLine);
	mCPreviewPanelType.ReadStrLine(strLine);
	MainGLCanvas_cls::ReadStrLineAnchor(sstream, strLine);
	MainGLCanvas_cls::ReadStrLineGUI(strLine);
	mpCParent->ReadStrLine(strLine);
	mpCParent->mpCImportList->SetToDefault(_IMPORT_LIST_ALL);
	for (unsigned int i = 0; i < 5; i++)
	    GetPCGLCanvasCtrl(i)->ReadStrLine(sstream, strLine);
	    //mpCCanvas[i]->ReadStrLine(sstream, strLine);
	DF3GL_cls::mspCProperty->ReadStrLine(strLine);
	GpCClrDialog->ReadStrLine(sstream, strLine);
    }


    FlexGridSizerAdjust(mCPreviewPanelType.mBody);
    RefreshPanels();
    if (mpCPathCtrl->mpCGUI != NULL) mpCPathCtrl->mpCGUI->UpdateComboboxList();
    
    for (unsigned int i = 0; i < 5; i++){
	GetPCGLCanvasCtrl(i)->UpdateToggleButtonsAndParams();
    }
    
    FilterCtrl_cls::PopListOmit();
    //mpCFilterCtrl->UpdateList();
    mpCDF3SeqCtrl->UpdateFilterPanelListAll();

    UpdateMenu();

    if (strFileIn != L"DF3ViewerConfigure.txt")
	mCLastOpenedFileOSP.msBody = strFileIn;
}

void FrameMain_cls::
SaveConfigure(wxString strFileOut, bool flag){

    wxFile CFile(strFileOut, wxFile::write);
    if (CFile.IsOpened() == FALSE) {
	MsgBox(this, _("File open fails"), strFileOut);
	return;
    }
    
    if (strFileOut != L"DF3ViewerConfigure.txt")
	mCLastOpenedFileOSP.msBody = strFileOut;

    wxString sOut;

    sOut << mpCDF3SeqCtrl->SerializeRenderParam();
    sOut << mpCDF3SeqCtrl->SerializeSceneConf();
    sOut << mCLastOpenedFileDF3.Serialize();
    sOut << mCLastOpenedFileOSP.Serialize();
    sOut << mCLastOpenedFileIMG.Serialize();
    sOut << mCLastExportedFileDF3.Serialize();
    sOut << mCPreviewPanelType.Serialize();
    sOut << MainGLCanvas_cls::SerializeGUI();
    sOut << mpCParent->Serialize();
    sOut << mpCPovRay->SerializeConf(flag);
    sOut << mpCPathCtrl->Serialize(flag);
    
    if (flag == _FM_PROJECT_CONF){
	sOut << MainGLCanvas_cls::SerializeAnchor();
	sOut << mpCParent->mpCCustomColor->Serialize(); // F

	sOut << mpCDF3SeqCtrl->SerializeAllDF3Sequence();

	sOut << mpCParent->mpCTime->SerializeParam();
	sOut << mpCParent->mpCTreeBoxRule->SerializeConf();
	sOut << mpCParent->mpCDBoxMain->SerializeConf();
	sOut << mpCStereo->Serialize();
	sOut << DrawingBlock_cls::msCHotSpot.mpCGUI->Serialize();
	sOut << mpCParent->mpCLightSRC->Serialize();
	sOut << DrawingBlock_cls::mspCBoxSize->Serialize();
	sOut << DrawingBlock_cls::mspCRotate->Serialize();
	sOut << mpCDF3SeqCtrl->mCBaseAlpha.Serialize();
	for (unsigned int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	    sOut << mpCCanvas[i]->SerializeConf();
	sOut << DF3GL_cls::mspCProperty->SerializeConf();
	sOut << GpCClrDialog->SerializeCustomColors();
    }
    //ofstream << wxConvFile.cWX2WC(sOut);
    CFile.Write(sOut, wxConvFile);
    
    //ofstream.close();
}

// --------------------

void FrameMain_cls::
NormalizeActiveCameraPath(){
    mpCPathCtrl->GetActivePath()->NormalizeTop();
}

void FrameMain_cls::
UpdateCameraPos(){
    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvas(i)->UpdateCameraPos();
}

void FrameMain_cls::
ForceNewDrawGLPanel(int index){
    if (index == -1)
	for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	    GetPCGLCanvas(i)->mCDrawInfo.ForceNewDraw();
    else
	GetPCGLCanvas(index)->mCDrawInfo.ForceNewDraw();
}

void FrameMain_cls::
PaintGLPanel(int index, bool bForce){
    if (bForce) ForceNewDrawGLPanel(index);
    wxPaintEvent dummy;
    if (index == -1)
	for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++){
	    if (GetPCGLCanvas(i)->IsShown() == TRUE)
		GetPCGLCanvas(i)->AddPendingEvent(dummy);
	}
    else
	GetPCGLCanvas(index)->AddPendingEvent(dummy);
}

void FrameMain_cls::
OnPaint(wxPaintEvent& event){
    // must always be here (Ƃ͂{CŉȂ̂łȂĂ)
    // wxPaintDC dc(this); 

    if (mbPathChanged == TRUE){
	for (unsigned int i = 0; i < mpCPathCtrl->mVpCPath.size(); i++)
	    mpCPathCtrl->mVpCPath[i]->GetSetCurrentPos(mpCParent->mpCTime->GetDoubleIndex());
	UpdateCameraPos();
	mbPathChanged = FALSE;
    }

    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvas(i)->AddPendingEvent(event);

    mpCControlPanel->AddPendingEvent(event);

    UpdateStatusBar();
    
    event.Skip();
}

void FrameMain_cls::
OnCloseData(wxCommandEvent& event){
    //MsgBox(this, "!!", "!!");
    mpCDF3SeqCtrl->GetPDF3SeqActive()->ReleaseAll(_DF3SEQ_ALL, FALSE);
    mpCDF3SeqCtrl->GetPDF3SeqActive()->SetFileChangedTagAll();
    mpCDF3SeqCtrl->GetPDF3SeqActive()->ClearFileSequence();
    mpCDF3SeqCtrl->GetPDF3SeqActive()->mpCFilterCtrl->ClearData();
    Refresh(TRUE);
}

void FrameMain_cls::
OnQuit(wxCommandEvent& event){
    if (MsgBoxYesno(this, _("Query"), _("Really Quit ?")) == TRUE){
	SaveConfigure(L"DF3ViewerConfigure.txt", _FM_DEFAULT_CONF);
	// ɃfXgNgϐɍŝ͉B
	
	//FIX_ME!! }`Xbhŏ͂܂


	mpCMNumBoxInformation->Show(FALSE);
	Close(true);
    }
}

void FrameMain_cls::
OnDebug(){
    wxString str;
    
    /* Undo
    for (int i = 0; i < GCUndoList.mVPCUndoList.size(); i++){
	str << GCUndoList.mVPCUndoList[i]->mCommandType;
	if (i == GCUndoList.mCurrentIndex) str << wxT("*");
	str << wxT(":");
    }
    */

    str << GstrDebug;
    
    str << wxT("version") << mpCPovRay->mCPovRayVersion.mBody;

    wxMessageBox(str, _("Debug info"),
                 wxOK | wxICON_INFORMATION, this);
}

void FrameMain_cls::
OnAbout(wxCommandEvent& event){
    static wxString wstrYesNo[3] = {wxT("no"), wxT("yes")};
    wxString strAboutGLVer(mpCGLInfo->mstrGLVersion.c_str(), wxConvFile);
    wxString strMessage = wxString::Format
	(_FRAME_MAIN_APPNAME _T("\n")
	 _T("%s %s\n%s %s\n%s %lu MB\n%s %d\n%s %d.%d.x\n%s %s\n%s %s\n%s %s\n%s %d\nProgrammed by Takaaki Takeda\nMorphology Algorithm provided by Yoshitaka Kimori"),
	 _("Powered by"), wxVERSION_STRING,
	 _("running under"), wxGetOsDescription().c_str(),
	 _("free memory"), (long)(wxGetFreeMemory() / 1024 / 1024).ToLong(),
	 wxT("CoreNumber:"), wxThread::GetCPUCount(),
	 wxT("OpenGL:"), mpCGLInfo->mMajorVersion, mpCGLInfo->mMinorVersion,
	 wxT("3DTexture Support:"), wstrYesNo[DF3GL_cls::mspCProperty->mbUse3DTexture].c_str(),
	 wxT("PBO Supported:"), wstrYesNo[RedrawPBO_cls::msbSupported].c_str(),
	 wxT("FBO Supported:"), wstrYesNo[FBO_cls::msbSupported].c_str(),
	 wxT("pid"), mpCParent->mPID);

    AboutBox_cls CAboutBox(this, wxID_ANY, 
			   _("About DF3 Viewer Oosawa"), strMessage);
    CAboutBox.ShowModal();
}

void FrameMain_cls::
OnOpen(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Coose first file"));
    if (mCLastOpenedFileDF3.msBody != wxT("")){
	SplitPathWX_cls CPath(mCLastOpenedFileDF3.msBody);
	GpCFileDialog->SetInitPath(CPath.GetPathWXStr(_FN_DRIVE_DIR));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	wxString strFilePath = GpCFileDialog->GetPath();
	if (strFilePath.Matches(wxT(".osp")))
	    if (MsgBoxYesno(this, _("Opening .osp File"), _("Read as a Project file?")) == TRUE){
		OpenProjectMain(strFilePath);	    
		UpdateAfterProjectOpen();
		return;
	    }
	    
	wxString strStatus; 
	// CHECK_ME!! LegacyłwxConvFile͂Ȃ͂H{ꂪ݁H
	strStatus << wxT("Open file ") << strFilePath;
	PushStatusTextMain(strStatus);
	mpCParent->OpenFileSequence(strFilePath);
	
	mbHasOpenedProject = FALSE;
	
	// {[t
	if ((mpCDF3SeqCtrl->DoesFilterExistInAllDF3(_FILTER_STREAMLINE) == FALSE) &&
	    (mpCDF3SeqCtrl->GetPFilterCtrlActive()->DoesFilterExist(_FILTER_VOLUME, _FILTER_INCLUDE_INVALID) == FALSE) &&
	    (mpCDF3SeqCtrl->GetPFilterCtrlActive()->DoesFilterExist(_FILTER_ISOSURFACE, _FILTER_INCLUDE_INVALID) == FALSE)){
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemVolume);
	    AddPendingEvent(com);
	}
    }
    mCSWMain.Start();
}

void FrameMain_cls::
OnAdd(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Append::Coose first file"));
    if (mCLastOpenedFileDF3.msBody != wxT("")){
	SplitPathWX_cls CPath(mCLastOpenedFileDF3.msBody);
	GpCFileDialog->SetInitPath(CPath.GetPathWXStr(_FN_DRIVE_DIR));
    }
    if (GpCFileDialog->ShowModal() == wxID_OK)
	// CHECK_ME!! LegacyłwxConvFile͂Ȃ͂H{ꂪ݁H
	mpCParent->AddFileSequence(GpCFileDialog->GetPath());
    
    GCUndoList.Clear();
    mCSWMain.Start();
}

void FrameMain_cls::
OnOpenEdit(wxCommandEvent& event){
    mpCParent->OpenFileEdit(_("Open Data file"), TRUE);
}

void FrameMain_cls::
OnAddEdit(wxCommandEvent& event){
    mpCParent->OpenFileEdit(_("Append Data file"), FALSE);
}

void FrameMain_cls::
OnMenuPopStatusBar(wxCommandEvent& event){
    PopStatusTextMain();
}

void FrameMain_cls::
OnProjectOpen(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Select a project file"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.osp)|*.osp"));
    if (mCLastOpenedFileOSP.msBody != wxT("")){
	SplitPathWX_cls CPath(mCLastOpenedFileOSP.msBody);
	GpCFileDialog->SetInitPath
	    (CPath.GetPathWXStr(_FN_DRIVE_DIR),
	     CPath.GetPathWXStr(_FN_FNAME_EXT));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_CANCEL) return;

    GbGLLockForLoading = TRUE;
    GbGLUnlockOK = FALSE;
    mCSWMain.Start();
    OpenProjectMain(GpCFileDialog->GetPath());

    UpdateAfterProjectOpen();
}

void FrameMain_cls::
UpdateAfterProjectOpen(){
    mpCParent->mpCTime->UpdateDF3SeqGUI();
    mpCPovRay->HideAndShow();
    mpCParent->mpCTreeBoxRule->mpCGUI->HideAndShow();
    mpCParent->mpCLightSRC->mpCGUI->ReconnectMNumParam();
	
    // XeIݒ肪݂͕`OɍXVĂȂƑʖ
    mpCStereo->UpdateItems(); 
        for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++){
	    if (GetPCGLCanvas(i)->mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
		GetPCGLCanvas(i)->LinkageConnect(-1);
    }

    mpCDF3SeqCtrl->UpdateFilterTargetsAll();
    mpCMNumDownSizing->UpdateValues();
    //GbGLLockForLoading = FALSE;
    mbOpenProject = TRUE;
    GbGLUnlockOK = TRUE;
}

void FrameMain_cls::
OpenProjectMain(wxString strFilename){
    mpCDF3SeqCtrl->ClearFilterAll();
    mpCPathCtrl->ClearPath();
    ReadConfigure(wxConvFile.cWX2WC(strFilename));
    GCUndoList.Clear();
    
    mpCParent->mpCTime->CheckWorkingArea();
    mpCDF3SeqCtrl->mpCGUI->UpdatePanelsBitmapState();

    wxString strInfo;
    strInfo << strFilename;
    if (mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence.size() > 0)
	strInfo << wxT(" @ ") << mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence[0].GetInfoStr() << wxT(" - ") << _APPNAME_SHORT;
    SetTitle(strInfo);

    mbHasOpenedProject = TRUE;
}

void FrameMain_cls::
OnProjectSave(wxCommandEvent& event){
    if (mbHasOpenedProject == FALSE){
	OnProjectSaveAs(event);
	return;
    }

    wxBeginBusyCursor();
    GetStatusBar()->PushStatusText(wxT("Saving..."));
    SaveConfigure(mCLastOpenedFileOSP.msBody, 
		  _FM_PROJECT_CONF);
    wxMilliSleep(500);
    GetStatusBar()->PopStatusText();
    wxEndBusyCursor();
}

void FrameMain_cls::
OnProjectSaveAs(wxCommandEvent& event){
    GpCFileDialog->SetMessage(wxT("Select a file"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.osp)|*.osp"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    if (mCLastOpenedFileOSP.msBody != wxT("")){
	SplitPathWX_cls CPath(mCLastOpenedFileOSP.msBody);
	if (mbHasOpenedProject == TRUE)
	    GpCFileDialog->SetInitPath
		(CPath.GetPathWXStr(_FN_DRIVE_DIR),
		 CPath.GetPathWXStr(_FN_FNAME_EXT));
	else
	    GpCFileDialog->SetInitPath
		(CPath.GetPathWXStr(_FN_DRIVE_DIR), wxT(".osp"));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	SaveConfigure(GpCFileDialog->GetPath(), _FM_PROJECT_CONF);
	wxString strInfo = GpCFileDialog->GetPath();
	mbHasOpenedProject = TRUE;
	mCLastOpenedFileOSP.msBody = strInfo;
	if (mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence.size() > 0)
	    strInfo << wxT(" @ ") << mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence[0].GetInfoStr() << wxT(" - ") << _APPNAME_SHORT;
	SetTitle(strInfo);
    }
}

void FrameMain_cls::
OnImportPath(wxCommandEvent& event){
    mpCParent->ImportParam(_IMPORT_LIST_PATH);
    mpCDF3SeqCtrl->UpdateFilterTargetsAll();
    mpCMNumPlayOption->UpdateValues();
    RefreshPanels();
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
}

void FrameMain_cls::
OnImportRenderParam(wxCommandEvent& event){
    mpCParent->ImportParam(_IMPORT_LIST_RENDER);
    mpCDF3SeqCtrl->UpdateFilterTargetsAll();
    mpCMNumPlayOption->UpdateValues();
    RefreshPanels();
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
}

void FrameMain_cls::
OnExportDF3(wxCommandEvent &event){
    GpCFileDialog->SetMessage(wxT("Coose DF3 file"));
    GpCFileDialog->SetWildcard(wxT("DF3(*.df3)|*.df3"));
    GpCFileDialog->SetStyle( wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    
    if (mCLastExportedFileDF3.msBody != wxT("")){
	SplitPathWX_cls CPath(mCLastExportedFileDF3.msBody);
	GpCFileDialog->SetInitPath(CPath.GetPathWXStr(_FN_DRIVE_DIR), CPath.GetPathWXStr(_FN_FNAME) + wxT(".df3"));
    }

    bool bMirroring[3] = {FALSE, FALSE, FALSE};
    BoxCopyData_cls* pCBoxData =
	(BoxCopyData_cls*)mpCDF3SeqCtrl->GetFirstPFilterDataInAllDF3(_FILTER_BOXCOPY);
    if (pCBoxData != NULL)
	LOOP_XYZ bMirroring[xyz] = pCBoxData->mCbValid.mbBody & pCBoxData->mCbMirroring.mpbBody[xyz];
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	mpCDF3SeqCtrl->GetPDF3Active()->ExportDF3
	    (GpCFileDialog->GetPath(),  bMirroring);
	mCLastExportedFileDF3.msBody = GpCFileDialog->GetPath();
    }
}

void FrameMain_cls::
OnExportDF3Seq(wxCommandEvent &event){
    mpCParent->ExportDF3Seq();
}

void FrameMain_cls::
OnExportImgSeq(wxCommandEvent &event){
    mpCParent->ExportImgSeq();
}

void FrameMain_cls::
OnExportIsosurfaceOBJ(wxCommandEvent &event){
    FilterBase_cls *pFilter;
    if (mpCDF3SeqCtrl->GetPFilterCtrlActive()
	->DoesFilterExist(_FILTER_ISOSURFACE, TRUE, &pFilter) == TRUE){
	GpCFileDialog->SetMessage(wxT("Export isosurfece (Wavefront OBJ Format)"));
	GpCFileDialog->SetWildcard(wxT("Wavefront OBJ(*.obj)|*.obj"));
	GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
	GpCFileDialog->SetInitPath(mpCPovRay->mCConfWorkingDir.msBody);
	if (GpCFileDialog->ShowModal() == wxID_OK)
	    ((PovIsosurface_cls*)pFilter)->
		ExportWavefrontOBJ(GpCFileDialog->GetPath());
    }
}

void FrameMain_cls::
OnExportIsosurfacePOV(wxCommandEvent &event){
    FilterBase_cls *pFilter;
    wxString strPath;
    int skip = 0;
    GpCFileDialog->SetMessage(wxT("Export isosurfece (POV mesh2 Format)"));
    GpCFileDialog->SetInitPath(mpCPovRay->mCConfWorkingDir.msBody,
			       wxT("Isosurface.pov"));
    GpCFileDialog->SetWildcard(wxT("povray mesh2 format(*.pov)|*.pov"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    
    while(mpCDF3SeqCtrl->GetPFilterCtrlActive()
	  ->DoesFilterExist(_FILTER_ISOSURFACE, _FILTER_INCLUDE_INVALID,
			    &pFilter, skip) == TRUE){
	if (strPath == wxT("")){
	    if (GpCFileDialog->ShowModal() == wxID_OK)
		strPath = GpCFileDialog->GetPath();
	    else
		return;
	}
	
	((PovIsosurface_cls*)pFilter)->ExportMesh2Pov(strPath);
	
	skip++;
    }
}

void FrameMain_cls::
OnSaveImage(wxCommandEvent &event){
    mpCCanvas[0]->mpCGLCanvas->mbSaveImageQueue = TRUE;
    PaintGLPanel(0);
}

void FrameMain_cls::
OnSaveImgSeqBegin(wxCommandEvent &event){
    if (mpCCanvas[0]->GetDisplayMode() < _GL_CANVAS_LINKED_CAM0)
	if (MsgBoxYesno
	    (mpCCanvas[0]->mpCGLCanvas->mpCLinkedImgSeq->mpCGUI,
	     _("Output Image Sequence"), _("Panel 0 is not linked to camera")) == TRUE){
	    int camIndex = mpCPovRay->GetCameraIndex();
	    if (camIndex != -2)
		mpCCanvas[0]->mpCGLCanvas->LinkageConnect(camIndex/*-1*/);
	}

    if (mpCParent->mpCTime->mCStep.mBody != 1){
	wxString strMes;
	strMes << _("Skipping number is: ") << mpCParent->mpCTime->mCStep.mBody << ENDLWX << _("Change Skipping to 1 ?");
	if (MsgBoxYesno
	    (mpCCanvas[0]->mpCGLCanvas->mpCLinkedImgSeq->mpCGUI,
	     _("Output Image Sequence"), strMes) == TRUE){
	    mpCParent->mpCTime->mCStep.mBody = 1;
	    mpCMNumPlayOption->UpdateValues();
	}
    }

    mpCCanvas[0]->mpCGLCanvas->mpCLinkedImgSeq = mpCParent->mpCImgSequence;
    mpCCanvas[0]->mpCGLCanvas->mbSaveImageQueue = TRUE;
    mpCCanvas[0]->mpCGLCanvas->mbSaveImgSeqQueue = TRUE;
    mpCParent->mpCImgSequence->mCurrentOffset = 0;

    ForceNewDrawGLPanel(0);

    mpCParent->mpCTime->FrameMoveL(-1);
    mpCParent->mpCTime->mbPlayTex = TRUE;
    mpCParent->mpCTime->mPlayMode = _TIME_CTRL_PLAY_FULL;
    mpCParent->mpCTime->mPlayDirection = +1;
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
}

void FrameMain_cls::
OnPlayTex(wxCommandEvent &event){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, btnCtrlPlayFWD1);
    mpCControlPanel->AddPendingEvent(com);
}

void FrameMain_cls::
OnPlayTexInv(wxCommandEvent &event){
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, btnCtrlPlayBCK1);
    mpCControlPanel->AddPendingEvent(com);
}

void FrameMain_cls::
OnPlayTexStop(wxCommandEvent &event){
    if (mpCCanvas[0]->mpCGLCanvas->mbSaveImgSeqQueue == TRUE){
	mpCCanvas[0]->mpCGLCanvas->mbSaveImageQueue = FALSE;
	mpCCanvas[0]->mpCGLCanvas->mbSaveImgSeqQueue = FALSE;

	//mpCCanvas[0]->mpCGLCanvas->mpCLinkedImgSeq->DisableAbort();
	mpCParent->mpCTime->mbPlayTex = FALSE;
	
	//#ifdef WIN32
	// LINUXł͕ʃXbhŏă_COoāAԍ
	mpCParent->mpCImgSequence->mpCGUI->OutputFinish();
	MsgBox(this, _("Image sequence output finished."), _("Finished"));
	ForceNewDrawGLPanel(0);
	//#endif
    }

    mpCControlPanel->UpdateButtonColor();
}

void FrameMain_cls::
OnSaveImgSeq(wxCommandEvent &event){
    int width, height;
    mpCCanvas[0]->GetClientSize(&width, &height);
    mpCParent->mpCImgSequence->SetGeom(width, height, mpCCanvas[0]->mpCGLCanvas->mCGLPerspective.mDeg);
    mpCParent->mpCImgSequence->mCInitNum.mBody = mpCParent->mpCTime->mCWAMin.mBody;
    mpCCanvas[0]->mpCGLCanvas->mpCLinkedImgSeq = mpCParent->mpCImgSequence;
    mpCParent->mpCImgSequence->SetDefaultPath(mCLastOpenedFileIMG.msBody);
    mpCParent->mpCImgSequence->OpenWindow(this);
}

void FrameMain_cls::
OnRedo(wxCommandEvent& event){
    int step = 1;
    int type = GCUndoList.GetRedoCommandType(step);
    while (type == 2){
	step++;
	type = GCUndoList.GetRedoCommandType(step);
    }

    GCUndoList.ExecCurrent();
    mpCDF3SeqCtrl->mpCGUI->mpCPanelList->UpdateBitmapPanels();
    mUpdateLevel = 1;
    PaintGLPanel();
    mpCPanelTop->GetSizer()->Layout();
    mpCParent->mpCTime->UpdateDF3SeqGUI();
    wxSizeEvent dummy;
    mpCDF3SeqCtrl->mpCGUI->AddPendingEvent(dummy);

    if ((type & _COMMAND_TYPE_REQUIRE_RECOLOR) != 0)
	if (mpCParent->mpCCustomColor->mpCGUI != NULL)
	    mpCParent->mpCCustomColor->mpCGUI->UpdateValues();

    if ((type & _COMMAND_TYPE_REQUIRE_RETEX) != 0){
	wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemReTexture);
	AddPendingEvent(cmd);
    }
}

void FrameMain_cls::
OnUndo(wxCommandEvent& event){
    int step = 1;
    int type = GCUndoList.GetUndoCommandType(step);
    while (type == 1){
	step++;
	type = GCUndoList.GetUndoCommandType(step);
    }
	
    if (GCUndoList.UndoCurrent() == FALSE) return;
    mpCDF3SeqCtrl->mpCGUI->mpCPanelList->UpdateBitmapPanels();
    mUpdateLevel = 1;
    PaintGLPanel();
    mpCPanelTop->GetSizer()->Layout();
    mpCParent->mpCTime->UpdateDF3SeqGUI();
    wxSizeEvent dummy;
    mpCDF3SeqCtrl->mpCGUI->AddPendingEvent(dummy);

    if ((type & _COMMAND_TYPE_REQUIRE_RECOLOR) != 0)
	if (mpCParent->mpCCustomColor->mpCGUI != NULL)
	    mpCParent->mpCCustomColor->mpCGUI->UpdateValues();

    if ((type & _COMMAND_TYPE_REQUIRE_RETEX) != 0){
	wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemReTexture);
	AddPendingEvent(cmd);
    }
}

void FrameMain_cls::
OnMenuFilterSwapUp(wxCommandEvent& event){
    mpCDF3SeqCtrl->GetPFilterCtrlActive()->SwapFilter(-1);
}

void FrameMain_cls::
OnMenuFilterSwapDown(wxCommandEvent& event){
    mpCDF3SeqCtrl->GetPFilterCtrlActive()->SwapFilter(+1);
}

void FrameMain_cls::
AddPovObject(int type){
    PovObjectData_cls CData(mpCDF3SeqCtrl->GetPFilterCtrlActive(), TRUE, type);
    if (CData.mCObjType.mBody == _OBJECT_TYPE_WIRED_BOX){
	CData.mCTexProperty.mCDiffuse.mBody = 0.2;
	CData.mCTexProperty.mCAmbient.mBody = 0.8;
    }
    GCUndoList.SetNewCommand
	(new ComPovObjectParamAdd_cls (mpCDF3SeqCtrl->GetPFilterCtrlActive(), -1, &CData),
	 new ComFilterParamRemove_cls(mpCDF3SeqCtrl->GetPFilterCtrlActive(), (int)mpCDF3SeqCtrl->GetPFilterCtrlActive()->mVpCFilter.size()));
    GCUndoList.ExecCurrent();

    mpCDF3SeqCtrl->GetPFilterCtrlActive()->SelectLastItem();
}

#define MACRO_AddPrimitive(name,NAME)\
void FrameMain_cls::\
 OnMenuPovObj##name(wxCommandEvent& WXUNUSED(event)){	\
    AddPovObject(_OBJECT_TYPE_##NAME); }

MACRO_AddPrimitive(Plane,PLANE)
MACRO_AddPrimitive(Box,BOX)
MACRO_AddPrimitive(WiredBox,WIRED_BOX)
MACRO_AddPrimitive(Sphere,SPHERE)
MACRO_AddPrimitive(Cone,CONE)
MACRO_AddPrimitive(Arrow,ARROW)
MACRO_AddPrimitive(Text,TEXT)
MACRO_AddPrimitive(Mesh,MESH)
MACRO_AddPrimitive(Plugin,PLUGIN)

void FrameMain_cls::
WarningForMultiVolume(){
    // COMPLETE_ME!!
}

#define MACRO_AddFilter(Filter,AnotherCommand)		\
    void FrameMain_cls::\
    OnMenu##Filter(wxCommandEvent& WXUNUSED(event)){\
    GCUndoList.SetNewCommand\
	(new Com##Filter##ParamAdd_cls(mpCDF3SeqCtrl->GetPFilterCtrlActive(), -1, NULL),	\
	 new ComFilterParamRemove_cls(mpCDF3SeqCtrl->GetPFilterCtrlActive(), (int)mpCDF3SeqCtrl->GetPFilterCtrlActive()->mVpCFilter.size())); \
    FilterBase_cls::msbConstructedFromMenu = TRUE;\
    GCUndoList.ExecCurrent();\
    FilterBase_cls::msbConstructedFromMenu = FALSE;\
    AnotherCommand;\
}

MACRO_AddFilter(Isosurface,)
MACRO_AddFilter(CrossSection,)
MACRO_AddFilter(ThreeView,)
MACRO_AddFilter(Fog,)
MACRO_AddFilter(BoxCopy,)
MACRO_AddFilter(Clipping,)
MACRO_AddFilter(Volume,)
MACRO_AddFilter(BlurGauss,)
MACRO_AddFilter(InvDiffuse,)
MACRO_AddFilter(LevelAndGamma,)
MACRO_AddFilter(FixPosition,)
MACRO_AddFilter(DataRotate,)
MACRO_AddFilter(LayerColorCurve,)
MACRO_AddFilter(CenterOfMass,)
MACRO_AddFilter(MorphOpenClose,)
MACRO_AddFilter(PovDiffObject,mpCDF3SeqCtrl->GetPFilterCtrlActive()->SelectLastItem())
MACRO_AddFilter(PovStreamLine,)
MACRO_AddFilter(PovVelField,)

void FrameMain_cls::
OnMenuFilterAdvanced(wxCommandEvent& WXUNUSED(event)){
    mpCDF3SeqCtrl->GetPFilterCtrlActive()->AdvancedSetting();
}

void FrameMain_cls::
OnMenuPovRay(wxCommandEvent& WXUNUSED(event)){
    mpCPovRay->OpenWindow(this);
    //mpCPovRay->mpCGUI->UpdateButtonMinimize();
    mpCPovRay->HideAndShow();
    
    mpCPovRay->mpCGUI->UpdateComboboxList();
    mpCPovRay->mpCGUI->CheckFileExistence();
}

void FrameMain_cls::
OnMenuPovRayAdvanced(wxCommandEvent& event){
    mpCPovRay->mpCGUI->mpCMNumCameraParamAdvanced->OpenDialogEX();
    mpCPovRay->HideAndShow();
}

void FrameMain_cls::
OnMenuTree(wxCommandEvent& event){
    mpCParent->mpCTreeBoxRule->OpenWindow(this);
}

void FrameMain_cls::
OnMenuStereogram(wxCommandEvent& WXUNUSED(event)){
    mpCStereo->OpenWindow(this);
    mpCStereo->UpdateItems();
    mpCStereo->mpCGUI->HideAndShowItems();
}

void FrameMain_cls::
OnMenuCameraPath(wxCommandEvent& WXUNUSED(event)){
    mpCPathCtrl->DialogControl_cls::OpenWindow(this);
    mpCPathCtrl->mpCGUI->ReconnectView();
    mpCPathCtrl->mpCGUI->ReconnectViewAdv();
    RefreshCameraCombobox();

}

void FrameMain_cls::
OnMenuTimeRemap(wxCommandEvent& event){
    mpCParent->mpCTime->SetBUseTimeRemap(event.IsChecked());
    
}

void FrameMain_cls::
OnMenuGoFrame(wxCommandEvent& event){
    long frame = wxGetNumberFromUser(wxT("Frame"), wxT(""), _("Input Frame"),
				     mpCParent->mpCTime->mFrame,
				     0, mpCParent->mpCTime->mCMaxFrame.mBody);
    if (frame == -1) return;
    mpCParent->mpCTime->mFrame = frame;
    //mpCDF3SeqCtrl->mpCGUI->mUpdateLevel++;
    //UpdateDrawingData();
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
    

}

void FrameMain_cls::
OnCommandPreviewConfig(wxCommandEvent& event){
    DF3GL_cls::mspCProperty->mbBlendEquationEX = (MainGLCanvas_cls::IsGLBlendEquationEXOK());
    DF3GL_cls::mspCProperty->OpenWindow(this);
    //DF3GL_cls::mspCProperty->UpdateItems(TRUE);
    DF3GL_cls::mspCProperty->mpCGUI->HideAndShowAll();
}

void FrameMain_cls::
OnMenuSetAnchorPath(wxCommandEvent& event){
    LOOP_XYZ 
	MainGLCanvas_cls::msCAnchorPos.mPos[xyz] = mpCPathCtrl->GetActivePath()->mCurrentAnc[xyz];

    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvas(i)->UpdateAnc();
    UpdateDrawingData();
    PaintGLPanel();
}

void FrameMain_cls::
OnMenuSetAnchorZero(wxCommandEvent& event){
    LOOP_XYZ
	MainGLCanvas_cls::msCAnchorPos.mPos[xyz] = 0;

    for (int i = 0; i < _GLCANVAS_INDEX_MAX; i++)
	GetPCGLCanvas(i)->UpdateAnc();
    UpdateDrawingData();
    PaintGLPanel();
}

void FrameMain_cls::
OnMenuLightSource(wxCommandEvent& WXUNUSED(event)){
    mpCParent->mpCLightSRC->OpenWindow(this);
    mpCParent->mpCLightSRC->UpdateInterpolatedValues();
    mpCParent->mpCLightSRC->mpCGUI->RemakeIconList();
}

void FrameMain_cls::
OnMenuHotSpot(wxCommandEvent& WXUNUSED(event)){
    DrawingBlock_cls::msCHotSpot.OpenWindow(mpCParent->mpCTreeBoxRule->mpCGUI);
    DrawingBlock_cls::msCHotSpot.UpdateInterpolatedValues();
}

void FrameMain_cls::
OnMenuExportPovRaySnap(wxCommandEvent& WXUNUSED(event)){
    PovRaySnapMain(FALSE);
}

void FrameMain_cls::
OnMenuRenderPovRaySnap(wxCommandEvent& WXUNUSED(event)){
    PovRaySnapMain(TRUE);
    
    mpCPovRay->mSnapNumber++;
    mpCPovRay->UpdateItems();
}

void FrameMain_cls::
PovRaySnapMain(bool bRender){
    mpCPovRay->mbPovOutForRender = bRender;
    int stereoEyeOrg = mpCStereo->mCEye.mBody;

    if (mpCPovRay->mCStereoEye.mBody == 3){
	wxString listStereo[4] = 
	    {_("0: Take two stereogram snapshots."),
	     _("1: Take only one snapshot."),
	     _("2: Take two stereogram snapshots always."),
	     _("3: Take only one snapshot always.") };
	
	wxString strMessage;
	if (bRender == TRUE)
	    strMessage << _("Rendering with Stereogram.\nSelect Rendering type.");
	else
	    strMessage << _("Exporting with Stereogram.\nSelect Export type.");

	strMessage << _("\n\n*)To Render 2 images,\nCheck off [Keep Single Instance]");

	int selected = wxGetSingleChoiceIndex
	    (strMessage, _("Stereogram Snapshot"),
	     4, listStereo, this, 150, 120, FALSE, 150, 120); 
	if (selected == -1) return;
	if (selected == 0 && bRender == TRUE)
	    mpCPovRay->mbRenderingTwoSnap = TRUE;
	if (selected == 1) mpCPovRay->mCStereoEye.mBody = 0;
	if (selected == 2 && bRender == TRUE)
	    mpCPovRay->mbRenderingTwoSnap = TRUE;
	if (selected == 3) mpCPovRay->mCStereoEye.mBody = 0;
    }
    
    for (int stereoIndex = 0; stereoIndex < 2; stereoIndex++){
	int stereo = mpCPovRay->GetStereoId(stereoIndex);
	if (stereo == -1) continue;

	FilterCtrl_cls::msStereoTmpFileIOMode = 
	    mpCPovRay->GetStereoTmpFileIOMode(stereoIndex);

	mpCStereo->mCEye.mBody = stereo;
	if (mpCParent->ProcOutputPovRay(stereo) == FALSE) return;
	if (bRender == TRUE) mpCPovRay->RenderByPovSnap(stereo);
    }

    mpCStereo->mCEye.mBody = stereoEyeOrg;
    FilterCtrl_cls::msStereoTmpFileIOMode = 3; // ftHg
    mpCPovRay->mbRenderingTwoSnap = FALSE;
}

void FrameMain_cls::
OnMenuExportPovRayAnim(wxCommandEvent& WXUNUSED(event)){

    mpCPovRay->mbPovOutForRender = FALSE;
    unsigned int init, fin;

    mpCParent->OutputPovRayIOAnim(&init, &fin, TRUE);
    mpCPovRay->StopExportAnim();

    wxString strFileOut = mpCPovRay->mCConfWorkingDir.msBody + wxT("/RenderAnim.sh");
#ifdef WIN32
    std::wfstream ofstreamScript(strFileOut.c_str(), std::ios::out);
#else
    std::wfstream ofstreamScript(strFileOut.ToAscii(), std::ios::out);
#endif

    if (ofstreamScript.fail()) return;
    
    ofstreamScript << "trap ctrl_c INT" << ENDL
		   << "function ctrl_c() {" << ENDL
		   << "\techo -- Trapped CTRL-C" << ENDL
		   << "\texit;" << ENDL
		   << "}" << ENDL;

    wxString strFileBase = mpCPovRay->GetFileStr(_POV_ANIM, mpCStereo->GetEye());
    int pos = strFileBase.Find(wxT("%04d"));
    if (pos != wxNOT_FOUND) strFileBase.Replace(wxT("%04d"), wxT(""));
    ofstreamScript << "for f in `seq -f %04g $1 $2 $3`; do povray " << strFileBase << "${f}.ini; done";
    ofstreamScript.close();

    GetStatusBar()->SetStatusText(wxT("field_2"), 2);
}

void FrameMain_cls::
OnMenuRenderPovRayAnim(wxCommandEvent& WXUNUSED(event)){
    if (mpCPovRay->mbRenderingAnim == TRUE){
	if (MsgBoxYesno(this, _("Render Anim by Pov-Ray"), 
			_("Rendering sequence is running.\nStop the rendering?\n(Rendering stops after the current frame is finished.)")) == FALSE)
	    return;
	mpCPovRay->StopRenderAnim();
	return;
    }
    else {
	if (MsgBoxYesno(this, _("Render Anim by Pov-Ray"), _("You are goint to render sequence.\nExecute it now?")) == FALSE)
	    return; 
    }
    
    mpCPovRay->mbPovOutForRender = TRUE;
    mpCPovRay->WaitingForExport(TRUE);
    unsigned int init, fin;
    bool bExport = mpCParent->OutputPovRayIOAnim(&init, &fin);
    mpCPovRay->StopExportAnim();
    mpCPovRay->WaitingForExport(FALSE);
    if (bExport == FALSE) return;
    
    mpCPovRay->RenderByPovAnim(init, fin);
}

void FrameMain_cls::
OnMenuPovWine(wxCommandEvent& event){
    mpCPovRay->mCbWinePov.mbBody = event.IsChecked();
}

void FrameMain_cls::
OnMenuPovRayError(wxCommandEvent& event){
    wxString strErr = _("Error is detected.\nInterrupted by user, or Pov-Ray is not installed or wrong path is set,\nor another Pov-Ray is already opend.\nYou can set path by configure dialog.");
    strErr << mstrErr;
    wxString strTitle = _("Failed to start or finish Pov-Ray.");
    if (mpCPovRay->mbRenderingAnim == TRUE){
	mpCPovRay->StopRenderAnim();
	strErr << _("\nAnimation sequence is automatically stopped.");
	MsgBox(this, strErr, strTitle);
	return;
    }

    MsgBox(this, strErr, strTitle);
}

void FrameMain_cls::
OnMenuAutoRescale(wxCommandEvent& event){
    unsigned int size[3];
    unsigned int maxSize = 0;
    LOOP_XYZ {
	size[xyz] = mpCDF3SeqCtrl->GetCurrentSizeOf1Data(xyz, 0);
	if (maxSize < size[xyz]) maxSize = size[xyz];
    }
    if (maxSize == 0) return;
	
    double min[3], max[3];
    LOOP_XYZ min[xyz] = - (double)size[xyz] / maxSize;
    LOOP_XYZ max[xyz] = + (double)size[xyz] / maxSize;

    BoxCopyData_cls* pCBoxData =
	(BoxCopyData_cls*)mpCDF3SeqCtrl->GetFirstPFilterDataInAllDF3(_FILTER_BOXCOPY);
    if (pCBoxData != NULL)
	LOOP_XYZ if (pCBoxData->mCbValid.mbBody == TRUE && 
		     pCBoxData->mCbMirroring.mpbBody[xyz] == TRUE){
	    min[xyz] = 0;
	    max[xyz] *= 2;
	}

    LOOP_XYZ DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[xyz] = min[xyz];
    LOOP_XYZ DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[xyz+3] = max[xyz];
    DrawingBlock_cls::mspCBoxSize->SetKeyIfChanged
	(mpCParent->mpCTime->GetDoubleIndex());
    RefreshPanels();
    PaintGLPanel();
}

void FrameMain_cls::
OnMenuViewPanelType(wxCommandEvent& event){
    FlexGridSizerAdjust(event.GetId() - menuViewMainPanelType0);
}

void FrameMain_cls::
OnMenuViewExtra(wxCommandEvent& event){
    if (event.IsChecked() == TRUE)
	mpCGLExtFrame->Show(TRUE);
    else
	mpCGLExtFrame->Show(FALSE);
}

void FrameMain_cls::
OnMenuToolTip(wxCommandEvent& event){
    mpCParent->mCbToolTip.mbBody = event.IsChecked();
    wxToolTip::Enable(mpCParent->mCbToolTip.mbBody);
}

void FrameMain_cls::
OnMenuAddLight(wxCommandEvent& event){
    mpCParent->mpCLightSRC->OpenWindow(this);
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, btnLightAdd);
    mpCParent->mpCLightSRC->mpCGUI->AddPendingEvent(com);
    mpCParent->mpCLightSRC->UpdateInterpolatedValues();
}

void FrameMain_cls::
OnMenuAddHotSpot(wxCommandEvent& event){
    DrawingBlock_cls::msCHotSpot.OpenWindow(this);
    wxCommandEvent com(wxEVT_COMMAND_BUTTON_CLICKED, buttonCtrlSpotAdd);
    DrawingBlock_cls::msCHotSpot.mpCGUI->AddPendingEvent(com);
    DrawingBlock_cls::msCHotSpot.UpdateInterpolatedValues();
}

void FrameMain_cls::
OnMenuTextureDLG(wxCommandEvent& event){
    mpCParent->mpCTexPropertyCtrl->UpdateColorList();
    mpCParent->mpCTexPropertyCtrl->ConnectProperty
	(mpCParent->mpCTexPropertyCtrl->mpCConnected, 
	 mpCParent->mpCTexPropertyCtrl->mstrItemName);
    mpCParent->mpCTexPropertyCtrl->OpenWindow(mpCDF3SeqCtrl->GetPFilterCtrl(0)->mpCFilterPanelsLink);
    //mpCParent->mpCTexPropertyCtrl->mpCGUI->HideAndShow();
    //mpCParent->mpCTexPropertyCtrl->mpCGUI->UpdateButtonMinimize();
}

void FrameMain_cls::
OnMenuCustomColor(wxCommandEvent& event){
    mpCParent->mpCCustomColor->OpenWindow(this);
    mpCParent->mpCCustomColor->mpCGUI->UpdateValues();
}

void FrameMain_cls::
OnMenuPreference(wxCommandEvent& event){
    MainGLCanvas_cls::OpenPreference(this);
}

void FrameMain_cls::
OnMenuScene(wxCommandEvent& event){
    mpCParent->mpCScene->InitializeTmpValues();
    if (mpCParent->mpCScene->OpenWindowModal(this) == TRUE)
	mpCParent->mpCScene->AssignTmpValues();

    PaintGLPanel();
    mpCParent->mpCTime->UpdateDF3SeqGUISlider();
    mpCParent->mpCTime->UpdateDF3SeqGUI();

}

void FrameMain_cls::
OnMenuSetCamPos(wxCommandEvent& event){
    SetKeyPath(_CAMERA_PATH_CAMERA);
}

void FrameMain_cls::
OnMenuSetAncPos(wxCommandEvent& event){
    SetKeyPath(_CAMERA_PATH_ANCHOR);
}

void FrameMain_cls::
OnMenuRefresh(wxCommandEvent& event){
    
    UpdateDrawingData();
    PaintGLPanel();

    mpCParent->mpCTime->UpdateDF3SeqGUI();
    //FitSplitterWindow();
    //RefreshPanels(); /*??*/

    mpCPovRay->ProcessRenderAnim();
}

void FrameMain_cls::
OnMenuRefreshTL(wxCommandEvent& event){
    mpCDF3SeqCtrl->mpCGUI->LinkParameter(wxT("[Cam XYZ]"), &mpCPathCtrl->GetActivePath()->mCPosition);
    mpCDF3SeqCtrl->mpCGUI->LinkParameter(wxT("[Anc XYZ]"), &mpCPathCtrl->GetActivePath()->mCAncPos);
    
    // FIX_ME!! ȕւ̂ߑIF{̓ANeBuACe̓ւ]܂
    // PSelectItemɃAhX邾Ɖ
    if (MainGLCanvas_cls::mspCSelectedItem != NULL){
	if (MainGLCanvas_cls::mspCSelectedItem->mLabelStr == L"CamPos" &&
	    MainGLCanvas_cls::mspCSelectedItem != &mpCPathCtrl->GetActivePath()->mCPosition){
	    MainGLCanvas_cls::SelectItem(&mpCPathCtrl->GetActivePath()->mCPosition);
	    //MainGLCanvas_cls::SelectItem(NULL);
	    //mpCDF3SeqCtrl->mpCGUI->DeactivateAllPanel(TRUE);
	}
    }
	
    if (MainGLCanvas_cls::mspCSelectedItem != NULL){
	if (MainGLCanvas_cls::mspCSelectedItem->mLabelStr == L"AncPos" &&
	    MainGLCanvas_cls::mspCSelectedItem != &mpCPathCtrl->GetActivePath()->mCAncPos){
	    MainGLCanvas_cls::SelectItem(&mpCPathCtrl->GetActivePath()->mCAncPos);
	    //MainGLCanvas_cls::SelectItem(NULL);
	    //mpCDF3SeqCtrl->mpCGUI->DeactivateAllPanel(TRUE);
	}
    }
}

void FrameMain_cls::
OnMenuRefreshViewList(wxCommandEvent& event){
    for (int i = 0; i < 5; i++)
	GetPCGLCanvasCtrl(i)->UpdateComboBoxList(mpCPathCtrl->mCCameraNum.mBody);
}

void FrameMain_cls::
OnMenuReTexture(wxCommandEvent& event){
    if (GbGLLockForMultithread == TRUE) return;
    
    mpCDF3SeqCtrl->ReleaseAllDF3Seq(_DF3SEQ_TEXTURE);
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
    FilterObject_cls::msbRetex = TRUE;
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
    AddPendingEvent(cmd);
    mCSWMain.Start();
}

void FrameMain_cls::
OnMenuReLoad(wxCommandEvent& event){
    if (GbGLLockForMultithread == TRUE) return;
 
    mpCDF3SeqCtrl->ReleaseAllDF3Seq(_DF3SEQ_ALL, FALSE);
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
    FilterObject_cls::msbRetex = TRUE;
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
}

void FrameMain_cls::
OnMenuReLoadSnap(wxCommandEvent& event){
    if (GbGLLockForMultithread == TRUE) return;

    for (int df3index = 0; df3index < _DF3_MAX_SLOT; df3index++){
	mpCDF3SeqCtrl->ReleaseStepDF3
	    (df3index, mpCDF3SeqCtrl->GetRemappedIndex(df3index),
	     _DF3SEQ_ALL, FALSE);
    }
    mpCDF3SeqCtrl->ClearTreeInfo(-1);

    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
    FilterObject_cls::msbRetex = TRUE;
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
}

void FrameMain_cls::
OnMenuRefreshPanels(wxCommandEvent& event){
    RefreshPanels();
}

void FrameMain_cls::
OnMenuRefreshCameraNumerical(wxCommandEvent& event){
    RefreshCameraNumerical();
}

void FrameMain_cls::
OnMenuRefreshCameraCombobox(wxCommandEvent& event){
    RefreshCameraCombobox();
}

void FrameMain_cls::
OnMenuRefreshCombo(wxCommandEvent& event){
    mpCDF3SeqCtrl->UpdateFilterColorsAll();
    mpCParent->mpCTexPropertyCtrl->UpdateColorList();
}

void FrameMain_cls::
OnMenuRefreshColorBar(wxCommandEvent& event){
    mpCParent->mpCCustomColor->UpdateColorBar();
    mpCParent->mpCTexPropertyCtrl->UpdateColorBar();
    mpCDF3SeqCtrl->UpdateFilterColorBarAll();
}

void FrameMain_cls::
OnMenuSetFocus(wxCommandEvent& event){
    //MsgBox(this, "!!", "!!");
    mbForceFocus = TRUE;
}

void FrameMain_cls::
OnMenuSplitterResize(wxCommandEvent& event){
    SplitterWindowResize();
    FitSplitterWindow();
}

void FrameMain_cls::
OnMenuDF3GUIChanged(wxCommandEvent& event){
    /*
    int DF3PanelHeight = mpCDF3SeqCtrl->mpCGUI->GetSize().GetHeight();
    if (DF3PanelHeight > 240) DF3PanelHeight = 240;
    mpCSplitterMain->SetMinimumPaneSize(DF3PanelHeight);
    */
    FitSplitterWindow();
}

void FrameMain_cls::
OnSash(wxCommandEvent& event){
    // event.SkipɃTCYm肷̂ŁAŃ
    mpCDF3SeqCtrl->mpCGUI->RechckSize();
    /*
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemSplitterResize);
    AddPendingEvent(com);
    event.Skip();
    */
}

// ----------

void FrameMain_cls::
OnKeyUp(wxKeyEvent& event){
    /*
    int code = event.GetKeyCode();
    switch(code){
    case 'A':
	MsgBox(this, "!!", "Key Up A");
    default: 
	break;
    }

    SetFocus();
    event.Skip();
    */
}

void FrameMain_cls::
OnMouseMotion(wxMouseEvent& event){
    MsgBoxf(this, "!!", "%d", event.m_controlDown);
    mbDragCtrlKey = event.m_controlDown;
}

// q̃_CAOPostEventŃCxg悤ɂ̂
// 傾MenuAccelerationEmulate
void FrameMain_cls::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();

    wxCommandEvent event2(wxEVT_COMMAND_MENU_SELECTED, 0);
    if (event.GetModifiers() == wxMOD_CONTROL){
	switch(code){
	case '1':
	case WXK_NUMPAD1:
	    mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_X_MINUS);
	    mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
	    break;
	case '3':
	case WXK_NUMPAD3:
	    mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_MINUS);
	    mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
	    break;
	    case '7':
	case WXK_NUMPAD7:
	    mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_PLUS);
	    mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
	    break;
	case WXK_LEFT: {
	    if (mbViaIdle == TRUE){
		mpCParent->mpCTime->FrameStep(-1);
		mbViaIdle = FALSE; }
	    break; }
	case WXK_RIGHT: {
	    if (mbViaIdle == TRUE){
		mpCParent->mpCTime->FrameStep(+1);
		mbViaIdle = FALSE; }
	    break; }
	case '.':
	    event2.SetId(menuItemSetAnchorToZero); break;
	case 'A': 
	    mpCDF3SeqCtrl->mpCGUI->SelectAllKey();
	    mpCParent->mpCTime->UpdateDF3SeqGUI();
	    PaintGLPanel();
	    break;
	case 'C':
	    mpCDF3SeqCtrl->mpCGUI->DispatchKeyEventToActivePanel(event);
	    break;
	case 'D':
	    if (mpCDF3SeqCtrl->mpCGUI->GetSelectedKeyNum() != 0)
		mpCDF3SeqCtrl->mpCGUI->SelectAllKey(FALSE);
	    else
		mpCDF3SeqCtrl->mpCGUI->mpCPanelList->DeactivateAllPanel();
	    mpCParent->mpCTime->UpdateDF3SeqGUI();
	    PaintGLPanel();
	    break;
	case 'F':
	    event2.SetId(menuItemFilterAdvanced); break;
	case 'G':
	    event2.SetId(menuItemGoFrame); break;
	case 'H':
	    event2.SetId(menuItemConfHotSpot); break;
	case 'J':
	    event2.SetId(menuItemCustomColor); break;
	case 'K':
	    event2.SetId(menuItemScene); break;
	case 'L': 
	    event2.SetId(menuItemConfLightSource); break; 
	case 'M': 
	    event2.SetId(menuItemConfStereogram); break; 
	case 'R': 
	    event2.SetId(menuItemConfPovRay); break; 
	case 'T': 
	    event2.SetId(menuItemTextureDLG); break; 
	case 'O': case 'o':
	    event2.SetId(menuItemProjectOpen); break; 
	case 'P':
	    event2.SetId(menuItemPreviewConfig); break;
	case 'S': 
	    event2.SetId(menuItemProjectSave); break; 
	case 'U': 
	    event2.SetId(menuItemConfCameraPath); break; 
	case 'V':
	case 'X':
	    mpCDF3SeqCtrl->mpCGUI->DispatchKeyEventToActivePanel(event);
	    break;
	case 'Y': 
	    event2.SetId(menuItemRedo); break; 
	case 'Z': 
	    event2.SetId(menuItemUndo); break; 
	default: 
	    break;
	}
    }
    else if (event.GetModifiers() == wxMOD_ALT)
	switch(code){
	case 'A':
	    event2.SetId(menuItemPlayTex); break;
	}
    else if (event.GetModifiers() == (wxMOD_ALT | wxMOD_SHIFT))
	switch(code){
	case 'A':
	    event2.SetId(menuItemPlayTexInv); break;
	}
    else if (event.GetModifiers() == (wxMOD_CONTROL | wxMOD_SHIFT))
	switch(code){
	case WXK_LEFT:
	    mpCParent->mpCTime->FrameStep(-2);
	    break;
	case WXK_RIGHT:
	    mpCParent->mpCTime->FrameStep(+2); 
	    break;
	}
    else if (event.GetModifiers() == wxMOD_ALTGR)
	switch(code){
	case 'P':
	    event2.SetId(menuItemPreference); break;
	case 'T':
	    event2.SetId(menuItemConfTree); break;
	case WXK_LEFT:
	    mpCParent->mpCTime->FrameStep(-10); break;
	case WXK_RIGHT:
	    mpCParent->mpCTime->FrameStep(+10); break;
	case 'J':
	    event2.SetId(menuItemGoFrame); break;
	    break;
	}
    else
	{
	    switch(code){
	    case '0':
	    case WXK_NUMPAD0:
		mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_FREE);
		mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
		break;
	    case '1':
	    case WXK_NUMPAD1:
		mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_X_PLUS);
		mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
		break;
	    case '3':
	    case WXK_NUMPAD3:
		mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_PLUS);
		mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
		break;
	    case '5':
	    case WXK_NUMPAD5:
		mpCConnectedGLPanel->TogglePerspective();
		mpCConnectedGLPanel->Refresh(FALSE);
	    break;
	    case '7':
	    case WXK_NUMPAD7:
		mpCConnectedGLPanel->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_MINUS);
		mpCConnectedGLPanel->mpCGLCtrl->UpdateWindow();
		break;
#ifdef WIN32		
	    case 39:
#else
	    case '^':
#endif
		mpCParent->mpCTime->ZoomIn();
		break; 
	    case '-':
		mpCParent->mpCTime->ZoomOut();
		break; 
	    case 'B':
		mpCParent->mpCTime->SetWAInHere(); break;
	    case 'G':
		if (MainGLCanvas_cls::msManipulatorMode != _MANIP_TRANSLATE)
		    GpCurrentGLPanel->TranslationMode();
		PaintGLPanel(); break;
	    case 'N':
		mpCParent->mpCTime->SetWAOutHere(); break;
	    case 'J':
		mpCParent->mpCTime->SnipPrev();
		PaintGLPanel();	break;
	    case 'K':
		mpCParent->mpCTime->SnipNext(); 
		PaintGLPanel();	break;
	    case 'R':
		if (MainGLCanvas_cls::msManipulatorMode != _MANIP_ROTATE)
		    GpCurrentGLPanel->RotationMode();
		PaintGLPanel(); break;
	    case 'S':
		if (MainGLCanvas_cls::msManipulatorMode != _MANIP_SCALE)
		    GpCurrentGLPanel->ScaleMode();
		PaintGLPanel(); break;
	    case 'U':
		mpCDF3SeqCtrl->mpCGUI->ShowAllTimeDependentItems();
		break;
	    case 'X':
		if (MainGLCanvas_cls::msMoveMode == _POS_AND_DIR_MOVE_X)
		    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_FREE;
		else
		    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_X;
		PaintGLPanel(-1, FALSE);
		break;
	    case 'Y':
		if (MainGLCanvas_cls::msMoveMode == _POS_AND_DIR_MOVE_Y)
		    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_FREE;
		else
		MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_Y;
		PaintGLPanel(-1, FALSE);
		break;
	    case 'Z':
		if (MainGLCanvas_cls::msMoveMode == _POS_AND_DIR_MOVE_Z)
		    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_FREE;
		else
		    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_Z;
		PaintGLPanel(-1, FALSE);
		break;
	    case WXK_ESCAPE:
		MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_FREE;
		if (MainGLCanvas_cls::msManipulatorMode != _MANIP_TRANSLATE)
		    SetCursor(wxCursor(wxCURSOR_ARROW));
		MainGLCanvas_cls::msManipulatorMode = _MANIP_TRANSLATE;
		GpCurrentGLPanel->TranslationMode();
		PaintGLPanel(-1, FALSE);
		break;
	    case '.':
		event2.SetId(menuItemSetAnchorToPath); break;
	    default:
		break;
	    }
	}

    if (code == WXK_F2) mpCDF3SeqCtrl->GetPFilterCtrlActive()->Rename();
    if (code == WXK_F9) event2.SetId(menuItemRenderSnap);
    if (code == WXK_F8) event2.SetId(menuItemSaveImageSeq);
    if (code == WXK_F7) event2.SetId(menuItemSaveImage);

    if (event2.GetId() != 0) GetEventHandler()->AddPendingEvent(event2);

    //event.Skip();
}

void FrameMain_cls::
UpdateDrawingData(){
    //if (GbInitalizedOnIdle == FALSE) return;
    
    mUpdateLevel += mpCDF3SeqCtrl->mpCGUI->mUpdateLevel;
    double doubleIndex = mpCParent->mpCTime->GetDoubleIndex();
    
    Parameters_cls::SetCurrentDoubleIndex(doubleIndex);
    for (unsigned int i = 0; i < mpCPathCtrl->mVpCPath.size(); i++)
	mpCPathCtrl->mVpCPath[i]->GetSetCurrentPos(mpCParent->mpCTime->GetDoubleIndex());

    LevelMap_cls::SetCurrent(&mpCDF3SeqCtrl->GetPDF3Active()->mCLevelMap);

    //mpCDF3SeqCtrl->GetPFilterCtrl(0)->UpdateParameters(doubleIndex);

    unsigned int size[3];
    //LOOP_XYZ size[xyz] = mpCDF3SeqCtrl->CurrentSizeOf1Data(xyz, 0);
    //pov̎ɓǂłȂDF3̃TCYv̂œǂݍݍς݂̂Ȃ̐擪̏
    LOOP_XYZ size[xyz] = mpCDF3SeqCtrl->GetPDF3SeqActive()->GetDataSize(xyz);
    //printf ("size=%d %d %d\n", size[0], size[1], size[2]);
    
    mpCDF3SeqCtrl->GetPFilterCtrlActive()->
	GetTranslate(DrawingBlock_cls::msTranslate, 
		     mpCParent->mpCTime->mFrame,
		     mpCParent->mpCTime->mCMaxFrame.mBody, size);
    
    mpCDF3SeqCtrl->UpdateFilterParametersAll(doubleIndex);
    if (mpCParent->mpCTexPropertyCtrl != NULL){
	mpCParent->mpCTexPropertyCtrl->UpdateLinkedProperty();
	mpCParent->mpCTexPropertyCtrl->UpdateItems();
    }

    double *pTreeFocus;
    switch(mpCParent->mpCTreeBoxRule->mCFocusType.mBody){
    case _TREEFOCUS_CAMPOS:
	pTreeFocus = mpCPathCtrl->GetActivePath()->mCCurrentCam.mPos; break;
    case _TREEFOCUS_STEREOFOCUS:
	pTreeFocus = mpCPathCtrl->GetActivePath()->mCurrentFocus; break;
    case _TREEFOCUS_ANCPOS:
	pTreeFocus = mpCPathCtrl->GetActivePath()->mCurrentAnc; break;
    }
    
    DrawingBlock_cls::msCurrentDoubleIndex = doubleIndex;
    DrawingBlock_cls::SetTreeParam
	(pTreeFocus,
	 mpCParent->mpCTreeBoxRule->mCDepthMax.mBody,
	 mpCParent->mpCTreeBoxRule->mCDepthMin.mBody,
	 mpCParent->mpCTreeBoxRule->mCCritScale.mBody);
    mpCParent->mpCDBoxMain->SetRoot();
    
    if ((mUpdateLevel > 0) && (DF3GL_cls::mspCProperty->IsGUIShownOnScreen() == TRUE))
	DF3GL_cls::mspCProperty->mpCGUI->UpdateGraph();
    
    if ((mUpdateLevel > 0) && (mpCStereo->IsGUIShownOnScreen() == TRUE))
	mpCStereo->UpdateItems();

    if ((mUpdateLevel > 0) && (mpCPathCtrl->IsGUIShownOnScreen() == TRUE))
	mpCPathCtrl->UpdateItems();

    if (mUpdateLevel > 1) mpCParent->RefreshDialogs();

    /*if (mUpdateLevel > 0)*/mpCParent->mpCLightSRC->UpdateInterpolatedValues();
            
    if (mUpdateLevel > 0) DrawingBlock_cls::msCHotSpot.UpdateInterpolatedValues();

    mpCDF3SeqCtrl->mCBaseAlpha.GetPInterpolatedValue(doubleIndex);
    if (mUpdateLevel > 0) mpCMNumBoxInformation->UpdateValues(3);
    if (mUpdateLevel > 0) mpCMNumBoxInformation->UpdateValues(4);
        
    DrawingBlock_cls::mspCBoxSize->GetPInterpolatedValue(doubleIndex);
    DrawingBlock_cls::mspCRotate->GetPInterpolatedValue(doubleIndex);
    if (mUpdateLevel > 0) mpCMNumBoxInformation->UpdateValues();

    mUpdateLevel = 0;
    mpCDF3SeqCtrl->mpCGUI->mUpdateLevel = 0;
}

bool FrameMain_cls::
IsIntersectCanvas(wxRect rect){
    bool bIntersect = FALSE;
    for (unsigned int i = 0; i < 5; i++)
	if (GetPCGLCanvas(i)->GetScreenRect().Intersects(rect))
	    bIntersect  = TRUE;
    
    return bIntersect;
}

// Memo:: IsIntersectCanvas(mpCMNumCopy->GetScreenRect()))

void FrameMain_cls::
RefreshPanels(){
    if (mpCMNumBoxInformation != NULL)
	mpCMNumBoxInformation->UpdateValues();

    mpCPathCtrl->UpdateItems();

    DF3GL_cls::mspCProperty->UpdateItems();
    mpCPovRay->UpdateItems();
    mpCParent->mpCTreeBoxRule->UpdateItems();

    //mpCFilterPain->RefreshBG(mpCDF3SeqCtrl->mCConfActiveSlot.mBody);
    mpCFilterPain->mpCBookFilter->Layout();
    mpCFilterPain->mpCBookFilter->FitInside();
    mpCFilterPain->Layout();
    mpCFilterPain->FitInside();
    //GetSizer()->Layout();

    UpdateStatusBar();
}

void FrameMain_cls::
RefreshCameraNumerical(){
    UpdateCameraPos();
    UpdateDrawingData();
    mpCPathCtrl->UpdateItems();
}

void FrameMain_cls::
RefreshCameraCombobox(){
    if (mpCPovRay->mpCGUI != NULL){
	mpCPovRay->mpCGUI->UpdateComboboxList();
	mpCPovRay->HideAndShow();
    }
    if (mpCPathCtrl->mpCGUI != NULL)
	mpCPathCtrl->mpCGUI->UpdateComboboxList();
}

void FrameMain_cls::
FlexGridSizerAdjust(unsigned int type){
    mCPreviewPanelType.mBody = type;
    mpCPanelTop->SplitPanel(type);

    wxSizeEvent dummyEvent;
    mpCPanelTop->AddPendingEvent(dummyEvent);
}

void FrameMain_cls::
SplitterWindowResize(){
    // tB^[̃TCY
#ifdef WIN32
    // XN[o[op̌vZ̋
    // FIX_ME pŃĂ邯ǁA{ɂ@́H
    /*
    int sashPos = mpCSplitterMain->GetSashPosition();
    mpCSplitterMain->SetSashPosition(sashPos - 1, TRUE);
    mpCSplitterMain->SetSashPosition(sashPos, TRUE);
    */
#endif
}

// ---------

void FrameMain_cls::
InitializeOnIdle(){
    ReadConfigure(L"DF3ViewerConfigure.txt");
    DF3GL_cls::mspCProperty->Set3DTextureCondition
	(mpCGLInfo->mMajorVersion, mpCGLInfo->mMinorVersion);
    mpCDF3SeqCtrl->mpCGUI->UpdateItemsVisivility();
    mpCDF3SeqCtrl->mpCGUI->mpCPanelList->UpdateBitmapPanels();
    mpCDF3SeqCtrl->mpCGUI->Refresh(TRUE);
    mpCDF3SeqCtrl->mpCGUI->ActivatePanel(wxT("[Cam XYZ]"), TRUE);
    mpCMenuHelp->Check(menuItemToolTip, mpCParent->mCbToolTip.mbBody);
    PovVolume_cls::InitializeStaticMember(mpCPovRay, mpCParent->mpCLightSRC);

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemRefreshVList);
    AddPendingEvent(com);

    FitSplitterWindow(TRUE);

    //GbInitalizedOnIdle = TRUE;
}

void FrameMain_cls::
ProcPlayTex(){
    clock_t start_clock = clock();
    if (mpCCanvas[0]->mpCGLCanvas->mbSaveImgSeqQueue == TRUE &&
	mpCParent->mpCTime->mCbRepeat.mbBody == TRUE){
	mpCParent->mpCTime->mCbRepeat.mbBody = FALSE;
	mpCControlPanel->mpCToggleRepeat->SetValue(FALSE);
    }
    
    bool NextNextCondition = mpCDF3SeqCtrl->PlayTex();

    if (NextNextCondition == TRUE){
	unsigned int nextnextStep = 
	    mpCParent->mpCTime->CalcNextStep(mpCParent->mpCTime->mPlayDirection);
	while(TRUE){
	    if ((clock() - mClockLastDraw) >= mWaitDuration) break;
	    // FIX_ME!! 
	    /*
	    if (mpCDF3SeqCtrl->IdleProcessesMainAll
		(mpCDF3SeqCtrl->GetRemappedIndex(_DF3_SLOT_0_FIX_ME, nextnextStep),
		 _DF3_ENABLE_RESUME) == FALSE && 
		mpCDF3SeqCtrl->IdleProcessesRelease
		(_DF3INDEX_ALL, _DF3_ENABLE_RESUME) == FALSE) break;
	    */
	    bool bBreak = FALSE;
	    if (mpCDF3SeqCtrl->mbPreFetch == TRUE)
		for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++){
		    if (mpCDF3SeqCtrl->IdleProcessesMainEach
			(df3, mpCDF3SeqCtrl->GetRemappedIndex(df3, nextnextStep),
			 _DF3_ENABLE_RESUME) == FALSE &&
			mpCDF3SeqCtrl->IdleProcessesRelease
			(df3, _DF3_ENABLE_RESUME) == FALSE) bBreak = TRUE;
		}
	    if (bBreak == TRUE) break;
	}
	
	int elasped_millisec = 
	    1000 * (clock() - mClockLastDraw)/CLOCKS_PER_SEC;
	mClockLastDraw = clock();
	if (mMilliSleep > elasped_millisec)
	    wxMilliSleep(mMilliSleep - elasped_millisec);
    }
    else
	wxMilliSleep(mMilliSleep / 4);
}

void FrameMain_cls::
OnIdle(wxIdleEvent& event){
    static bool sbInit = TRUE;
    if (sbInit == TRUE){
	InitializeOnIdle();
	sbInit = FALSE;
    }

    if (mbForceFocus){
	SetFocus();
	mbForceFocus = FALSE;
    }

    if (mbOpenProject){
	UpdateCameraPos();
	UpdateDrawingData();
	PaintGLPanel();
	mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
	mbOpenProject = FALSE;
	return;
    }

    if (GbGLLockForLoading == TRUE && GbGLUnlockOK == TRUE){
	GbGLLockForLoading = FALSE;
	Refresh(TRUE); return;
    }

    mpCPovRay->ProcessRenderAnim();

    //RGBÃ}`XbhȂ҂
    if (GbGLLockForMultithread == TRUE &&
	GbGLForceWaitThreadEnd == TRUE) return; 
    GbGLForceWaitThreadEnd = FALSE;

    mbViaIdle = TRUE;
    mWaitDuration = CLOCKS_PER_SEC * mMilliSleep / 1000;
    
    wxGLContext *pCGLContext = GpCurrentGLPanel->mpCGLContext;

    if (mpCParent->mpCTime->mbPlayTex == TRUE){
	event.Skip();
	ProcPlayTex();
	return;
    }

    if (mpCDF3SeqCtrl->IdleProcessesRelease
	(_DF3INDEX_ALL, _DF3_ENABLE_RESUME) == TRUE ||
	mpCDF3SeqCtrl->IdleProcessesFetch() == TRUE){
	mpCDF3SeqCtrl->mpCGUI->UpdateDisplay();
	mbIdle = FALSE;
    }
    else
	if (mbIdle == FALSE){
	    mbIdle = TRUE;
	}

    mpCFilterPain->ProcessEventOnStack();

    event.Skip();
}

// -----------

wxString FrameMain_cls::
GetCurrentActiveFileWXStr(){
    return mpCDF3SeqCtrl->GetPDF3Active()->GetFilePathWXStr();
}

wxString FrameMain_cls::
GetFilePathWXStr(int df3index){
    return mpCDF3SeqCtrl->GetPDF3Seq(df3index)->GetPDF3()->GetFilePathWXStr();
}

wxString FrameMain_cls::
GetFilePathNextWXStr(int df3index){
    return mpCDF3SeqCtrl->GetPDF3Seq(df3index)->GetPDF3()->mpCNextDF3->GetFilePathWXStr();
}

// --------------

// GUĨI[o[bvǂɂ鏀
bool FrameMain_cls::
IsIntersectDialogs(wxRect rect){
    wxRect rectPov(0, 0, 0, 0);
    wxRect rectTree(0, 0, 0, 0);
    wxRect rectLight(0, 0, 0, 0);
    if (mpCPovRay->mpCGUI != NULL)
	rectPov = mpCPovRay->mpCGUI->GetScreenRect();
    if (mpCParent->mpCTreeBoxRule->mpCGUI != NULL)
	rectTree = mpCParent->mpCTreeBoxRule->mpCGUI->GetScreenRect();
    if (mpCParent->mpCLightSRC->mpCGUI != NULL)
	rectLight = mpCParent->mpCLightSRC->mpCGUI->GetScreenRect();

    return TRUE;
}

FrameMain_cls* FrameMain_cls::mspCThis;
