// GLOBJECTS.cpp : DLL AvP[ṼGg |Cg`܂B
// (setq c-basic-offset 4)

#include "stdafx.h"

#ifdef _MANAGED
#pragma managed(push, off)
#endif

#define _MAKE_DLL
#include "GLOBJECTS.h"

#include <GL/gl.h>
#include <GL/glu.h>

#include <math.h>

#define GLOBJ_SPHERE1 0.447213595f
#define GLOBJ_SPHERE2 0.894427190f
#define GLOBJ_SPHERE3 0.276393202f
#define GLOBJ_SPHERE4 0.723606797f
#define GLOBJ_SPHERE5 0.525731112f
#define GLOBJ_SPHERE6 0.850650808f

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#ifndef M_PI
#define M_PI 3.141593
#endif

# define _GRID_INNER 0
# define _GRID_OUTER 1

#ifdef WIN32
HMODULE g_hModule = NULL;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved){
    switch( ul_reason_for_call ) {
    case DLL_PROCESS_ATTACH:  // [hꂽ
	g_hModule = hModule;
	break;
    case DLL_PROCESS_DETACH:  // A[hꂽ
	g_hModule = NULL;
	break;
    case DLL_THREAD_ATTACH:   // Xbh쐬
	break;
    case DLL_THREAD_DETACH:   // XbhI
	break;
    }
    return TRUE;
}
#endif

namespace GLOBJ{

    void Normalize(double vec[3], double length){
	double norm = sqrt(vec[X]*vec[X] + vec[Y]*vec[Y] + vec[Z]*vec[Z]);
	LOOP_XYZ vec[xyz] /= norm * length;
    }

    void Normalize(float vec[3], float length){
	float norm = sqrt(vec[X]*vec[X] + vec[Y]*vec[Y] + vec[Z]*vec[Z]);
	LOOP_XYZ vec[xyz] /= norm * length;
    }

    /*!
      @brief XYZW theta-phi Wɕϊ
    */
    void ChangeCoordinate3Dto2D(double vec3D[3], double vec2D[2]){
	int phi = 0, theta = 1;
	vec2D[phi] = atan2(vec3D[Y], -vec3D[X]);
	vec2D[phi] = (vec2D[phi] + M_PI)/(2.0 * M_PI);
	vec2D[theta] = atan2(vec3D[Z], 
			     sqrt(vec3D[X]*vec3D[X]+vec3D[Y]*vec3D[Y]));
	vec2D[theta] = (vec2D[theta]+M_PI/2.0)/M_PI;
    }
    
    /*!
      @brief x[0,1] y[0,1] ͈̔͂͂ݏoW̏C
    */
    void AdjustVec2DOverBoundary(double vector[2], double vectormem[2]){
	for (int xy = 0; xy <= 1; xy++){
	    if (vector[xy]-vectormem[xy] > 0.5)
		vector[xy] = vector[xy] - 1.0f; 
	    if (vector[xy]-vectormem[xy] < -0.5)
		vector[xy] = vector[xy] + 1.0f; 
	}
    }

    /*!
      @brief ʒuƕxNg~Q\p Matrix ݒ
     */
    void SetMatrix3dv3(double loc[3], double tgt[3], double top[3]){
	GLdouble rgt[3];
	GLdouble matrix[16] = {
	    0, 0, 0, 0,    0, 0, 0, 0,    0, 0, 0, 0,    0, 0, 0, 1};
	glTranslated(loc[X], loc[Y], loc[Z]);
	rgt[Z] = tgt[X] * top[Y] - tgt[Y] * top[X];
	rgt[X] = tgt[Y] * top[Z] - tgt[Z] * top[Y];
	rgt[Y] = tgt[Z] * top[X] - tgt[X] * top[Z];
	// IuWFNg]s
	matrix[0]=rgt[X];matrix[4]= top[X]; matrix[8] = -tgt[X]; 
	matrix[1]=rgt[Y];matrix[5]= top[Y]; matrix[9] = -tgt[Y]; 
	matrix[2]=rgt[Z];matrix[6]= top[Z]; matrix[10]= -tgt[Z]; 
	glMultMatrixd(matrix); 
    }
    
    /*!
      @brief ʒuƕxNg~Q\p Matrix ݒ̋tϊ
     */
    void SetMatrix3dv3Inv(double loc[3], double tgt[3], double top[3]){
	GLdouble rgt[3];
	GLdouble matrix[16] = {
	    0, 0, 0, 0,    0, 0, 0, 0,    0, 0, 0, 0,    0, 0, 0, 1};
	glTranslated(-loc[X], -loc[Y], -loc[Z]);
	rgt[Z] = tgt[X] * top[Y] - tgt[Y] * top[X];
	rgt[X] = tgt[Y] * top[Z] - tgt[Z] * top[Y];
	rgt[Y] = tgt[Z] * top[X] - tgt[X] * top[Z];
	// IuWFNg]s
	matrix[0]= rgt[X];matrix[4]= rgt[Y]; matrix[8] =  rgt[Z]; 
	matrix[1]= top[X];matrix[5]= top[Y]; matrix[9] =  top[Z]; 
	matrix[2]=-tgt[X];matrix[6]=-tgt[Y]; matrix[10]= -tgt[Z]; 
	glMultMatrixd(matrix); 
    }

    /*!
      @brief @AeNX`W݂ŁARp`|S\B
    */
    void Sphere::DrawTriangle
	(double v1[3], double v2[3], double v3[3]){
	
	double normal1[3],normal2[3],normal3[3];
	double texvector1[2],texvector2[2],texvector3[2];
	
	LOOP_XYZ normal1[xyz] = v1[xyz];
	LOOP_XYZ normal2[xyz] = v2[xyz];
	LOOP_XYZ normal3[xyz] = v3[xyz]; 

	glBegin(GL_TRIANGLES);

	// @xNgAeNX`WA_W ^ ̂P
	Normalize(normal1, 1.0);
	glNormal3dv(normal1);
	ChangeCoordinate3Dto2D(normal1, texvector1); 
	glTexCoord2dv(texvector1);
	glVertex3dv(v1);
  
	// @xNgAeNX`WA_W ^ ̂Q
	Normalize(normal2,(double)1.0);
	glNormal3dv(normal2);
	ChangeCoordinate3Dto2D(normal2, texvector2); 
	AdjustVec2DOverBoundary(texvector2, texvector1); 
	glTexCoord2dv(texvector2);
	glVertex3dv(v2);

	// @xNgAeNX`WA_W ^ ̂R
	// eNX`Ŵ͂ݏoĂB
	Normalize(normal3,(double)1.0);
	glNormal3dv(normal3);
	ChangeCoordinate3Dto2D(normal3, texvector3); 
	if (texvector3[Y] > 0.99 || texvector3[Y] < 0.01) 
	    texvector3[X] = (texvector1[X] + texvector2[X])/2.0f; 
	else 
	    AdjustVec2DOverBoundary(texvector3, texvector2); 
	glTexCoord2dv(texvector3);
	glVertex3dv(v3);

	glEnd();
    }

    /*!
      @brief ċAIɂRp`|S𕪊āA炩ȋ`悷
     */
    void Sphere::DivideTriangle
	(double v1[3], double v2[3], double v3[3], int depth){
	
	double v12[3], v23[3], v31[3];

	if (depth <= 0){
	    DrawTriangle(v1,v2,v3);
	    return; }
	
	LOOP_XYZ v12[xyz] = v1[xyz] + v2[xyz];
	LOOP_XYZ v23[xyz] = v2[xyz] + v3[xyz];
	LOOP_XYZ v31[xyz] = v3[xyz] + v1[xyz]; 

	Normalize(v12,(double)1.0);
	Normalize(v23,(double)1.0);
	Normalize(v31,(double)1.0);
	DivideTriangle(v1,v12,v31, depth-1);
	DivideTriangle(v2,v23,v12, depth-1);
	DivideTriangle(v12,v23,v31, depth-1);
	DivideTriangle(v31,v23,v3, depth-1);
    }

    int Sphere::DListDraw(int depth, int iMode){
	
	GLdouble icosahedronv[12][3] = {
	    {             0,             0,             1},
	    {             0, GLOBJ_SPHERE2, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1}, 
	    {-GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    {             0,-GLOBJ_SPHERE2,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6,-GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {             0,             0,            -1} };

	GLint icosahedronface[20][3] = {
	    {1,2,0},{2,3,0},{3,4,0},{4,5,0},{5,1,0},
	    {1,6,2},{2,6,7},{2,7,3},{3,7,8},{4,3,8},
	    {4,8,9},{4,9,5},{5,9,10},{5,10,1},{1,10,6},
	    {6,10,11},{7,6,11},{8,7,11},{9,8,11},{10,9,11} };
	
	int    listName = 0;
	double tmpvector0[3], tmpvector1[3], tmpvector2[3];
  
	// TEXTURE̊͂Őݒ肵ĂӖ 
	// ł́AWƃeNX`̈ʒu֌Ŵ݂^ 
  	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ 
	    glNewList (listName, iMode); 
	}

	for (int i=0; i<20; i++){
	    LOOP_XYZ{
		tmpvector0[xyz] = icosahedronv[icosahedronface[i][0]][xyz];
		tmpvector1[xyz] = icosahedronv[icosahedronface[i][1]][xyz];
		tmpvector2[xyz] = icosahedronv[icosahedronface[i][2]][xyz];}
	    DivideTriangle(tmpvector0,tmpvector1,tmpvector2,depth);}
	
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }
    
    void Sphere::MakeMeshSphereDivide
    (std::vector < float > *pVVertices, std::vector < float > *pVNormals,
     std::vector < unsigned int > *pVIndex, 
     std::vector < unsigned int > *pVIndexNormal,
     float v1[3], float v2[3], float v3[3], 
     int index1, int index2, int index3, int *pCurrentIndex, int depth){
	float v12[3], v23[3], v31[3];
	
	if (depth <= 0){
	    pVIndex->push_back(index1);
	    pVIndex->push_back(index2);
	    pVIndex->push_back(index3);
	    pVIndexNormal->push_back(index1);
	    pVIndexNormal->push_back(index2);
	    pVIndexNormal->push_back(index3);
	    return; }

	LOOP_XYZ v12[xyz] = v1[xyz] + v2[xyz];
	LOOP_XYZ v23[xyz] = v2[xyz] + v3[xyz];
	LOOP_XYZ v31[xyz] = v3[xyz] + v1[xyz]; 
	Normalize(v12,(double)1.0);
	Normalize(v23,(double)1.0);
	Normalize(v31,(double)1.0);

	LOOP_XYZ pVVertices->push_back(v12[xyz]);
	LOOP_XYZ pVVertices->push_back(v23[xyz]);
	LOOP_XYZ pVVertices->push_back(v31[xyz]);
	LOOP_XYZ pVNormals->push_back(v12[xyz]);
	LOOP_XYZ pVNormals->push_back(v23[xyz]);
	LOOP_XYZ pVNormals->push_back(v31[xyz]);
	*pCurrentIndex += 3;
	int currentIndex = *pCurrentIndex; //ċAɕς̂local
	
	MakeMeshSphereDivide
	    (pVVertices, pVNormals, pVIndex, pVIndexNormal, v1, v12, v31, 
	     index1, currentIndex - 3, currentIndex - 1, 
	     pCurrentIndex, depth - 1);
	MakeMeshSphereDivide
	    (pVVertices, pVNormals, pVIndex, pVIndexNormal, v2, v23, v12, 
	     index2, currentIndex - 2, currentIndex - 3, 
	     pCurrentIndex, depth - 1);
	MakeMeshSphereDivide
	    (pVVertices, pVNormals, pVIndex, pVIndexNormal, v12, v23, v31,
	     currentIndex - 3, currentIndex - 2, currentIndex - 1,
	     pCurrentIndex, depth - 1);
	MakeMeshSphereDivide
	    (pVVertices, pVNormals, pVIndex, pVIndexNormal, v31, v23, v3, 
	     currentIndex - 1, currentIndex - 2, index3,
	     pCurrentIndex, depth - 1);
    }

    void Sphere::MakeMeshSphere(int depth, 
				std::vector < float > *pVVertices,
				std::vector < float > *pVNormals,
				std::vector < unsigned int > *pVIndex,
				std::vector < unsigned int > *pVIndexNormal){

	GLdouble icosahedronv[12][3] = {
	    {             0,             0,             1},
	    {             0, GLOBJ_SPHERE2, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5,-GLOBJ_SPHERE4, GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6, GLOBJ_SPHERE3, GLOBJ_SPHERE1}, 
	    {-GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {-GLOBJ_SPHERE6, GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    {             0,-GLOBJ_SPHERE2,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE6,-GLOBJ_SPHERE3,-GLOBJ_SPHERE1},
	    { GLOBJ_SPHERE5, GLOBJ_SPHERE4,-GLOBJ_SPHERE1},
	    {             0,             0,            -1} };

	GLint icosahedronface[20][3] = {
	    {1,2,0},{2,3,0},{3,4,0},{4,5,0},{5,1,0},
	    {1,6,2},{2,6,7},{2,7,3},{3,7,8},{4,3,8},
	    {4,8,9},{4,9,5},{5,9,10},{5,10,1},{1,10,6},
	    {6,10,11},{7,6,11},{8,7,11},{9,8,11},{10,9,11} };
	
	int    index = 0;
	float tmpvector0[3], tmpvector1[3], tmpvector2[3];
	
	for (int i=0; i<20; i++){
	    LOOP_XYZ{
		tmpvector0[xyz] = icosahedronv[icosahedronface[i][0]][xyz];
		tmpvector1[xyz] = icosahedronv[icosahedronface[i][1]][xyz];
		tmpvector2[xyz] = icosahedronv[icosahedronface[i][2]][xyz];}
	    LOOP_XYZ pVVertices->push_back(tmpvector0[xyz]);
	    LOOP_XYZ pVVertices->push_back(tmpvector1[xyz]);
	    LOOP_XYZ pVVertices->push_back(tmpvector2[xyz]);
	    LOOP_XYZ pVNormals->push_back(tmpvector0[xyz]);
	    LOOP_XYZ pVNormals->push_back(tmpvector1[xyz]);
	    LOOP_XYZ pVNormals->push_back(tmpvector2[xyz]);
	    index+= 3;
	    MakeMeshSphereDivide
		(pVVertices, pVNormals, pVIndex, pVIndexNormal,
		 tmpvector0,tmpvector1,tmpvector2,
		 index - 3, index - 2, index - 1, &index, depth);
	}
    }

    // ----------
    // facet360̖񐔂ł邱
    int Cone::DListDraw(int facets, int fineness, float topScale, 
			bool bOpen, int GLMode){
	int    listName = 0;

  	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, GLMode); 
	}

	double angle = atan2( 1.0 - topScale, 2.0);
	double cofRadial   = cos(angle);
	double cofVertical = sin(angle);

	int ddeg = 360 / facets;	
	for (int i = 0; i < fineness; i++){
	    double z0 = -1 + 2.0f/fineness * i;
	    double z1 = -1 + 2.0f/fineness * (i+1);
	    double scaleR0 = 1.0 - (1.0 - topScale) / fineness * i;
	    double scaleR1 = 1.0 - (1.0 - topScale) / fineness * (i+1);
   
	    glBegin(GL_QUAD_STRIP);
	    for (int deg = 0; deg <= 360; deg += ddeg){
		double radian = (float)deg * 3.1416 / 180;
		double x = cos(radian);
		double y = sin(radian);
		glNormal3d(cofRadial * x, cofRadial * y, cofVertical); 
		glVertex3d(scaleR1 * x, scaleR1 * y, z1); 
		glNormal3d(cofRadial * x, cofRadial * y, cofVertical); 
		glVertex3d(scaleR0 * x, scaleR0 * y, z0);
	    }
	    glEnd();
	}
	
	if (bOpen == FALSE){
	    double radius0 = 1.0f/fineness;
	    double radius1 = topScale / fineness;
	    if (topScale != 0){
		glBegin(GL_TRIANGLE_FAN);
		glNormal3d(0, 0, 1); 
		glVertex3f(0, 0, 1); 
		for (int deg = 0; deg <= 360; deg += ddeg){
		    double radian = (float)deg * 3.1416 / 180;
		    double x = radius1 * cos(radian);
		    double y = radius1 * sin(radian);
		    glNormal3d(0, 0, 1); glVertex3d(x, y, 1); 
		}
		glEnd();
	    }
	    
	    glBegin(GL_TRIANGLE_FAN);
	    glNormal3d(0, 0, -1); 
	    glVertex3f(0, 0, -1); 
	    for (int deg = 360; deg >= 0; deg -= ddeg){
		double radian = (float)deg * 3.1416 / 180;
		double x = radius0 * cos(radian);
		double y = radius0 * sin(radian);
		glNormal3d(0, 0, -1); glVertex3d(x, y, -1); 
	    }
	    glEnd();
	    
	    for (int i = 1; i < fineness; i++){
		float radius0 = 1.0f/fineness * i;
		float radius1 = 1.0f/fineness * (i+1);
		glBegin(GL_QUAD_STRIP);
		for (int deg = 0; deg <= 360; deg += ddeg){
		    double radian = (float)deg * 3.1416 / 180;
		    double x = cos(radian);
		    double y = sin(radian);
		    glNormal3d(0, 0, -1); glVertex3d(radius1*x, radius1*y, -1); 
		    glNormal3d(0, 0, -1); glVertex3d(radius0*x, radius0*y, -1); 
		}
		glEnd();
		
		if (topScale != 0){
		    radius0 = topScale/fineness * i;
		    radius1 = topScale/fineness * (i+1);
		    glBegin(GL_QUAD_STRIP);
		    for (int deg = 0; deg <= 360; deg += ddeg){
			double radian = (float)deg * 3.1416 / 180;
			double x = cos(radian);
			double y = sin(radian);
			glNormal3d(0, 0, 1); glVertex3d(radius0*x, radius0*y, 1); 
			glNormal3d(0, 0, 1); glVertex3d(radius1*x, radius1*y, 1); 
		    }
		    glEnd();
		}
	    }
	}
	
	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }

    void Cone::MakeMeshDisk(std::vector < float > *pVVertices,
			    std::vector < float > *pVNormals,
			    std::vector < unsigned int > *pVIndex,
			    std::vector < unsigned int > *pVIndexNormal,
			    int facets, int fineness, float scale,
			    float z, float nz){
	int indexOffset = pVVertices->size() / 3;

	pVVertices->push_back(0);
	pVVertices->push_back(0);
	pVVertices->push_back(z);
	pVNormals->push_back(0);
	pVNormals->push_back(0);
	pVNormals->push_back(nz);
	
	int ddeg = 360 / facets;
	for (int i = 1; i <= fineness; i++){
	    float radius0 = scale/fineness * i;
	    for (int deg = 0; deg <= 360; deg += ddeg){
		float radian = (float)deg * 3.1416 / 180;
		float x = cos(radian);
		float y = sin(radian);
		pVVertices->push_back(radius0*x);
		pVVertices->push_back(radius0*y);
		pVVertices->push_back(z);
		pVNormals->push_back(0);
		pVNormals->push_back(0);
		pVNormals->push_back(nz);
	    }
	}
	
	//^
	if (nz > 0){
	    for (int index = 0; index < facets; index++){
		pVIndex->push_back(indexOffset);
		pVIndex->push_back(indexOffset + index + 1);
		pVIndex->push_back(indexOffset + index + 2);
		pVIndexNormal->push_back(indexOffset);
		pVIndexNormal->push_back(indexOffset+index + 1);
		pVIndexNormal->push_back(indexOffset+index + 2);
	    }
	    pVIndex->push_back(indexOffset);
	    pVIndex->push_back(indexOffset + facets);
	    pVIndex->push_back(indexOffset + 1);
	    pVIndexNormal->push_back(indexOffset);
	    pVIndexNormal->push_back(indexOffset + facets);
	    pVIndexNormal->push_back(indexOffset + 1);
	}
	else{
	    for (int index = 0; index < facets; index++){
		pVIndex->push_back(indexOffset + index + 2);
		pVIndex->push_back(indexOffset + index + 1);
		pVIndex->push_back(indexOffset);
		pVIndexNormal->push_back(indexOffset+index + 2);
		pVIndexNormal->push_back(indexOffset+index + 1);
		pVIndexNormal->push_back(indexOffset);
	    }
	    pVIndex->push_back(indexOffset + 1);
	    pVIndex->push_back(indexOffset + facets);
	    pVIndex->push_back(indexOffset);
	    
	    pVIndexNormal->push_back(indexOffset + 1);
	    pVIndexNormal->push_back(indexOffset + facets);
	    pVIndexNormal->push_back(indexOffset);
	}
	
	//^񒆈ȊO
	if (nz > 0){
	    for (int i = 1; i < fineness; i++){
		int baseIndex0 = indexOffset + 1 + (facets + 1) * (i-1);
		int baseIndex1 = indexOffset + 1 + (facets + 1) * (i);
		for (int index = 0; index < facets; index++){
		    pVIndex->push_back(baseIndex1 + index);
		    pVIndex->push_back(baseIndex0 + index + 1);
		    pVIndex->push_back(baseIndex0 + index);
		    pVIndex->push_back(baseIndex1 + index + 1);		    
		    pVIndex->push_back(baseIndex0 + index + 1);
		    pVIndex->push_back(baseIndex1 + index);
		    pVIndexNormal->push_back(baseIndex1 + index);
		    pVIndexNormal->push_back(baseIndex0 + index + 1);
		    pVIndexNormal->push_back(baseIndex0 + index);
		    pVIndexNormal->push_back(baseIndex1 + index + 1);		    
		    pVIndexNormal->push_back(baseIndex0 + index + 1);
		    pVIndexNormal->push_back(baseIndex1 + index);
		}
	    }
	}
	else{
	    for (int i = 1; i < fineness; i++){
		int baseIndex0 = indexOffset + 1 + (facets + 1) * (i-1);
		int baseIndex1 = indexOffset + 1 + (facets + 1) * (i);
		for (int index = 0; index < facets; index++){
		    pVIndex->push_back(baseIndex0 + index);
		    pVIndex->push_back(baseIndex0 + index + 1);
		    pVIndex->push_back(baseIndex1 + index);
		    pVIndex->push_back(baseIndex1 + index);
		    pVIndex->push_back(baseIndex0 + index + 1);
		    pVIndex->push_back(baseIndex1 + index + 1);
		    pVIndexNormal->push_back(baseIndex0 + index);
		    pVIndexNormal->push_back(baseIndex0 + index + 1);
		    pVIndexNormal->push_back(baseIndex1 + index);
		    pVIndexNormal->push_back(baseIndex1 + index);
		    pVIndexNormal->push_back(baseIndex0 + index + 1);
		    pVIndexNormal->push_back(baseIndex1 + index + 1);
		}
	    }
	}
    }

    void Cone::MakeMeshCone(std::vector < float > *pVVertices,
			    std::vector < float > *pVNormals,
			    std::vector < unsigned int > *pVIndex,
			    std::vector < unsigned int > *pVIndexNormal,
			    int facets, int fineness, 
			    float topScale, bool bOpen){
	
	float angle = (float)atan2( 1.0 - topScale, 2.0);
	float cofRadial   = cos(angle);
	float cofVertical = sin(angle);
	
	int ddeg = 360 / facets;
	for (int i = 0; i <= fineness; i++){
	    float z0 = -1 + 2.0f/fineness * i;
	    float scaleR0 = 1.0f - (1.0f - topScale) / fineness * i;
	    
	    for (int deg = 0; deg <= 360; deg += ddeg){
		float radian = (float)deg * 3.1416 / 180;
		float x = cos(radian);
		float y = sin(radian);
		
		pVVertices->push_back(scaleR0 * x);
		pVVertices->push_back(scaleR0 * y);
		pVVertices->push_back(z0);
		pVNormals->push_back(cofRadial * x);
		pVNormals->push_back(cofRadial * y);
		pVNormals->push_back(cofVertical);
	    }
	}

	for (int i = 0; i < fineness; i++){
	    int baseIndex0 = (facets + 1) * i;
	    int baseIndex1 = (facets + 1) * (i+1);
	    for (int index = 0; index < facets; index++){
		pVIndex->push_back(baseIndex0 + index);
		pVIndex->push_back(baseIndex0 + index + 1);
		pVIndex->push_back(baseIndex1 + index);
		pVIndex->push_back(baseIndex1 + index);
		pVIndex->push_back(baseIndex0 + index + 1);
		pVIndex->push_back(baseIndex1 + index + 1);
		pVIndexNormal->push_back(baseIndex0 + index);
		pVIndexNormal->push_back(baseIndex0 + index + 1);
		pVIndexNormal->push_back(baseIndex1 + index);
		pVIndexNormal->push_back(baseIndex1 + index);
		pVIndexNormal->push_back(baseIndex0 + index + 1);
		pVIndexNormal->push_back(baseIndex1 + index + 1);
	    }
	}

	if (bOpen == FALSE){
	    MakeMeshDisk(pVVertices, pVNormals,
			 pVIndex, pVIndexNormal,
			 facets, fineness, 1.0f, -1, -1);
	    
	    if (topScale != 0){
		MakeMeshDisk(pVVertices, pVNormals,
			     pVIndex, pVIndexNormal,
			     facets, fineness, topScale, 1, 1);
	    }
	}
    }
    
    // ----------

    bool GridFlat::mbInitialized = FALSE;
    bool GridFlat::mbColor = FALSE;
    int  GridFlat::mDListInner = -1;
    int  GridFlat::mDListOuter = -1;
    int  GridFlat::mFineness = 10;

    /*!
      @brief ʃObh[-1:+1],[-1:+1]̕`
      @param[in] fineness ׂ
      @param[in] iMode `惂[h
      @param[out] VKfBXvCXgԍ
    */
    int GridFlat::DListDraw(int fineness, int GLMode,
			    int gridMode){
	int    listName = 0;

  	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, GLMode); 
	}
	
	if (fineness < 3) fineness = 3;

	glBegin(GL_LINES);
	for (int i= -fineness + (gridMode == _GRID_INNER)
		 ; i <= fineness - (gridMode == _GRID_INNER) ; i++){
	    
	    if (i == 0) continue;
	    
	    float value = (float)i / fineness;
	    glVertex3f(value, -1, 0); glVertex3f(value, +1, 0);
	    glVertex3f(-1, value, 0); glVertex3f(+1, value, 0);
	}

	glVertex3d(1.05, 0.05, 0); glVertex3d(1.1, 0, 0);
	glVertex3d(1.05,-0.05, 0); glVertex3d(1.1, 0, 0);

	glVertex3d( 0.05, 1.05, 0); glVertex3d(0, 1.1, 0);
	glVertex3d(-0.05, 1.05, 0); glVertex3d(0, 1.1, 0);
	
	glEnd();
	
	if (gridMode == _GRID_OUTER){
	    glBegin(GL_LINES);
	    if (mbColor == TRUE) glColor3d(0.5, 0.2, 0.2);
	    glVertex3f(-1, 0,   0); glVertex3f(+1,  0,  0);
	    if (mbColor == TRUE) glColor3d(0.2, 0.5, 0.2);
	    glVertex3f( 0,-1,   0); glVertex3f( 0, +1,  0);
	    if (mbColor == TRUE) glColor3d(0.2, 0.2, 0.6);
	    glVertex3f( 0,  0, -1); glVertex3f( 0,  0, +1);
	    glEnd();
	}
	
	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }
    
    void GridFlat::InitializeIfNot(){
	if (mbInitialized == TRUE) return;
	mDListInner = DListDraw(mFineness, GL_COMPILE, _GRID_INNER);
	mDListOuter = DListDraw(mFineness, GL_COMPILE, _GRID_OUTER);
	mbInitialized = TRUE;
    }

    void GridFlat::Draw(double scale){
	InitializeIfNot();
	glPushMatrix();
	glScaled(scale, scale, scale);
	glCallList(mDListInner);
	glScaled(10, 10, 10);
	glCallList(mDListInner);
	glScaled(10, 10, 10);
	glCallList(mDListOuter);
	glPopMatrix();
    }

    void GridFlat::ColorModeOn(void){
	mbColor = TRUE;
    }

    // ----------

    bool GridCircularFlat::mbInitialized = FALSE;
    bool GridCircularFlat::mbColor = FALSE;
    int  GridCircularFlat::mDListCircular = -1;
    int  GridCircularFlat::mFineness = 2;

    /*!
      @brief ~̕ʃObh̕`
      @param[in] fineness ׂ
      @param[in] iMode `惂[h
      @param[out] VKfBXvCXgԍ
    */
    int GridCircularFlat::DListDraw(int fineness, int GLMode){

	int    listName = 0;

	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, GLMode); 
	}
	
	double incr = 1.0 / fineness;
	
	double tabSin[120], tabCos[120];
	for (unsigned int i = 0; i < 120; i++){
	    tabSin[i] = sin((double)i * 3 * M_PI / 180);
	    tabCos[i] = cos((double)i * 3 * M_PI / 180);
	}

	for (double radi = incr 
		 ; radi <= 1 + 1e-5; radi += incr){
	    glBegin(GL_LINE_LOOP);
	    for (int index = 0; index < 120; index++)
		glVertex3d(tabCos[index] * radi, tabSin[index] * radi, 0);
	    glEnd();
	}

	for (double radi = 1 
		 ; radi <= 9 + 1e-5; radi += 1){
	    glBegin(GL_LINE_LOOP);
	    for (int index = 0; index < 120; index++)
		glVertex3d(tabCos[index] * radi, tabSin[index] * radi, 0);
	    glEnd();
	}
	
	glEnable(GL_LINE_STIPPLE);
	glBegin(GL_LINES);
	for (int i = 10; i <= 110; i+=10){
	    if (i % 30 == 0) i += 10;
	    glVertex3d(tabCos[i] * 0.1, tabSin[i] * 0.1, 0);
	    glVertex3d(tabCos[i] * 10 , tabSin[i] * 10 , 0);
	}
	glEnd();
	glDisable(GL_LINE_STIPPLE);
		
	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }

    void GridCircularFlat::InitializeIfNot(){
	if (mbInitialized == TRUE) return;
	mDListCircular = DListDraw(mFineness, GL_COMPILE);
	mbInitialized = TRUE;
    }

    void GridCircularFlat::Draw(double scale){
	InitializeIfNot();
	glPushMatrix();
	glScaled(scale, scale, scale);
	glCallList(mDListCircular);
	glPopMatrix();
    }

    // ---------

    bool GridPolar::mbInitialized = FALSE;
    bool GridPolar::mbColor = FALSE;
    int  GridPolar::mDListPolar = -1;
    int  GridPolar::mFineness = 2;

    /*!
      @brief ɂ̃ObhiaPj̕`
      @param[in] fineness ׂ
      @param[in] iMode `惂[h
      @param[out] VKfBXvCXgԍ
    */
    int GridPolar::DListDraw(int fineness, int GLMode){

	int    listName = 0;

	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, GLMode); 
	}

	for (int itheta = -80; itheta <= 80; itheta+=10){
	    double theta = itheta * M_PI/180;
	    double z = 1.01 * sin(theta);
	    double r = 1.01 * cos(theta);
	    glBegin(GL_LINE_STRIP);
	    for (int iphi = 0; iphi <= 360; iphi+=10){
		double phi = iphi * M_PI/180;
		double x = r * cos(phi);
		double y = r * sin(phi);
		glVertex3d(x,y,z); }
	    glEnd(); 
	}
	
	for (int iphi = 0; iphi <= 360; iphi+=10){
	    double phi = iphi * M_PI/180;
	    glBegin(GL_LINE_STRIP);
	    for (int itheta = -80; itheta <= 80; itheta+=10){
		double theta = itheta * M_PI/180;
		double z = 1.00 * sin(theta);
		double r = 1.00 * cos(theta);
		double x = r * cos(phi);
		double y = r * sin(phi);
		glVertex3d(x,y,z); }
	    glEnd(); 
	}
	
	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }
    
    void GridPolar::InitializeIfNot(){
	if (mbInitialized == TRUE) return;
	mDListPolar = DListDraw(mFineness, GL_COMPILE);
	mbInitialized = TRUE;
    }

    void GridPolar::Draw(double scale){
	InitializeIfNot();
	glPushMatrix();
	glScaled(scale, scale, scale);
	glCallList(mDListPolar);
	glPopMatrix();
    }

    // ----

    bool Object::mbInitialized = FALSE;
    int  Object::mDList[6] = {0, 0, 0, 0, 0, 0};

    int Object::DListDraw(int type, int GLMode){
	int listName;
	if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ 
	    glNewList (listName, GLMode); }
	
	switch (type){
	case _CAMERA_1:
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.5, -1, -1);  glVertex3d( 0.5, -1, -1);
	    glVertex3d( 0.5,  1, -1);  glVertex3d(-0.5,  1, -1);  
	    glEnd();
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.5, -1, 1);  glVertex3d( 0.5, -1, 1);
	    glVertex3d( 0.5,  1, 1);  glVertex3d(-0.5,  1, 1);  
	    glEnd();
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.7, -1.2, -1.2);  glVertex3d( 0.7, -1.2, -1.2);
	    glVertex3d( 0.7,  1.2, -1.2);  glVertex3d(-0.7,  1.2, -1.2);   
	    glEnd();

	    glBegin(GL_LINES);
	    glVertex3d(-0.5, -1, -1); glVertex3d(-0.5, -1, 1);
	    glVertex3d( 0.5, -1, -1); glVertex3d( 0.5, -1, 1);
	    glVertex3d( 0.5,  1, -1); glVertex3d( 0.5,  1, 1);
	    glVertex3d(-0.5,  1, -1); glVertex3d(-0.5,  1, 1);
	    glEnd();
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.1,  1.1,  0.2);  glVertex3d( 0.1,  1.1, 0.2);
	    glVertex3d( 0.0,  1.1, -0.2);
	    glEnd();
	    break;
	case _CAMERA_2:
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-4.0, -3.0, -8.0);  glVertex3d( 4.0, -3.0, -8.0);
	    glVertex3d( 4.0,  3.0, -8.0);  glVertex3d(-4.0,  3.0, -8.0);
	    glEnd();
	  
	    glBegin(GL_LINES);
	    glVertex3d(-4.0, -3.0, -8.0); glVertex3d(-1.0, -0.75, -2.0);
	    glVertex3d( 4.0, -3.0, -8.0); glVertex3d( 1.0, -0.75, -2.0);
	    glVertex3d( 4.0,  3.0, -8.0); glVertex3d( 1.0,  0.75, -2.0);
	    glVertex3d(-4.0,  3.0, -8.0); glVertex3d(-1.0,  0.75, -2.0);
	    glEnd();

	    glBegin(GL_TRIANGLES);
	    glVertex3d(-1, 3.0, -8.0); 
	    glVertex3d( 0, 4.0, -8.0); 
	    glVertex3d(+1, 3.0, -8.0); 
	    
	    glEnd();
		
	    break;
	case _CAMERA_POLYGON:
	    glBegin(GL_QUADS);
	    glVertex3d(-0.48,  0.98, -1);  glVertex3d( 0.48,  0.98, -1);  
	    glVertex3d( 0.48, -0.98, -1);  glVertex3d(-0.48, -0.98, -1);
	    glEnd();
	  
	    glBegin(GL_QUADS);
	    glVertex3d(-0.48, -0.98, 1);  glVertex3d( 0.48, -0.98, 1);
	    glVertex3d( 0.48,  0.98, 1);  glVertex3d(-0.48,  0.98, 1);
	    glEnd();
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.7, -1.2, -1.2);  glVertex3d( 0.7, -1.2, -1.2);
	    glVertex3d( 0.7,  1.2, -1.2);  glVertex3d(-0.7,  1.2, -1.2);
	    glEnd();
	  
	    glBegin(GL_QUADS);
	    glVertex3d(-0.48,  1,  0.98);  glVertex3d( 0.48,  1,  0.98);
	    glVertex3d( 0.48,  1, -0.98);  glVertex3d(-0.48,  1, -0.98); 
	    glEnd();
	  
	    glBegin(GL_QUADS);
	    glVertex3d(-0.5,  0.98,  0.98);  glVertex3d(-0.5,  0.98, -0.98);
	    glVertex3d(-0.5, -0.98, -0.98);  glVertex3d(-0.5, -0.98, +0.98); 
	    glEnd();
	  
	    glBegin(GL_QUADS);
	    glVertex3d(-0.48, -1, -0.98);  glVertex3d( 0.48, -1, -0.98);  
	    glVertex3d( 0.48, -1,  0.98);  glVertex3d(-0.48, -1,  0.98);
	    glEnd();
	  
	    glBegin(GL_QUADS);
	    glVertex3d( 0.5, -0.98, +0.98);  glVertex3d( 0.5, -0.98, -0.98);
	    glVertex3d( 0.5,  0.98, -0.98);  glVertex3d( 0.5,  0.98,  0.98);  
	    glEnd();

	    glColor3d(0, 0, 0);
	    glBegin(GL_QUADS);
	    glVertex3d(-0.3,  0.3, -1.02);  glVertex3d( 0.3,  0.3, -1.02);  
	    glVertex3d( 0.3, -0.3, -1.02);  glVertex3d(-0.3, -0.3, -1.02);
	    glEnd();
	  
	    glColor3d(1,1,1);
	    glBegin(GL_LINES);
	    glVertex3d( 0,  1.1,  0);
	    glVertex3d( 0,  2.5,  0);
	    glEnd();
	    break;
	case _CAMERA_CROSSHAIR:
	    glBegin(GL_LINES);
	    glVertex3d(-0.5, 0, 0); glVertex3d(+0.5, 0, 0);
	    glVertex3d(0, -0.5, 0); glVertex3d(0, +0.5, 0);
	    glVertex3d(0, 0, -0.5); glVertex3d(0, 0, +0.5);
	    glEnd();
	    break;
	case _GLOBJ_WIREBOX:
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.5, -0.5, -0.5); glVertex3d(+0.5, -0.5, -0.5);
	    glVertex3d(+0.5, +0.5, -0.5); glVertex3d(-0.5, +0.5, -0.5);
	    glEnd();
	    glBegin(GL_LINE_LOOP);
	    glVertex3d(-0.5, -0.5, +0.5); glVertex3d(+0.5, -0.5, +0.5);
	    glVertex3d(+0.5, +0.5, +0.5); glVertex3d(-0.5, +0.5, +0.5);
	    glEnd();
	    glBegin(GL_LINES);
	    glVertex3d(-0.5, -0.5, -0.5); glVertex3d(-0.5, -0.5, +0.5);
	    glVertex3d(+0.5, -0.5, -0.5); glVertex3d(+0.5, -0.5, +0.5);
	    glVertex3d(+0.5, +0.5, -0.5); glVertex3d(+0.5, +0.5, +0.5);
	    glVertex3d(-0.5, +0.5, -0.5); glVertex3d(-0.5, +0.5, +0.5);
	    glEnd();
	    break;
	case _GLOBJ_LIGHTSRC:
	    glBegin(GL_LINES);
	    for (int i = 0; i < 360; i+=10){
		double rad = 3.14159 * i / 180;
		glVertex3d(cos(rad), sin(rad), 0);
	    }
	    glEnd();
	    glBegin(GL_LINE_STRIP);
	    for (int i = 0; i <= 360; i+=10){
		double rad = 3.14159 * i / 180;
		glVertex3d(0.7 * cos(rad), 0.7 * sin(rad), 0);
	    }
	    glEnd();
	    break;
	}

	if (GLMode == GL_COMPILE ||
	    GLMode == GL_COMPILE_AND_EXECUTE) glEndList();

	return listName;
    }
    
    void Object::InitializeIfNot(){
	if (mbInitialized == TRUE) return;
	for (int i = 0; i < 6; i++)
	    mDList[i] = DListDraw(i + _CAMERA_1, GL_COMPILE);
	mbInitialized = TRUE;
    }

    void Object::Draw(int type){
	InitializeIfNot();
	glCallList(mDList[type]);
    }

    int Object::GetList(int type){
	InitializeIfNot();
	return mDList[type];
    }

}

#ifdef _MANAGED
#pragma managed(pop)
#endif
