// -*- c -*-
// GLOBJSPHERES.cpp 
// (setq c-basic-offset 4)

#ifdef _MANAGED
#pragma managed(push, off)
#endif

#define _MAKE_DLL
#include "GLOBJECTS.h"

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

bool GLOBJ::Strings2D::mbInitGLUT = FALSE;

namespace GLOBJ{
    void Raster2D::Push2DMatrix(int width, int height){
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, width, 0, height);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
    }

    void Raster2D::Pop2DMatrix(){
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW); 
    }

    void Strings2D::MyInitiGLUT(){
	int argc = 1;
	char **argv = new char* [1];
	argv[0] = new char [6];
	printf(argv[0], "dummy");
	glutInit(&argc, argv);
	delete argv[0]; 
	delete argv;
	mbInitGLUT = TRUE;
    }

    void Strings2D::SetWindowGeometry(int width, int height){
	msWidth = width;
	msHeight = height;
    }
    
    void Strings2D::Draw(void *fonttype, const char *chars, 
			 int posx, int posy, int mode){

	if (mbInitGLUT == FALSE) MyInitiGLUT();

	if (mode == _STRINGS_TOP_LEFT)
	    posy = msHeight - posy - 12; // $BK\Mh%U%)%s%H$K$h$C$FJQ$o$k$Y$-(B

	int len = (int)strlen(chars);
	Raster2D::Push2DMatrix(msWidth, msHeight);
	glRasterPos2i(posx, posy);
	for (int i = 0; i < len; i++){
	    if (chars[i] == '\n'){
		posy -= 24;
		glRasterPos2i(posx, posy); }
	    glutBitmapCharacter(fonttype, chars[i]); }
	Raster2D::Pop2DMatrix();
    }

    void Strings2D::Draw3DPos(void *fonttype, const char *chars, 
			      float posx, float posy, float posz){
	if (mbInitGLUT == FALSE) MyInitiGLUT();

	glRasterPos3f(posx, posy, posz);
	while(*chars){
	    glutBitmapCharacter(fonttype, *chars);
	    ++chars;
	}
    }
    
    void Strings2D::FDrawFloat(void *fonttype, std::string format, float val,
			       int posx, int posy, int mode){
	char buf[255];
	sprintf(buf, format.c_str(), val);
	Draw(fonttype, buf, posx, posy, mode); 
    }

    int Strings2D::msWidth;
    int Strings2D::msHeight;
}
